var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { get } from 'lodash';
import IdManager from './helpers/IdManager';
import server from './helpers/Server';
import Button from './helpers/Button';
import Spinner from './helpers/Spinner';
import MessageIcons from './helpers/MessageIcons';
import FontAwesome from 'react-fontawesome';
import { Col, Grid, Row, Well } from 'react-bootstrap';
import ResourceSelector from './modules/ReactSelector';
import Form from "react-jsonschema-form";
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';

import User from "./classes/User";

var Administrator = (_temp = _class = function (_React$Component) {
  _inherits(Administrator, _React$Component);

  function Administrator(props) {
    _classCallCheck(this, Administrator);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, _this.state);

    _this.handleDelete = _this.handleDelete.bind(_this);
    _this.setPath = _this.setPath.bind(_this);
    _this.setItemDetails = _this.setItemDetails.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getAdminGrid = _this.getAdminGrid.bind(_this);
    _this.getResources = _this.getResources.bind(_this);
    _this.getResourceItems = _this.getResourceItems.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.getAdminContent = _this.getAdminContent.bind(_this);
    return _this;
  }

  Administrator.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  Administrator.prototype.setPath = function setPath(newPath, updateMessage) {
    if (newPath) {
      var path = newPath.value ? newPath.value : newPath;
      this.setState({
        path: path,
        centerDivVisible: false,
        submitIsAPost: path.includes("new/forms")
      }, this.fetchData(path, updateMessage));
      ;
    }
  };

  Administrator.prototype.setItemDetails = function setItemDetails(id, uiSchema, schema, value) {
    var hidden = false;
    var deleteVisible = !id.includes("~new~");
    if (uiSchema["ui:readonly"]) {
      hidden = true;
    }
    this.setState({
      item: { id: id, uiSchema: uiSchema, schema: schema, value: value },
      itemSelected: true,
      submitButtonHidden: hidden,
      deleteButtonVisible: deleteVisible,
      centerDivVisible: true
    });
  };

  Administrator.prototype.fetchData = function fetchData(path, updateMessage) {
    var _this2 = this;

    var config = {
      auth: {
        username: this.state.session.userInfo.username,
        password: this.state.session.userInfo.password
      }
    };
    axios.get(this.props.session.restServer + server.getWsServerAdminApi() + path, config).then(function (response) {
      _this2.setState({
        data: response.data
      });
      if (updateMessage) {
        _this2.setState({
          message: "found " + (response.data.valueCount ? response.data.valueCount : "") + " docs for " + IdManager.padPath(path),
          messageIcon: _this2.state.messageIcons.info
        });
      }
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.state.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = "no docs found";
        messageIcon = _this2.state.messageIcons.warning;
      }
      _this2.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };
  // /delete/user


  Administrator.prototype.handleDelete = function handleDelete() {
    var _this3 = this;

    var config = {
      auth: {
        username: this.state.session.userInfo.username,
        password: this.state.session.userInfo.password
      }
    };
    axios.delete(this.props.session.restServer + server.getWsServerAdminApi() + IdManager.idToPath(this.state.item.id), config).then(function (response) {
      _this3.setState({
        message: "deleted " + IdManager.idToPaddedPath(_this3.state.item.id)
      });
      _this3.setPath(_this3.state.path);
      _this3.setState({ centerDivVisible: true, submitIsDelete: false });
    }).catch(function (error) {
      var message = error.response.data.userMessage;
      var messageIcon = _this3.state.messageIcons.error;
      _this3.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  Administrator.prototype.handlePost = function handlePost(formData) {
    var _this4 = this;

    var config = {
      auth: {
        username: this.state.session.userInfo.username,
        password: this.state.session.userInfo.password
      }
    };
    axios.post(this.props.session.restServer + server.getWsServerAdminApi() + IdManager.idToPath(this.state.item.id), formData.formData, config).then(function (response) {
      _this4.setState({
        message: "updated " + IdManager.idToPaddedPath(_this4.state.item.id),
        item: { id: _this4.state.item.id, uiSchema: _this4.state.item.uiSchema, schema: _this4.state.item.schema, value: formData.formData }
      });
      _this4.setPath(_this4.state.path);
      _this4.setState({ centerDivVisible: true });
    }).catch(function (error) {
      var message = error.response.data.userMessage;
      var messageIcon = _this4.state.messageIcons.error;
      _this4.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  Administrator.prototype.handlePut = function handlePut(formData) {
    var _this5 = this;

    var config = {
      auth: {
        username: this.state.session.userInfo.username,
        password: this.state.session.userInfo.password
      }
    };
    var path = IdManager.idToPath(this.state.item.id);
    var message = "";
    if (path.startsWith("misc/utilities")) {
      this.setState({
        message: "This will take a few minutes"
      });
    }
    axios.put(this.props.session.restServer + server.getWsServerAdminApi() + path, formData.formData, config).then(function (response) {
      message = "updated " + path;
      if (path.startsWith("misc/utilities")) {
        message = path + ": " + response.data.userMessage;
      }
      if (formData.formData && formData.formData.password) {
        if (formData.formData.username === _this5.props.session.userInfo.username) {
          _this5.state.session.userInfo.password = formData.formData.password;
        }
      }
      _this5.setState({
        message: message,
        item: {
          id: _this5.state.item.id,
          uiSchema: _this5.state.item.uiSchema,
          schema: _this5.state.item.schema,
          value: formData.formData
        }
      });
      _this5.setPath(_this5.state.path);
      _this5.setState({ centerDivVisible: true });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this5.state.messageIcons.error;
      _this5.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  Administrator.prototype.onSubmit = function onSubmit(formData) {
    if (this.state.submitIsAPost) {
      this.handlePost(formData);
    } else {
      this.handlePut(formData);
    }
  };

  Administrator.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        'div',
        null,
        this.getAdminContent()
      )
    );
  };

  return Administrator;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this6 = this;

  this.componentWillMount = function () {
    _this6.getResources();
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this6.state = _this6.setTheState(nextProps, _this6.state);
  };

  this.setTheState = function (props, currentState) {
    var action = 'GET';
    var path = 'users/statistics';
    var item = { id: "", uiSchema: {}, schema: {}, value: {} };
    var itemSelected = false;
    var resources = [];
    var submitButtonHidden = false;
    var centerDivVisible = false;
    var submitIsAPost = false;
    if (currentState) {
      if (currentState.action && currentState.action !== action) {
        action = currentState.action;
      }
      if (currentState.path && currentState.path !== path) {
        path = currentState.path;
      }
      if (currentState.item && currentState.item.id.length > 0) {
        currentState.item = item;
      }
      if (currentState.itemSelected) {
        itemSelected = currentState.itemSelected;
      }
      if (currentState.resources && currentState.resources.length > 0) {
        resources = currentState.resources;
      }
      if (currentState.submitButtonHidden) {
        submitButtonHidden = currentState.submitButtonHidden;
      }
      if (currentState.centerDivVisible) {
        centerDivVisible = currentState.centerDivVisible;
      }
      if (currentState.submitIsAPost) {
        submitIsAPost = currentState.submitIsAPost;
      }
    }

    var userInfo = {};
    if (props.session && props.session.userInfo) {
      userInfo = new User(props.session.userInfo.username, props.session.userInfo.password, props.session.userInfo.domain, props.session.userInfo.email, props.session.userInfo.firstname, props.session.userInfo.lastname, props.session.userInfo.title, props.session.userInfo.authenticated, props.session.userInfo.domains);
    }

    return {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.AgesEditor],
        messages: props.session.labels[props.session.labelTopics.messages],
        liturgicalAcronyms: props.session.labels[props.session.labelTopics.liturgicalAcronyms]
      },
      session: {
        userInfo: userInfo
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: props.session.labels[props.session.labelTopics.messages].initial,
      action: action,
      path: path,
      item: item,
      itemSelected: itemSelected,
      resources: resources,
      submitButtonHidden: submitButtonHidden,
      deleteButtonVisible: get(currentState, "deleteButtonVisible", true),
      centerDivVisible: centerDivVisible,
      submitIsAPost: submitIsAPost,
      options: {
        sizePerPage: 10,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this6.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      selectRow: {
        mode: 'radio',
        clickToSelect: true,
        onSelect: _this6.handleRowSelect,
        hideSelectColumn: true
      }
    };
  };

  this.handleRowSelect = function (row, isSelected, e) {
    _this6.setItemDetails(row._id, _this6.state.data.valueSchemas[row._valueSchemaId].uiSchema, _this6.state.data.valueSchemas[row._valueSchemaId].schema, row.value);
  };

  this.getResources = function () {
    var config = {
      auth: {
        username: _this6.state.session.userInfo.username,
        password: _this6.state.session.userInfo.password
      }
    };

    axios.get(_this6.props.session.restServer + server.getWsServerAdminApi() + "resources", config).then(function (response) {
      _this6.setState({
        resources: response.data.resources
      }, _this6.fetchData("users/statistics", true));
    }).catch(function (error) {
      _this6.setState({
        resources: []
      });
    });
  };

  this.getResourceItems = function () {
    if (_this6.state.data) {
      if (_this6.state.data === 'no docs found') {
        return "";
      } else {
        return React.createElement(
          'div',
          null,
          React.createElement(
            Well,
            null,
            React.createElement(
              'div',
              { className: 'control-label' },
              'Select an item...'
            ),
            React.createElement(
              BootstrapTable,
              {
                data: _this6.state.data.values,
                trClassName: "App-data-tr",
                striped: true,
                hover: true,
                pagination: true,
                options: _this6.state.options,
                selectRow: _this6.state.selectRow,
                search: true
              },
              React.createElement(
                TableHeaderColumn,
                {
                  isKey: true,
                  dataField: '_id',
                  dataSort: true
                },
                'ID'
              )
            )
          )
        );
      }
    } else {
      return "";
    }
  };

  this.getAdminGrid = function () {
    return React.createElement(
      Grid,
      null,
      React.createElement(
        Row,
        { className: 'show-grid' },
        React.createElement(
          Col,
          { sm: 5, md: 5 },
          React.createElement(
            Well,
            null,
            React.createElement(ResourceSelector, {
              initialValue: _this6.state.path,
              resources: _this6.state.resources,
              changeHandler: _this6.setPath,
              multiSelect: false,
              title: 'Select a resource:'
            })
          ),
          _this6.getResourceItems()
        ),
        React.createElement(
          Col,
          { sm: 7, md: 7 },
          _this6.state.itemSelected && _this6.state.centerDivVisible && React.createElement(
            'div',
            { className: 'App-form-container' },
            React.createElement(
              Well,
              null,
              React.createElement(
                'h3',
                null,
                'ID: ',
                IdManager.idToPaddedPath(_this6.state.item.id)
              ),
              React.createElement(
                Form,
                {
                  schema: _this6.state.item.schema,
                  uiSchema: _this6.state.item.uiSchema,
                  formData: _this6.state.item.value,
                  onSubmit: _this6.onSubmit },
                React.createElement(
                  'div',
                  null,
                  React.createElement(Button, { label: 'Submit', hidden: _this6.state.submitButtonHidden }),
                  _this6.state.deleteButtonVisible && React.createElement(
                    'button',
                    {
                      type: 'button',
                      className: 'App-Form-Delete-Button',
                      onClick: _this6.handleDelete
                    },
                    'Delete'
                  )
                )
              )
            )
          )
        ),
        React.createElement(Col, { sm: 0, md: 0 })
      )
    );
  };

  this.getAdminContent = function () {
    if (_this6.state.resources) {
      return React.createElement(
        'div',
        { className: 'App-administrator' },
        React.createElement(
          Grid,
          null,
          React.createElement(
            Row,
            { className: 'show-grid' },
            React.createElement(Col, { sm: 3, md: 3 }),
            React.createElement(
              Col,
              { sm: 6, md: 6 },
              React.createElement(
                'div',
                { className: 'App App-message' },
                React.createElement(FontAwesome, { name: _this6.state.messageIcon }),
                _this6.state.message
              )
            ),
            React.createElement(Col, { sm: 3, md: 3 })
          )
        ),
        _this6.getAdminGrid()
      );
    } else {
      return React.createElement(
        'div',
        { className: 'App-administrator' },
        React.createElement(Spinner, { message: _this6.state.labels.messages.retrieving })
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? Administrator.propTypes = {
  session: PropTypes.object.isRequired
} : void 0;

Administrator.defaultProps = {};

export default Administrator;