var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Alert, Button, Col, ControlLabel, Glyphicon, Grid, Row, Table, Well } from 'react-bootstrap';
import ModalParaRowEditor from './ModalParaRowEditor';
import { get } from 'lodash';
import Spinner from './helpers/Spinner';
import server from './helpers/Server';
import MessageIcons from './helpers/MessageIcons';
import IdManager from './helpers/IdManager';
import ModalAgesServiceSelector from './modules/ModalAgesServiceSelector';
import ReactSelector from './modules/ReactSelector';
import User from "./classes/User";

/**
 *
 */
var AgesEditor = (_temp = _class = function (_React$Component) {
  _inherits(AgesEditor, _React$Component);

  function AgesEditor(props) {
    _classCallCheck(this, AgesEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, _this.state);

    _this.edit = _this.edit.bind(_this);
    _this.editable = _this.editable.bind(_this);
    _this.fetchAgesIndex = _this.fetchAgesIndex.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getAgesTableInfo = _this.getAgesTableInfo.bind(_this);
    _this.getAgesTableRow = _this.getAgesTableRow.bind(_this);
    _this.getModalEditor = _this.getModalEditor.bind(_this);
    _this.getSelectedService = _this.getSelectedService.bind(_this);
    _this.getServiceSelectorPanel = _this.getServiceSelectorPanel.bind(_this);
    _this.handleFetchAgesIndexCallback = _this.handleFetchAgesIndexCallback.bind(_this);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    _this.handleLibrarySelection = _this.handleLibrarySelection.bind(_this);
    _this.handleParaTextEditorClose = _this.handleParaTextEditorClose.bind(_this);
    _this.handleParaTextEditorSubmit = _this.handleParaTextEditorSubmit.bind(_this);
    _this.handleServiceSelection = _this.handleServiceSelection.bind(_this);
    _this.handleServiceSelectionClose = _this.handleServiceSelectionClose.bind(_this);
    _this.handleValueUpdateCallback = _this.handleValueUpdateCallback.bind(_this);
    _this.isTouchDevice = _this.isTouchDevice.bind(_this);
    //    this.renderTouchEdit = this.renderTouchEdit.bind(this);
    _this.renderHtml = _this.renderHtml.bind(_this);
    _this.setTable = _this.setTable.bind(_this);
    _this.showServiceSelector = _this.showServiceSelector.bind(_this);
    _this.updateTemplateValues = _this.updateTemplateValues.bind(_this);
    return _this;
  }

  // if we did not receive table values as a prop, fetch them


  /**
   * Does the user have permission to edit records in this library?
   * @param library
   * @returns {boolean}
   */


  // renderTouchEdit = (text) => {
  //   return (<span>{text} <Glyphicon glyph="pencil"/></span>);
  // };

  AgesEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App App-ParaColTextEditor' },
      React.createElement(
        Well,
        null,
        React.createElement(
          Grid,
          { className: 'App-Grid' },
          React.createElement(
            Row,
            { className: 'App-Selection-Row' },
            React.createElement(
              Col,
              { xs: 12, md: 12 },
              React.createElement(
                'h3',
                null,
                this.state.labels.thisClass.panelTitle
              )
            )
          ),
          React.createElement(
            Row,
            { className: 'App-Selection-Row' },
            React.createElement(
              Col,
              { xs: 12 },
              this.getServiceSelectorPanel()
            )
          ),
          React.createElement(
            Row,
            { className: 'App-Selection-Row' },
            React.createElement(
              Col,
              { xs: 12 },
              this.getSelectedService()
            )
          ),
          React.createElement(
            Row,
            { className: 'App-Selection-Row' },
            React.createElement(
              Col,
              { xs: 12, md: 12 },
              React.createElement(
                ControlLabel,
                null,
                this.state.labels.thisClass.selectLibrary
              ),
              React.createElement(ReactSelector, {
                initialValue: this.state.selectedLibrary,
                resources: this.state.session.userInfo.domains.author,
                changeHandler: this.handleLibrarySelection,
                multiSelect: false
              })
            )
          ),
          React.createElement(
            Row,
            { className: 'App-Selection-Row' },
            React.createElement(
              Col,
              { xs: 4, md: 4 },
              React.createElement(
                Button,
                {
                  bsStyle: 'primary',
                  onClick: this.fetchData,
                  disabled: !this.state.url
                },
                this.state.labels.thisClass.fetch
              )
            ),
            React.createElement(Col, { xs: 8, md: 8 })
          ),
          this.getAgesTableRow()
        )
      )
    );
  };

  return AgesEditor;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {
    _this2.fetchAgesIndex();
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var url = undefined;
    if (currentState && currentState.url) {
      url = currentState.url;
    }
    var serviceType = undefined;
    if (currentState && currentState.serviceType) {
      serviceType = currentState.serviceType;
    }
    var serviceDate = undefined;
    if (currentState && currentState.serviceDate) {
      serviceDate = currentState.serviceDate;
    }
    var serviceDow = undefined;
    if (currentState && currentState.serviceDow) {
      serviceDow = currentState.serviceDow;
    }
    var selectedService = undefined;
    if (currentState && currentState.selectedService) {
      selectedService = currentState.selectedService;
    }
    var agesIndexValues = [];
    var agesIndexFetched = false;
    if (currentState && currentState.agesIndexFetched) {
      agesIndexValues = currentState.agesIndexValues;
      agesIndexFetched = true;
    }
    var selectedLibrary = "";
    if (currentState && currentState.selectedLibrary) {
      selectedLibrary = currentState.selectedLibrary;
    }

    var userInfo = {};
    if (props.session && props.session.userInfo) {

      var adminDomains = [];
      var authorDomains = [];

      adminDomains = props.session.userInfo.domains["admin"].filter(function (domain) {
        if (domain.value.endsWith("_sys_linguistics")) {
          return domain;
        } else if (!domain.value.includes("_sys_")) {
          return domain;
        }
      });

      authorDomains = props.session.userInfo.domains["admin"].filter(function (domain) {
        if (domain.value.endsWith("_sys_linguistics")) {
          return domain;
        } else if (!domain.value.includes("_sys_")) {
          return domain;
        }
      });
      var domains = { admin: adminDomains, author: authorDomains };

      userInfo = new User(props.session.userInfo.username, props.session.userInfo.password, props.session.userInfo.domain, props.session.userInfo.email, props.session.userInfo.firstname, props.session.userInfo.lastname, props.session.userInfo.title, props.session.userInfo.authenticated, domains);
    }

    return {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.AgesEditor],
        messages: props.session.labels[props.session.labelTopics.messages],
        liturgicalAcronyms: props.session.labels[props.session.labelTopics.liturgicalAcronyms]
      },
      session: {
        userInfo: userInfo
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: props.session.labels[props.session.labelTopics.messages].initial,
      selectedLibrary: selectedLibrary,
      showModalEditor: false,
      selectedId: "",
      selectedTopicKey: "",
      renderedTable: undefined,
      showModalServiceSelector: false,
      url: url,
      serviceDate: serviceDate,
      serviceDow: serviceDow,
      serviceType: serviceType,
      selectedService: selectedService,
      agesIndexFetched: agesIndexFetched,
      agesIndexValues: agesIndexValues,
      fetchingData: false,
      iconCount: 0,
      topicKeyCount: get(_this2.state, "topicKeyCount", 0),
      middleBlockCompleteCount: get(_this2.state, "middleBlockCompleteCount", 0),
      percentComplete: get(_this2.state, "percentComplete", 0)
    };
  };

  this.isTouchDevice = function () {
    return 'ontouchstart' in document.documentElement;
  };

  this.fetchAgesIndex = function () {
    if (_this2.props.agesIndexValues) {
      _this2.setState({
        agesIndexFetched: true,
        agesIndexValues: _this2.props.agesIndexValues
      });
    } else {
      _this2.setState({
        message: _this2.state.labels.messages.retrieving
      }, server.getAgesIndex(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, _this2.handleFetchAgesIndexCallback));
    }
  };

  this.handleFetchAgesIndexCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      var values = restCallResult.data.values[0];
      if (values["tableData"]) {
        _this2.setState({
          agesIndexFetched: true,
          agesIndexValues: values["tableData"]
        });
      }
    }
  };

  this.fetchData = function () {
    var parms = "u=" + encodeURIComponent(_this2.state.url) + "&t=" + encodeURIComponent(_this2.state.selectedLibrary);

    _this2.setState({
      message: _this2.state.labels.messages.retrieving,
      fetchingData: true
    }, server.getAgesEditorTemplate(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, parms, _this2.handleFetchCallback));
  };

  this.handleFetchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      var data = restCallResult.data.values[0];
      var values = data.values;
      var topicKeys = data.topicKeys;
      var topicKeyCount = topicKeys.length;
      var topElement = data.topElement.children[0].children[0]; // tbody
      console.log(topElement);
      _this2.setState({
        dataFetched: true,
        fetchingData: false,
        values: values,
        topicKeys: topicKeys,
        topicKeyCount: topicKeyCount,
        topElement: topElement
      }, _this2.setTable);
    }
  };

  this.handleParaTextEditorClose = function () {
    _this2.setState({
      showModalEditor: false
    });
  };

  this.handleLibrarySelection = function (selection) {
    _this2.setState({
      selectedLibrary: selection["value"]
    });
  };

  this.handleParaTextEditorSubmit = function (value) {
    // only update if the value changed
    if (value !== _this2.state.values[_this2.state.selectedId]) {
      // update the value held client-side in memory
      var values = _this2.state.values;
      values[_this2.state.selectedId] = value;
      _this2.setState({
        changedText: value,
        values: values
      }, _this2.setTable);
    }
  };

  this.handleValueUpdateCallback = function (restCallResult) {
    if (restCallResult) {
      _this2.setState({
        message: restCallResult.message,
        messageIcon: restCallResult.messageIcon
      });
    }
  };

  this.editable = function (id) {
    var library = IdManager.getLibrary(id);
    var canEdit = false;
    for (var _iterator = _this2.state.session.userInfo.domains.author, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var entry = _ref;

      if (entry.value == library) {
        canEdit = true;
        break;
      }
    }
    return canEdit;
  };

  this.getModalEditor = function () {
    return React.createElement(ModalParaRowEditor, {
      session: _this2.props.session,
      editId: _this2.state.selectedId,
      value: _this2.state.selectedValue,
      showModal: _this2.state.showModalEditor,
      onClose: _this2.handleParaTextEditorClose,
      onSubmit: _this2.handleParaTextEditorSubmit,
      canChange: _this2.editable(_this2.state.selectedId)
    });
  };

  this.edit = function (id) {
    _this2.setState({
      showModalEditor: true,
      selectedId: id,
      selectedValue: _this2.state.values[id]
    });
  };

  this.setTable = function () {
    _this2.setState({
      renderedTable: _this2.renderHtml(_this2.state.topElement)
    });
  };

  this.updateTemplateValues = function () {
    if (_this2.state.changedText) {
      var values = _this2.state.values;
      values[_this2.state.selectedId] = _this2.state.changedText;
      _this2.setState({
        values: values
      }, _this2.setTable);
    }
  };

  this.renderHtml = function (element) {
    var props = {};
    var children = [];

    var tag = element.tag;

    if (element.key) {
      props["key"] = element.key;
    }
    if (element.className) {
      props["className"] = element.className + " ages-table-element";
    } else {
      if (tag === "table" || tag === "tbody" || tag === "tr") {
        props["className"] = "ages";
      }
    }
    if (element.dataKey) {
      props["data-key"] = element.dataKey;
      if (_this2.isTouchDevice()) {
        props["onClick"] = _this2.edit.bind(null, element.dataKey);
      } else {
        props["onDoubleClick"] = _this2.edit.bind(null, element.dataKey);
      }
      var value = _this2.state.values[element.dataKey];
      children.push(value);
    }
    if (element.topicKey) {
      props["data-topicKey"] = element.topicKey;
    }

    if (element.children) {
      for (var i = 0; i < element.children.length; i++) {
        children.push(_this2.renderHtml(element.children[i]));
      }
    }
    return React.createElement(tag, props, children);
  };

  this.showServiceSelector = function () {
    _this2.setState({
      showModalServiceSelector: true
    });
  };

  this.handleServiceSelection = function (url, serviceType, serviceDate, serviceDow) {
    var selectedService = serviceType;
    if (_this2.state.labels.liturgicalAcronyms[serviceType]) {
      selectedService = _this2.state.labels.liturgicalAcronyms[serviceType];
    }
    if (serviceDate != "any") {
      selectedService = selectedService + " " + serviceDate;
    }
    if (serviceDow != "any") {
      selectedService = selectedService + " " + serviceDow;
    }
    _this2.setState({
      showModalServiceSelector: false,
      url: url,
      serviceDate: serviceDate,
      serviceDow: serviceDow,
      serviceType: serviceType,
      selectedService: selectedService
    });
  };

  this.handleServiceSelectionClose = function () {
    _this2.setState({
      showModalServiceSelector: false
    });
  };

  this.getServiceSelectorPanel = function () {
    if (_this2.state.showModalServiceSelector) {
      return React.createElement(ModalAgesServiceSelector, {
        session: _this2.props.session,
        callBack: _this2.handleServiceSelection,
        onClose: _this2.handleServiceSelectionClose,
        values: _this2.state.agesIndexValues
      });
    } else {
      if (_this2.state.agesIndexFetched) {
        return React.createElement(
          Button,
          {
            bsStyle: 'primary',
            onClick: _this2.showServiceSelector
          },
          _this2.state.labels.thisClass.select
        );
      } else {
        return React.createElement(Spinner, { message: _this2.state.labels.messages.retrieving });
      }
    }
  };

  this.getAgesTableInfo = function () {
    if (_this2.state.dataFetched) {
      if (_this2.state.selectedLibrary) {
        return React.createElement(
          'div',
          null,
          React.createElement(
            Alert,
            { bsStyle: 'info' },
            React.createElement(
              'p',
              null,
              React.createElement(Glyphicon, { glyph: 'hand-right' }),
              _this2.state.labels.thisClass.msg2,
              _this2.state.url
            )
          ),
          React.createElement(
            Alert,
            { bsStyle: 'info' },
            React.createElement(
              'p',
              null,
              React.createElement(Glyphicon, { glyph: 'hand-right' }),
              _this2.state.labels.thisClass.agesGreek,
              _this2.state.labels.thisClass.yourTranslationA,
              _this2.state.selectedLibrary,
              _this2.state.labels.thisClass.yourTranslationB,
              _this2.state.labels.thisClass.agesEnglish,
              _this2.state.labels.thisClass.msg1
            )
          )
        );
      } else {
        return React.createElement(
          'div',
          null,
          React.createElement(
            Alert,
            { bsStyle: 'info' },
            React.createElement(
              'p',
              null,
              React.createElement(Glyphicon, { glyph: 'hand-right' }),
              _this2.state.labels.thisClass.msg2,
              _this2.state.url
            )
          ),
          React.createElement(
            Alert,
            { bsStyle: 'info' },
            React.createElement(
              'p',
              null,
              React.createElement(Glyphicon, { glyph: 'hand-right' }),
              _this2.state.labels.thisClass.agesGreek,
              _this2.state.labels.thisClass.agesEnglish,
              _this2.state.labels.thisClass.msg1
            )
          )
        );
      }
    } else {
      return React.createElement('div', null);
    }
  };

  this.getAgesTableRow = function () {
    if (_this2.state.fetchingData) {
      return React.createElement(Spinner, { message: _this2.state.labels.messages.retrieving });
    } else if (_this2.state.dataFetched) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Row,
          { className: 'App-Info-Row' },
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            _this2.getAgesTableInfo()
          )
        ),
        React.createElement(
          Row,
          { className: 'App App-Ages-Table-Row' },
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            _this2.state.dataFetched && React.createElement(
              'div',
              { className: 'ages-content' },
              React.createElement(
                Table,
                { responsive: true },
                _this2.state.renderedTable
              ),
              _this2.state.showModalEditor && _this2.getModalEditor()
            )
          )
        )
      );
    } else {
      return React.createElement('div', null);
    }
  };

  this.getSelectedService = function () {
    if (_this2.state.selectedService) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          ControlLabel,
          null,
          _this2.state.labels.thisClass.selected
        ),
        React.createElement(
          'span',
          null,
          _this2.state.selectedService
        )
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? AgesEditor.propTypes = {
  session: PropTypes.object.isRequired,
  agesIndexValues: PropTypes.array
} : void 0;

export default AgesEditor;