function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import FontAwesome from 'react-fontawesome';
import auth from './helpers/Auth';
import Form from "react-jsonschema-form";
import server from './helpers/Server';
import MessageIcons from './helpers/MessageIcons';

var ChangePassword = function (_React$Component) {
  _inherits(ChangePassword, _React$Component);

  function ChangePassword(props) {
    _classCallCheck(this, ChangePassword);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: {
          thisClass: nextProps.session.labels[nextProps.session.labelTopics.ChangePasswordPage]
        },
        message: nextProps.session.labels[nextProps.session.labelTopics.messages].initial
      });
    };

    _this.onSubmit = function (_ref) {
      var formData = _ref.formData;

      if (formData.password === formData.passwordReenter) {
        var config = {
          auth: {
            username: formData.username,
            password: formData.currentPassword
          }
        };
        var path = "users/password/" + formData.username;
        axios.put(_this.props.session.restServer + server.getWsServerAdminApi() + path, formData, config).then(function (response) {
          auth.setCredentials(formData.username, formData.password, true);
          _this.props.callback(response.status, true, formData.username, formData.password, response.data // domain, email, firstname, lastname, title
          );
          _this.setState({
            formData: formData,
            message: _this.state.labels.thisClass.changed,
            messageIcon: MessageIcons.getMessageIcons().info
          });
        }).catch(function (error) {
          _this.setState({ msg: error.message });
          _this.props.callback(error.message, false, formData.username, formData.password, undefined);
        });
      } else {
        _this.setState({
          formData: formData,
          message: _this.state.labels.thisClass.doNotMatch,
          messageIcon: MessageIcons.getMessageIcons().error
        });
      }
    };

    _this.state = {
      path: "",
      username: "",
      password: "",
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ChangePasswordPage]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: props.session.labels[props.session.labelTopics.messages].initial
    };
    return _this;
  }

  ChangePassword.prototype.fetchLoginForm = function fetchLoginForm() {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    axios.get(this.props.session.restServer + server.getWsServerPasswordChangeApi(), config).then(function (response) {
      if (response.data && response.data.valueSchemas) {
        var schemaInfo = response.data.valueSchemas["UserPasswordSelfChangeForm:1.1"];
        _this2.setState({
          data: response.data,
          schema: schemaInfo.schema,
          uiSchema: schemaInfo.uiSchema,
          formData: response.data.values[0].value,
          path: _this2.props.path
        });
      }
    }).catch(function (error) {
      _this2.setState({ data: error.message, path: _this2.props.path });
      _this2.props.callback(error.message, false, _this2.state.formData.username, _this2.state.formData.password);
    });
  };

  ChangePassword.prototype.render = function render() {
    if (this.state.path !== this.props.path) {
      this.fetchLoginForm();
    }
    if (this.state.data) {
      if (this.state.schema) {
        return React.createElement(
          'div',
          { className: 'App-login' },
          React.createElement(Form, { schema: this.state.schema,
            uiSchema: this.state.uiSchema,
            formData: this.state.formData,
            onSubmit: this.onSubmit
          }),
          React.createElement(
            'p',
            { className: 'App-login-msg' },
            React.createElement(FontAwesome, { name: this.state.messageIcon }),
            ' ',
            this.state.message
          )
        );
      } else {
        return React.createElement(
          'div',
          { className: 'App-login' },
          React.createElement(
            'p',
            null,
            this.props.path
          ),
          React.createElement(
            'pre',
            null,
            JSON.stringify(this.state.data, null, 2)
          )
        );
      }
    } else {
      return React.createElement(
        'div',
        { className: 'Resource' },
        React.createElement(
          'p',
          null,
          'Loading ',
          this.props.path,
          ' from ',
          this.root,
          '!'
        )
      );
    }
  };

  return ChangePassword;
}(React.Component);

process.env.NODE_ENV !== "production" ? ChangePassword.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func.isRequired,
  formPrompt: PropTypes.string.isRequired,
  formMsg: PropTypes.string.isRequired
} : void 0;
ChangePassword.defaultProps = {};

export default ChangePassword;