function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import server from './helpers/Server';
import { Alert } from 'react-bootstrap';
import versionNumbers from './helpers/VersionNumbers';

/**
 * Provides information about the running version.
 */

var Configuration = function (_React$Component) {
  _inherits(Configuration, _React$Component);

  function Configuration(props) {
    _classCallCheck(this, Configuration);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {
      _this.fetchData();
    };

    _this.state = {
      dataLoaded: false,
      dbServer: "",
      dbReadOnly: "",
      wsVersion: "",
      synchEnabled: false,
      synchDbConnectionOk: false
    };
    return _this;
  }

  Configuration.prototype.fetchData = function fetchData() {
    var _this2 = this;

    axios.get(this.props.restServer + server.getWsServerVersionApi()).then(function (response) {
      _this2.setState({
        dataLoaded: true,
        dbServerDomain: response.data.dbServerDomain,
        dbReadOnly: response.data.dbReadOnly,
        wsVersion: response.data.wsVersion,
        synchEnabled: response.data.synchEnabled,
        synchDbConnectionOk: response.data.synchDbConnectionOk
      });
    }).catch(function (error) {
      _this2.setState({ data: error.message });
    });
  };

  Configuration.prototype.render = function render() {
    if (this.state.dataLoaded) {
      return React.createElement(
        'div',
        { className: 'App-DomainSelector' },
        React.createElement(
          Alert,
          { bsStyle: 'info' },
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.appVersion,
            ' ',
            this.props.appVersion,
            '.'
          ),
          React.createElement(
            'p',
            null,
            'ioc-liturgical-react ',
            versionNumbers.getPackageNumber(),
            '.'
          ),
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.DbServer,
            ' ',
            this.state.dbServerDomain
          ),
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.RestServer,
            ' ',
            this.props.restServer
          ),
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.wsVersion,
            ' ',
            this.state.wsVersion
          ),
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.synchEnabled,
            ' ',
            this.state.synchEnabled
          ),
          React.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.synchDbConnectionOk,
            ' ',
            this.state.synchDbConnectionOkLabel
          )
        )
      );
    } else {
      return React.createElement(
        'div',
        { className: 'Resource' },
        React.createElement(
          'p',
          null,
          'Loading information...'
        )
      );
    }
  };

  return Configuration;
}(React.Component);

process.env.NODE_ENV !== "production" ? Configuration.propTypes = {
  session: PropTypes.object.isRequired,
  appVersion: PropTypes.string.isRequired,
  restServer: PropTypes.string.isRequired
} : void 0;

Configuration.defaultProps = {};

export default Configuration;