var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { get } from 'lodash';
import { Button, ControlLabel, FormControl } from 'react-bootstrap';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import Server from "./helpers/Server";
import MessageIcons from './helpers/MessageIcons';
import FontAwesome from 'react-fontawesome';
import axios from "axios/index";

export var DomainLister = (_temp = _class = function (_React$Component) {
  _inherits(DomainLister, _React$Component);

  function DomainLister(props) {
    _classCallCheck(this, DomainLister);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.editable = _this.editable.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getAddButton = _this.getAddButton.bind(_this);
    _this.getModalNewEntryForm = _this.getModalNewEntryForm.bind(_this);
    _this.getTable = _this.getTable.bind(_this);
    _this.handleAddButtonClick = _this.handleAddButtonClick.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    _this.notEditable = _this.notEditable.bind(_this);
    _this.onAfterSaveCell = _this.onAfterSaveCell.bind(_this);
    _this.onBeforeSaveCell = _this.onBeforeSaveCell.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.putUpdate = _this.putUpdate.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  /**
   *
   * @param row - returns the entire row including nbr, topicKey, etc.
   * @param cellName - the column title, i.e. the library
   * @param cellValue - the text value entered
   */


  DomainLister.prototype.putUpdate = function putUpdate() {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    var row = this.state.data[this.state.updateIndex];
    var id = row.domain;
    var path = "misc/domains/" + id;
    var message = "";
    axios.put(this.props.session.restServer + Server.getWsServerAdminApi() + path, this.state.data[this.state.updateIndex], config).then(function (response) {
      message = "updated " + path;
      _this2.setState({
        message: message
      });
      _this2.setState({ centerDivVisible: true });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = MessageIcons.getMessageIcons().error;
      _this2.setState({ message: message, messageIcon: messageIcon });
    });
  };

  DomainLister.prototype.fetchData = function fetchData() {
    if (this.props.session && this.props.session.userInfo) {
      this.setState({
        message: this.state.labels.search.msg2,
        messageIcon: MessageIcons.getMessageIcons().info,
        showSearchResults: false
      });

      Server.getCollectiveDomains(this.props.session.restServer, this.props.session.userInfo.username, this.props.session.userInfo.password, this.handleSearchCallback);
    }
  };

  DomainLister.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  /**
   * Does the user have permission to edit records in this library?
   * @param library
   * @returns {boolean}
   */


  DomainLister.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-page App-search' },
      React.createElement(
        'h3',
        null,
        this.state.labels.thisClass.title
      ),
      React.createElement(
        'div',
        null,
        this.state.labels.search.resultLabel,
        ': ',
        React.createElement(
          'span',
          { className: 'App App-message' },
          React.createElement(FontAwesome, { name: this.state.messageIcon }),
          this.state.message,
          ' ',
          this.getAddButton()
        )
      ),
      this.state.showSearchResults && React.createElement(
        ControlLabel,
        null,
        this.state.labels.thisClass.howto
      ),
      this.state.showModalAdd && this.getModalNewEntryForm(),
      this.state.showSearchResults && React.createElement(
        'div',
        { className: 'App-search-results' },
        React.createElement(
          'div',
          { className: 'row' },
          this.getTable()
        )
      )
    );
  };

  return DomainLister;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentDidMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this3.setState(_this3.setTheState(nextProps, _this3.state), _this3.fetchData);
  };

  this.setTheState = function (props, currentState) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.SearchGeneric];
    var messageIcon = MessageIcons.getMessageIcons().info;

    var clickType = "dbclick";
    try {
      if (window.innerWidth < 800) {
        clickType = "click";
      }
    } catch (err) {
      clickType = "dbclick";
    }

    return {
      labels: {
        thisClass: labels[labelTopics.DomainLister],
        search: theSearchLabels
      },
      message: theSearchLabels.msg1,
      messageIcon: get(currentState, "messageIcon", messageIcon),
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      resultCount: 0,
      data: get(currentState, "data", { values: [{ "id": "", "languageCode": "", "countryCode:": "", "realm:": "", "description:": "" }] }),
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this3.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      filter: { type: 'RegexFilter', delay: 100 },
      cellEditProp: {
        mode: clickType,
        beforeSaveCell: _this3.onBeforeSaveCell,
        afterSaveCell: _this3.onAfterSaveCell,
        nonEditableRows: _this3.notEditable,
        blurToEscape: true
      },
      showSelectionButtons: false,
      selectedCode: get(currentState, "selectedCode", ""),
      selectedValue: get(currentState, "selectedValue", ""),
      selectedCountryCode: get(currentState, "selectedCountryCode", ""),
      selectedCountryValue: get(currentState, "selectedCountryValue", ""),
      showModalEditor: false,
      idColumnSize: "80px",
      updateIndex: get(currentState, "updateIndex", 0)
    };
  };

  this.notEditable = function () {
    return _this3.state.data.filter(function (d) {
      return !_this3.props.session.userInfo.isAuthorFor(d.domain);
    }).map(function (d) {
      return d.domain;
    });
  };

  this.onBeforeSaveCell = function (row, cellName, cellValue) {};

  this.onAfterSaveCell = function (row, cellName, cellValue) {
    var index = row.nbr;
    var dataRow = row;
    dataRow.description = cellValue;
    // update the local array with the new value
    var data = _this3.state.data;
    data[index] = dataRow;
    _this3.setState({
      data: data,
      updateIndex: index
    }, _this3.putUpdate);
  };

  this.handleAddButtonClick = function () {
    _this3.setState({ showModalAdd: true });
  };

  this.handleSearchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      _this3.setState({
        data: restCallResult.data.values
      });
      var resultCount = 0;
      var message = _this3.state.labels.search.foundNone;
      var found = _this3.state.labels.search.foundMany;
      if (restCallResult.data.valueCount) {
        resultCount = restCallResult.data.valueCount;
        if (resultCount === 0) {
          message = _this3.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this3.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this3.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: MessageIcons.getMessageIcons().info,
        showSearchResults: true
      });
    }
  };

  this.getAddButton = function () {
    return React.createElement(
      Button,
      {
        className: 'Text-Note-Add-Button',
        bsStyle: 'primary',
        bsSize: "xsmall",
        onClick: _this3.handleAddButtonClick },
      React.createElement(FontAwesome, {
        className: 'App-Add-ico',
        name: 'plus' })
    );
  };

  this.getModalNewEntryForm = function () {};

  this.handleRowSelect = function (row, isSelected, e) {
    _this3.setState({
      selectedCode: row["id"]
    }, _this3.handleCallback);
  };

  this.handleCallback = function () {
    if (_this3.props.callBack) {
      _this3.props.callBack(_this3.state.selectedCode);
    }
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this3.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.getTable = function () {
    return React.createElement(
      BootstrapTable,
      {
        ref: 'theTable',
        data: _this3.state.data,
        exportCSV: false,
        trClassName: "App-data-tr",
        striped: true,
        hover: true,
        pagination: true,
        options: _this3.state.options,
        cellEdit: _this3.state.cellEditProp
      },
      React.createElement(
        TableHeaderColumn,
        {
          ref: 'domain',
          isKey: true,
          dataField: 'domain',
          dataSort: true,
          'export': true,
          hidden: true
        },
        'ID'
      ),
      React.createElement(
        TableHeaderColumn,
        {
          ref: 'languageCode',
          dataField: 'languageCode',
          dataSort: true,
          filter: _this3.state.filter,
          width: "10%",
          editable: false
        },
        _this3.state.labels.thisClass.languageCode
      ),
      React.createElement(
        TableHeaderColumn,
        {
          ref: 'countryCode',
          dataField: 'countryCode',
          dataSort: true,
          filter: _this3.state.filter,
          width: "10%",
          editable: false
        },
        _this3.state.labels.thisClass.countryCode
      ),
      React.createElement(
        TableHeaderColumn,
        {
          ref: 'realm',
          dataField: 'realm',
          dataSort: true,
          filter: _this3.state.filter,
          width: "15%",
          editable: false
        },
        _this3.state.labels.thisClass.realm
      ),
      React.createElement(
        TableHeaderColumn,
        {
          ref: 'description',
          dataField: 'description',
          dataFormat: _this3.cellEditFormat,
          dataSort: true,
          filter: _this3.state.filter,
          editable: { type: 'textarea' }
        },
        _this3.state.labels.thisClass.description
      )
    );
  };

  this.editable = function (library) {
    return { type: 'textarea' };
  };
}, _temp);

process.env.NODE_ENV !== "production" ? DomainLister.propTypes = {
  session: PropTypes.object.isRequired,
  callBack: PropTypes.func
} : void 0;

DomainLister.defaultProps = {};

export default DomainLister;