function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import server from './helpers/Server';
import { DropdownButton, MenuItem } from 'react-bootstrap';

var DomainSelector = function (_React$Component) {
  _inherits(DomainSelector, _React$Component);

  function DomainSelector(props) {
    _classCallCheck(this, DomainSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentDidMount = function () {
      _this.fetchData();
    };

    _this.onSelect = function (index) {
      var item = _this.state.items[index];
      var idParts = item.value.split("|");
      var domain = item.value;
      if (idParts.length === 3) {
        domain = idParts[2];
      }
      _this.props.callback(domain, item.label);
    };

    _this.getMenuItems = function (items) {
      var itemsList = items.map(function (item, index) {
        var domain = item.value;
        var idParts = item.value.split("_");
        if (idParts.length === 3) {
          domain = idParts[2];
        }
        return React.createElement(
          MenuItem,
          { key: domain, eventKey: index },
          item.value + ": " + item.label
        );
      });
      return itemsList;
    };

    _this.state = {
      serverNotCalled: true
    };
    _this.getMenuItems = _this.getMenuItems.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  DomainSelector.prototype.domainObjectsToStringArray = function domainObjectsToStringArray(domains) {
    var values = domains.values;
  };

  DomainSelector.prototype.fetchData = function fetchData() {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    this.setState({ serverNotCalled: false });
    axios.get(this.props.session.restServer + server.getDbServerDropdownsSearchTextApi(), config).then(function (response) {
      _this2.setState({ items: response.data.values[0].domains });
    }).catch(function (error) {
      _this2.setState({ data: error.message });
      _this2.props.callback(error.message, "");
    });
  };

  DomainSelector.prototype.render = function render() {
    if (this.state.items) {
      return React.createElement(
        'div',
        { className: 'App-DomainSelector' },
        React.createElement(
          'h3',
          { className: 'App-DomainSelector-prompt' },
          this.props.formPrompt
        ),
        React.createElement(
          DropdownButton,
          {
            bsStyle: this.props.style,
            bsSize: this.props.size,
            title: this.props.title,
            id: this.props.id,
            onSelect: this.onSelect
          },
          this.getMenuItems(this.state.items)
        )
      );
    } else {
      return React.createElement(
        'div',
        { className: 'Resource' },
        React.createElement(
          'p',
          null,
          'Loading domains!'
        )
      );
    }
  };

  return DomainSelector;
}(React.Component);

process.env.NODE_ENV !== "production" ? DomainSelector.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func.isRequired,
  id: PropTypes.string.isRequired,
  title: PropTypes.string.isRequired,
  size: PropTypes.string,
  style: PropTypes.string,
  filterLanguage: PropTypes.string,
  publicOnly: PropTypes.bool
} : void 0;

DomainSelector.defaultProps = {
  size: "small",
  style: "primary",
  filterLanguage: "",
  publicOnly: true
};

export default DomainSelector;