function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Accordion, Panel } from 'react-bootstrap';

import DocIds from './modules/docs/DocIds';
import DocProps from './modules/docs/DocProps';
import DocComparison from './modules/docs/DocComparison';
import DocSearchTypes from './modules/docs/DocSearchTypes';
import DocSimpleSearch from './modules/docs/DocSimpleSearch';
import DocSearchResults from './modules/docs/DocSearchResults';
import DocSearchAdvanced from './modules/docs/DocSearchAdvanced';
import DocRegEx from './modules/docs/DocSearchRegularExpressions';

var HelpSearch = function (_React$Component) {
  _inherits(HelpSearch, _React$Component);

  function HelpSearch(props) {
    _classCallCheck(this, HelpSearch);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: nextProps.session.labels[nextProps.session.labelTopics.help]
      });
    };

    _this.state = {
      labels: props.session.labels[props.session.labelTopics.help]
    };
    return _this;
  }

  HelpSearch.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-page App-help' },
      React.createElement(
        'h2',
        null,
        this.state.labels.searchPageTitle
      ),
      React.createElement(
        'div',
        { className: 'jumbotron' },
        React.createElement(
          'p',
          null,
          this.state.labels.searchPara01
        ),
        React.createElement(
          'p',
          null,
          this.state.labels.searchPara02
        ),
        React.createElement(
          'p',
          null,
          this.state.labels.searchPara03
        ),
        React.createElement(
          Accordion,
          null,
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecDocIds, eventKey: '1' },
            React.createElement(DocIds, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecDocProps, eventKey: '2' },
            React.createElement(DocProps, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecDocSearchTypes, eventKey: '3' },
            React.createElement(DocSearchTypes, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecSimpleSearch, eventKey: '4' },
            React.createElement(DocSimpleSearch, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecSearchResults, eventKey: '6' },
            React.createElement(DocSearchResults, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecDocVersionComparisonTitle, eventKey: '5' },
            React.createElement(DocComparison, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecAdvancedSearch, eventKey: '7' },
            React.createElement(DocSearchAdvanced, { session: this.props.session })
          ),
          React.createElement(
            Panel,
            { header: this.state.labels.searchSecDocRegExSearch, eventKey: '8' },
            React.createElement(DocRegEx, { session: this.props.session })
          )
        )
      )
    );
  };

  return HelpSearch;
}(React.Component);

process.env.NODE_ENV !== "production" ? HelpSearch.propTypes = {
  session: PropTypes.object.isRequired
} : void 0;

HelpSearch.defaultProps = {};

export default HelpSearch;