function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import server from './helpers/Server';
import { ControlLabel, DropdownButton, FormGroup, MenuItem } from 'react-bootstrap';
import DatePicker from 'react-bootstrap-date-picker';
import Form from 'react-jsonschema-form';
import ResponseParser from './helpers/ResponseParser';

var LiturgicalDayProperties = function (_React$Component) {
  _inherits(LiturgicalDayProperties, _React$Component);

  function LiturgicalDayProperties(props) {
    _classCallCheck(this, LiturgicalDayProperties);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: nextProps.session.labels[nextProps.session.labelTopics.ldp]
      });
    };

    _this.componentWillMount = function () {
      var value = new Date().toISOString();
      _this.setState({
        value: value // ISO String, ex: "2016-11-19T12:00:00.000Z"
      });
    };

    _this.handleChange = function (value, formattedValue) {
      _this.setState({
        value: value, // ISO String, ex: "2016-11-19T12:00:00.000Z"
        formattedValue: formattedValue // Formatted String, ex: "11/19/2016"
      }, _this.fetchData(value));
    };

    _this.onSelect = function (index) {
      _this.setState({
        selectedType: index
      });
    };

    _this.state = {
      selectedType: "g",
      labels: props.session.labels[props.session.labelTopics.ldp]
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  LiturgicalDayProperties.prototype.fetchData = function fetchData(date) {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    var parms = "?t=" + encodeURIComponent(this.state.selectedType) + "&d=" + encodeURIComponent(date);
    axios.get(this.props.session.restServer + server.getWsServerLiturgicalDayPropertiesApi() + parms, config).then(function (response) {
      ResponseParser.setItem(response.data);
      _this2.setState({
        item: ResponseParser.getItemObject()
      });
    }).catch(function (error) {
      _this2.setState({ data: error.message });
      _this2.props.callback(error.message, "");
    });
  };

  LiturgicalDayProperties.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-DateSelector' },
      React.createElement(
        'h3',
        { className: 'App-DateSelector-prompt' },
        this.props.formPrompt
      ),
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.prompt
        ),
        React.createElement('p', null),
        React.createElement(
          DropdownButton,
          {
            bsStyle: 'primary',
            title: this.state.labels.calendar,
            key: "a",
            id: 'App-DateSelector-calendar-type',
            onSelect: this.onSelect
          },
          React.createElement(
            MenuItem,
            { eventKey: 'j' },
            this.state.labels.julian
          ),
          React.createElement(
            MenuItem,
            { eventKey: 'g' },
            this.state.labels.gregorian
          )
        ),
        React.createElement('p', null),
        React.createElement(DatePicker, {
          id: 'app-datepicker',
          value: this.state.value,
          onChange: this.handleChange
        })
      ),
      this.state.item ? React.createElement(Form, {
        schema: this.state.item.schema,
        uiSchema: this.state.item.uiSchema,
        formData: this.state.item.value,
        onSubmit: this.onSubmit }) : React.createElement('div', null)
    );
  };

  return LiturgicalDayProperties;
}(React.Component);

process.env.NODE_ENV !== "production" ? LiturgicalDayProperties.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func.isRequired
} : void 0;

LiturgicalDayProperties.defaultProps = {};

export default LiturgicalDayProperties;