function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import auth from './helpers/Auth';
import Form from "react-jsonschema-form";
import server from './helpers/Server';

var Login = function (_React$Component) {
  _inherits(Login, _React$Component);

  function Login(props) {
    _classCallCheck(this, Login);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.onSubmit = function (_ref) {
      var formData = _ref.formData;

      var config = {
        auth: {
          username: formData.username,
          password: formData.password
        }
      };
      axios.get(_this.props.restServer + server.getWsServerLoginUserApi(), config).then(function (response) {
        auth.setCredentials(formData.username, formData.password, true);
        _this.props.loginCallback(response.status, true, formData.username, formData.password, response.data.values // [0] = domain, email, firstname, lastname, title, and [1] = prefs
        );
        var parms = "l=" + encodeURIComponent(_this.props.location);

        server.getResources(_this.props.restServer, formData.username, formData.password, parms, _this.props.dropdownsCallback);
      }).catch(function (error) {
        auth.setCredentials(formData.username, formData.password, false);
        // important -- leave this here. There are errors thrown
        // by other components that get caught here for some reason.
        console.log("caught login error");
        console.log(error);
        _this.props.loginCallback(error.message, false, formData.username, formData.password, undefined);
      });
    };

    _this.state = {
      path: "",
      username: "",
      password: ""
    };
    return _this;
  }

  Login.prototype.fetchResources = function fetchResources() {};

  Login.prototype.fetchLoginForm = function fetchLoginForm() {
    var _this2 = this;

    axios.get(this.props.restServer + server.getWsServerLoginApi()).then(function (response) {
      _this2.setState({ data: response.data, path: _this2.props.path });
    }).catch(function (error) {
      _this2.setState({ data: error.message, path: _this2.props.path });
      _this2.props.loginCallback(error.message, false, _this2.state.formData.username, _this2.state.formData.password);
    });
  };

  Login.prototype.render = function render() {
    if (this.state.path !== this.props.path) {
      this.fetchLoginForm();
    }
    if (this.state.data) {
      if (this.state.data.schema) {
        var formData = { username: this.props.username, password: this.props.password };
        return React.createElement(
          'div',
          { className: 'App-login' },
          React.createElement(
            'h3',
            { className: 'App-login-prompt' },
            this.props.formPrompt
          ),
          React.createElement(Form, { schema: this.state.data.schema,
            uiSchema: this.state.data.uiSchema,
            formData: formData,
            onSubmit: this.onSubmit
          }),
          React.createElement(
            'p',
            { className: 'App-login-msg' },
            this.props.formMsg
          )
        );
      } else {
        return React.createElement(
          'div',
          { className: 'App-login' },
          React.createElement(
            'p',
            null,
            this.props.path
          ),
          React.createElement(
            'pre',
            null,
            JSON.stringify(this.state.data, null, 2)
          )
        );
      }
    } else {
      return React.createElement(
        'div',
        { className: 'Resource' },
        React.createElement(
          'p',
          null,
          'Loading ',
          this.props.path,
          ' from ',
          this.root,
          '!'
        )
      );
    }
  };

  return Login;
}(React.Component);

process.env.NODE_ENV !== "production" ? Login.propTypes = {
  restServer: PropTypes.string.isRequired,
  username: PropTypes.string.isRequired,
  password: PropTypes.string.isRequired,
  loginCallback: PropTypes.func.isRequired,
  dropdownsCallback: PropTypes.func.isRequired,
  formPrompt: PropTypes.string.isRequired,
  formMsg: PropTypes.string.isRequired,
  location: PropTypes.string
} : void 0;
Login.defaultProps = {
  location: "unknown|unknown|unknown|unknown|unknown"
};

export default Login;