function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Alert, Button, Glyphicon, Modal } from 'react-bootstrap';

import IdManager from './helpers/IdManager';
import MessageIcons from './helpers/MessageIcons';
import ParaRowTextEditor from './ParaRowTextEditor';
/**
 * Display the ParaRowEditor as a modal window.
 */
export var ModalParaRowEditor = function (_React$Component) {
  _inherits(ModalParaRowEditor, _React$Component);

  function ModalParaRowEditor(props) {
    _classCallCheck(this, ModalParaRowEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {
      if (_this.props.session.languageCode !== nextProps.session.languageCode) {
        _this.setState(function (prevState, props) {
          return {
            labels: {
              thisClass: nextProps.session.labels[nextProps.session.labelTopics.ModalParaRowEditor],
              messages: nextProps.session.labels[nextProps.session.labelTopics.messages],
              resultsTableLabels: nextProps.session.labels[nextProps.session.labelTopics.resultsTable]
            },
            message: nextProps.session.labels[nextProps.session.labelTopics.messages].initial
          };
        }, function () {
          return this.handleStateChange("place holder");
        });
      }
    };

    _this.handleStateChange = function (parm) {
      // call a function is needed, e.g. if you need to call the rest server again
    };

    _this.onSubmit = function (value) {
      _this.props.onSubmit(value);
    };

    _this.getModalInfo = function () {
      if (_this.props.canChange) {
        return React.createElement(
          Alert,
          { bsStyle: 'info' },
          React.createElement(
            'p',
            null,
            React.createElement(Glyphicon, { glyph: 'hand-right' }),
            _this.state.labels.thisClass.msg1
          )
        );
      } else {
        return React.createElement(
          Alert,
          { bsStyle: 'warning' },
          React.createElement(
            'p',
            null,
            React.createElement(Glyphicon, { glyph: 'hand-right' }),
            _this.state.labels.thisClass.msg2
          )
        );
      }
    };

    _this.state = {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ModalParaRowEditor],
        messages: props.session.labels[props.session.labelTopics.messages],
        resultsTableLabels: props.session.labels[props.session.labelTopics.resultsTable]
      },
      message: props.session.labels[props.session.labelTopics.messages].initial,
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      showModal: _this.props.showModal,
      topic: IdManager.getTopic(_this.props.editId),
      key: IdManager.getKey(_this.props.editId),
      valuesSame: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.getModalInfo = _this.getModalInfo.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  ModalParaRowEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSeq);
  };

  ModalParaRowEditor.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalParaRowEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        { backdrop: "static", dialogClassName: 'App-Modal-Para-Row-Editor', show: this.state.showModal, onHide: this.close },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          this.getModalInfo(),
          React.createElement(ParaRowTextEditor, {
            session: this.props.session,
            docType: 'Liturgical',
            idLibrary: IdManager.getLibrary(this.props.editId),
            idTopic: IdManager.getTopic(this.props.editId),
            idKey: IdManager.getKey(this.props.editId),
            value: this.props.value,
            onSubmit: this.onSubmit,
            canChange: this.props.canChange
          })
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            {
              onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalParaRowEditor;
}(React.Component);
process.env.NODE_ENV !== "production" ? ModalParaRowEditor.propTypes = {
  session: PropTypes.object.isRequired,
  onClose: PropTypes.func.isRequired,
  onSubmit: PropTypes.func.isRequired,
  showModal: PropTypes.bool.isRequired,
  editId: PropTypes.string.isRequired,
  value: PropTypes.string.isRequired,
  canChange: PropTypes.bool.isRequired
} : void 0;
export default ModalParaRowEditor;