var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import 'react-select/dist/react-select.css';
import ResourceSelector from './modules/ReactSelector';
import TemplateNodeInitializer from './classes/TemplateNodeInitializer';
import UiSchemas from './classes/UiSchemas';
import IdManager from './helpers/IdManager';
import server from './helpers/Server';
import IdBuilder from './modules/IdBuilder';
import NewEntryForm from './modules/NewEntryForm';
import ParaRowTextEditor from './ParaRowTextEditor';
import { Panel, Well } from 'react-bootstrap';

/**
 * This allows addition of a new entry. The forms are only 'pure ontology'
 * and are hard coded. They should use the web service dropdown
 * this.state.session.uiSchemas.formsDropdown
 */
export var NewEntry = (_temp = _class = function (_React$Component) {
  _inherits(NewEntry, _React$Component);

  function NewEntry(props) {
    _classCallCheck(this, NewEntry);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var formsDropdown = [{ label: "Animal", value: "AnimalCreateForm:1.1" }, { label: "Being", value: "BeingCreateForm:1.1"
      //      ,{label: "Biblical Text (Source)", value: "TextBiblicalSourceCreateForm:1.1"}
      //      ,{label: "Biblical Text (Translation)", value: "TextBiblicalTranslationCreateForm:1.1"}
    }, { label: "Concept", value: "ConceptCreateForm:1.1"
      //      ,{label: "Concordance Line", value: "ConcordanceLine:1.1"}
    }, { label: "Event", value: "EventCreateForm:1.1" }, { label: "Group", value: "GroupCreateForm:1.1" }, { label: "Human", value: "HumanCreateForm:1.1"
      //     ,{label: "Liturgical Text (Source)", value: "TextLiturgicalSourceCreateForm:1.1"}
      //      ,{label: "Liturgical Text (Translation)", value: "TextLiturgicalTranslationCreateForm:1.1"}
    }, { label: "Mystery", value: "MysteryCreateForm:1.1" }, { label: "Object", value: "ObjectCreateForm:1.1" }, { label: "Place", value: "PlaceCreateForm:1.1" }, { label: "Plant", value: "PlantCreateForm:1.1"
      //      ,{label: "Reference to Animal", value: "LinkRefersToAnimalCreateForm:1.1"}
      //      ,{label: "Reference to Being", value: "LinkRefersToBeingCreateForm:1.1"}
      //      ,{label: "Reference to Biblical Text", value: "LinkRefersToBiblicalTextCreateForm:1.1"}
      //      ,{label: "Reference to Concept", value: "LinkRefersToConceptCreateForm:1.1"}
      //      ,{label: "Reference to Event", value: "LinkRefersToEventCreateForm:1.1"}
      //      ,{label: "Reference to God", value: "LinkRefersToGodCreateForm:1.1"}
      //      ,{label: "Reference to Group", value: "LinkRefersToGroupCreateForm:1.1"}
      //      ,{label: "Reference to Human", value: "LinkRefersToHumanCreateForm:1.1"}
      //      ,{label: "Reference to Mystery", value: "LinkRefersToMysteryCreateForm:1.1"}
      //      ,{label: "Reference to Object", value: "LinkRefersToObjectCreateForm:1.1"}
      //      ,{label: "Reference to Place", value: "LinkRefersToPlaceCreateForm:1.1"}
      //      ,{label: "Reference to Plant", value: "LinkRefersToPlantCreateForm:1.1"}
      //      ,{label: "Reference to Role", value: "LinkRefersToRoleCreateForm:1.1"}
    }, { label: "Role", value: "RoleCreateForm:1.1"
      //      ,{label: "Section", value: "Section:1.1"}
      //      ,{label: "Template", value: "Template:1.1"}
      //      ,{label: "Text Note ", value: "TextualNote:1.1"}
      //      ,{label: "Tree Node", value: "TokenAnalysisCreateForm:1.1"}
      //      ,{label: "User Note (Private)", value: "UserNoteCreateForm:1.1"}
      //      ,{label: "Word Analysis", value: "WordAnalysis:1.1"}
    }];

    var uiSchemas = {};
    if (props.session && props.session.uiSchemas) {
      uiSchemas = new UiSchemas(props.session.uiSchemas.formsDropdown, props.session.uiSchemas.formsSchemas, props.session.uiSchemas.forms);
    }
    var labels = props.session.labels;
    var topics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[topics.NewEntry],
        search: labels[topics.search],
        paraRowEditor: labels[topics.ParaTextEditor]
      },
      session: {
        uiSchemas: uiSchemas
      },
      formsDropdown: formsDropdown,
      idBuilt: false,
      message: labels[topics.search].msg1,
      messageIcon: _this.messageIcons.info,
      formSelected: false,
      selectedForm: "",
      initialOntologyType: "Human",
      isUserNoteForm: false,
      isReferenceForm: false,
      isTranslationForm: false,
      translationDocType: "Liturgical",
      IdLibrary: "",
      LibraryReadOnly: false,
      IdTopic: "",
      IdTopicValue: "",
      IdTopicType: "",
      IdTopicParts: {
        library: "",
        topic: "",
        key: ""
      },
      IdKey: "",
      IdKeyValue: "",
      IdKeyType: "",
      IdSeq: "",
      selected: {
        schema: {},
        uiSchema: {},
        form: {},
        path: server.getDbServerDocsApi()
      },
      panel: {
        idBuilderOpen: true,
        paraTextOpen: false,
        formOpen: false
      },
      translationValue: "",
      workflow: {
        userRolesForLibrary: {
          admins: [],
          authors: [],
          readers: [],
          reviewers: []
        },
        statusDropdown: [],
        isPublic: false,
        stateEnabled: false,
        workflowEnabled: false,
        defaultStatusAfterEdit: "FINALIZED",
        defaultStatusAfterFinalization: "FINALIZED"
      }
    };
    _this.handleFormSelection = _this.handleFormSelection.bind(_this);
    _this.handleIdSelection = _this.handleIdSelection.bind(_this);
    _this.handleIdLibrarySelection = _this.handleIdLibrarySelection.bind(_this);
    _this.handleIdTopicSelection = _this.handleIdTopicSelection.bind(_this);
    _this.toogleIdBuilderPanel = _this.toogleIdBuilderPanel.bind(_this);
    _this.toogleParaTextPanel = _this.toogleParaTextPanel.bind(_this);
    _this.handleParallelTextEditorCallback = _this.handleParallelTextEditorCallback.bind(_this);
    _this.handleParallelTextEditorSubmit = _this.handleParallelTextEditorSubmit.bind(_this);
    _this.handleWorkflowAssignmentCallback = _this.handleWorkflowAssignmentCallback.bind(_this);
    _this.toogleFormPanel = _this.toogleFormPanel.bind(_this);
    _this.setLibraryWorkflowInfo = _this.setLibraryWorkflowInfo.bind(_this);
    _this.handleStatusChange = _this.handleStatusChange.bind(_this);
    return _this;
  }

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  /**
   * TODO:
   * add code to set the form users to those
   * for the role selected in the form.
   */


  // placeholder in case want to do something with the formData


  // in the ResourceSelector, use this to get all forms:
  //               resources={this.state.session.uiSchemas.formsDropdown}

  NewEntry.prototype.render = function render() {

    return React.createElement(
      'div',
      { className: 'App-new-entry' },
      React.createElement(
        Well,
        null,
        React.createElement(ResourceSelector, {
          title: this.state.labels.thisClass.formSelector,
          initialValue: this.state.selectedForm,
          resources: this.state.formsDropdown,
          changeHandler: this.handleFormSelection,
          multiSelect: false
        })
      ),
      this.state.formSelected ? React.createElement(
        Well,
        null,
        React.createElement(
          Panel,
          {
            header: this.state.labels.search.IdParts.title,
            eventKey: 'id-parts-builder',
            expanded: this.state.panel.idBuilderOpen,
            onSelect: this.toogleIdBuilderPanel,
            collapsible: true
          },
          React.createElement(IdBuilder, {
            session: this.props.session,
            IdLibrary: this.state.IdLibrary,
            IdTopic: this.state.IdTopic,
            IdTopicValue: this.state.IdTopicValue,
            IdTopicType: this.state.IdTopicType,
            IdKey: this.state.IdKey,
            IdKeyValue: this.state.IdKeyValue,
            IdKeyType: this.state.IdKeyType,
            handleLibraryChange: this.handleIdLibrarySelection,
            handleTopicChange: this.handleIdTopicSelection,
            handleSubmit: this.handleIdSelection,
            initialOntologyType: this.state.initialOntologyType
          })
        )
      ) : React.createElement('div', null),
      this.state.formSelected ? React.createElement(
        Well,
        null,
        this.state.idBuilt && (this.state.isTranslationForm || this.state.isReferenceForm) && React.createElement(
          Panel,
          {
            header: this.state.labels.paraRowEditor.panelTitle,
            eventKey: 'para-text-panel',
            expanded: this.state.panel.paraTextOpen,
            onSelect: this.toogleParaTextPanel,
            collapsible: true
          },
          React.createElement(ParaRowTextEditor, {
            session: this.props.session,
            canChange: false,
            docType: this.state.translationDocType,
            idLibrary: this.state.IdLibrary,
            idTopic: this.state.isReferenceForm ? this.state.IdTopicParts.topic : this.state.IdTopic,
            idKey: this.state.isReferenceForm ? this.state.IdTopicParts.key : this.state.IdKey,
            value: this.state.translationValue,
            onSubmit: this.state.isReferenceForm ? undefined : this.handleParallelTextEditorSubmit,
            onChange: this.state.isReferenceForm ? undefined : this.handleParallelTextEditorCallback,
            message: this.state.isReferenceForm ? undefined : this.state.message,
            messageIcon: this.state.isReferenceForm ? undefined : this.state.messageIcon
          })
        )
      ) : React.createElement('div', null),
      this.state.formSelected ? React.createElement(
        Well,
        null,
        this.state.idBuilt && React.createElement(
          Panel,
          {
            header: this.state.labels.thisClass.panels.form,
            eventKey: 'form-panel',
            expanded: this.state.panel.formOpen,
            onSelect: this.toogleFormPanel,
            collapsible: true
          },
          this.state.IdTopicValue && React.createElement(
            Well,
            null,
            React.createElement(
              'div',
              null,
              this.state.IdTopicValue,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.state.IdTopic,
                ')'
              )
            )
          ),
          this.state.IdKeyValue && React.createElement(
            Well,
            null,
            React.createElement(
              'div',
              null,
              this.state.IdKeyValue,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.state.IdKey,
                ')'
              )
            )
          ),
          React.createElement(NewEntryForm, {
            session: this.props.session,
            path: this.state.selected.path,
            schema: this.state.selected.schema,
            uiSchema: this.state.selected.uiSchema,
            formData: this.state.selected.form,
            onSubmit: this.onSubmit
          })
        )
      ) : React.createElement('div', null)
    );
  };

  return NewEntry;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var topics = nextProps.session.labelTopics;

    _this2.setState({
      labels: {
        thisClass: labels[topics.NewEntry],
        search: labels[topics.search],
        paraRowEditor: labels[topics.ParaTextEditor]
      }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.handleStatusChange = function (item) {

    var userIndex = "";

    switch (item.value) {
      case "EDITING":
        userIndex = "authors";
        break;
      case "READY_TO_EDIT":
        userIndex = "admins";
        break;
      case "READY_TO_FINALIZE":
        userIndex = "admins";
        break;
      case "READY_TO_REVIEW":
        userIndex = "admins";
        break;
      case "READY_TO_RELEASE":
        userIndex = "admins";
        break;
      case "REVIEWING":
        userIndex = "reviewers";
        break;
      default:
    }

    _this2.setState({
      selectedStatus: item.value,
      selectedUser: "",
      userRolesIndex: userIndex
    });
  };

  this.handleWorkflowAssignmentCallback = function (status, user) {
    _this2.state.selected.form.assignedToUser = user;
    _this2.state.selected.form.status = status;
    _this2.setState({
      workflowStatus: status,
      workflowUser: user
    });
  };

  this.handleFormSelection = function (selection) {
    var theForm = _this2.state.session.uiSchemas.getForm(selection.value);

    theForm.assignedToUser = _this2.props.session.userInfo.username;

    // If the form is for making a translation, we
    // we want to display a panel for a Parallel Row Text Editor.
    // So, we need to check if this is a translation, and
    // also determine whether it is biblical or liturgical.
    var theTranslationDocType = "Liturgical";
    var thisIsATranslationForm = false;
    if (selection.value.includes("Translation")) {
      thisIsATranslationForm = true;
      if (selection.value.includes("Biblical")) {
        theTranslationDocType = "Biblical";
      } else {
        theTranslationDocType = "Liturgical";
      }
    }
    var isTemplateForm = selection.value.includes("Template");
    var thisIsAReferenceForm = false;
    if (selection.value.startsWith("Link")) {
      // switch to links if need be
      thisIsAReferenceForm = true;
    }
    var isUserNoteForm = theForm["partTypeOfKey"].includes("TIMESTAMP");
    var thisIsAnOntologyForm = theForm["partTypeOfKey"].includes("ONTOLOGY");
    var initialOntologyType = "Human";
    if (thisIsAnOntologyForm) {
      var parts = selection.label.split(" ");
      if (parts.length === 3) {
        initialOntologyType = parts[2];
      } else {
        initialOntologyType = selection.label;
      }
    }

    // the purpose of the next series of if statements for the
    // library, topic, and key
    // is to either preserve or reset the initial id and value
    // used in the IdBuilder.
    var topicTypeChanged = _this2.state.IdTopicType !== theForm["partTypeOfTopic"];
    var keyTypeChanged = _this2.state.IdKeyType !== theForm["partTypeOfKey"];

    var idLibrary = theForm["library"];
    if (isUserNoteForm) {
      idLibrary = _this2.props.session.userInfo.domain;
    } else {
      if (idLibrary === undefined || idLibrary.length < 6) {
        if (topicTypeChanged) {
          idLibrary = "";
        } else {
          if (idLibrary !== _this2.state.IdLibrary) {
            // try to avoid calling the rest server if we did it
            // last form change
            idLibrary = _this2.state.IdLibrary;
          }
        }
      } else {
        // try to avoid calling the rest server if we did it
        // last form change
        server.getDropdownUsersForLibrary(_this2.props.session.restServer, _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, idLibrary, _this2.setLibraryWorkflowInfo);
      }
    }

    var idTopic = theForm["topic"];
    var idTopicValue = "";
    if (idTopic === undefined || idTopic.length < 1) {
      if (topicTypeChanged) {
        idTopic = "";
        idTopicValue = "";
      } else {
        idTopic = _this2.state.IdTopic;
        idTopicValue = _this2.state.IdTopicValue;
      }
    }
    var idKey = theForm["key"];
    var idKeyValue = "";
    if (isUserNoteForm) {
      var date = new Date();
      var month = (date.getMonth() + 1).toString().padStart(2, "0");
      var day = date.getDate().toString().padStart(2, "0");
      var hour = date.getHours().toString().padStart(2, "0");
      var minute = date.getMinutes().toString().padStart(2, "0");
      var second = date.getSeconds().toString().padStart(2, "0");
      idKey = date.getFullYear() + "." + month + "." + day + ".T" + hour + "." + minute + "." + second;
      idKeyValue = idKey;
    } else {
      if (idKey === undefined || idKey.length < 1) {
        if (keyTypeChanged) {
          idKey = "";
          idKeyValue = "";
        } else {
          idKey = _this2.state.IdKey;
          idKeyValue = _this2.state.IdKeyValue;
        }
      }
    }
    _this2.setState({
      selected: {
        schema: _this2.state.session.uiSchemas.getSchema(selection.value),
        uiSchema: _this2.state.session.uiSchemas.getUiSchema(selection.value),
        form: theForm,
        path: _this2.state.session.uiSchemas.getHttpPostPathForSchema(selection.value)
      },
      selectedForm: selection.value,
      initialOntologyType: initialOntologyType,
      isUserNoteForm: isUserNoteForm,
      isTranslationForm: thisIsATranslationForm,
      isReferenceForm: thisIsAReferenceForm,
      isTemplateForm: isTemplateForm,
      translationDocType: theTranslationDocType,
      formSelected: true,
      IdLibrary: idLibrary,
      IdTopic: idTopic,
      IdTopicType: theForm["partTypeOfTopic"],
      IdTopicValue: idTopicValue,
      IdKey: idKey,
      IdKeyValue: idKeyValue,
      IdKeyType: theForm["partTypeOfKey"],
      idBuilt: false
    });
    if (!_this2.state.panel.idBuilderOpen) {
      _this2.toogleIdBuilderPanel();
    }
  };

  this.setLibraryWorkflowInfo = function (restCallResult) {
    if (restCallResult && restCallResult.data.values && restCallResult.data.values.length > 0) {
      var config = restCallResult.data.values[3].config;
      var isPublic = true;
      if (config.isPublic) {
        isPublic = config.isPublic;
      }

      _this2.setState({
        workflow: {
          userRolesForLibrary: restCallResult.data.values[0],
          statusDropdown: restCallResult.data.values[1].statusDropdown,
          isPublic: isPublic,
          stateEnabled: config.stateEnabled,
          workflowEnabled: config.workflowEnabled,
          defaultStatusAfterEdit: config.defaultStatusAfterEdit,
          defaultStatusAfterFinalization: config.defaultStatusAfterFinalization
        }
      });
    }
  };

  this.handleIdLibrarySelection = function (library) {
    if (library) {
      _this2.setState({
        IdLibrary: library
      });

      // get the authorized admins, authors, readers, and reviewers for this library
      server.getDropdownUsersForLibrary(_this2.props.session.restServer, _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, library, _this2.setLibraryWorkflowInfo);
    }
  };

  this.handleIdTopicSelection = function (topic, value) {
    _this2.setState({
      IdTopic: topic,
      IdTopicValue: value
    });
  };

  this.handleIdSelection = function (IdLibrary, IdTopic, IdTopicValue, IdKey, IdKeyValue, seq) {
    var IdBuilt = IdLibrary.length > 0 && IdTopic.length > 0 && IdKey.length > 0;
    var idSeq = "";
    if (seq) {
      idSeq = IdManager.replaceLibrary(seq, IdLibrary);
    } else if (_this2.state.isUserNoteForm) {
      idSeq = IdManager.toId(IdLibrary, IdTopic, IdKey);
    }
    var idTopicParts = {};
    if (_this2.state.isReferenceForm) {
      var parts = IdManager.getParts(IdTopic);
      if (parts) {
        idTopicParts = {
          library: parts.library,
          topic: parts.topic,
          key: parts.key
        };
      }
    }

    _this2.setState({
      IdLibrary: IdLibrary,
      IdTopic: IdTopic,
      IdTopicValue: IdTopicValue,
      IdKey: IdKey,
      IdKeyValue: IdKeyValue,
      IdSeq: idSeq,
      idBuilt: IdBuilt,
      IdTopicParts: idTopicParts
    });

    if (_this2.state.isTemplateForm) {
      var nodeBuilder = new TemplateNodeInitializer(IdLibrary, IdTopic, IdKey, "SERVICE", "WHEN_DAY_NAME_IS");
      var node = nodeBuilder.getRootNode();
      // {
      //   title: "TEMPLATE"
      //   , subtitle: IdLibrary + "~" + IdTopic + "~head"
      //   , expanded: true
      //   , children: [
      //     {
      //       title: "SECTION"
      //       , subtitle: "section01"
      //       , children: []
      //     }
      //   ]
      // };
      _this2.state.selected.form.node = JSON.stringify(node);
    }

    _this2.state.selected.form.library = IdLibrary;
    _this2.state.selected.form.topic = IdTopic;
    _this2.state.selected.form.key = IdKey;
    _this2.state.selected.form.id = IdLibrary + "~" + IdTopic + "~" + IdKey;
    _this2.state.selected.form.seq = idSeq;
    _this2.state.selected.form.status = _this2.state.workflow.defaultStatusAfterEdit;

    if (_this2.state.workflow && _this2.state.workflow.workflowEnabled) {
      _this2.state.selected.form.assignedToUser = _this2.state.workflow.userRolesForLibrary[_this2.state.userRolesIndex];
    } else {
      _this2.state.selected.form.assignedToUser = "";
    }
    _this2.toogleIdBuilderPanel();
    if (_this2.state.isTranslationForm) {
      if (!_this2.state.panel.paraTextOpen) {
        _this2.toogleParaTextPanel();
      }
    } else if (_this2.state.isReferenceForm) {
      if (!_this2.state.panel.paraTextOpen) {
        _this2.toogleParaTextPanel();
      }
      if (!_this2.state.panel.formOpen) {
        _this2.toogleFormPanel();
      }
    } else {
      if (!_this2.state.panel.formOpen) {
        _this2.toogleFormPanel();
      }
    }
  };

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    _this2.setState({
      formData: formData
    });
  };

  this.toogleIdBuilderPanel = function () {
    _this2.setState({
      panel: {
        idBuilderOpen: !_this2.state.panel.idBuilderOpen
      }
    });
  };

  this.toogleParaTextPanel = function () {
    _this2.setState({
      panel: {
        paraTextOpen: !_this2.state.panel.paraTextOpen
      }
    });
  };

  this.handleParallelTextEditorCallback = function (value) {
    _this2.setState({
      translationValue: value
    });
    _this2.state.selected.form.value = value;
  };

  this.handleParallelTextEditorSubmit = function () {
    _this2.onSubmit({
      formData: _this2.state.selected.form
    });
  };

  this.toogleFormPanel = function () {
    _this2.setState({
      panel: {
        formOpen: !_this2.state.panel.formOpen
      }
    });
  };
}, _temp);

/**
 , forms: PropTypes.object.isRequired

 * @type {{restServer: *, userInfo: *, uiSchemas: *, biblicalBooksDropdown: *, biblicalChaptersDropdown: *, biblicalVersesDropdown: *, biblicalSubversesDropdown: *, changeHandler: *, languageCode: *}}
 */
process.env.NODE_ENV !== "production" ? NewEntry.propTypes = {
  session: PropTypes.object.isRequired,
  changeHandler: PropTypes.func.isRequired
} : void 0;

export default NewEntry;