var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { get } from 'lodash';
import server from './helpers/Server';
import ResourceSelector from './modules/ReactSelector';
import MessageIcons from './helpers/MessageIcons';
import FontAwesome from 'react-fontawesome';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import { Button, Col, ControlLabel, FormControl, FormGroup, Grid, Row, Tab, Tabs, Well } from 'react-bootstrap';
import User from "./classes/User";

/**
 * Provides a text editor with source and models as parallel columns
 */
var ParaColLabelEditor = (_temp = _class = function (_React$Component) {
  _inherits(ParaColLabelEditor, _React$Component);

  function ParaColLabelEditor(props) {
    _classCallCheck(this, ParaColLabelEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, _this.state);

    _this.editable = _this.editable.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getKeyInputRow = _this.getKeyInputRow.bind(_this);
    _this.getNewKeyButtonRow = _this.getNewKeyButtonRow.bind(_this);
    _this.getTabs = _this.getTabs.bind(_this);
    _this.getUiLanguageRow = _this.getUiLanguageRow.bind(_this);
    _this.getUiSystemRow = _this.getUiSystemRow.bind(_this);
    _this.getUiTopicRow = _this.getUiTopicRow.bind(_this);
    _this.getUiNewTopicRow = _this.getUiNewTopicRow.bind(_this);
    _this.getValueInputRow = _this.getValueInputRow.bind(_this);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    _this.handleFilterClear = _this.handleFilterClear.bind(_this);
    _this.handleKeyInputChange = _this.handleKeyInputChange.bind(_this);
    _this.handleLibrarySelection = _this.handleLibrarySelection.bind(_this);
    _this.handleNewKeySubmit = _this.handleNewKeySubmit.bind(_this);
    _this.handleNewTopicChange = _this.handleNewTopicChange.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleSystemSelect = _this.handleSystemSelect.bind(_this);
    _this.handleTopicSelect = _this.handleTopicSelect.bind(_this);
    _this.handleValueInputChange = _this.handleValueInputChange.bind(_this);
    _this.handleValueUpdateCallback = _this.handleValueUpdateCallback.bind(_this);
    _this.onAfterSaveCell = _this.onAfterSaveCell.bind(_this);
    _this.onBeforeSaveCell = _this.onBeforeSaveCell.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.putUiLabel = _this.putUiLabel.bind(_this);
    _this.setTableData = _this.setTableData.bind(_this);
    return _this;
  }

  /**
   *
   * @param row - returns the entire row including nbr, topicKey, etc.
   * @param cellName - the column title, i.e. the library
   * @param cellValue - the text value entered
   */

  /**
   * Does the user have permission to edit records in this library?
   * @param library
   * @returns {boolean}
   */


  ParaColLabelEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App App-ParaColLabelEditor' },
      React.createElement(
        'div',
        { className: 'row' },
        React.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          React.createElement(
            Well,
            { className: 'App-Para-Col-Editor' },
            React.createElement(
              'form',
              { onSubmit: this.handleSubmit },
              React.createElement(
                FormGroup,
                null,
                React.createElement(
                  Grid,
                  null,
                  React.createElement(
                    Row,
                    null,
                    React.createElement(
                      Col,
                      { xs: 12, md: 12 },
                      React.createElement(
                        'h3',
                        null,
                        this.state.labels.thisClass.panelTitle
                      )
                    )
                  ),
                  React.createElement(
                    Well,
                    null,
                    this.getUiSystemRow(),
                    this.getUiLanguageRow(),
                    React.createElement(
                      Row,
                      null,
                      React.createElement(
                        Col,
                        null,
                        '\xA0'
                      )
                    ),
                    React.createElement(
                      Row,
                      null,
                      React.createElement(
                        Col,
                        { xs: 12, md: 12 },
                        React.createElement(
                          Button,
                          {
                            type: 'submit',
                            bsStyle: 'primary',
                            disabled: this.state.selectedUiSystem.length < 1 || this.state.languages.length < 1
                          },
                          this.state.labels.messages.submit
                        ),
                        React.createElement(
                          'div',
                          null,
                          this.state.labels.messages.status,
                          ': ',
                          React.createElement(
                            'span',
                            { className: 'App App-message' },
                            React.createElement(FontAwesome, {
                              name: this.state.messageIcon }),
                            this.state.message,
                            ' '
                          )
                        )
                      )
                    )
                  ),
                  this.state.dataFetched && this.state.values && this.getTabs()
                )
              )
            )
          )
        )
      )
    );
  };

  return ParaColLabelEditor;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var dataFetched = false;
    var values = undefined;
    var about = {};
    var libraryKeyValues = {};
    var libraryKeys = [];
    var templateKeys = [];
    var libraries = [_this2.props.source, "", "", ""];
    var languages = ["en", "", "", ""];
    var topic = "";
    var message = props.session.labels[props.session.labelTopics.messages].initial;
    var messageIcon = MessageIcons.getMessageIcons().info;

    if (currentState) {
      if (message !== currentState.message) {
        message = currentState.message;
      }
      if (messageIcon !== currentState.messageIcon) {
        messageIcon = currentState.messageIcon;
      }
      if (currentState.dataFetched) {
        dataFetched = currentState.dataFetched;
      }
      if (currentState.languages) {
        languages = currentState.languages;
      }
      if (currentState.libraries) {
        libraries = currentState.libraries;
      }
      if (currentState.dataFetched) {
        values = currentState.values;
      }
    }

    var userInfo = {};
    if (props.session && props.session.userInfo) {
      userInfo = new User(props.session.userInfo.username, props.session.userInfo.password, props.session.userInfo.domain, props.session.userInfo.email, props.session.userInfo.firstname, props.session.userInfo.lastname, props.session.userInfo.title, props.session.userInfo.authenticated, props.session.userInfo.domains);
    }

    var clickType = "dbclick";
    try {
      if (window.innerWidth < 800) {
        clickType = "click";
      }
    } catch (err) {
      clickType = "dbclick";
    }

    return {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ParaColLabelEditor],
        messages: props.session.labels[props.session.labelTopics.messages],
        button: props.session.labels[props.session.labelTopics.button],
        toAdd: {
          panelTitle: "View, Create, or Update User Interface Labels"
        }
      },
      session: {
        userInfo: userInfo
      },
      uiTopicsDropdown: get(_this2.state, "uiTopicsDropdown", []),
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: message,
      selectedUiSystem: get(_this2.state, "selectedUiSystem", "ilr"),
      selectedUiTopic: get(_this2.state, "selectedUiTopic", ""),
      resultCount: -1,
      topic: topic,
      languages: languages,
      libraries: libraries,
      dataFetched: dataFetched,
      values: values,
      updatedLanguage: get(_this2.state, "updatedLanguage", ""),
      updatedKey: get(_this2.state, "updatedKey", ""),
      updatedSeq: get(_this2.state, "updatedSeq", ""),
      updatedTopic: get(_this2.state, "updatedTopic", ""),
      updatedValue: get(_this2.state, "updatedValue", ""),
      about: about,
      libraryKeyValues: libraryKeyValues,
      libraryKeys: libraryKeys,
      templateKeys: templateKeys,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      cellEditProp: {
        mode: clickType,
        beforeSaveCell: _this2.onBeforeSaveCell,
        afterSaveCell: _this2.onAfterSaveCell
      },
      maxCols: 7,
      maxLibraries: 4,
      topicKeyColumnSize: "40px",
      libraryReviewColumnSize: "20px",
      libraryValueColumnSize: "80px",
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: props.session.labels[props.session.labelTopics.messages].regEx
      }
    };
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.fetchData = function () {
    var libraries = [];
    _this2.state.languages.forEach(function (lang) {
      if (lang) {
        var library = lang + "_sys_" + _this2.state.selectedUiSystem;
        libraries.push(library);
      }
    });
    var parms = "&l=" + encodeURIComponent(libraries.join(",")) + "&e=" + encodeURIComponent("en_sys_") + _this2.state.selectedUiSystem;

    // add empty libraries for the table columns (hidden if empty, but must exist)
    var missing = 4 - libraries.length;
    for (var i = 0; i < missing; i++) {
      libraries.push("");
    }
    _this2.setState({
      message: _this2.state.labels.messages.retrieving,
      libraries: libraries
    }, server.getUiLabels(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, parms, _this2.handleFetchCallback));
  };

  this.handleFetchCallback = function (restCallResult) {
    if (restCallResult) {
      var data = restCallResult.data.values[0];
      var libraryKeyValues = data.libraryKeyValues;
      var templateKeys = data.templateKeys;
      var topics = data.topics.sort();
      var uiTopicsDropdown = [];
      try {
        for (var key in topics) {
          var topic = topics[key];
          uiTopicsDropdown.push({ label: topic, value: topic });
        }
      } catch (err) {
        console.log(err);
      }
      _this2.setState({
        dataFetched: true,
        libraryKeyValues: libraryKeyValues,
        templateKeys: templateKeys,
        topics: topics,
        uiTopicsDropdown: uiTopicsDropdown,
        message: _this2.state.labels.messages.found + " " + templateKeys.length + " " + _this2.state.labels.messages.docs,
        messageIcon: restCallResult.messageIcon,
        resultCount: templateKeys.length
      }, _this2.setTableData);
    }
  };

  this.getTabs = function () {
    return React.createElement(
      'div',
      { className: 'row' },
      React.createElement(
        Tabs,
        { id: 'App-Text-Node-Editor-Tabs', animation: false },
        React.createElement(
          Tab,
          { eventKey: "tabEditor", title: _this2.state.labels.thisClass.editor },
          React.createElement(
            'div',
            { className: 'App-Label-Editor-Row col-sm-12 col-md-12 col-lg-12' },
            React.createElement(
              Grid,
              null,
              React.createElement(
                Row,
                null,
                React.createElement(
                  Col,
                  { xs: 9, md: 9 },
                  React.createElement(
                    'div',
                    { className: 'control-label' },
                    _this2.state.labels.thisClass.msg2
                  )
                ),
                React.createElement(
                  Col,
                  { xs: 3, md: 3 },
                  React.createElement(
                    Button,
                    {
                      onClick: _this2.handleFilterClear,
                      bsStyle: 'primary',
                      className: 'App-table-filter-clear'
                    },
                    _this2.state.labels.messages.clearFilters
                  )
                )
              )
            ),
            React.createElement(
              BootstrapTable,
              {
                ref: 'table',
                data: _this2.state.values,
                trClassName: "App-data-tr",
                striped: true,
                pagination: true,
                options: _this2.state.options,
                cellEdit: _this2.state.cellEditProp
              },
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'topicKey',
                  isKey: true,
                  dataField: 'topicKey',
                  dataSort: true,
                  width: _this2.state.topicKeyColumnSize,
                  filter: _this2.state.tableColumnFilter
                },
                'Topic~Key'
              ),
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'review',
                  dataField: "review",
                  tdClassname: 'tdColEditorReview',
                  width: _this2.state.libraryReviewColumnSize,
                  editable: false,
                  filter: _this2.state.tableColumnFilter
                },
                "< ! >"
              ),
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'source',
                  dataSort: true,
                  dataField: _this2.state.libraries[0],
                  tdClassname: 'tdColEditorSource',
                  width: _this2.state.libraryValueColumnSize,
                  editable: _this2.editable(_this2.state.libraries[0]),
                  filter: _this2.state.tableColumnFilter
                },
                _this2.state.libraries[0]
              ),
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'lib1',
                  dataSort: true,
                  dataField: _this2.state.libraries[1],
                  editable: _this2.editable(_this2.state.libraries[1]),
                  tdClassname: 'tdColEditorLib1',
                  width: _this2.state.libraryValueColumnSize,
                  hidden: _this2.state.libraries[1].length == 0,
                  filter: _this2.state.tableColumnFilter
                },
                _this2.state.libraries[1]
              ),
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'lib2',
                  dataField: _this2.state.libraries[2],
                  dataSort: true,
                  tdClassname: 'tdColEditorLib2',
                  width: _this2.state.libraryValueColumnSize,
                  editable: _this2.editable(_this2.state.libraries[2]),
                  filter: _this2.state.tableColumnFilter,
                  hidden: _this2.state.libraries[2].length == 0
                },
                _this2.state.libraries[2]
              ),
              React.createElement(
                TableHeaderColumn,
                {
                  ref: 'lib3',
                  dataField: _this2.state.libraries[3],
                  dataSort: true,
                  editable: _this2.editable(_this2.state.libraries[0]),
                  tdClassname: 'tdColEditorLib3',
                  width: _this2.state.libraryValueColumnSize,
                  filter: _this2.state.tableColumnFilter,
                  hidden: _this2.state.libraries[3].length == 0
                },
                _this2.state.libraries[3]
              )
            )
          )
        ),
        React.createElement(
          Tab,
          { eventKey: "tabAddTopicKey", title: _this2.state.labels.thisClass.newKey },
          React.createElement(
            Well,
            null,
            _this2.getUiTopicRow(),
            _this2.getUiNewTopicRow(),
            _this2.getKeyInputRow(),
            _this2.getValueInputRow(),
            _this2.getNewKeyButtonRow()
          )
        )
      )
    );
  };

  this.handleKeyInputChange = function (event) {
    _this2.setState({ updatedKey: event.target.value });
  };

  this.handleNewTopicChange = function (event) {
    var selectedUiTopic = "";
    var updatedTopic = event.target.value;
    if (_this2.props.session.labelTopics[event.target.value]) {
      selectedUiTopic = event.target.value;
    }
    _this2.setState({
      selectedUiTopic: selectedUiTopic,
      updatedTopic: updatedTopic,
      updatedLanguage: "en"
    });
  };

  this.handleValueInputChange = function (event) {
    _this2.setState({ updatedValue: event.target.value });
  };

  this.handleValueUpdateCallback = function (restCallResult) {
    if (restCallResult) {
      if (_this2.props.callback) {
        _this2.props.callback(_this2.state.selectedUiSystem, _this2.state.updatedLanguage, _this2.state.updatedTopic, _this2.state.updatedKey, _this2.state.updatedValue);
      }
      _this2.setState({
        message: restCallResult.message,
        messageIcon: restCallResult.messageIcon
      }, _this2.fetchData);
    }
  };

  this.setTableData = function () {
    if (_this2.state.dataFetched) {
      var tableData = [];
      var j = _this2.state.templateKeys.length;
      for (var i = 0; i < j; i++) {
        try {
          var topicKey = _this2.state.templateKeys[i].key;
          var date = _this2.state.libraryKeyValues[_this2.state.libraries[0]][_this2.state.templateKeys[i].libKeysIndex].modifiedWhen;
          var seq = _this2.state.libraryKeyValues[_this2.state.libraries[0]][_this2.state.templateKeys[i].libKeysIndex].seq;
          var source = _this2.state.libraryKeyValues[_this2.state.libraries[0]][_this2.state.templateKeys[i].libKeysIndex].value;
          var lib1 = "";
          var lib1Date = "";
          var lib2 = "";
          var lib2Date = "";
          var lib3 = "";
          var lib3Date = "";
          var review = "";
          var reviewIcon = "< ! >";
          if (_this2.state.libraries[1].length > 0) {
            try {
              lib1 = _this2.state.libraryKeyValues[_this2.state.libraries[1]][_this2.state.templateKeys[i].libKeysIndex].value;
              lib1Date = _this2.state.libraryKeyValues[_this2.state.libraries[1]][_this2.state.templateKeys[i].libKeysIndex].modifiedWhen;
              if (date > lib1Date) {
                review = reviewIcon;
              }
            } catch (err) {}
          }
          if (_this2.state.libraries[2].length > 0) {
            try {
              lib2 = _this2.state.libraryKeyValues[_this2.state.libraries[2]][_this2.state.templateKeys[i].libKeysIndex].value;
              lib2Date = _this2.state.libraryKeyValues[_this2.state.libraries[2]][_this2.state.templateKeys[i].libKeysIndex].modifiedWhen;
              if (review !== reviewIcon) {
                if (date > lib2Date) {
                  review = reviewIcon;
                }
              }
            } catch (err) {}
          }
          if (_this2.state.libraries[3].length > 0) {
            try {
              lib3 = _this2.state.libraryKeyValues[_this2.state.libraries[3]][_this2.state.templateKeys[i].libKeysIndex].value;
              lib3Date = _this2.state.libraryKeyValues[_this2.state.libraries[3]][_this2.state.templateKeys[i].libKeysIndex].modifiedWhen;
              if (review !== reviewIcon) {
                if (date > lib3Date) {
                  review = reviewIcon;
                }
              }
            } catch (err) {}
          }
          var row = {};
          row["nbr"] = i;
          row["seq"] = seq;
          row["topicKey"] = topicKey;
          row["review"] = review;
          row[_this2.state.libraries[0]] = source;
          row[_this2.state.libraries[1]] = lib1;
          row[_this2.state.libraries[2]] = lib2;
          row[_this2.state.libraries[3]] = lib3;
          tableData.push(row);
        } catch (err) {
          console.log(_this2.state.libraries);
          console.log(i + " " + _this2.state.libraries[i]);
          console.log(err);
        }
      }
      _this2.setState({
        values: tableData
      });
    }
  };

  this.handleSystemSelect = function (system) {
    _this2.setState({
      selectedUiSystem: system.value
    });
  };

  this.handleTopicSelect = function (topic) {
    _this2.setState({
      selectedUiTopic: topic.value,
      updatedLanguage: "en",
      updatedTopic: topic.value
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    // row["id"], etc.
  };

  this.onBeforeSaveCell = function (row, cellName, cellValue) {};

  this.onAfterSaveCell = function (row, cellName, cellValue) {
    var index = row.nbr;
    var seq = row.seq;
    var topicKey = row.topicKey;
    var library = cellName;
    var value = cellValue;
    var id = library + "~" + topicKey;
    var language = "";
    var topic = "";
    var key = "";
    try {
      var parts = topicKey.split("~");
      topic = parts[0];
      key = parts[1];
      parts = library.split("_");
      language = parts[0];
    } catch (err) {
      console.log(err);
    }
    // update the local array with the new value
    var libraryKeyValues = _this2.state.libraryKeyValues;
    libraryKeyValues[library][_this2.state.templateKeys[index].libKeysIndex].value = value;
    _this2.setState({
      libraryKeyValues: libraryKeyValues,
      updatedLanguage: language,
      updatedTopic: topic,
      updatedKey: key,
      updatedValue: value,
      updatedSeq: seq,
      updatedId: id
    }, _this2.putUiLabel);
  };

  this.putUiLabel = function () {
    if (_this2.state.updatedTopic && _this2.state.updatedLanguage && _this2.state.updatedKey && _this2.state.updatedValue && _this2.state.updatedId) {
      var parms = "i=" + encodeURIComponent(_this2.state.updatedId) + "&t=" + encodeURIComponent("UI Interface Label");

      server.putUiLabel(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, { value: _this2.state.updatedValue, seq: _this2.state.updatedSeq }, parms, _this2.handleValueUpdateCallback);
    }
  };

  this.handleLibrarySelection = function (selection) {
    var libraries = [];
    var source = _this2.props.source;
    var sourceFound = false;
    libraries.push(_this2.props.source);
    selection.forEach(function (lib) {
      if (lib.value == source) {
        sourceFound = true;
      } else {
        libraries.push(lib.value);
      }
    });
    var emptyCols = _this2.state.maxCols - libraries.length;
    for (var i = 0; i < emptyCols; i++) {
      libraries.push("");
    }
    var message = "";
    var messageIcon = MessageIcons.getMessageIcons().info;
    if (!sourceFound) {
      message = _this2.state.labels.thisClass.sourceRequired + " " + _this2.props.source;
      messageIcon = MessageIcons.getMessageIcons().error;
    } else if (selection.length > _this2.state.maxLibraries) {
      message = _this2.state.labels.thisClass.maxLibraries + " " + _this2.state.maxLibraries;
      messageIcon = MessageIcons.getMessageIcons().error;
    }
    _this2.setState({
      libraries: libraries,
      message: message,
      messageIcon: messageIcon
    });
  };

  this.handleUiSystemSelection = function (selection) {
    _this2.setState({
      selectedUiSystem: selection.value,
      dataFetched: false
    });
  };

  this.handleUiLanguageSelection = function (selection) {
    var languages = [];
    var source = "en";
    var sourceFound = false;
    languages.push("en");
    selection.forEach(function (lib) {
      if (lib.value == source) {
        sourceFound = true;
      } else {
        languages.push(lib.value);
      }
    });
    var emptyCols = _this2.state.maxCols - languages.length;
    for (var i = 0; i < emptyCols; i++) {
      languages.push("");
    }
    var message = "";
    var messageIcon = MessageIcons.getMessageIcons().info;
    if (!sourceFound) {
      message = _this2.state.labels.thisClass.sourceRequired + " " + _this2.props.source;
      messageIcon = MessageIcons.getMessageIcons().error;
    } else if (selection.length > _this2.state.maxLibraries) {
      message = _this2.state.labels.thisClass.maxLibraries + " " + _this2.state.maxLibraries;
      messageIcon = MessageIcons.getMessageIcons().error;
    }
    _this2.setState({
      languages: languages,
      message: message,
      messageIcon: messageIcon,
      dataFetched: false
    });
  };

  this.editable = function (library) {
    var canEdit = false;
    for (var _iterator = _this2.state.session.userInfo.domains.author, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var entry = _ref;

      if (entry.value == library) {
        canEdit = true;
        break;
      }
    }
    if (canEdit) {
      return { type: 'textarea' };
    } else {
      return false;
    }
  };

  this.handleSubmit = function (event) {
    _this2.fetchData();
    event.preventDefault();
  };

  this.handleFilterClear = function () {
    if (_this2.refs) {
      if (_this2.refs.topicKey) {
        _this2.refs.topicKey.applyFilter("");
      }
      if (_this2.refs.source) {
        _this2.refs.source.applyFilter("");
      }
      if (_this2.refs.lib1) {
        _this2.refs.lib1.applyFilter("");
      }
      if (_this2.refs.lib2) {
        _this2.refs.lib2.applyFilter("");
      }
      if (_this2.refs.lib3) {
        _this2.refs.lib3.applyFilter("");
      }
    }
  };

  this.getUiLanguageRow = function () {
    if (_this2.props.session && _this2.props.session.dropdowns && _this2.props.session.dropdowns.uiLanguagesDropdown) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Row,
          null,
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            React.createElement(ResourceSelector, {
              title: _this2.state.labels.thisClass.language,
              initialValue: _this2.state.languages.join(),
              resources: _this2.props.session.dropdowns.uiLanguagesDropdown,
              changeHandler: _this2.handleUiLanguageSelection,
              multiSelect: true
            })
          )
        )
      );
    }
  };

  this.getKeyInputRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          ControlLabel,
          null,
          _this2.state.labels.thisClass.enterNewKey
        ),
        React.createElement(FormControl, {
          id: "fxKeyInputRow",
          className: "App-Label-Editor-New-Key",
          type: 'text',
          value: _this2.state.value,
          placeholder: _this2.state.labels.thisClass.enterNewKey,
          onChange: _this2.handleKeyInputChange
        })
      )
    );
  };

  this.handleNewKeySubmit = function () {
    var id = "en_sys_" + _this2.state.selectedUiSystem + "~" + _this2.state.updatedTopic + "~" + _this2.state.updatedKey;
    _this2.setState({
      updatedId: id
    }, _this2.putUiLabel);
  };

  this.getNewKeyButtonRow = function () {
    return React.createElement(
      Row,
      null,
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          Button,
          {
            onClick: _this2.handleNewKeySubmit,
            bsStyle: 'primary',
            className: 'App-Label-Editor-New-Key-Button'
          },
          _this2.state.labels.button.submit
        )
      )
    );
  };

  this.getValueInputRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          ControlLabel,
          null,
          _this2.state.labels.thisClass.enterValue
        ),
        React.createElement(FormControl, {
          id: "fxValueInputRow",
          className: "App-Label-Editor-New-Value",
          type: 'text',
          value: _this2.state.value,
          placeholder: _this2.state.labels.thisClass.enterValue,
          onChange: _this2.handleValueInputChange
        })
      )
    );
  };

  this.getUiNewTopicRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          ControlLabel,
          null,
          _this2.state.labels.thisClass.newTopic
        ),
        React.createElement(FormControl, {
          id: "fxNewTopicInputRow",
          className: "App-Label-Editor-New-Topic",
          type: 'text',
          value: _this2.state.value,
          placeholder: _this2.state.labels.thisClass.newTopic,
          onChange: _this2.handleNewTopicChange
        })
      )
    );
  };

  this.getUiSystemRow = function () {
    if (_this2.props.session && _this2.props.session.dropdowns && _this2.props.session.dropdowns.uiSystemsDropdown) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Row,
          null,
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            React.createElement(ResourceSelector, {
              title: _this2.state.labels.thisClass.system,
              initialValue: _this2.state.selectedUiSystem,
              resources: _this2.props.session.dropdowns.uiSystemsDropdown,
              changeHandler: _this2.handleUiSystemSelection,
              multiSelect: false
            })
          )
        )
      );
    }
  };

  this.getUiTopicRow = function () {
    if (_this2.props.session && _this2.props.session.dropdowns && _this2.props.session.dropdowns.uiSystemsDropdown) {
      return React.createElement(
        'div',
        { className: 'App-Label-Editor-Row' },
        React.createElement(
          Row,
          null,
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            React.createElement(ResourceSelector, {
              title: _this2.state.labels.thisClass.topic,
              initialValue: _this2.state.selectedUiTopic,
              resources: _this2.state.uiTopicsDropdown,
              changeHandler: _this2.handleTopicSelect,
              multiSelect: false
            })
          )
        )
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ParaColLabelEditor.propTypes = {
  session: PropTypes.object.isRequired,
  source: PropTypes.string.isRequired,
  callback: PropTypes.func
} : void 0;

ParaColLabelEditor.defaultProps = {};

export default ParaColLabelEditor;