var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { get } from 'lodash';
import GenericSearchOptions from "./modules/GenericSearchOptions";
import GenericModalNewEntryForm from './modules/GenericModalNewEntryForm';
import ModalSchemaBasedEditor from './modules/ModalSchemaBasedEditor';
import FontAwesome from 'react-fontawesome';
import { Alert, Button, ButtonGroup, ControlLabel, FormControl, FormGroup, Panel } from 'react-bootstrap';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import { SuperTypes } from './classes/ENUMS';
import User from './classes/User';
import Server from './helpers/Server';

/**
 * If a schema is not included in the dropdown
 * it probably means in ioc-liturgical-schemas
 * NEW_FORM_CLASSES_DB_API that the include
 * in Schema editor = false
 */
export var SearchGeneric = (_temp = _class = function (_React$Component) {
  _inherits(SearchGeneric, _React$Component);

  function SearchGeneric(props) {
    _classCallCheck(this, SearchGeneric);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.deselectAllRows = _this.deselectAllRows.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getAddButton = _this.getAddButton.bind(_this);
    _this.getMatcherTypes = _this.getMatcherTypes.bind(_this);
    _this.getModalEditor = _this.getModalEditor.bind(_this);
    _this.getModalNewEntryForm = _this.getModalNewEntryForm.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.getSelectedDocOptions = _this.getSelectedDocOptions.bind(_this);
    _this.getTable = _this.getTable.bind(_this);
    _this.getTableForAbbreviations = _this.getTableForAbbreviations.bind(_this);
    _this.getTableForBibliographies = _this.getTableForBibliographies.bind(_this);
    _this.getTableGeneric = _this.getTableGeneric.bind(_this);
    _this.handleAddButtonClick = _this.handleAddButtonClick.bind(_this);
    _this.handleAdvancedSearchSubmit = _this.handleAdvancedSearchSubmit.bind(_this);
    _this.handleCancelRequest = _this.handleCancelRequest.bind(_this);
    _this.handleCloseModal = _this.handleCloseModal.bind(_this);
    _this.handleCloseModalAdd = _this.handleCloseModalAdd.bind(_this);
    _this.handleDoneRequest = _this.handleDoneRequest.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    _this.showRowComparison = _this.showRowComparison.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  SearchGeneric.prototype.getSearchForm = function getSearchForm() {
    if (this.state.dropdowns) {
      return React.createElement(
        'div',
        null,
        React.createElement(GenericSearchOptions, {
          session: this.props.session,
          initialType: this.props.initialType,
          properties: this.state.dropdowns.typeProps["Bibliography"],
          matchers: this.getMatcherTypes(),
          tags: this.state.dropdowns.typeTags["Bibliography"],
          tagOperators: this.state.dropdowns.tagOperators,
          handleSubmit: this.handleAdvancedSearchSubmit
        })
      );
    } else {
      return React.createElement(
        'span',
        null,
        'Loading dropdowns for search...'
      );
    }
  };

  SearchGeneric.prototype.getMatcherTypes = function getMatcherTypes() {
    return [{ label: this.state.labels.search.matchesAnywhere, value: "c" }, { label: this.state.labels.search.matchesAtTheStart, value: "sw" }, { label: this.state.labels.search.matchesAtTheEnd, value: "ew" }, { label: this.state.labels.search.matchesRegEx, value: "rx" }];
  };

  SearchGeneric.prototype.handleCancelRequest = function handleCancelRequest() {
    if (this.props.callback) {
      this.props.callback("", "");
    }
  };

  SearchGeneric.prototype.handleDoneRequest = function handleDoneRequest() {
    if (this.props.callback) {
      this.props.callback(this.state.selectedId, this.state.selectedValue);
    }
  };

  SearchGeneric.prototype.getSelectedDocOptions = function getSelectedDocOptions() {
    return React.createElement(
      Panel,
      null,
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.search.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedId,
          disabled: true
        }),
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.search.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedValue,
          disabled: true
        }),
        React.createElement(
          'div',
          null,
          React.createElement(
            ButtonGroup,
            { bsSize: 'xsmall' },
            React.createElement(
              Button,
              { onClick: this.handleCancelRequest },
              'Cancel'
            ),
            React.createElement(
              Button,
              { onClick: this.handleDoneRequest },
              'Done'
            )
          )
        )
      )
    );
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  SearchGeneric.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  SearchGeneric.prototype.fetchData = function fetchData(event) {
    if (this.state.docType && this.state.docType !== "*") {
      this.setState({
        message: this.state.labels.search.msg2,
        messageIcon: this.messageIcons.info,
        showSearchResults: false
      });
      var config = {
        auth: {
          username: this.state.session.userInfo.username,
          password: this.state.session.userInfo.password
        }
      };

      var parms = "t=" + encodeURIComponent(this.state.docType) + "&d=" + encodeURIComponent(this.state.docLibrary) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher) + "&l=" + encodeURIComponent(this.state.tags) + "&o=" + encodeURIComponent(this.state.tagOperator) + "&r=" + encodeURIComponent(this.state.propertiesToReturn);

      Server.getGenericSearchResult(this.props.session.restServer, this.state.session.userInfo.username, this.state.session.userInfo.password, parms, this.handleSearchCallback);
    }
  };

  SearchGeneric.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-page App-search' },
      React.createElement(
        'h3',
        null,
        this.state.labels.search.pageTitle
      ),
      React.createElement(
        Alert,
        null,
        this.state.labels.search.instructions
      ),
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      React.createElement(
        'div',
        { className: 'App-search-form' },
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            this.getSearchForm()
          )
        )
      ),
      React.createElement(
        'div',
        null,
        this.state.labels.search.resultLabel,
        ': ',
        React.createElement(
          'span',
          { className: 'App App-message' },
          React.createElement(FontAwesome, {
            name: this.state.messageIcon }),
          this.state.message,
          ' ',
          this.getAddButton()
        )
      ),
      this.state.showSearchResults && React.createElement(
        'div',
        null,
        this.state.labels.search.msg5,
        ' ',
        this.state.labels.search.msg6
      ),
      this.state.showModalAdd && this.getModalNewEntryForm(),
      this.state.showModalEditor && this.getModalEditor(),
      this.state.showSearchResults && React.createElement(
        'div',
        { className: 'App-search-results' },
        React.createElement(
          'div',
          { className: 'row' },
          this.getTable()
        )
      )
    );
  };

  return SearchGeneric;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {
    var showSelectionButtons = false;
    if (_this2.props.callback) {
      showSelectionButtons = true;
    }
    _this2.setState({
      message: _this2.state.labels.search.msg1,
      messageIcon: _this2.messageIcons.info,
      docPropMessage: _this2.state.docPropMessageByValue,
      showSelectionButtons: showSelectionButtons
    });
    var config = {
      auth: {
        username: _this2.state.session.userInfo.username,
        password: _this2.state.session.userInfo.password
      }
    };
    var path = _this2.props.session.restServer + Server.getDbServerDropdownsSearchBibliographyApi();
    axios.get(path, config).then(function (response) {
      // literals used as keys to get data from the response
      var valueKey = "dropdown";
      var propsKey = "typeProps";
      var tagsKey = "typeTags";
      var tagOperatorsKey = "tagOperators";
      var objectTypesKey = "typeList";
      var values = response.data.values[0][valueKey];
      _this2.setState({
        dropdowns: {
          types: values[objectTypesKey],
          typeProps: values[propsKey],
          typeTags: values[tagsKey],
          tagOperators: values[tagOperatorsKey],
          loaded: true
        },
        newEntryType: "BibEntryArticle"
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 401) {
        message = Server.getWsServerDbApi() + " is a protected database.  Please login and try again.";
        messageIcon = _this2.messageIcons.error;
      } else if (error && error.response && error.response.status === 404) {
        message = "error retrieving values for dropdowns";
        messageIcon = _this2.messageIcons.error;
      } else if (error && error.message && error.message.toLowerCase() === "network error") {
        message = "The database server " + Server.getWsServerDbApi() + " is not available.";
        messageIcon = _this2.messageIcons.error;
      }
      _this2.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state.docType));
  };

  this.setTheState = function (props, docType) {

    /**
     * Below is how we define the node properties to return from a database search.
     * Each of the above SuperTypes needs its corresponding propsToReturn and its own
     * Bootstrap Table (see getTable());
     * Most of these are used in the table that lists the results.
     * There is a different table for each type.  Although not explicitly requested,
     * the database will always add n._valueSchemaId.
     *
     * All the 'magic' happens in the function handleAdvancedSearchSubmit().
     * It examines the label returned from the search option for the type
     * to see what kind of schema we are dealing with.
     */
    var propsToReturnForBiblio = "n.id as id";
    propsToReturnForBiblio += ", n.library as library";
    propsToReturnForBiblio += ", n.topic as topic";
    propsToReturnForBiblio += ", n.key as key";
    propsToReturnForBiblio += ", n.entryType as type";
    propsToReturnForBiblio += ", coalesce(n.author, n.editor, n.editora) as author";
    propsToReturnForBiblio += ", n.title as title";
    propsToReturnForBiblio += ", coalesce(n.year, n.date) as date";
    propsToReturnForBiblio += ", n.tags as tags";

    var propsToReturnForOntology = "n.id as id";
    propsToReturnForOntology += ", n.library as library";
    propsToReturnForOntology += ", n.topic as topic";
    propsToReturnForOntology += ", n.key as key";
    propsToReturnForOntology += ", n.name as name";
    propsToReturnForOntology += ", n.description as desc";
    propsToReturnForOntology += ", n.tags as tags";

    var propsToReturnForGeneric = "n.id as id";
    propsToReturnForGeneric += ", n.library as library";
    propsToReturnForGeneric += ", n.topic as topic";
    propsToReturnForGeneric += ", n.key as key";
    propsToReturnForGeneric += ", coalesce(n.value, n.name, n.title) as value";
    propsToReturnForGeneric += ", n.tags as tags";

    var userDomain = "";
    var userInfo = {};

    if (props.session && props.session.userInfo && props.session.userInfo.domain) {
      userDomain = props.session.userInfo.domain;
      userInfo = new User(props.session.userInfo.username, props.session.userInfo.password, props.session.userInfo.domain, props.session.userInfo.email, props.session.userInfo.firstname, props.session.userInfo.lastname, props.session.userInfo.title, props.session.userInfo.authenticated, props.session.userInfo.domains);
    }
    var theSearchLabels = props.session.labels[props.session.labelTopics.SearchGeneric];

    return {
      labels: {
        resultsTableLabels: props.session.labels[props.session.labelTopics.resultsTable],
        search: theSearchLabels
      },
      message: theSearchLabels.msg1,
      session: {
        userInfo: userInfo
      },
      propertiesToReturn: get(_this2.state, "propertiesToReturn", propsToReturnForGeneric),
      propertiesToReturnGeneric: propsToReturnForGeneric,
      propertiesToReturnForBiblio: propsToReturnForBiblio,
      propertiesToReturnForOntology: propsToReturnForOntology,
      docType: "*",
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      matcherTypes: [{ label: theSearchLabels.matchesAnywhere, value: "c" }, { label: theSearchLabels.matchesAtTheStart, value: "sw" }, { label: theSearchLabels.matchesAtTheEnd, value: "ew" }, { label: theSearchLabels.matchesRegEx, value: "rx" }],
      matcher: "c",

      query: "",

      suggestedQuery: "",

      propertyTypes: [{ label: "ID", value: "id" }, { label: "Value (insensitive)", value: "nnp" }, { label: "Value (sensitive)", value: "value" }],

      docPropMessage: "",

      docPropMessageById: "Search By ID searches the ID of the docs, with the parts domain~topic~key, e.g. gr_gr_cog~actors~Priest.",

      docPropMessageByValue: "Search By Value is insensitive to accents, case, and punctuation.",

      docPropMessageByValueSensitive: "Search By Value (sensitive) is sensitive to accents, case, and punctuation.",

      searchFormToggle: _this2.messageIcons.toggleOff,

      showSearchForm: true,

      searchFormType: "simple",

      showSearchResults: false,

      resultCount: 0,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'checkbox' // radio vs. checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      filter: { type: 'RegexFilter', delay: 100 },
      showSelectionButtons: false,
      searchSuperType: get(_this2.state, "searchSuperType", SuperTypes.GENERIC),
      SuperTypes: SuperTypes,
      selectedId: get(_this2.state, "selectedId", ""),
      selectedLibrary: "",
      selectedTopic: "",
      selectedKey: "",
      selectedType: get(_this2.state, "selectedType", ""),
      title: "",
      selectedText: "",
      showModalEditor: false,
      idColumnSize: "80px",
      showModalAdd: get(_this2.state, "showModalAdd", false),
      addPanelOpen: get(_this2.state, "addPanelOpen", false),
      newEntryLibrary: get(_this2.state, "newEntryLibrary", userDomain),
      newEntryKey: get(_this2.state, "newEntryKey", ""),
      newEntryType: get(_this2.state, "newEntryType", "")
    };
  };

  this.handleCloseModalAdd = function () {
    _this2.setState({ showModalAdd: false }, _this2.fetchData);
  };

  this.handleAddButtonClick = function () {
    _this2.setState({ showModalAdd: true });
  };

  this.handleAdvancedSearchSubmit = function (type, typeLabel, library, property, matcher, value, tagOperator, tags) {
    var schema = type;
    if (schema.endsWith("CreateForm:1.1")) {
      schema = schema.substring(0, schema.length - 14);
    } else if (schema.endsWith(":1.1")) {
      schema = schema.substring(0, schema.length - 4);
    }
    var selectedSuperType = _this2.state.SuperTypes.GENERIC;
    var propertiesToReturn = _this2.state.propertiesToReturnGeneric;

    if (typeLabel.includes("Bibliography")) {
      selectedSuperType = _this2.state.SuperTypes.BIBLIOGRAPHY;
      propertiesToReturn = _this2.state.propertiesToReturnForBiblio;
    } else if (typeLabel.includes("Ontology")) {
      selectedSuperType = _this2.state.SuperTypes.ONTOLOGY;
      propertiesToReturn = _this2.state.propertiesToReturnForOntology;
    }
    _this2.setState({
      docType: schema,
      searchSuperType: selectedSuperType,
      propertiesToReturn: propertiesToReturn,
      docLibrary: library,
      docProp: property,
      matcher: matcher,
      query: value,
      tagOperator: tagOperator,
      tags: tags
    }, _this2.fetchData);
  };

  this.deselectAllRows = function () {
    _this2.refs.theTable.setState({
      selectedRowKeys: []
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    _this2.setState({
      selectedId: row["id"],
      selectedLibrary: row["library"],
      selectedTopic: row["topic"],
      selectedKey: row["key"],
      title: row["id"],
      showIdPartSelector: false,
      showModalEditor: _this2.props.editor
    });
  };

  this.showRowComparison = function (id) {
    if (_this2.props.editor) {
      _this2.setState({
        showModalEditor: true,
        selectedId: id
      });
    } else {
      _this2.setState({
        selectedId: id
      });
    }
  };

  this.handleCloseModal = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalEditor: false,
        selectedId: id,
        selectedValue: value
      });
    } else {
      _this2.setState({
        showModalEditor: false
      }, _this2.fetchData);
    }
    _this2.deselectAllRows();
  };

  this.getModalEditor = function () {
    return React.createElement(ModalSchemaBasedEditor, {
      session: _this2.props.session,
      restPath: Server.getDbServerDocsApi(),
      onClose: _this2.handleCloseModal,
      showModal: true,
      title: _this2.state.selectedId,
      idLibrary: _this2.state.selectedLibrary,
      idTopic: _this2.state.selectedTopic,
      idKey: _this2.state.selectedKey,
      canUpdate: _this2.props.session.userInfo.isAuthorFor(_this2.state.selectedLibrary)
    });
  };

  this.getModalNewEntryForm = function () {
    return React.createElement(GenericModalNewEntryForm, {
      session: _this2.props.session,
      restPath: Server.getDbServerDocsApi(),
      onClose: _this2.handleCloseModalAdd,
      title: _this2.state.labels.search.createTitle
    });
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };
  this.searchFormTypes = {
    simple: "simple",
    advanced: "advanced",
    idPattern: "id"
  };

  this.handleSearchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      _this2.setState({
        data: restCallResult.data
      });
      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (restCallResult.data.valueCount) {
        resultCount = restCallResult.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }
  };

  this.getAddButton = function () {
    return React.createElement(
      Button,
      {
        className: 'Text-Note-Add-Button',
        bsStyle: 'primary',
        bsSize: "xsmall",
        onClick: _this2.handleAddButtonClick },
      React.createElement(FontAwesome, {
        className: 'App-Add-ico',
        name: 'plus' })
    );
  };

  this.getTable = function () {
    switch (_this2.state.searchSuperType) {
      case _this2.state.SuperTypes.BIBLIOGRAPHY:
        {
          return _this2.getTableForBibliographies();
          break;
        }
      case _this2.state.SuperTypes.ONTOLOGY:
        {
          return _this2.getTableForOntology();
          break;
        }
      default:
        {
          return _this2.getTableGeneric();
        }
    }
  };

  this.getTableForAbbreviations = function () {};

  this.getTableForBibliographies = function () {
    return React.createElement(
      BootstrapTable,
      {
        ref: 'theTable',
        data: _this2.state.data.values,
        exportCSV: false,
        trClassName: "App-data-tr",
        striped: true,
        hover: true,
        pagination: true,
        options: _this2.state.options,
        selectRow: _this2.state.selectRow
      },
      React.createElement(
        TableHeaderColumn,
        {
          isKey: true,
          dataField: 'id',
          dataSort: true,
          'export': true,
          hidden: true
        },
        'ID'
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'library',
          dataSort: true,
          'export': false,
          tdClassname: 'tdDomain',
          width: "10%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerDomain
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'key',
          dataSort: true,
          'export': false,
          tdClassname: 'tdKey',
          width: "10%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerText
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'type',
          dataSort: true,
          tdClassname: 'tdType',
          width: "10%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerType
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'title',
          dataSort: true,
          tdClassname: "tdTitle",
          width: "35%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerNote
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'author',
          dataSort: true,
          tdClassname: "tdAuthor",
          width: "15%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerNote
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'date',
          dataSort: true,
          tdClassname: "tdDate",
          width: "10%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerNote
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'tags',
          'export': false,
          dataSort: true,
          width: "20%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerTags
      )
    );
  };

  this.getTableGeneric = function () {
    return React.createElement(
      BootstrapTable,
      {
        ref: 'theTable',
        data: _this2.state.data.values,
        exportCSV: false,
        trClassName: "App-data-tr",
        search: true,
        searchPlaceholder: _this2.state.labels.resultsTableLabels.filterPrompt,
        striped: true,
        hover: true,
        pagination: true,
        options: _this2.state.options,
        selectRow: _this2.state.selectRow
      },
      React.createElement(
        TableHeaderColumn,
        {
          isKey: true,
          dataField: 'id',
          dataSort: true,
          'export': true,
          hidden: true
        },
        'ID'
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'library',
          dataSort: true,
          'export': false,
          width: "10%"
        },
        _this2.state.labels.resultsTableLabels.headerDomain
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'topic',
          dataSort: true,
          'export': false,
          width: "10%"
        },
        _this2.state.labels.resultsTableLabels.headerTopic
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'key',
          dataSort: true,
          tdClassname: 'tdKey',
          width: "10%"
        },
        _this2.state.labels.resultsTableLabels.headerKey
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'value',
          dataSort: true,
          width: "40%"
        },
        _this2.state.labels.resultsTableLabels.headerValue
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'tags',
          'export': false,
          dataSort: true
        },
        _this2.state.labels.resultsTableLabels.headerTags
      )
    );
  };

  this.getTableForOntology = function () {
    return React.createElement(
      BootstrapTable,
      {
        ref: 'theTable',
        data: _this2.state.data.values,
        exportCSV: false,
        trClassName: "App-data-tr",
        search: true,
        searchPlaceholder: _this2.state.labels.resultsTableLabels.filterPrompt,
        striped: true,
        hover: true,
        pagination: true,
        options: _this2.state.options,
        selectRow: _this2.state.selectRow
      },
      React.createElement(
        TableHeaderColumn,
        {
          isKey: true,
          dataField: 'id',
          dataSort: true,
          'export': true,
          hidden: true
        },
        'ID'
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'topic',
          dataSort: true,
          'export': false,
          tdClassname: 'tdTopic',
          width: "10%"
        },
        _this2.state.labels.resultsTableLabels.headerTopic
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'key',
          dataSort: true,
          tdClassname: 'tdKey',
          width: "10%"
        },
        _this2.state.labels.resultsTableLabels.headerKey
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'name',
          dataSort: true
        },
        _this2.state.labels.resultsTableLabels.headerName
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'description',
          'export': false,
          dataSort: true
        },
        _this2.state.labels.resultsTableLabels.headerDesc
      ),
      React.createElement(
        TableHeaderColumn,
        {
          dataField: 'tags',
          'export': false,
          dataSort: true
        },
        _this2.state.labels.resultsTableLabels.headerTags
      ),
      React.createElement(TableHeaderColumn, {
        dataField: '_valueSchemaId',
        'export': false,
        hidden: true
      })
    );
  };
}, _temp);

process.env.NODE_ENV !== "production" ? SearchGeneric.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func,
  editor: PropTypes.bool,
  initialType: PropTypes.string,
  fixedType: PropTypes.bool
} : void 0;

SearchGeneric.defaultProps = {
  initialType: "*",
  editor: true,
  fixedType: true
};

export default SearchGeneric;