var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { get } from 'lodash';
import TextNoteSearchOptions from "./modules/TextNoteSearchOptions";
import ModalTextNoteEditor from './modules/ModalTextNoteEditor';
import FontAwesome from 'react-fontawesome';
import { Button, ButtonGroup, ControlLabel, FormControl, FormGroup, Panel, PanelGroup } from 'react-bootstrap';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import Server from './helpers/Server';
import FormattedTextNote from './FormattedTextNote';

export var SearchTextNotes = (_temp = _class = function (_React$Component) {
  _inherits(SearchTextNotes, _React$Component);

  function SearchTextNotes(props) {
    _classCallCheck(this, SearchTextNotes);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.deselectAllRows = _this.deselectAllRows.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getMatcherTypes = _this.getMatcherTypes.bind(_this);
    _this.getModalEditor = _this.getModalEditor.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.getSelectedDocOptions = _this.getSelectedDocOptions.bind(_this);
    _this.handleAdvancedSearchSubmit = _this.handleAdvancedSearchSubmit.bind(_this);
    _this.handleCancelRequest = _this.handleCancelRequest.bind(_this);
    _this.handleCloseModal = _this.handleCloseModal.bind(_this);
    _this.handleDoneRequest = _this.handleDoneRequest.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.noteFormatter = _this.noteFormatter();
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    _this.showRowComparison = _this.showRowComparison.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  SearchTextNotes.prototype.getSearchForm = function getSearchForm() {
    if (this.state.dropdowns) {
      return React.createElement(
        'div',
        null,
        React.createElement(TextNoteSearchOptions, {
          session: this.props.session,
          types: this.state.dropdowns.types,
          initialType: this.props.initialType,
          properties: this.state.dropdowns.typeProps["NoteTextual"],
          matchers: this.getMatcherTypes(),
          tags: this.state.dropdowns.typeTags["NoteTextual"],
          tagOperators: this.state.dropdowns.tagOperators,
          handleSubmit: this.handleAdvancedSearchSubmit,
          labels: this.state.labels.search
        })
      );
    } else {
      return React.createElement(
        'span',
        null,
        'Loading dropdowns for search...'
      );
    }
  };

  SearchTextNotes.prototype.getMatcherTypes = function getMatcherTypes() {
    return [{ label: this.state.labels.search.matchesAnywhere, value: "c" }, { label: this.state.labels.search.matchesAtTheStart, value: "sw" }, { label: this.state.labels.search.matchesAtTheEnd, value: "ew" }, { label: this.state.labels.search.matchesRegEx, value: "rx" }];
  };

  SearchTextNotes.prototype.handleCancelRequest = function handleCancelRequest() {
    if (this.props.callback) {
      this.props.callback("", "");
    }
  };

  SearchTextNotes.prototype.handleDoneRequest = function handleDoneRequest() {
    if (this.props.callback) {
      this.props.callback(this.state.selectedId, this.state.selectedValue);
    }
  };

  SearchTextNotes.prototype.getSelectedDocOptions = function getSelectedDocOptions() {
    return React.createElement(
      Panel,
      null,
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.search.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedId,
          disabled: true
        }),
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.search.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedValue,
          disabled: true
        }),
        React.createElement(
          'div',
          null,
          React.createElement(
            ButtonGroup,
            { bsSize: 'xsmall' },
            React.createElement(
              Button,
              { onClick: this.handleCancelRequest },
              'Cancel'
            ),
            React.createElement(
              Button,
              { onClick: this.handleDoneRequest },
              'Done'
            )
          )
        )
      )
    );
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  SearchTextNotes.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  SearchTextNotes.prototype.fetchData = function fetchData(event) {
    var _this2 = this;

    this.setState({
      message: this.state.labels.search.msg2,
      messageIcon: this.messageIcons.info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.state.docType) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher) + "&l=" + encodeURIComponent(this.state.tags) + "&o=" + encodeURIComponent(this.state.tagOperator);
    var path = this.props.session.restServer + Server.getDbServerNotesApi() + parms;
    axios.get(path, config).then(function (response) {
      // response.data will contain: "id, library, topic, key, value, tags, text"
      _this2.setState({
        data: response.data
      });
      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (response.data.valueCount) {
        resultCount = response.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.search.foundNone;
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  SearchTextNotes.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-page App-search' },
      React.createElement(
        'h3',
        null,
        this.state.labels.search.pageTitle
      ),
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      React.createElement(
        'div',
        { className: 'App-search-form' },
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            this.getSearchForm()
          )
        )
      ),
      React.createElement(
        'div',
        null,
        this.state.labels.search.resultLabel,
        ': ',
        React.createElement(
          'span',
          { className: 'App App-message' },
          React.createElement(FontAwesome, {
            name: this.state.messageIcon }),
          this.state.message,
          ' '
        )
      ),
      this.state.showSearchResults && React.createElement(
        'div',
        null,
        this.state.labels.search.msg5,
        ' ',
        this.state.labels.search.msg6
      ),
      this.state.showModalEditor && this.getModalEditor(),
      this.state.showSearchResults && React.createElement(
        'div',
        { className: 'App-search-results' },
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            BootstrapTable,
            {
              ref: 'theTable',
              data: this.state.data.values,
              exportCSV: false,
              trClassName: "App-data-tr",
              striped: true,
              hover: true,
              pagination: true,
              options: this.state.options,
              selectRow: this.state.selectRow
            },
            React.createElement(
              TableHeaderColumn,
              {
                isKey: true,
                dataField: 'id',
                dataSort: true,
                'export': true,
                hidden: true
              },
              'ID'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'text',
                dataSort: true,
                'export': false,
                tdClassname: 'tdText',
                width: "30%",
                filter: this.state.filter
              },
              this.state.labels.resultsTable.headerText
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'type',
                dataSort: true,
                tdClassname: 'tdType',
                width: "10%",
                filter: this.state.filter
              },
              this.state.labels.resultsTable.headerType
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'valueFormatted',
                dataSort: true,
                width: "50%",
                filter: this.state.filter,
                dataFormat: this.noteFormatter,
                formatExtraData: this.props.session
              },
              this.state.labels.resultsTable.headerNote
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'tags',
                'export': false,
                dataSort: true,
                width: "10%",
                filter: this.state.filter
              },
              this.state.labels.resultsTable.headerTags
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'noteTitle',
                'export': true,
                hidden: true
              },
              'Title'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'liturgicalScope',
                'export': true,
                hidden: true
              },
              'Liturgical Scope'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'liturgicalLemma',
                'export': true,
                hidden: true
              },
              'Liturgical Lemma'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'biblicalScope',
                'export': true,
                hidden: true
              },
              'Liturgical Scope'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'biblicalLemma',
                'export': true,
                hidden: true
              },
              'Liturgical Lemma'
            )
          )
        )
      )
    );
  };

  return SearchTextNotes;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    var showSelectionButtons = false;
    if (_this3.props.callback) {
      showSelectionButtons = true;
    }
    _this3.setState({
      message: _this3.state.labels.search.msg1,
      messageIcon: _this3.messageIcons.info,
      docPropMessage: _this3.state.docPropMessageByValue,
      showSelectionButtons: showSelectionButtons
    });
    var config = {
      auth: {
        username: _this3.props.session.userInfo.username,
        password: _this3.props.session.userInfo.password
      }
    };
    var path = _this3.props.session.restServer + Server.getDbServerDropdownsSearchNotesApi();
    axios.get(path, config).then(function (response) {
      // literals used as keys to get data from the response
      var valueKey = "dropdown";
      var propsKey = "typeProps";
      var tagsKey = "typeTags";
      var tagOperatorsKey = "tagOperators";
      var textNoteTypesKey = "textNoteTypes";
      var values = response.data.values[0][valueKey];
      _this3.setState({
        dropdowns: {
          types: values[textNoteTypesKey],
          typeProps: values[propsKey],
          typeTags: values[tagsKey],
          tagOperators: values[tagOperatorsKey],
          loaded: true
        }
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this3.messageIcons.error;
      if (error && error.response && error.response.status === 401) {
        message = Server.getWsServerDbApi() + " is a protected database.  Please login and try again.";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.response && error.response.status === 404) {
        message = "error retrieving values for dropdowns";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.message && error.message.toLowerCase() === "network error") {
        message = "The database server " + Server.getWsServerDbApi() + " is not available.";
        messageIcon = _this3.messageIcons.error;
      }
      _this3.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this3.setState(_this3.setTheState(nextProps, _this3.state.docType));
  };

  this.setTheState = function (props, docType) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.searchNotes];

    return {
      labels: {
        search: theSearchLabels,
        resultsTable: labels[labelTopics.resultsTable]
      },
      docType: "NoteTextual",
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      matcherTypes: [{ label: theSearchLabels.matchesAnywhere, value: "c" }, { label: theSearchLabels.matchesAtTheStart, value: "sw" }, { label: theSearchLabels.matchesAtTheEnd, value: "ew" }, { label: theSearchLabels.matchesRegEx, value: "rx" }],
      matcher: "c",

      query: "",

      suggestedQuery: "",

      propertyTypes: [{ label: "ID", value: "id" }, { label: "Value (insensitive)", value: "nnp" }, { label: "Value (sensitive)", value: "value" }],

      docPropMessage: "",

      docPropMessageById: "Search By ID searches the ID of the docs, with the parts domain~topic~key, e.g. gr_gr_cog~actors~Priest.",

      docPropMessageByValue: "Search By Value is insensitive to accents, case, and punctuation.",

      docPropMessageByValueSensitive: "Search By Value (sensitive) is sensitive to accents, case, and punctuation.",

      searchFormToggle: _this3.messageIcons.toggleOff,

      showSearchForm: true,

      searchFormType: "simple",

      showSearchResults: false,

      resultCount: 0,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this3.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this3.handleRowSelect,
        className: "App-row-select"
      },
      filter: { type: 'RegexFilter', delay: 100 },

      showSelectionButtons: false,
      selectedId: get(_this3.state, "selectedId", ""),
      selectedLibrary: "",
      selectedTopic: "",
      selectedKey: "",
      title: "",
      selectedText: "",
      showModalEditor: false,
      idColumnSize: "80px"
    };
  };

  this.handleAdvancedSearchSubmit = function (type, property, matcher, value, tagOperator, tags) {
    _this3.setState({
      docType: type,
      docProp: property,
      matcher: matcher,
      query: value,
      tagOperator: tagOperator,
      tags: tags
    }, _this3.fetchData);
  };

  this.deselectAllRows = function () {
    _this3.refs.theTable.setState({
      selectedRowKeys: []
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    _this3.setState({
      selectedId: row["id"],
      selectedLibrary: row["library"],
      selectedTopic: row["topic"],
      selectedKey: row["key"],
      title: row["id"],
      selectedText: row["text"],
      showIdPartSelector: true,
      showModalEditor: _this3.props.editor
    });
  };

  this.showRowComparison = function (id) {
    if (_this3.props.editor) {
      _this3.setState({
        showModalEditor: true,
        selectedId: id
      });
    } else {
      _this3.setState({
        selectedId: id
      });
    }
  };

  this.handleCloseModal = function (id, value) {
    if (id && id.length > 0) {
      _this3.setState({
        showModalEditor: false,
        selectedId: id,
        selectedValue: value
      });
    } else {
      _this3.setState({
        showModalEditor: false
      }, _this3.fetchData);
    }
    _this3.deselectAllRows();
  };

  this.getModalEditor = function () {
    return React.createElement(ModalTextNoteEditor, {
      session: _this3.props.session,
      restPath: Server.getDbServerDocsApi(),
      noteIdTopic: _this3.state.selectedTopic,
      noteIdLibrary: _this3.state.selectedLibrary,
      noteIdKey: _this3.state.selectedKey,
      onClose: _this3.handleCloseModal
    });
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this3.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };
  this.searchFormTypes = {
    simple: "simple",
    advanced: "advanced",
    idPattern: "id"
  };

  this.noteFormatter = function (cell, row, formatExtraData) {
    return function (cell, row, formatExtraData) {
      return React.createElement(FormattedTextNote, {
        session: formatExtraData,
        note: row["valueFormatted"],
        type: row["type"],
        title: row["title"],
        scopeLiturgical: row["liturgicalScope"],
        lemmaLiturgical: row["liturgicalLemma"],
        scopeBiblical: row["biblicalScope"],
        lemmaBiblical: row["biblicalLemma"]
      });
    };
  };
}, _temp);

process.env.NODE_ENV !== "production" ? SearchTextNotes.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func,
  editor: PropTypes.bool.isRequired,
  initialType: PropTypes.string,
  fixedType: PropTypes.bool.isRequired
} : void 0;

SearchTextNotes.defaultProps = {
  initialType: "*"
};

export default SearchTextNotes;