var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { get } from 'lodash';
import TreebankSearchOptions from "./modules/TreebankSearchOptions";
import FontAwesome from 'react-fontawesome';
import { Button, ButtonGroup, ControlLabel, FormControl, FormGroup, Modal, Panel, Well } from 'react-bootstrap';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import Server from './helpers/Server';
import TreeViewUtils from './helpers/TreeViewUtils';
import Spinner from './helpers/Spinner';
import DependencyDiagram from './modules/DependencyDiagram';
import HyperTokenText from './modules/HyperTokenText';

export var SearchTreebanks = (_temp = _class = function (_React$Component) {
  _inherits(SearchTreebanks, _React$Component);

  function SearchTreebanks(props) {
    _classCallCheck(this, SearchTreebanks);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.fetchData = _this.fetchData.bind(_this);
    _this.fetchDiagramData = _this.fetchDiagramData.bind(_this);
    _this.showSearchStatus = _this.showSearchStatus.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleAdvancedSearchSubmit = _this.handleAdvancedSearchSubmit.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.handleCancelRequest = _this.handleCancelRequest.bind(_this);
    _this.handleDoneRequest = _this.handleDoneRequest.bind(_this);
    _this.getSelectedDocOptions = _this.getSelectedDocOptions.bind(_this);
    _this.getModalWindow = _this.getModalWindow.bind(_this);
    _this.handleCloseModal = _this.handleCloseModal.bind(_this);
    _this.getMatcherTypes = _this.getMatcherTypes.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    _this.deselectAllRows = _this.deselectAllRows.bind(_this);
    _this.handleTokenClick = _this.handleTokenClick.bind(_this);
    _this.treeViewSelectCallback = _this.treeViewSelectCallback.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  SearchTreebanks.prototype.getSearchForm = function getSearchForm() {
    return React.createElement(
      'div',
      null,
      this.state.dropdowns ? React.createElement(TreebankSearchOptions, {
        sources: this.state.dropdowns.sources,
        initialType: this.props.fixedType ? this.props.initialType : this.state.docType,
        properties: this.state.dropdowns.typeProps,
        matchers: this.getMatcherTypes(),
        tags: this.state.dropdowns.typeTags,
        tagOperators: this.state.dropdowns.tagOperators,
        labels: this.state.labels.thisClass,
        relationshipLabels: this.state.dropdowns.relLabels,
        handleSubmit: this.handleAdvancedSearchSubmit
      }) : "Loading dropdowns for search..."
    );
  };

  SearchTreebanks.prototype.getMatcherTypes = function getMatcherTypes() {
    return [{ label: this.state.labels.thisClass.matchesAnywhere, value: "c" }, { label: this.state.labels.thisClass.matchesAtTheStart, value: "sw" }, { label: this.state.labels.thisClass.matchesAtTheEnd, value: "ew" }, { label: this.state.labels.thisClass.matchesRegEx, value: "rx" }];
  };

  SearchTreebanks.prototype.handleCancelRequest = function handleCancelRequest() {
    if (this.props.callback) {
      this.props.callback("", "");
    }
  };

  SearchTreebanks.prototype.handleDoneRequest = function handleDoneRequest() {
    if (this.props.callback) {
      this.props.callback(this.state.selectedId, this.state.selectedValue);
    }
  };

  SearchTreebanks.prototype.getSelectedDocOptions = function getSelectedDocOptions() {
    return React.createElement(
      Panel,
      null,
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.thisClass.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedId,
          disabled: true
        }),
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.thisClass.selectedDoc
        ),
        React.createElement(FormControl, {
          type: 'text',
          value: this.state.selectedValue,
          disabled: true
        }),
        React.createElement(
          'div',
          null,
          React.createElement(
            ButtonGroup,
            { bsSize: 'xsmall' },
            React.createElement(
              Button,
              { onClick: this.handleCancelRequest },
              'Cancel'
            ),
            React.createElement(
              Button,
              { onClick: this.handleDoneRequest },
              'Done'
            )
          )
        )
      )
    );
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  SearchTreebanks.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  SearchTreebanks.prototype.fetchData = function fetchData(event) {
    var _this2 = this;

    this.setState({
      message: this.state.labels.thisClass.msg2,
      messageIcon: this.messageIcons.info,
      fetchingData: true,
      dataFetched: false
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.state.docType) + "&r=" + encodeURIComponent(this.state.relLabel) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher) + "&l=" + encodeURIComponent(this.state.tags) + "&o=" + encodeURIComponent(this.state.tagOperator);
    var path = this.props.session.restServer + Server.getDbServerTreebanksApi() + parms;
    axios.get(path, config).then(function (response) {
      _this2.setState({
        data: response.data,
        fetchingData: false,
        dataFetched: true
      });

      var resultCount = 0;
      var message = _this2.state.labels.thisClass.foundNone;
      var found = _this2.state.labels.thisClass.foundMany;
      if (response.data.valueCount) {
        resultCount = response.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.thisClass.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.thisClass.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }
      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.thisClass.foundNone;
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  SearchTreebanks.prototype.fetchDiagramData = function fetchDiagramData() {
    var _this3 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.state.docType);

    var path = this.props.session.restServer + Server.getDbServerTreebanksApi() + "/" + encodeURIComponent("en_sys_linguistics") + "/" + encodeURIComponent(this.state.selectedTopic) + parms;
    axios.get(path, config).then(function (response) {
      var text = response.data.values[0].text.value;
      var tokens = response.data.values[1].tokens;
      var nodes = response.data.values[2].nodes;
      var treeViewUtils = new TreeViewUtils(nodes);
      var treeNodeData = treeViewUtils.toTreeViewData("Root");
      _this3.setState({
        text: text,
        nodes: nodes,
        tokens: tokens,
        treeNodeData: treeNodeData,
        showModalWindow: true
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this3.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this3.state.labels.search.foundNone;
        messageIcon = _this3.messageIcons.warning;
        _this3.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  SearchTreebanks.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App-page App-search-treebanks' },
      React.createElement(
        'h3',
        null,
        this.state.labels.thisClass.pageTitle
      ),
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      React.createElement(
        'div',
        { className: 'App-search-form' },
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            this.getSearchForm()
          )
        )
      ),
      this.showSearchStatus(),
      this.state.showModalWindow && this.getModalWindow(),
      this.state.showSearchResults && React.createElement(
        'div',
        { className: 'App-search-results' },
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            BootstrapTable,
            {
              ref: 'theTable',
              data: this.state.data.values,
              exportCSV: false,
              trClassName: "App-data-tr",
              search: true,
              searchPlaceholder: this.state.labels.resultsTable.filterPrompt,
              striped: true,
              hover: true,
              pagination: true,
              options: this.state.options,
              selectRow: this.state.selectRow
            },
            React.createElement(
              TableHeaderColumn,
              {
                isKey: true,
                dataField: 'c.id',
                'export': true,
                hidden: true
              },
              'ID'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'c.topic',
                'export': true,
                hidden: true
              },
              'Sentence'
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'd.token',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerChildToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'd.nnpToken',
                hidden: true
              },
              this.state.labels.resultsTable.headerChildToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'd.grammar',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerChildGrammar
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'DtoC',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerChildLabel
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'c.token',
                dataSort: true,
                filter: this.state.tableColumnFilter,
                columnClassName: "App-Search-Treebank-Target"
              },
              this.state.labels.resultsTable.headerToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'c.nnpToken',
                hidden: true
              },
              this.state.labels.resultsTable.headerToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'c.grammar',
                dataSort: true,
                filter: this.state.tableColumnFilter,
                columnClassName: "App-Search-Treebank-Target"
              },
              this.state.labels.resultsTable.headerGrammar
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'CtoB',
                dataSort: true,
                filter: this.state.tableColumnFilter,
                columnClassName: "App-Search-Treebank-Target"
              },
              this.state.labels.resultsTable.headerLabel
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'b.token',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerParentToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'b.nnpToken',
                hidden: true
              },
              this.state.labels.resultsTable.headerParentToken
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'b.grammar',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerParentGrammar
            ),
            React.createElement(
              TableHeaderColumn,
              {
                dataField: 'BtoA',
                dataSort: true,
                filter: this.state.tableColumnFilter
              },
              this.state.labels.resultsTable.headerParentLabel
            )
          )
        )
      )
    );
  };

  return SearchTreebanks;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.componentWillMount = function () {
    var showSelectionButtons = false;
    if (_this4.props.callback) {
      showSelectionButtons = true;
    }
    _this4.setState({
      message: _this4.state.labels.thisClass.msg1,
      messageIcon: _this4.messageIcons.info,
      docPropMessage: _this4.state.docPropMessageByValue,
      showSelectionButtons: showSelectionButtons,
      fetchingData: false,
      dataFetched: false
    });
    var config = {
      auth: {
        username: _this4.props.session.userInfo.username,
        password: _this4.props.session.userInfo.password
      }
    };
    var path = _this4.props.session.restServer + Server.getDbServerDropdownsSearchTreebanksApi();
    axios.get(path, config).then(function (response) {
      // literals used as keys to get data from the response
      var sourceKey = "sourceList";
      var relLabelsKey = "relLabels";
      var valueKey = "dropdown";
      var listKey = "typeList";
      var propsKey = "typeProps";
      var tagsKey = "typeTags";
      var tagOperatorsKey = "tagOperators";

      var values = response.data.values[0][valueKey];
      _this4.setState({
        dropdowns: {
          sources: values[sourceKey],
          relLabels: values[relLabelsKey],
          types: values[listKey],
          typeProps: values[propsKey],
          typeTags: values[tagsKey],
          tagOperators: values[tagOperatorsKey],
          loaded: true
        }
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this4.messageIcons.error;
      if (error && error.response && error.response.status === 401) {
        message = Server.getWsServerDbApi() + " is a protected database.  Please login and try again.";
        messageIcon = _this4.messageIcons.error;
      } else if (error && error.response && error.response.status === 404) {
        message = "error retrieving values for dropdowns";
        messageIcon = _this4.messageIcons.error;
      } else if (error && error.message && error.message.toLowerCase() === "network error") {
        message = "The database server " + Server.getWsServerDbApi() + " is not available.";
        messageIcon = _this4.messageIcons.error;
      }
      _this4.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this4.setTheState(nextProps, _this4.state);
  };

  this.setTheState = function (props, currentState) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.searchTreebanks];

    return {
      labels: {
        thisClass: theSearchLabels,
        messages: labels[labelTopics.messages],
        resultsTable: labels[labelTopics.resultsTable]
      },
      docType: get(currentState, "docType", props.initialType),
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      matcherTypes: [{ label: theSearchLabels.matchesAnywhere, value: "c" }, { label: theSearchLabels.matchesAtTheStart, value: "sw" }, { label: theSearchLabels.matchesAtTheEnd, value: "ew" }, { label: theSearchLabels.matchesRegEx, value: "rx" }],
      matcher: "c",

      query: "",

      suggestedQuery: "",

      propertyTypes: [{ label: "ID", value: "id" }, { label: "Value (insensitive)", value: "nnp" }, { label: "Value (sensitive)", value: "value" }],

      docPropMessage: "",

      docPropMessageById: "Search By ID searches the ID of the docs, with the parts domain~topic~key, e.g. gr_gr_cog~actors~Priest.",

      docPropMessageByValue: "Search By Value is insensitive to accents, case, and punctuation.",

      docPropMessageByValueSensitive: "Search By Value (sensitive) is sensitive to accents, case, and punctuation.",

      searchFormToggle: _this4.messageIcons.toggleOff,

      showSearchForm: true,

      searchFormType: "simple",

      showSearchResults: false,

      resultCount: 0,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this4.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this4.handleRowSelect,
        className: "App-row-select"
      },
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: labels[labelTopics.messages].regEx
      },

      showSelectionButtons: false,
      selectedId: get(currentState, "selectedId", ""),
      selectedLibrary: "",
      selectedTopic: "",
      selectedKey: "",
      title: "",
      selectedText: "",
      showModalWindow: get(currentState, "showModalWindow", false),
      idColumnSize: "80px",
      updatingData: get(currentState, "updatingData", false),
      dataUpdated: get(currentState, "dataUpdated", false),
      selectedTokenIndexNumber: get(currentState, "selectedTokenIndexNumber", 1)
    };
  };

  this.treeViewSelectCallback = function (node) {
    if (node && node.key) {
      var intKey = parseInt(node.key);
      _this4.handleTokenClick(intKey - 1, _this4.state.tokens[intKey]);
    }
  };

  this.handleTokenClick = function (index, token) {
    var treeViewIndex = parseInt(index) + 1;
    var tokenIndex = parseInt(index);
    var tokenIsWord = true;
    if (token && token.length < 2) {
      var notLetter = '"\'·.,;?!~@#$%^&z-z_[]{})(-:0123456789';
      if (notLetter.includes(token)) {
        tokenIsWord = false;
      }
    }
    var treeViewUtils = new TreeViewUtils(_this4.state.nodes);
    var treeNodeData = treeViewUtils.toTreeViewData("Root", treeViewIndex);

    _this4.setState({
      selectedTokenIndex: index,
      selectedTokenIndexNumber: tokenIndex,
      selectedToken: token,
      selectedTokenIsWord: tokenIsWord,
      treeNodeData: treeNodeData
    });
  };

  this.handleAdvancedSearchSubmit = function (type, relLabel, property, matcher, value, tagOperator, tags) {
    _this4.setState({
      docType: type,
      relLabel: relLabel,
      docProp: property,
      matcher: matcher,
      query: value,
      tagOperator: tagOperator,
      tags: tags
    }, _this4.fetchData);
  };

  this.deselectAllRows = function () {
    _this4.refs.theTable.setState({
      selectedRowKeys: []
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    _this4.setState({
      selectedTopic: row["c.topic"]
    }, _this4.fetchDiagramData);
  };

  this.handleCloseModal = function () {
    _this4.setState({
      showModalWindow: false
    });
    _this4.deselectAllRows();
  };

  this.getModalWindow = function () {
    return React.createElement(
      'div',
      { className: "App-Modal-Dependency-Diagram" },
      React.createElement(
        Modal,
        { backdrop: 'static', show: true, onHide: _this4.handleCloseModal },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            _this4.state.selectedTopic
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(HyperTokenText, {
            session: _this4.props.session,
            tokens: _this4.state.tokens,
            selectedToken: _this4.state.selectedTokenIndexNumber,
            onClick: _this4.handleTokenClick
          }),
          React.createElement(
            Well,
            { className: "App-DependencyDiagram-Well" },
            React.createElement(DependencyDiagram, {
              data: _this4.state.treeNodeData,
              highlightSelected: true,
              onClick: _this4.treeViewSelectCallback
            })
          )
        ),
        React.createElement(Modal.Footer, null)
      )
    );
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this4.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle"
    // , toggleOn: "eye"
    // , toggleOff: "eye-slash"
    , toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };
  this.searchFormTypes = {
    simple: "simple",
    advanced: "advanced",
    idPattern: "id"
  };

  this.showSearchStatus = function () {
    if (_this4.state.fetchingData) {
      return React.createElement(Spinner, { message: _this4.state.labels.messages.searching });
    } else if (_this4.state.showSearchResults) {
      return React.createElement(
        'div',
        null,
        _this4.state.labels.thisClass.resultLabel,
        ': ',
        React.createElement(
          'span',
          { className: 'App App-message' },
          React.createElement(FontAwesome, {
            name: _this4.state.messageIcon }),
          _this4.state.message,
          ' '
        ),
        React.createElement(
          'div',
          null,
          _this4.state.labels.thisClass.msg5,
          ' ',
          _this4.state.labels.thisClass.msg6
        )
      );
    } else {
      return React.createElement('span', null);
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? SearchTreebanks.propTypes = {
  session: PropTypes.object.isRequired,
  callback: PropTypes.func,
  editor: PropTypes.bool.isRequired,
  initialType: PropTypes.string.isRequired,
  fixedType: PropTypes.bool.isRequired
} : void 0;

export default SearchTreebanks;