function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by mac002 on 6/6/17.
 */

var UdTreeNode = function () {
  function UdTreeNode(id, token, lemma, gloss, dependsOn, refersTo, label, gCase, gender, mood, number, person, pos, tense, voice) {
    var _this = this;

    _classCallCheck(this, UdTreeNode);

    this.getGrammarForNounLikeWords = function () {
      return _this.pos + "." + _this.number + "." + _this.gender + "." + _this.case;
    };

    this.hasGrammarForNounLikeWords = function () {
      if (_this.pos && _this.gender && _this.number && _this.case) {
        if (TreeNode.requiresReferent(_this.pos)) {
          return _this.refersTo;
        } else {
          return true;
        }
      } else {
        return false;
      }
    };

    this.getGrammarForVerb = function () {
      return _this.pos + "." + _this.person + "." + _this.number + "." + _this.tense + "." + _this.voice + "." + _this.mood;
    };

    this.hasGrammarForVerb = function () {
      if (_this.pos && _this.person && _this.number && _this.tense && _this.voice && _this.mood) {
        return true;
      } else {
        return false;
      }
    };

    this.getGrammarForParticiple = function () {
      return _this.pos + "." + _this.voice + "." + _this.tense + "." + _this.gender + "." + _this.number + "." + _this.case;
    };

    this.hasGrammarForParticiple = function (requireReferent) {
      if (_this.pos && _this.voice && _this.tense && _this.gender && _this.number && _this.case) {
        if (requireReferent) {
          if (_this.refersTo) {
            return true;
          } else {
            return false;
          }
        } else {
          return true;
        }
      } else {
        return false;
      }
    };

    this.hasGrammarForInfinitive = function () {
      if (_this.pos && _this.voice && _this.tense) {
        return true;
      } else {
        return false;
      }
    };

    this.getGrammarForInfinitive = function () {
      return _this.pos + "." + _this.tense + "." + _this.voice;
    };

    this.hasGrammarForParticiple = function () {
      if (_this.pos && _this.tense && _this.voice) {
        return true;
      } else {
        return false;
      }
    };

    this.isComplete = function () {
      var result = false;
      if (_this.lemma && _this.gloss && _this.dependsOn && _this.label && _this.pos) {
        switch (_this.pos) {
          case "ADJ":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ADJ.COMP":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ADJ.SUP.ABS":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ADJ.SUP.REL":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ART":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ART.DEF":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "ART.INDF":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.COR":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.DEF":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.DEM":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.INDF":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.PERS":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.POSS":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.Q":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.REFL":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "PRON.REL":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "NOUN":
            {
              result = _this.hasGrammarForNounLikeWords();
              break;
            }
          case "INF":
            {
              result = _this.hasGrammarForInfinitive();
              break;
            }
          case "PTCP":
            {
              result = _this.hasGrammarForParticiple();
              break;
            }
          case "VERB":
            {
              result = _this.hasGrammarForVerb();
              break;
            }
          default:
            {
              result = true;
            }
        }
      }
      return result;
    };

    this.notComplete = function () {
      return !_this.isComplete();
    };

    this.getGrammar = function () {
      switch (_this.pos) {
        case "ADJ":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ADJ.COMP":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ADJ.SUP.ABS":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ADJ.SUP.REL":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ART":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ART.DEF":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "ART.INDF":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "INF":
          {
            return _this.getGrammarForInfinitive();
          }
        case "PTCP":
          {
            return _this.getGrammarForParticiple();
          }
        case "PRON":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.COR":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.DEF":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.DEM":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.INDF":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.PERS":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.POSS":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.Q":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.REFL":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "PRON.REL":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "NOUN":
          {
            return _this.getGrammarForNounLikeWords();
          }
        case "VERB":
          {
            return _this.getGrammarForVerb();
          }
        default:
          {
            return _this.pos;
          }
      }
    };

    this.id = id;
    this.dependsOn = dependsOn ? dependsOn : "";
    this.refersTo = refersTo ? refersTo : "";
    this.token = token;
    this.lemma = lemma;
    this.gloss = gloss;
    this.label = label;
    this.case = gCase;
    this.gender = gender;
    this.mood = mood;
    this.number = number;
    this.person = person;
    this.pos = pos;
    this.tense = tense;
    this.voice = voice;
    this.grammar = this.getGrammar();
  }

  // e.g. VERB.3.SG.PRS.ACT.IND


  // e.g. PTCP.ACT.AOR.M.SG.NOM


  // e.g. INF.AOR.ACT


  // e.g. INF.AOR.ACT


  UdTreeNode.requiresReferent = function requiresReferent(pos) {
    switch (pos) {
      case "PRON":
        {
          return true;
          break;
        }
      case "PRON.COR":
        {
          return false;
          break;
        }
      case "PRON.DEF":
        {
          return true;
          break;
        }
      case "PRON.DEM":
        {
          return true;
          break;
        }
      case "PRON.INDF":
        {
          return false;
          break;
        }
      case "PRON.PERS":
        {
          return true;
          break;
        }
      case "PRON.POSS":
        {
          return true;
          break;
        }
      case "PRON.Q":
        {
          return false;
          break;
        }
      case "PRON.REFL":
        {
          return true;
          break;
        }
      case "PRON.REL":
        {
          return false;
          break;
        }
      default:
        {
          return false;
        }
    }
  };

  /**
   * On the server-side, the tags for grammar are set by LTKDbTokenAnalysis
   * in the org.ocmc.ioc.liturgical.schemas.models.supers package.
   * So, if changes are made here, you need to make
   * them also in LTKDbTokenAnalysis.
   */


  return UdTreeNode;
}();

export default UdTreeNode;