function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by mac002 on 6/6/17.
 * Note: if you want to use the functions for this class,
 * you should import the class, and when you set the state,
 * create a new instance of User and pass in the constructor
 * parameters from props.session.userInfo.  Then in your
 * component, use this.state.session.userInfo instead of
 * this.props.session.userInfo.  This is only necessary if
 * you are using the functions.  The reason for this is
 * that users of ioc-liturgical-react who use redux will
 * make a copy of objects and lose the functions.
 */

var User = function User(username, password, domain, email, firstname, lastname, title, authenticated, domains, prefs) {
  var _this = this;

  _classCallCheck(this, User);

  this.isAdminFor = function (library) {
    var authorized = false;
    if (_this.domains && _this.domains.admin) {
      for (var _iterator = _this.domains.admin, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var entry = _ref;

        if (entry.value == library) {
          authorized = true;
          break;
        }
      }
    }
    return authorized;
  };

  this.isAuthorFor = function (library) {
    var authorized = false;
    if (_this.isAdminFor(library)) {
      authorized = true;
    } else {
      if (_this.domains && _this.domains.author) {
        for (var _iterator2 = _this.domains.author, _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref2 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref2 = _i2.value;
          }

          var entry = _ref2;

          if (entry.value == library) {
            authorized = true;
            break;
          }
        }
      }
    }
    return authorized;
  };

  this.isReaderFor = function (library) {
    var authorized = false;
    if (_this.domains && _this.domains.reader) {
      if (_this.isAdminFor(library) || _this.isAuthorFor(library)) {
        authorized = true;
      } else {
        for (var _iterator3 = _this.domains.reader, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
          var _ref3;

          if (_isArray3) {
            if (_i3 >= _iterator3.length) break;
            _ref3 = _iterator3[_i3++];
          } else {
            _i3 = _iterator3.next();
            if (_i3.done) break;
            _ref3 = _i3.value;
          }

          var entry = _ref3;

          if (entry.value == library) {
            authorized = true;
            break;
          }
        }
      }
    }
    return authorized;
  };

  this.username = username ? username : "";
  this.password = password ? password : "";
  this.domain = domain ? domain : "";
  this.email = email ? email : "";
  this.firstname = firstname ? firstname : "";
  this.lastname = lastname ? lastname : "";
  this.title = title ? title : "";
  this.authenticated = authenticated ? authenticated : false;
  this.domains = domains ? domains : { admin: {}, author: {}, reader: {} };
  this.prefs = prefs ? prefs : {};
}

/**
 * Does the user have permission to author (create, update) records in this library?
 * @param library
 * @returns {boolean}
 */


/**
 * Does the user have permission to author (create, update) records in this library?
 * @param library
 * @returns {boolean}
 */

/**
 * Does the user have permission to read records in this library?
 * @param library
 * @returns {boolean}
 */
;

export default User;