var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { get } from 'lodash';
import { Alert, Button, Glyphicon } from 'react-bootstrap';
import Server from './Server';
import MessageIcons from './MessageIcons';

var DeleteButton = (_temp = _class = function (_React$Component) {
  _inherits(DeleteButton, _React$Component);

  function DeleteButton(props) {
    _classCallCheck(this, DeleteButton);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.deleteButton],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      show: false
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleDelete = _this.handleDelete.bind(_this);
    _this.handleDeleteCallback = _this.handleDeleteCallback.bind(_this);
    _this.handleDismiss = _this.handleDismiss.bind(_this);
    _this.handleShow = _this.handleShow.bind(_this);return _this;
  }

  // if we need to do something after setState, do it here...


  DeleteButton.prototype.handleDismiss = function handleDismiss() {
    this.setState({ show: false });
  };

  DeleteButton.prototype.handleDelete = function handleDelete() {
    Server.restDelete(this.props.session.restServer, this.props.session.userInfo.username, this.props.session.userInfo.password, this.props.idLibrary, this.props.idTopic, this.props.idKey, this.handleDeleteCallback);
  };

  DeleteButton.prototype.handleShow = function handleShow() {
    this.setState({ show: true });
  };

  DeleteButton.prototype.render = function render() {
    if (this.state.show) {
      return React.createElement(
        Alert,
        { bsStyle: 'danger', onDismiss: this.handleDismiss },
        React.createElement(
          'h4',
          null,
          this.state.labels.thisClass.danger
        ),
        React.createElement(
          'p',
          null,
          this.state.labels.thisClass.msg1
        ),
        React.createElement(
          'p',
          null,
          React.createElement(
            Button,
            {
              bsStyle: 'danger',
              onClick: this.handleDelete
            },
            this.state.labels.thisClass.yesDelete
          ),
          React.createElement(
            'span',
            null,
            ' or '
          ),
          React.createElement(
            Button,
            { onClick: this.handleDismiss },
            this.state.labels.buttons.cancel
          )
        )
      );
    }
    return React.createElement(
      Button,
      { className: 'App App-Button App-Delete-Button', bsStyle: 'warning', onClick: this.handleShow },
      React.createElement(Glyphicon, { glyph: "trash" }),
      this.state.labels.buttons.delete
    );
  };

  return DeleteButton;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.deleteButton],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial,
        somethingWeTrackIfChanged: get(_this2.state, "somethingWeTrackIfChanged", "")
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.handleDeleteCallback = function (result) {
    _this2.setState({ show: false }, _this2.props.onDelete);
  };
}, _temp);
;

process.env.NODE_ENV !== "production" ? DeleteButton.propTypes = {
  session: PropTypes.object.isRequired,
  idLibrary: PropTypes.string.isRequired,
  idTopic: PropTypes.string.isRequired,
  idKey: PropTypes.string.isRequired,
  onDelete: PropTypes.func.isRequired
} : void 0;

// set default values for props here
DeleteButton.defaultProps = {
  languageCode: "en"
};

export default DeleteButton;