var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { Button } from 'react-bootstrap';
import PropTypes from 'prop-types';
import Server from "./Server";
import Spinner from './Spinner';
import MessageIcons from "./MessageIcons";

var DownloadUserRecords = (_temp = _class = function (_React$Component) {
  _inherits(DownloadUserRecords, _React$Component);

  function DownloadUserRecords(props) {
    _classCallCheck(this, DownloadUserRecords);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    _this.state = {
      fetching: false,
      labels: {
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.fetchDocData = _this.fetchDocData.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  DownloadUserRecords.prototype.render = function render() {
    if (this.state.fetching) {
      return React.createElement(Spinner, { message: this.state.labels.messages.retrieving });
    } else {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Button,
          { onClick: this.fetchDocData },
          'Download'
        )
      );
    }
  };

  return DownloadUserRecords;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState(function (prevState, props) {
      return {
        labels: {
          messages: labels[labelTopics.messages]
        },
        message: labels[labelTopics.messages].initial
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.fetchDocData = function () {
    _this2.setState({ fetching: true });
    Server.restGetUserDocs(_this2.props.session.restServer, Server.getDbServerUserDocsApi(), _this2.props.session.userInfo.username, _this2.props.session.userInfo.password).then(function (response) {
      _this2.setState({
        userMessage: response.userMessage,
        developerMessage: response.developerMessage,
        messageIcon: response.messageIcon,
        status: response.status,
        fetching: false
      });
    }).catch(function (error) {
      _this2.setState({
        userMessage: error.userMessage,
        developerMessage: error.developerMessage,
        messageIcon: error.messageIcon,
        status: error.status,
        fetching: false
      });
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? DownloadUserRecords.propTypes = {
  session: PropTypes.object.isRequired
} : void 0;

// set default values for props here
DownloadUserRecords.defaultProps = {};

export default DownloadUserRecords;