var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import MessageIcons from '../helpers/MessageIcons';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';

/**
 * Use this as an example starting point for new React components
 */
var GlossBuilder = (_temp = _class = function (_React$Component) {
  _inherits(GlossBuilder, _React$Component);

  function GlossBuilder(props) {
    _classCallCheck(this, GlossBuilder);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    return _this;
  }

  GlossBuilder.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App App-GlossBuilder' },
      React.createElement(
        'div',
        { className: 'row' },
        React.createElement(
          BootstrapTable,
          {
            data: this.state.values,
            trClassName: "App-data-tr",
            search: true,
            striped: true,
            hover: true,
            pagination: true,
            options: this.state.options,
            selectRow: this.state.selectRow
          },
          React.createElement(
            TableHeaderColumn,
            {
              isKey: true,
              dataField: 'id',
              hidden: true
            },
            'ID'
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'library',
              tdClassname: 'tdDomain',
              width: this.state.idColumnSize },
            this.props.resultsTableLabels.headerDomain
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'topic',
              width: this.state.idColumnSize },
            this.props.resultsTableLabels.headerTopic
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'key',
              width: this.state.idColumnSize },
            this.props.resultsTableLabels.headerKey
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'value',
              dataSort: true
            },
            this.props.resultsTableLabels.headerValue
          )
        )
      )
    );
  };

  return GlossBuilder;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps);
  };

  this.setTheState = function (props) {
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: {
        thisClass: labels[labelTopics.GlossBuilder],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      values: _this2.props.values,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      }
    };
  };

  this.handleRowSelect = function (row, isSelected, e) {
    var idParts = row["id"].split("~");
    _this2.setState({
      selectedId: row["id"],
      selectedIdParts: [{ key: "domain", label: idParts[0] }, { key: "topic", label: idParts[1] }, { key: "key", label: idParts[2] }],
      selectedValue: row["value"],
      showIdPartSelector: true,
      showModalCompareDocs: true
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? GlossBuilder.propTypes = {
  session: PropTypes.object.isRequired,
  values: PropTypes.array.isRequired,
  callBack: PropTypes.func.isRequired
} : void 0;

GlossBuilder.defaultProps = {};

export default GlossBuilder;