function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import ResourceSelector from '../modules/ReactSelector';

/**
 * Converts a specified label property into a ReactSelector
 * that has each of the label's sub-properties as key-values
 */

var LabelSelector = function (_React$Component) {
  _inherits(LabelSelector, _React$Component);

  function LabelSelector(props) {
    _classCallCheck(this, LabelSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {
      _this.state = _this.setTheState(nextProps);
    };

    _this.setTheState = function (props) {
      return {};
    };

    _this.compare = function (a, b) {
      var comparison = 0;
      if (a.label > b.label) {
        comparison = 1;
      } else if (a.label < b.label) {
        comparison = -1;
      }
      return comparison;
    };

    _this.toArray = function () {
      var s = _this.props.labels.values;
      var result = Object.keys(s).map(function (key) {
        var item = {};
        item.value = key;
        if (isNaN(key)) {
          // show the value with the label so the user knows the code being used
          item.label = key + ": " + s[key];
        } else {
          item.label = s[key];
        }
        return item;
      });
      if (_this.props.sort) {
        result = result.sort(_this.compare);
      }
      return result;
    };

    _this.state = _this.setTheState(props, "");

    _this.compare = _this.compare.bind(_this);
    _this.toArray = _this.toArray.bind(_this);
    return _this;
  }

  LabelSelector.prototype.render = function render() {
    return React.createElement(ResourceSelector, {
      title: this.props.labels.title,
      className: 'App-label-selector',
      initialValue: this.props.initialValue,
      resources: this.toArray(),
      changeHandler: this.props.changeHandler,
      multiSelect: false
    });
  };

  return LabelSelector;
}(React.Component);

process.env.NODE_ENV !== "production" ? LabelSelector.propTypes = {
  languageCode: PropTypes.string.isRequired,
  labels: PropTypes.object.isRequired,
  initialValue: PropTypes.string.isRequired,
  changeHandler: PropTypes.func.isRequired,
  sort: PropTypes.bool
} : void 0;

LabelSelector.defaultProps = {
  sort: true
};

export default LabelSelector;