function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { DropdownButton, MenuItem } from 'react-bootstrap';
import LifeCycleDemoSubComponent from './LifeCycleDemoSubComponent';
/**
 * Demonstrates the life cycle of a React component
 */

var LifeCycleDemo = function (_React$Component) {
  _inherits(LifeCycleDemo, _React$Component);

  /**
   * Use the constructor to set the state for things
   * whose value will never change during the life-cycle
   * @param props
   */
  function LifeCycleDemo(props) {
    _classCallCheck(this, LifeCycleDemo);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {
      _this.report("componentWillMount");
    };

    _this.componentDidMount = function () {
      _this.setState(function (prevState, props) {
        return {
          previous: prevState.stage,
          stage: "componentDidMount"
        };
      }, function () {
        return this.report("componentDidMount");
      });
    };

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState(function (prevState, props) {
        return {
          stage: "componentWillReceiveProps"
        };
      }, function () {
        return this.report("componentWillReceiveProps");
      });
    };

    _this.report = function (method) {
      console.log('LifeCycleDemo.' + method + ' previous: ' + _this.state.previous + ' stage: ' + _this.state.stage);
    };

    _this.handleSelection = function (event) {
      _this.setState({
        selectedLanguage: event
      });
    };

    _this.state = {
      previous: "",
      stage: "a",
      selectedLanguage: "en"
    };
    _this.handleSelection = _this.handleSelection.bind(_this);
    _this.report = _this.report.bind(_this);
    _this.report("constructor");
    return _this;
  }

  /**
   * Use componentDidMount to
   */


  LifeCycleDemo.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        DropdownButton,
        {
          bsStyle: 'primary',
          title: 'Select Language for Greeting',
          key: "btn",
          id: "btn-1",
          onSelect: this.handleSelection
        },
        React.createElement(
          MenuItem,
          { eventKey: 'en' },
          'English'
        ),
        React.createElement(
          MenuItem,
          { eventKey: 'el' },
          'Greek'
        )
      ),
      React.createElement(LifeCycleDemoSubComponent, {
        languageCode: this.state.selectedLanguage
      })
    );
  };

  return LifeCycleDemo;
}(React.Component);

process.env.NODE_ENV !== "production" ? LifeCycleDemo.propTypes = {
  languageCode: PropTypes.string.isRequired
} : void 0;

LifeCycleDemo.defaultProps = {};

export default LifeCycleDemo;