var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import Select from 'react-select';
import MessageIcons from './MessageIcons';
import Server from "./Server";
import { get } from 'lodash';

var OntologyRefSelector = (_temp = _class = function (_React$Component) {
  _inherits(OntologyRefSelector, _React$Component);

  function OntologyRefSelector(props) {
    _classCallCheck(this, OntologyRefSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: { //
        thisClass: labels[labelTopics.OntologyRefSelector],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedEntityValue: props.initialValue,
      selectedEntityLabel: "",
      fetching: false,
      data: [],
      lastType: props.type
    };

    _this.handleEntityChange = _this.handleEntityChange.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  OntologyRefSelector.prototype.render = function render() {
    if (this.state.data && this.state.data.length > 0) {
      return React.createElement(
        'div',
        { className: 'resourceSelector' },
        React.createElement(
          'div',
          { className: 'resourceSelectorPrompt' },
          this.props.title
        ),
        React.createElement(Select, {
          name: 'App-Ontology-Ref-Selector-Entity',
          value: this.state.selectedEntityValue,
          options: this.state.data,
          onChange: this.handleEntityChange,
          multi: false,
          autosize: true,
          clearable: true
        })
      );
    } else {
      return React.createElement('span', { className: 'App-no-display' });
    }
  };

  return OntologyRefSelector;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    _this2.setState({ fetching: true }, _this2.fetchData);
  };

  this.componentWillReceiveProps = function (nextProps) {

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.OntologyRefSelector],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial,
        selectedEntity: "*",
        fetching: false,
        data: get(_this2.state, "data", [])
      };
    });
    if (nextProps.type !== _this2.state.lastType) {
      _this2.setState({ lastType: nextProps.type }, _this2.fetchData);
    };
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.handleCallback = function () {
    _this2.props.callback(_this2.state.selectedEntityValue, _this2.state.selectedEntityLabel);
  };

  this.handleEntityChange = function (selection) {
    _this2.setState({
      selectedEntityValue: selection["value"],
      selectedEntityLabel: selection["label"]
    }, _this2.handleCallback);
  };

  this.fetchData = function () {
    var parms = "t=" + encodeURIComponent(_this2.props.type);

    Server.restGetPromise(_this2.props.session.restServer, Server.getDbServerDropdownsOntologyEntitiesApi(), _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, parms).then(function (response) {
      _this2.setState({
        data: response.data.values[0].dropdown,
        userMessage: response.userMessage,
        developerMessage: response.developerMessage,
        messageIcon: response.messageIcon,
        status: response.status,
        showSearchResults: response.data.values.length > 0,
        resultCount: response.data.values.length,
        fetching: false
      });
    }).catch(function (error) {
      _this2.setState({
        data: {
          values: [{
            "id": "",
            "library": "",
            "topic": "",
            "key": "",
            "value:": ""
          }],
          userMessage: error.userMessage,
          developerMessage: error.developerMessage,
          messageIcon: error.messageIcon,
          status: error.status,
          showSearchResults: false,
          resultCount: 0,
          fetching: false
        }
      });
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? OntologyRefSelector.propTypes = {
  session: PropTypes.object.isRequired,
  type: PropTypes.string.isRequired,
  callback: PropTypes.func.isRequired,
  initialValue: PropTypes.string
} : void 0;

// set default values for props here
OntologyRefSelector.defaultProps = {
  initialValue: "*"
};

export default OntologyRefSelector;