/**
 *
 * Helper functions to parse a schematized response from
 * the REST API.  The response has not just the requested
 * data, but also schemas for each object and a uiSchema.
 * @type {object}
 */

var itemId = "";
var schema = {};
var uiSchema = {};
var value = {};

module.exports = {

  setItem: function setItem(data) {
    itemId = data.values[0]._valueSchemaId;
    uiSchema = data.valueSchemas[itemId].uiSchema;
    schema = data.valueSchemas[itemId].schema;
    value = data.values[0].value;
  },
  getItemId: function getItemId() {
    return itemId;
  },
  getSchema: function getSchema() {
    return schema;
  },
  getUiSchema: function getUiSchema() {
    return uiSchema;
  },
  getValue: function getValue() {
    return value;
  },
  getItemObject: function getItemObject() {
    return {
      id: itemId,
      uiSchema: uiSchema,
      schema: schema,
      value: value
    };
  }
};