var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import Select from 'react-select';
import { Button } from 'react-bootstrap';
import 'react-select/dist/react-select.css';

export var EditableSelector = (_temp = _class = function (_React$Component) {
  _inherits(EditableSelector, _React$Component);

  function EditableSelector(props) {
    _classCallCheck(this, EditableSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button]
      },
      value: _this.props.initialValue,
      options: _this.props.options
    };
    _this.callBack = _this.callBack.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.onRemoveClick = _this.onRemoveClick.bind(_this);
    _this.onRemoveAllClick = _this.onRemoveAllClick.bind(_this);
    return _this;
  }

  EditableSelector.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'resourceSelector' },
      React.createElement(
        'div',
        { className: 'resourceSelectorPrompt' },
        this.props.title
      ),
      React.createElement(Select.Creatable, {
        name: 'form-field-name',
        value: this.state.value,
        options: this.state.options,
        onChange: this.handleChange,
        multi: this.props.multiSelect,
        autosize: true,
        clearable: true
      }),
      React.createElement(
        'div',
        { className: 'App resourceSelectorButtons' },
        React.createElement(
          Button,
          {
            className: 'App App-Button',
            bsStyle: 'primary',
            onClick: this.onRemoveClick },
          this.state.labels.buttons.remove
        ),
        React.createElement(
          Button,
          {
            className: 'App App-Button',
            bsStyle: 'warning',
            onClick: this.onRemoveAllClick },
          this.state.labels.buttons.removeAll
        )
      )
    );
  };

  return EditableSelector;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState({
      labels: {
        buttons: labels[labelTopics.button]
      },
      value: nextProps.initialValue,
      options: nextProps.options
    });
  };

  this.callBack = function () {
    _this2.props.changeHandler(_this2.state.value, _this2.state.options);
  };

  this.handleChange = function (selection) {
    _this2.setState({ value: selection.value }, _this2.callBack);
  };

  this.onRemoveClick = function () {
    var value = _this2.state.value;
    var options = [];
    options = _this2.state.options.filter(function (el) {
      return el.value !== value;
    });
    _this2.setState({ options: options, value: "" }, _this2.callBack);
  };

  this.onRemoveAllClick = function () {
    _this2.setState({ options: [], value: "" }, _this2.callBack);
  };
}, _temp);

process.env.NODE_ENV !== "production" ? EditableSelector.propTypes = {
  session: PropTypes.object.isRequired,
  initialValue: PropTypes.string,
  options: PropTypes.array.isRequired,
  changeHandler: PropTypes.func.isRequired,
  multiSelect: PropTypes.bool.isRequired,
  title: PropTypes.string
} : void 0;

// set default values for props here
EditableSelector.defaultProps = {
  initialValue: "",
  title: ""
};

export default EditableSelector;