var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, Modal } from 'react-bootstrap';

import GenericNewEntryForm from './GenericNewEntryForm';
import MessageIcons from '../helpers/MessageIcons';

/**
 * Display modal content.
 */
export var GenericModalNewEntryForm = (_temp = _class = function (_React$Component) {
  _inherits(GenericModalNewEntryForm, _React$Component);

  function GenericModalNewEntryForm(props) {
    _classCallCheck(this, GenericModalNewEntryForm);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    return _this;
  }

  GenericModalNewEntryForm.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  GenericModalNewEntryForm.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose(this.state.formData);
    }
  };

  GenericModalNewEntryForm.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-New-Entry-Form',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.props.title
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(GenericNewEntryForm, {
            session: this.props.session,
            path: this.props.restPath,
            onSubmit: this.onSubmit,
            schemaTypes: this.props.schemaTypes,
            title: this.props.title
          })
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.button.close
          )
        )
      )
    );
  };

  return GenericModalNewEntryForm;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState({
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      }
    });
  };

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    if (_this2.props.onSubmit) {
      _this2.props.onSubmit(formData);
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? GenericModalNewEntryForm.propTypes = {
  session: PropTypes.object.isRequired,
  restPath: PropTypes.string.isRequired,
  onSubmit: PropTypes.func,
  onClose: PropTypes.func,
  schemaTypes: PropTypes.array,
  title: PropTypes.string.isRequired
} : void 0;
GenericModalNewEntryForm.defaultProps = {
  canUpdate: true
};

export default GenericModalNewEntryForm;