var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import ResourceSelector from './ReactSelector';
import FontAwesome from 'react-fontawesome';
import { Button, Col, ControlLabel, FormControl, Grid, Row, Well } from 'react-bootstrap';

import MessageIcons from '../helpers/MessageIcons';
import { get } from "lodash";

var GenericSearchOptions = (_temp = _class = function (_React$Component) {
  _inherits(GenericSearchOptions, _React$Component);

  function GenericSearchOptions(props) {
    _classCallCheck(this, GenericSearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var initialType = "*";
    if (_this.props.initialType) {
      initialType = _this.props.initialType;
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        search: labels[labelTopics.SearchGeneric],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedTypeLabel: "",
      selectedType: initialType,
      selectedLibrary: "*",
      selectedProperty: "value",
      selectedMatcher: "c",
      value: "",
      selectedTagOperator: "any",
      selectedTags: "",
      tagData: [],
      dropDownProperties: {
        msg: labels[labelTopics.SearchGeneric].domainIs,
        source: _this.props.properties[initialType],
        initialValue: "*"
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handleLibraryChange = _this.handleLibraryChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTagsSelection = _this.handleTagsSelection.bind(_this);
    _this.handleTagOperatorChange = _this.handleTagOperatorChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);

    _this.getLibraryRow = _this.getLibraryRow.bind(_this);
    _this.getTypeRow = _this.getTypeRow.bind(_this);
    _this.getPropertyRow = _this.getPropertyRow.bind(_this);
    _this.getMatchLocationRow = _this.getMatchLocationRow.bind(_this);
    _this.getHasTagRow = _this.getHasTagRow.bind(_this);
    _this.getTagRow = _this.getTagRow.bind(_this);
    _this.getTextRow = _this.getTextRow.bind(_this);
    _this.getButtonRow = _this.getButtonRow.bind(_this);

    return _this;
  }

  GenericSearchOptions.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'container App-search-options-container' },
      React.createElement(
        Well,
        null,
        React.createElement(
          Grid,
          null,
          this.getTypeRow(),
          this.getLibraryRow(),
          this.getPropertyRow(),
          this.getTextRow(),
          this.getMatchLocationRow(),
          this.getHasTagRow(),
          this.getTagRow(),
          this.getButtonRow()
        )
      )
    );
  };

  return GenericSearchOptions;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {

    _this2.setState(function (prevState, props) {
      var labels = props.session.labels;
      var labelTopics = props.session.labelTopics;

      return {
        labels: {
          search: labels[labelTopics.SearchGeneric],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial
      };
    });
  };

  this.handleDocTypeChange = function (selection) {
    var type = selection["value"];
    var typeLabel = selection["label"];
    _this2.setState({
      selectedTypeLabel: typeLabel,
      selectedType: type,
      dropDownProperties: {
        msg: _this2.state.labels.search.domainIs,
        source: _this2.props.properties[type],
        initialValue: "*"
      }
    });
  };

  this.handlePropertyChange = function (item) {
    var newSelectedValue = _this2.state.value;

    if (item.value.startsWith("*")) {
      newSelectedValue = "";
    }
    _this2.setState({
      selectedProperty: item.value,
      value: newSelectedValue
    });
  };

  this.handleMatcherChange = function (item) {
    _this2.setState({ selectedMatcher: item.value });
  };

  this.handleValueChange = function (event) {
    _this2.setState({ value: event.target.value });
  };

  this.handleTagsSelection = function (selection) {
    var tags = selection.map(function (a) {
      return a.value;
    });

    _this2.setState({
      selectedTags: tags.toString()
    });
  };

  this.handleTagOperatorChange = function (selection) {
    _this2.setState({
      selectedTagOperator: selection["value"]
    });
  };

  this.handleSubmit = function (event) {
    _this2.props.handleSubmit(_this2.state.selectedType, _this2.state.selectedTypeLabel, _this2.state.selectedLibrary, _this2.state.selectedProperty, _this2.state.selectedMatcher, _this2.state.value, _this2.state.selectedTagOperator, _this2.state.selectedTags);
    event.preventDefault();
  };

  this.isDisabled = function () {
    var disableButton = false;
    switch (_this2.state.selectedType) {
      case "*":
        {
          disableButton = true;
          break;
        }
      default:
        {
          disableButton = false;
          break;
        }
    }
    return disableButton;
  };

  this.getTypeRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Bibliography-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Bibliography-Type-Selector" },
          React.createElement(ResourceSelector, {
            title: _this2.state.labels.search.findWhereTypeIs,
            initialValue: _this2.state.selectedType,
            resources: _this2.props.session.dropdowns.schemaEditorDropdown,
            changeHandler: _this2.handleDocTypeChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getPropertyRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Bibliography-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Bibliography-Type-Selector" },
          React.createElement(ResourceSelector, {
            title: _this2.state.labels.search.propertyIs,
            initialValue: _this2.state.selectedProperty,
            resources: _this2.props.properties,
            changeHandler: _this2.handlePropertyChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getTextRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          ControlLabel,
          null,
          _this2.state.labels.search.propertyTextIs
        ),
        React.createElement(FormControl, {
          id: "fxGenericSearchText",
          className: "App App-search-text-input",
          type: 'text',
          value: _this2.state.value,
          placeholder: _this2.state.labels.search.textPrompt,
          onChange: _this2.handleValueChange
        })
      )
    );
  };

  this.getMatchLocationRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Generic-Type-Selector" },
          React.createElement(ResourceSelector, {
            title: _this2.state.labels.search.matcherIs,
            initialValue: _this2.state.selectedMatcher,
            resources: _this2.props.matchers,
            changeHandler: _this2.handleMatcherChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getHasTagRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Generic-Tag-Selector" },
          React.createElement(ResourceSelector, {
            title: _this2.state.labels.search.has,
            initialValue: _this2.state.selectedTagOperator,
            resources: _this2.props.tagOperators,
            changeHandler: _this2.handleTagOperatorChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getTagRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Generic-Tag-Selector" },
          React.createElement(ResourceSelector, {
            title: _this2.state.labels.search.tags,
            initialValue: _this2.state.selectedTags,
            resources: _this2.props.tags,
            changeHandler: _this2.handleTagsSelection,
            multiSelect: true
          })
        )
      )
    );
  };

  this.handleLibraryChange = function (selection) {
    _this2.setState({ selectedLibrary: selection["value"] });
  };

  this.getLibraryRow = function () {
    if (_this2.props.session && _this2.props.session.userInfo && _this2.props.session.userInfo.domains) {
      if (_this2.props.session.userInfo.domains.reader) {
        var resources = _this2.props.session.userInfo.domains.reader;
        return React.createElement(
          Row,
          { className: 'show-grid App-Generic-Search-Options-Row' },
          React.createElement(
            Col,
            { xs: 12, md: 12 },
            React.createElement(
              'div',
              { className: "App App-Generic-Library-Selector" },
              React.createElement(ResourceSelector, {
                title: _this2.state.labels.search.domainIs,
                initialValue: _this2.state.selectedLibrary,
                resources: resources,
                changeHandler: _this2.handleLibraryChange,
                multiSelect: false
              })
            )
          )
        );
      }
    }
  };

  this.getButtonRow = function () {
    return React.createElement(
      Row,
      { className: 'show-grid App-Generic-Search-Options-Row' },
      React.createElement(
        Col,
        { xs: 12, md: 12 },
        React.createElement(
          'div',
          { className: "App App-Generic-Selector-Button" },
          React.createElement(
            ControlLabel,
            null,
            _this2.state.labels.search.clickTheButton
          ),
          React.createElement(
            'div',
            null,
            React.createElement(
              Button,
              {
                bsStyle: 'primary',
                bsSize: 'xsmall',
                type: 'submit',
                disabled: _this2.isDisabled(),
                onClick: _this2.handleSubmit
              },
              React.createElement(FontAwesome, { className: 'Button-Select-FontAwesome', name: "search" }),
              _this2.state.labels.search.submit
            )
          )
        )
      )
    );
  };
}, _temp);


process.env.NODE_ENV !== "production" ? GenericSearchOptions.propTypes = {
  session: PropTypes.object.isRequired,
  initialType: PropTypes.string.isRequired,
  properties: PropTypes.array.isRequired,
  matchers: PropTypes.array.isRequired,
  tags: PropTypes.array.isRequired,
  tagOperators: PropTypes.array.isRequired,
  handleSubmit: PropTypes.func.isRequired
} : void 0;

export default GenericSearchOptions;