var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { get } from 'lodash';
import PropTypes from 'prop-types';
import Server from '../helpers/Server';
import { Button, Label, Panel, PanelGroup, Well } from 'react-bootstrap';
import IdManager from '../helpers/IdManager';
import MessageIcons from '../helpers/MessageIcons';
import HyperTokenText from './HyperTokenText';
import DependencyDiagram from './DependencyDiagram';
import TokenTagger from '../helpers/TokenTagger'; // When convert to UD gram tags, use UdTokenTagger
import TreeViewUtils from '../helpers/TreeViewUtils';
import GrammarSitePanel from './GrammarSitePanel';
import SearchTreebanks from '../SearchTreebanks';

import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import FileSaver from "file-saver";

var Grammar = (_temp = _class = function (_React$Component) {
  _inherits(Grammar, _React$Component);

  function Grammar(props) {
    _classCallCheck(this, Grammar);

    var _this2 = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this2);

    _this2.state = _this2.setTheState(props, "");

    _this2.closeModal = _this2.closeModal.bind(_this2);
    _this2.getBody = _this2.getBody.bind(_this2);
    _this2.getDependencyDiagram = _this2.getDependencyDiagram.bind(_this2);
    _this2.getDependencyTreeAsLatex = _this2.getDependencyTreeAsLatex.bind(_this2);
    _this2.getDependencyTreeText = _this2.getDependencyTreeText.bind(_this2);
    _this2.getLatexNode = _this2.getLatexNode.bind(_this2);
    _this2.getLemmas = _this2.getLemmas.bind(_this2);
    _this2.getPanelBasicLexicon = _this2.getPanelBasicLexicon.bind(_this2);
    _this2.getPanelKriaras = _this2.getPanelKriaras.bind(_this2);
    _this2.getPanelLaParola = _this2.getPanelLaParola.bind(_this2);
    _this2.getPanelLexigram = _this2.getPanelLexigram.bind(_this2);
    _this2.getPanelLogeion = _this2.getPanelLogeion.bind(_this2);
    _this2.getPanelPerseusSite = _this2.getPanelPerseusSite.bind(_this2);
    _this2.getPanelPotentialAnalyses = _this2.getPanelPotentialAnalyses.bind(_this2);
    _this2.getPanels = _this2.getPanels.bind(_this2);
    _this2.getPanelSearchTreebanks = _this2.getPanelSearchTreebanks.bind(_this2);
    _this2.getPanelSmythGrammar = _this2.getPanelSmythGrammar.bind(_this2);
    _this2.getPanelTokenTagger = _this2.getPanelTokenTagger.bind(_this2);
    _this2.getPanelTriantafyllides = _this2.getPanelTriantafyllides.bind(_this2);
    _this2.handleEnglishLexiconCallback = _this2.handleEnglishLexiconCallback.bind(_this2);
    _this2.handleNodeClick = _this2.handleNodeClick.bind(_this2);
    _this2.handleRowSelect = _this2.handleRowSelect.bind(_this2);
    _this2.handleTaggerCallback = _this2.handleTaggerCallback.bind(_this2);
    _this2.handleTokenClick = _this2.handleTokenClick.bind(_this2);
    _this2.node = _this2.node.bind(_this2);
    _this2.setTextInfo = _this2.setTextInfo.bind(_this2);
    _this2.showModal = _this2.showModal.bind(_this2);
    _this2.treeViewSelectCallback = _this2.treeViewSelectCallback.bind(_this2);
    return _this2;
  }

  Grammar.prototype.inSelectionPath = function inSelectionPath(key) {};

  // Gets the set of lemmas from analyses for this token


  Grammar.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App App-Grammar' },
      React.createElement(
        Well,
        { className: "App-Grammar-Well" },
        this.getBody()
      )
    );
  };

  return Grammar;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentDidMount = function () {
    _this3.setState({ _isMounted: true });
  };

  this.componentWillUnmount = function () {
    if (_this3.state && _this3.state._requestTokens) {
      for (var _iterator = _this3.state._requestTokens.keys(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var token = _ref;

        try {
          Server.cancelRequest(token);
        } catch (error) {
          // ignore
        }
      }
    }
    _this3.setState({ _isMounted: false });
  };

  this.componentWillMount = function () {
    _this3.fetchData();
  };

  this.componentWillReceiveProps = function (nextProps) {
    var nextId = IdManager.toId("gr_gr_cog", nextProps.idTopic, nextProps.idKey);
    var full = false;
    if (nextProps.session && nextProps.session.userInfo && nextProps.session.userInfo.authenticated) {
      full = true;
    }
    _this3.state = _this3.setTheState(nextProps, _this3.state.text, _this3.state.dropdownsLoaded, _this3.state.data, _this3.state.tokens, _this3.state.analyses, _this3.state.selectedTokenTags, _this3.state.nodeData, _this3.state.nodeDependencies, _this3.state.treeNodeData, _this3.state.selectedPerseus, _this3.state.selectedToken, _this3.state.selectedTokenIndexNumber, _this3.state.selectedTokenIsWord, full);
    if (_this3.state.text && _this3.state.text.id !== nextId) {
      _this3.fetchData();
    }
  };

  this.setTheState = function (props, text, dropdownsLoaded, data, tokens, analyses, selectedTokenTags, nodeData, nodeDependencies, treeNodeData, selectedPerseus, selectedToken, selectedTokenIndexNumber, selectedTokenIsWord, full) {
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    return {
      labels: {
        thisClass: labels[labelTopics.Grammar],
        messages: labels[labelTopics.messages],
        search: labels[labelTopics.search],
        tokenTagger: labels[labelTopics.TokenTagger]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      full: full,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this3.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      showModal: false,

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this3.handleRowSelect,
        className: "App-row-select"
      },
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: labels[labelTopics.messages].regEx
      },
      id: IdManager.toId("gr_gr_cog", props.idTopic, _this3.props.idKey),
      props: props,
      text: text,
      dropdownsLoaded: dropdownsLoaded,
      data: data,
      tokens: tokens,
      analyses: analyses,
      selectedTokenPanelTitle: labels[labelTopics.TokenTagger].panelTitle,
      selectedTokenTags: selectedTokenTags,
      nodeData: nodeData,
      nodeDependencies: nodeDependencies,
      treeNodeData: treeNodeData ? treeNodeData : {},
      selectedPerseus: selectedPerseus ? selectedPerseus : {},
      selectedToken: selectedToken,
      selectedTokenIsWord: selectedTokenIsWord,
      selectedTokenIndex: get(_this3.state, "selectedTokenIndex", 0),
      selectedTokenIndexNumber: selectedTokenIndexNumber ? selectedTokenIndexNumber : 1,
      tokenAnalysis: get(_this3.state, "tokenAnalysis", {}),
      selectedNodeData: get(_this3.state, "selectedNodeData", {}),
      _isMounted: get(_this3.state, "_isMounted", false),
      _requestTokens: get(_this3.state, "_requestTokens", new Map())
    };
  };

  this.fetchData = function () {
    var requestTokens = _this3.state._requestTokens;
    var requestToken = Server.getRequestToken();
    requestTokens.set(requestToken, "live");
    Server.getTextAnalysis(_this3.props.session.restServer, _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, _this3.state.id, _this3.setTextInfo, requestToken);
    if (_this3.state.full) {
      Server.getTable(_this3.props.session.restServer, _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, Server.tableLexiconOald, _this3.handleEnglishLexiconCallback);
    }
    _this3.setState({ _requestTokens: requestTokens });
  };

  this.handleEnglishLexiconCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values && restCallResult.data.values.length > 0) {
      _this3.setState({
        englishLexiconLoaded: true,
        data: restCallResult.data.values[0]
      });
    }
  };

  this.setTextInfo = function (restCallResult) {
    if (_this3.state._isMounted && restCallResult && restCallResult.data && restCallResult.data.values) {
      if (restCallResult.data.values.length > 3) {
        var nodeData = restCallResult.data.values[3].nodes;
        var treeViewUtils = new TreeViewUtils(nodeData);
        var nodeDependencies = treeViewUtils.nodeDependencies;
        var treeNodeData = treeViewUtils.toTreeViewData("Root");
        _this3.setState({
          dropdownsLoaded: true,
          data: restCallResult.data.values[0].text,
          tokens: restCallResult.data.values[1].tokens,
          analyses: restCallResult.data.values[2].analyses,
          nodeData: nodeData,
          nodeDependencies: nodeDependencies,
          treeNodeData: treeNodeData
        });
      }
    }
  };

  this.treeViewSelectCallback = function (node) {
    if (node && node.key) {
      _this3.handleTokenClick(node.key, _this3.state.tokens[parseInt(node.key)]);
    }
  };

  this.getLatexNode = function (node, latex, first) {
    latex = "\\begin{mdframed}";
    if (first) {
      latex += "[everyline=true,style=dependency]";
    }
    latex += "\n";
    if (node.key === "Root") {
      latex += "\\grNode{Root}{}{}{}{}{}\n";
    } else {
      var label = node.label;
      if (label.endsWith("_CO")) {
        label = label.replace("_", "\\textunderscore ");
      }
      var gloss = node.gloss;
      gloss = gloss.replace(/\[/g, "{[}");
      gloss = gloss.replace(/\]/g, "{]}");

      latex += "\\grNode" + "{" + node.key + "}" + "{" + label + "}" + "{" + node.token + "}" + "{" + gloss + "}" + "{" + node.grammar + "}" + "{" + node.lemma + "}\n";
    }
    var _this = _this3;
    if (node.nodes) {
      latex += node.nodes.map(function (elem) {
        return _this.getLatexNode(elem, latex, false);
      }).join('');
    }
    latex += "\\end{mdframed}\n";
    return latex;
  };

  this.getDependencyTreeAsLatex = function () {
    var latex = _this3.getLatexNode(_this3.state.treeNodeData[0], "", true);
    var blob = new Blob([latex], { type: 'text/plain;charset=utf-8' });
    FileSaver.saveAs(blob, "test" + ".tex");
  };

  this.handleNodeClick = function (index) {
    _this3.handleTokenClick(index.toString(), _this3.state.tokens[index]);
  };

  this.handleTokenClick = function (index, token) {
    var tokenIndex = parseInt(index);
    var panelIndex = tokenIndex + 1;
    var tokenIsWord = true;
    if (token.length < 2) {
      var notLetter = '"\'·.,;?!~@#$%^&z-z_[]{})(-:0123456789';
      if (notLetter.includes(token)) {
        tokenIsWord = false;
      }
    }
    var treeViewUtils = new TreeViewUtils(_this3.state.nodeData);
    var treeNodeData = treeViewUtils.toTreeViewData("Root", index);
    _this3.setState({
      selectedTokenIndex: index,
      selectedTokenIndexNumber: tokenIndex,
      selectedToken: token,
      selectedTokenIsWord: tokenIsWord,
      selectedAnalysis: _this3.state.analyses[token],
      selectedNodeData: _this3.state.nodeData[tokenIndex],
      selectedLemma: _this3.state.analyses[token][0].lemmaGreek,
      selectedLemmas: _this3.getLemmas(token),
      selectedTokenPanelTitle: _this3.state.labels.tokenTagger.panelTitle + " " + panelIndex + " " + token,
      selectedPerseus: {
        lemma: "",
        gloss: "",
        pos: "",
        grammar: ""
      },
      treeNodeData: treeNodeData
    });
  };

  this.getLemmas = function (token) {
    var s = _this3.state.analyses[token].length;
    var lemmas = [];
    for (var i = 0; i < s; i++) {
      var lemma = _this3.state.analyses[token][i].lemmaGreek;
      if (lemmas.indexOf(lemma) === -1) {
        lemmas.push(lemma);
      }
    }
    return lemmas;
  };

  this.handleRowSelect = function (row) {
    try {
      var idParts = row["id"].split("~");
      var conciseParts = row["concise"].split("/");
      var nodeData = _this3.state.nodeData;
      var selectedPerseus = {
        lemma: row["lemmaGreek"],
        gloss: row["glosses"],
        pos: row["partOfSpeech"],
        grammar: conciseParts[2]
      };
      if (selectedPerseus.pos === "ARTICLE") {
        selectedPerseus.pos = "ART";
      }
      _this3.setState({
        selectedId: row["id"],
        selectedIdParts: [{ key: "domain", label: idParts[0] }, { key: "topic", label: idParts[1] }, { key: "key", label: idParts[2] }],
        selectedLemma: row["lemmaGreek"],
        showIdPartSelector: true,
        showModalCompareDocs: true,
        selectedPerseus: selectedPerseus
      });
    } catch (err) {
      console.log(err);
    }
  };

  this.handleTaggerCallback = function (treeNode) {
    var nodeData = _this3.state.nodeData;
    var dependsOn = treeNode.dependsOn;
    var i = parseInt(treeNode.id);
    nodeData[i].dependsOn = dependsOn;
    nodeData[i].refersTo = treeNode.refersTo;
    nodeData[i].gloss = treeNode.gloss;
    nodeData[i].label = treeNode.label;
    nodeData[i].grammar = treeNode.grammar;
    var treeViewUtils = new TreeViewUtils(nodeData);
    var nodeDependencies = treeViewUtils.nodeDependencies;
    var treeNodeData = treeViewUtils.toTreeViewData("Root");

    _this3.setState({
      selectedTokenTags: treeNode,
      nodeData: nodeData,
      nodeDependencies: nodeDependencies,
      treeNodeData: treeNodeData
    });
  };

  this.getPanelTokenTagger = function () {
    if (_this3.state.full) {
      return React.createElement(
        Panel,
        {
          header: _this3.state.selectedTokenPanelTitle,
          eventKey: 'tagger',
          collapsible: true
        },
        React.createElement(TokenTagger, {
          session: _this3.props.session,
          index: _this3.state.selectedTokenIndex,
          tokens: _this3.state.tokens,
          token: _this3.state.selectedToken,
          tokenAnalysis: _this3.state.selectedNodeData,
          copiedGloss: _this3.state.selectedPerseus.gloss,
          copiedLemma: _this3.state.selectedPerseus.lemma,
          copiedPos: _this3.state.selectedPerseus.pos,
          copiedGrammar: _this3.state.selectedPerseus.grammar,
          callBack: _this3.handleTaggerCallback
        }),
        _this3.getPanelSearchTreebanks()
      );
    }
  };

  this.getPanelPotentialAnalyses = function () {
    if (_this3.state.selectedTokenIsWord) {
      return React.createElement(
        Panel,
        {
          className: 'App-Grammar-Analyses-panel',
          header: _this3.state.labels.thisClass.panelAnalyses + ": " + _this3.state.selectedToken + " (" + _this3.state.analyses[_this3.state.selectedToken].length + ")",
          eventKey: 'analyses',
          collapsible: true
        },
        React.createElement(
          BootstrapTable,
          {
            data: _this3.state.analyses[_this3.state.selectedToken],
            trClassName: "App-data-tr",
            striped: true,
            hover: true,
            search: true,
            pagination: true,
            selectRow: _this3.state.selectRow,
            options: _this3.state.options
          },
          React.createElement(
            TableHeaderColumn,
            {
              isKey: true,
              dataField: 'id',
              dataSort: true,
              hidden: true
            },
            'ID'
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'lemmaGreek',
              filter: _this3.state.tableColumnFilter
            },
            _this3.state.labels.thisClass.colLemma
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'glosses',
              dataSort: true,
              filter: _this3.state.tableColumnFilter
            },
            _this3.state.labels.thisClass.colGlosses
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'parse',
              dataSort: true,
              filter: _this3.state.tableColumnFilter
            },
            _this3.state.labels.thisClass.colParse
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'concise',
              filter: _this3.state.tableColumnFilter
            },
            _this3.state.labels.thisClass.colAnalyses
          ),
          React.createElement(
            TableHeaderColumn,
            {
              dataField: 'source',
              filter: _this3.state.tableColumnFilter,
              width: '20%'
            },
            _this3.state.labels.thisClass.colSource
          )
        )
      );
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelLogeion = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://logeion.uchicago.edu/",
        title: _this3.state.labels.thisClass.panelLogeionSite
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelLexigram = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://www.lexigram.gr/lex/arch/",
        title: _this3.state.labels.thisClass.panelLexigramSite
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelPerseusSite = function () {
    if (_this3.state.selectedTokenIsWord) {
      return React.createElement(
        Panel,
        {
          className: 'App-Grammar-Site-panel',
          header: _this3.state.labels.thisClass.panelPerseusSite + ": " + _this3.state.selectedToken,
          eventKey: 'perseus',
          collapsible: true
        },
        React.createElement(
          'a',
          {
            key: "perseus" + _this3.state.selectedToken,
            target: '_blank',
            rel: "noopener noreferrer",
            href: "http://www.perseus.tufts.edu/hopper/morph?l=" + _this3.state.selectedToken + "&la=greek"
          },
          _this3.state.selectedToken
        )
      );
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelLaParola = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://www.laparola.net/greco/parola.php?p=",
        title: _this3.state.labels.thisClass.panelLaParola
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelKriaras = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://www.greek-language.gr/greekLang/medieval_greek/kriaras/search.html?lq=",
        title: _this3.state.labels.thisClass.panelKriaras
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelTriantafyllides = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://www.greek-language.gr/greekLang/modern_greek/tools/lexica/triantafyllides/search.html?dq=&lq=",
        title: _this3.state.labels.thisClass.panelTriantafyllides
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelBasicLexicon = function () {
    if (_this3.state.selectedTokenIsWord && _this3.state.selectedLemmas) {
      return React.createElement(GrammarSitePanel, {
        languageCode: _this3.props.session.languageCode,
        lemmas: _this3.state.selectedLemmas,
        url: "http://www.greek-language.gr/greekLang/ancient_greek/tools/lexicon/search.html?lq=",
        title: _this3.state.labels.thisClass.panelBasicLexicon
      });
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanelSearchTreebanks = function () {
    return React.createElement(
      Panel,
      {
        className: 'App-TokenTagger-Panel-Search-Treebanks',
        collapsible: true,
        header: _this3.state.labels.thisClass.panelTreebanks
      },
      React.createElement(SearchTreebanks, {
        session: _this3.props.session,
        editor: true,
        initialType: "PtbWord",
        fixedType: false
      })
    );
  };

  this.getPanelSmythGrammar = function () {
    if (_this3.state.selectedTokenIsWord) {
      return React.createElement(
        Panel,
        {
          className: 'App-Grammar-Site-panel ',
          header: _this3.state.labels.thisClass.panelSmyth,
          eventKey: 'smyth',
          collapsible: true
        },
        React.createElement(
          'a',
          {
            key: 'smyth',
            target: '_blank',
            rel: "noopener noreferrer",
            href: 'http://www.perseus.tufts.edu/hopper/text?doc=Perseus:text:1999.04.0007'
          },
          'View'
        )
      );
    } else {
      return React.createElement(Label, null);
    }
  };

  this.getPanels = function () {
    if (_this3.state.selectedToken) {
      return React.createElement(
        PanelGroup,
        { defaultActiveKey: 'analyses' },
        _this3.getPanelTokenTagger(),
        _this3.getPanelPotentialAnalyses(),
        _this3.getPanelLogeion(),
        _this3.getPanelLexigram(),
        _this3.getPanelPerseusSite(),
        _this3.getPanelLaParola(),
        _this3.getPanelKriaras(),
        _this3.getPanelTriantafyllides(),
        _this3.getPanelBasicLexicon(),
        _this3.getPanelSmythGrammar()
      );
    } else {
      return React.createElement('div', null);
    }
  };

  this.node = function (id, dependsOn, token, lemma, gloss, label, grammar) {
    var n = parseInt(id);
    n++;
    var result = [{
      v: id,
      f: "<span class='App AppDependencyNodeToken'>" + token + "</span>" + "<sup>" + n + "</sup>" + "<div class='App AppDependencyNodeLabel'>" + label + " / " + grammar + '</div>' + "<div>" + "<span class='App AppDependencyNodeGloss'>" + gloss + '</span>' + " / " + "<span class='App AppDependencyNodeLemma'>" + lemma + "</span>" + "</div>"
    }, dependsOn, grammar];
    return result;
  };

  this.showModal = function () {
    _this3.setState({
      showModal: true
    });
  };

  this.closeModal = function () {
    _this3.setState({
      showModal: false
    });
  };

  this.getDependencyDiagram = function () {
    if (_this3.state.full) {
      return React.createElement(
        Panel,
        {
          className: 'App-Grammar-Explorer-DependencyDiagram',
          collapsible: true,
          header: _this3.state.labels.thisClass.panelDependency
        },
        React.createElement(DependencyDiagram, {
          data: _this3.state.treeNodeData,
          onClick: _this3.treeViewSelectCallback,
          highlightSelected: true,
          offsetKey: true
        }),
        React.createElement(
          Button,
          { onClick: _this3.getDependencyTreeAsLatex },
          'Get Latex'
        )
      );
    }
  };

  this.getBody = function () {
    return React.createElement(
      'div',
      null,
      _this3.state.nodeData && _this3.getDependencyDiagram(),
      React.createElement(
        Well,
        null,
        React.createElement(HyperTokenText, {
          session: _this3.props.session,
          tokens: _this3.state.tokens ? _this3.state.tokens : [],
          onClick: _this3.handleTokenClick,
          selectedToken: _this3.state.selectedTokenIndexNumber
        }),
        _this3.state.selectedToken && _this3.getPanels()
      )
    );
  };

  this.getDependencyTreeText = function () {
    if (_this3.state.data && _this3.state.data.value) {
      return _this3.state.data.value;
    } else {
      return _this3.props.idTopic;
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? Grammar.propTypes = {
  session: PropTypes.object.isRequired,
  idTopic: PropTypes.string.isRequired,
  idKey: PropTypes.string.isRequired,
  text: PropTypes.string
} : void 0;

Grammar.defaultProps = {
  text: "Dependency Diagram"
};

export default Grammar;