var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { get } from 'lodash';
import MessageIcons from '../helpers/MessageIcons';
import Spinner from '../helpers/Spinner';

import { ControlLabel, Well } from 'react-bootstrap';

var HyperTokenText = (_temp = _class = function (_React$Component) {
  _inherits(HyperTokenText, _React$Component);

  function HyperTokenText(props) {
    _classCallCheck(this, HyperTokenText);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.renderTokens = _this.renderTokens.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    _this.getRuby = _this.getRuby.bind(_this);
    _this.getTokenWordSpan = _this.getTokenWordSpan.bind(_this);

    return _this;
  }

  HyperTokenText.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'App App-HyperTokenText-Container' },
      React.createElement(
        'div',
        null,
        React.createElement(
          ControlLabel,
          null,
          this.state.labels.thisClass.instructions
        )
      ),
      React.createElement(
        Well,
        null,
        React.createElement(
          'div',
          { className: 'App App-HyperTokenText-Text' },
          this.renderTokens()
        )
      )
    );
  };

  return HyperTokenText;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var selectedToken = get(currentState, "selectedToken", -1);
    if (_this2.props.selectedToken !== props.selectedToken) {
      selectedToken = props.selectedToken;
    }
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    return {
      labels: {
        thisClass: labels[labelTopics.HyperTokenText],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedToken: selectedToken,
      lastPropToken: get(props, "selectedToken", -1)
    };
  };

  this.handleClick = function (event) {
    _this2.setState({
      selectedToken: parseInt(event.currentTarget.id)
    });
    _this2.props.onClick(event.currentTarget.id, event.currentTarget.textContent.trim());
  };

  this.getTokenWordSpan = function (token, index) {
    if (_this2.state.selectedToken === index) {
      return React.createElement(
        'rb',
        null,
        React.createElement(
          'span',
          { className: 'App-HyperToken-Word-Selected', id: index, onClick: _this2.handleClick },
          token,
          '\xA0'
        )
      );
    } else {
      return React.createElement(
        'rb',
        null,
        React.createElement(
          'span',
          { className: 'App-HyperToken-Word', id: index, onClick: _this2.handleClick },
          token,
          '\xA0'
        )
      );
    }
  };

  this.getRuby = function (token, index) {
    return React.createElement(
      'ruby',
      { className: 'App App-HyperToken', key: index },
      _this2.getTokenWordSpan(token, index),
      React.createElement(
        'rt',
        null,
        React.createElement(
          'span',
          { className: 'App-HyperToken-Index' },
          index + 1
        )
      )
    );
  };

  this.renderTokens = function () {
    if (_this2.props.tokens && _this2.props.tokens.length > 0) {
      var result = [];
      var size = _this2.props.tokens.length;
      for (var index = 0; index < size; index++) {
        result.push(_this2.getRuby(_this2.props.tokens[index], index));
      }
      return result;
    } else {
      return React.createElement(
        'div',
        null,
        React.createElement(Spinner, { message: _this2.state.labels.messages.retrieving })
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? HyperTokenText.propTypes = {
  session: PropTypes.object.isRequired,
  tokens: PropTypes.array.isRequired,
  onClick: PropTypes.func.isRequired,
  selectedToken: PropTypes.number
} : void 0;

HyperTokenText.defaultProps = {};

export default HyperTokenText;