function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import { Alert, Button, Glyphicon, Modal } from 'react-bootstrap';
import { BootstrapTable, TableHeaderColumn } from 'react-bootstrap-table';
import MessageIcons from '../helpers/MessageIcons';

/**
 * Display modal window to allow user to select an AGES service or sacrament.
 */
export var ModalAgesServiceSelector = function (_React$Component) {
  _inherits(ModalAgesServiceSelector, _React$Component);

  function ModalAgesServiceSelector(props) {
    _classCallCheck(this, ModalAgesServiceSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.PropTypesWillMount = function () {};

    _this.close = function () {
      _this.setState({ showModal: false }, _this.props.onClose);
    };

    _this.open = function () {
      _this.setState({ showModal: true });
    };

    _this.handleRowSelect = function (row, isSelected, e) {
      _this.setState({
        selectedUrl: row["url"]
      }, _this.props.callBack(row["url"], row["type"], row["date"], row["dayOfWeek"]));
    };

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalAgesServiceSelector],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      options: {
        sizePerPage: 15,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select"
      },
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: labels[labelTopics.messages].regEx
      },

      showSelectionButtons: false,

      selectedId: "",
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    return _this;
  }

  ModalAgesServiceSelector.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(
            'div',
            { className: 'App-modal-body' },
            React.createElement(
              'div',
              { className: 'row' },
              React.createElement(
                Alert,
                { bsStyle: 'info', className: 'App-modal-alert' },
                React.createElement(
                  'p',
                  null,
                  React.createElement(Glyphicon, { glyph: 'hand-right' }),
                  this.state.labels.thisClass.msg1,
                  this.state.labels.thisClass.msg2,
                  this.state.labels.thisClass.msg3,
                  this.state.labels.thisClass.msg4
                )
              )
            ),
            React.createElement(
              'div',
              { className: 'row' },
              React.createElement(
                BootstrapTable,
                {
                  ref: 'table',
                  data: this.props.values,
                  trClassName: "App-data-tr",
                  striped: true,
                  pagination: true,
                  options: this.state.options,
                  selectRow: this.state.selectRow
                },
                React.createElement(
                  TableHeaderColumn,
                  {
                    ref: 'url',
                    isKey: true,
                    dataField: 'url',
                    dataSort: true,
                    width: this.state.topicKeyColumnSize,
                    filter: this.state.tableColumnFilter,
                    hidden: true
                  },
                  "URL"
                ),
                React.createElement(
                  TableHeaderColumn,
                  {
                    ref: 'type',
                    dataSort: true,
                    dataField: 'type',
                    tdClassname: 'tdColAgesType',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.type
                ),
                React.createElement(
                  TableHeaderColumn,
                  {
                    ref: 'date',
                    dataSort: true,
                    dataField: 'date',
                    tdClassname: 'tdColAgesDate',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.date
                ),
                React.createElement(
                  TableHeaderColumn,
                  {
                    ref: 'dayOfWeek',
                    dataField: "dayOfWeek",
                    dataSort: true,
                    tdClassname: 'tdColAgesDay',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.dayOfWeek
                )
              )
            )
          )
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalAgesServiceSelector;
}(React.Component);
process.env.NODE_ENV !== "production" ? ModalAgesServiceSelector.propTypes = {
  session: PropTypes.object.isRequired,
  callBack: PropTypes.func.isRequired,
  onClose: PropTypes.func.isRequired,
  values: PropTypes.array.isRequired
} : void 0;
export default ModalAgesServiceSelector;