var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, ControlLabel, Modal, Well } from 'react-bootstrap';

import CountryLister from '../CountryLister';
import MessageIcons from '../helpers/MessageIcons';

/**
 * Display modal ID Builder to allow the user to select
 * the parts of the ID for a schema based form
 */
export var ModalCountrySelector = (_temp = _class = function (_React$Component) {
  _inherits(ModalCountrySelector, _React$Component);

  function ModalCountrySelector(props) {
    _classCallCheck(this, ModalCountrySelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, {});

    _this.handleClose = _this.handleClose.bind(_this);
    _this.handleIdSelection = _this.handleIdSelection.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    _this.getSelection = _this.getSelection.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  ModalCountrySelector.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalCountrySelector.prototype.handleClose = function handleClose() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.formData);
  };

  ModalCountrySelector.prototype.render = function render() {
    return React.createElement(
      Well,
      null,
      this.getContent()
    );
  };

  return ModalCountrySelector;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state));
  };

  this.setTheState = function (props, currentState) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: {
        thisClass: labels[labelTopics.ModalCountrySelector],
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };
  };

  this.handleIdSelection = function (code, value) {
    _this2.setState({ selectedCode: code, selectedValue: value }, _this2.handleCallback);
  };

  this.handleCallback = function () {
    if (_this2.props.handleSubmit) {
      _this2.props.handleSubmit(_this2.state.selectedCode, _this2.state.selectedValue);
    }
  };

  this.getSelection = function () {
    if (_this2.state.selectedCode) {
      return React.createElement(
        'span',
        null,
        _this2.state.labels.messages.youSelected,
        ' ',
        _this2.state.selectedCode,
        ' ',
        _this2.state.selectedValue
      );
    }
  };

  this.getContent = function () {
    if (_this2.state.showModal) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Modal,
          {
            backdrop: "static",
            dialogClassName: 'App-Modal-Id-Builder',
            show: _this2.state.showModal,
            onHide: _this2.handleClose,
            keyboard: true
          },
          React.createElement(
            Modal.Header,
            { closeButton: true },
            React.createElement(
              Modal.Title,
              null,
              _this2.state.labels.thisClass.title
            )
          ),
          React.createElement(
            Modal.Body,
            null,
            React.createElement(
              'div',
              null,
              React.createElement(
                ControlLabel,
                null,
                _this2.state.labels.messages.rowSelect,
                ' ',
                _this2.state.labels.messages.filter,
                ' ',
                _this2.state.labels.messages.close
              ),
              React.createElement(
                ControlLabel,
                null,
                _this2.getSelection()
              ),
              React.createElement(CountryLister, {
                session: _this2.props.session,
                callBack: _this2.handleIdSelection
              })
            )
          ),
          React.createElement(
            Modal.Footer,
            null,
            React.createElement(
              Button,
              { onClick: _this2.handleClose },
              _this2.state.labels.button.close
            )
          )
        )
      );
    } else {
      return React.createElement('div', null);
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalCountrySelector.propTypes = {
  session: PropTypes.object.isRequired,
  handleSubmit: PropTypes.func.isRequired,
  onClose: PropTypes.func.isRequired
} : void 0;

ModalCountrySelector.defaultProps = {};

export default ModalCountrySelector;