var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, Modal, Well } from 'react-bootstrap';

import IdBuilder from './IdBuilder';
import MessageIcons from '../helpers/MessageIcons';

/**
 * Display modal ID Builder to allow the user to select
 * the parts of the ID for a schema based form
 */
export var ModalIdBuilder = (_temp = _class = function (_React$Component) {
  _inherits(ModalIdBuilder, _React$Component);

  function ModalIdBuilder(props) {
    _classCallCheck(this, ModalIdBuilder);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.handleClose = _this.handleClose.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    return _this;
  }

  ModalIdBuilder.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalIdBuilder.prototype.handleClose = function handleClose() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.formData);
  };

  ModalIdBuilder.prototype.render = function render() {
    return React.createElement(
      Well,
      null,
      this.getContent()
    );
  };

  return ModalIdBuilder;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState({
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      }
    });
  };

  this.getContent = function () {
    if (_this2.state.showModal) {
      return React.createElement(
        'div',
        null,
        React.createElement(
          Modal,
          {
            backdrop: "static",
            dialogClassName: 'App-Modal-Id-Builder',
            show: _this2.state.showModal,
            onHide: _this2.handleClose,
            keyboard: true
          },
          React.createElement(
            Modal.Header,
            { closeButton: true },
            React.createElement(
              Modal.Title,
              null,
              _this2.props.title
            ),
            _this2.props.text && _this2.props.textId && React.createElement(
              Well,
              null,
              React.createElement(
                'div',
                { className: "App-Modal-Text" },
                _this2.props.text,
                React.createElement(
                  'span',
                  { className: "control-label" },
                  ' (',
                  _this2.props.textId,
                  ')'
                )
              )
            )
          ),
          React.createElement(
            Modal.Body,
            null,
            React.createElement(IdBuilder, {
              session: _this2.props.session,
              IdLibrary: _this2.props.IdLibrary,
              IdTopic: _this2.props.IdTopic,
              IdTopicValue: _this2.props.IdTopicValue,
              IdTopicType: _this2.props.IdTopicType,
              IdKey: _this2.props.IdKey,
              IdKeyValue: _this2.props.IdKeyValue,
              IdKeyType: _this2.props.IdKeyType,
              handleLibraryChange: _this2.props.handleLibraryChange,
              handleTopicChange: _this2.props.handleTopicChange,
              handleSubmit: _this2.handleClose,
              initialOntologyType: _this2.props.initialOntologyType
            })
          ),
          React.createElement(
            Modal.Footer,
            null,
            React.createElement(
              Button,
              { onClick: _this2.close },
              _this2.state.labels.button.close
            )
          )
        )
      );
    } else {
      return React.createElement('div', null);
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalIdBuilder.propTypes = {
  session: PropTypes.object.isRequired,
  IdLibrary: PropTypes.string.isRequired,
  IdTopic: PropTypes.string.isRequired,
  IdTopicValue: PropTypes.string.isRequired,
  IdTopicType: PropTypes.string.isRequired,
  IdKey: PropTypes.string.isRequired,
  IdKeyValue: PropTypes.string.isRequired,
  IdKeyType: PropTypes.string.isRequired,
  handleLibraryChange: PropTypes.func.isRequired,
  handleTopicChange: PropTypes.func.isRequired,
  handleSubmit: PropTypes.func.isRequired,
  initialOntologyType: PropTypes.string.isRequired,
  onClose: PropTypes.func.isRequired
} : void 0;

ModalIdBuilder.defaultProps = {};

export default ModalIdBuilder;