function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import { Button, Modal, Well } from 'react-bootstrap';
import MessageIcons from '../helpers/MessageIcons';
import ReactSelector from './ReactSelector';

/**
 * Display modal window to allow user to select an item from a list.
 */
export var ModalReactSelector = function (_React$Component) {
  _inherits(ModalReactSelector, _React$Component);

  function ModalReactSelector(props) {
    _classCallCheck(this, ModalReactSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.PropTypesWillMount = function () {};

    _this.close = function () {
      _this.setState({ showModal: false });
    };

    _this.open = function () {
      _this.setState({ showModal: true });
    };

    _this.handleSelectionChange = function (selection) {
      var value = selection["value"];
      _this.setState({
        selectedValue: value
      }, _this.props.callBack(value));
    };

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalReactSelector],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedValue: "",
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.handleSelectionChange = _this.handleSelectionChange.bind(_this);
    return _this;
  }

  ModalReactSelector.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(
            'div',
            { className: 'App-modal-body' },
            React.createElement(
              Well,
              null,
              React.createElement(ReactSelector, {
                initialValue: this.props.initialValue,
                resources: this.props.resources,
                changeHandler: this.handleSelectionChange,
                multiSelect: false
              })
            )
          )
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalReactSelector;
}(React.Component);
process.env.NODE_ENV !== "production" ? ModalReactSelector.propTypes = {
  session: PropTypes.object.isRequired,
  resources: PropTypes.array.isRequired,
  initialValue: PropTypes.string,
  callBack: PropTypes.func.isRequired
} : void 0;
ModalReactSelector.defaultProps = {
  initialValue: ""
};

export default ModalReactSelector;