var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, Modal, Well } from 'react-bootstrap';
import SearchText from '../SearchText';
import MessageIcons from '../helpers/MessageIcons';

/**
 * Display modal text search that allows user to select a doc.
 */
export var ModalSearchTextWithCallback = (_temp = _class = function (_React$Component) {
  _inherits(ModalSearchTextWithCallback, _React$Component);

  function ModalSearchTextWithCallback(props) {
    _classCallCheck(this, ModalSearchTextWithCallback);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable],
        searchLabels: labels[labelTopics.search]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    return _this;
  }

  ModalSearchTextWithCallback.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalSearchTextWithCallback.prototype.handleSearchCallback = function handleSearchCallback(id, value, seq, schema) {
    this.setState({ showModal: false });
    if (id.length > 0) {
      this.props.onCallback(id, value, seq, schema);
    } else {
      this.close();
    }
  };

  ModalSearchTextWithCallback.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose();
    }
  };

  ModalSearchTextWithCallback.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-Search-Text-With-Callback',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.props.title
          ),
          this.props.text && this.props.textId && React.createElement(
            Well,
            null,
            React.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.text,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.textId,
                ')'
              )
            )
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(SearchText, {
            session: this.props.session,
            callback: this.handleSearchCallback,
            searchLabels: this.state.labels.searchLabels,
            resultsTableLabels: this.state.labels.resultsTableLabels,
            initialDocType: this.props.initialDocType
          })
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.button.close
          )
        )
      )
    );
  };

  return ModalSearchTextWithCallback;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState({
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable],
        searchLabels: labels[labelTopics.search]
      }
    });
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalSearchTextWithCallback.propTypes = {
  session: PropTypes.object.isRequired,
  initialDocType: PropTypes.string,
  onCallback: PropTypes.func.isRequired,
  onClose: PropTypes.func
} : void 0;
ModalSearchTextWithCallback.defaultProps = {
  initialDocType: "Liturgical"
};

export default ModalSearchTextWithCallback;