var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import axios from 'axios';
import { ControlLabel, Button, Modal, Well } from 'react-bootstrap';
import MessageIcons from '../helpers/MessageIcons';
import Spinner from '../helpers/Spinner';
import SplitTemplateEditor from '../SplitTemplateEditor';
import ReactModal from 'react-modal-resizable-draggable';

/**
 * Display modal content.
 */
export var ModalSplitTemplateEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalSplitTemplateEditor, _React$Component);

  function ModalSplitTemplateEditor(props) {
    _classCallCheck(this, ModalSplitTemplateEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      resultCount: 0,
      showSearchResults: false,
      schema: {},
      uiSchema: {},
      formData: {},
      data: { values: [{ "id": "", "value:": "" }] },
      showForm: false,
      topicText: "",
      keyText: "",
      treeData: undefined,
      dataFetched: false
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getEditor = _this.getEditor.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    return _this;
  }

  ModalSplitTemplateEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalSplitTemplateEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.messages.searching,
      messageIcon: MessageIcons.getMessageIcons().info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var path = this.props.session.restServer + this.props.restPath + "/" + this.props.idLibrary + "/" + this.props.idTopic + "/" + this.props.idKey;
    axios.get(path, config).then(function (response) {
      if (response.data.valueCount && response.data.valueCount > 0) {
        var data = response.data.values[0];
        var treeData = [];
        treeData.push(JSON.parse(data.node));
        var schemaId = data._valueSchemaId;
        var dataSchema = response.data.valueSchemas[schemaId].schema;
        var dataUiSchema = response.data.valueSchemas[schemaId].uiSchema;
        _this2.setState({
          schema: dataSchema,
          uiSchema: dataUiSchema,
          formData: data,
          showForm: true,
          message: _this2.state.labels.messages.found,
          messageIcon: MessageIcons.getMessageIcons().info,
          treeData: treeData,
          dataFetched: true
        });
      }
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = MessageIcons.getMessageIcons().error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.messages.foundNone;
        messageIcon = MessageIcons.getMessageIcons().warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  ModalSplitTemplateEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSchema);
  };

  ModalSplitTemplateEditor.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalSplitTemplateEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-Template-Editor',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && React.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && React.createElement(
            Well,
            { className: "App-Well-From-Text" },
            React.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && React.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && React.createElement(
            Well,
            { className: "App-Well-To-Text" },
            React.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && React.createElement(
            ControlLabel,
            null,
            this.state.labels.references.infoBelow
          ),
          this.props.canUpdate ? React.createElement('div', null) : React.createElement(
            ControlLabel,
            null,
            this.state.labels.messages.readOnly
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          this.getEditor()
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.buttons.close
          )
        )
      )
    );
  };

  return ModalSplitTemplateEditor;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    _this3.setState({
      showModal: _this3.props.showModal
    }, function () {
      this.fetchData();
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this3.setState({
      buttons: labels[labelTopics.button],
      messages: labels[labelTopics.messages],
      references: labels[labelTopics.ViewReferences]
    });
  };

  this.getEditor = function () {
    if (_this3.state.dataFetched) {
      return React.createElement(SplitTemplateEditor, {
        session: _this3.props.session,
        treeData: _this3.state.treeData,
        idLibrary: _this3.props.idLibrary,
        idTopic: _this3.props.idTopic,
        formData: _this3.state.formData,
        uiSchema: _this3.state.uiSchema,
        schema: _this3.state.schema
      });
    } else {
      return React.createElement(Spinner, { message: _this3.state.labels.messages.searching });
    }
  };
}, _temp);
process.env.NODE_ENV !== "production" ? ModalSplitTemplateEditor.propTypes = {
  session: PropTypes.object.isRequired,
  restPath: PropTypes.string.isRequired,
  onClose: PropTypes.func.isRequired,
  showModal: PropTypes.bool.isRequired,
  title: PropTypes.string.isRequired,
  idLibrary: PropTypes.string.isRequired,
  idTopic: PropTypes.string.isRequired,
  idKey: PropTypes.string.isRequired,
  canUpdate: PropTypes.bool
} : void 0;
ModalSplitTemplateEditor.defaultProps = {
  canUpdate: true
};

export default ModalSplitTemplateEditor;