var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, Col, ControlLabel, Form, FormControl, FormGroup, Glyphicon, InputGroup, Modal, Well } from 'react-bootstrap';
import MessageIcons from '../helpers/MessageIcons';
import ReactSelector from './ReactSelector';
import ModalReactSelector from './ModalReactSelector';
import ModalSearchTextWithCallback from './ModalSearchTextWithCallback';
import ModalSchemaBasedEditor from './ModalSchemaBasedEditor';
import Server from "../helpers/Server";

/**
 * Display modal window to allow user to edit information about a template node.
 * TODO: when user sets node type to a switch (e.g. WHEN_DAY_NAME_IS), display a list of cases and allow user to check box to include.
 */
export var ModalTemplateNodeEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalTemplateNodeEditor, _React$Component);

  function ModalTemplateNodeEditor(props) {
    _classCallCheck(this, ModalTemplateNodeEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalTemplateNodeEditor],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      node: _this.props.node,
      selectedNodeType: _this.props.node.title,
      selectedSubtitle: _this.props.node.subtitle,
      selectedSchemaValue: "",
      showModal: props.showModal,
      showModalSchemaEditor: false,
      showModalTextSearch: false,
      showTextInput: false,
      idKey: "head",
      modalTitle: _this.props.node.subtitle
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);

    _this.handleSelectionChange = _this.handleSelectionChange.bind(_this);

    _this.getModalTextSearch = _this.getModalTextSearch.bind(_this);
    _this.handleTextLookupCallback = _this.handleTextLookupCallback.bind(_this);

    _this.getModalSchemaEditorButton = _this.getModalSchemaEditorButton.bind(_this);
    _this.enableModalSchemaEditor = _this.enableModalSchemaEditor.bind(_this);
    _this.getModalSchemaEditor = _this.getModalSchemaEditor.bind(_this);
    _this.handleCloseModalSchemaEditor = _this.handleCloseModalSchemaEditor.bind(_this);

    _this.getModalReactSelector = _this.getModalReactSelector.bind(_this);
    _this.handleReactSelectorCallback = _this.handleReactSelectorCallback.bind(_this);

    _this.getSubtitleTextInput = _this.getSubtitleTextInput.bind(_this);
    _this.handleSubtitleChange = _this.handleSubtitleChange.bind(_this);

    _this.getSubtitleTextIdLookup = _this.getSubtitleTextIdLookup.bind(_this);
    _this.handleSubtitleTextIdChange = _this.handleSubtitleTextIdChange.bind(_this);
    _this.enableModalTextSearch = _this.enableModalTextSearch.bind(_this);

    _this.getNodeTypeSelector = _this.getNodeTypeSelector.bind(_this);
    _this.handleNodeTypeChange = _this.handleNodeTypeChange.bind(_this);

    _this.setSubtitle = _this.setSubtitle.bind(_this);
    _this.getServiceDate = _this.getServiceDate.bind(_this);

    return _this;
  }

  /**
   * This editor uses uischemas from the REST API
   * @returns {*}
   */


  /**
   * TODO: This is unfinished.  The idea is to allow the user
   * to see (and perhaps easily set) the year, month, and date
   * without having to invoke the modal schema based editor.
   * @returns {*}
   */


  ModalTemplateNodeEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      this.state.showModalSchemaEditor && this.getModalSchemaEditor(),
      this.state.showModalTextSearch && this.getModalTextSearch(),
      React.createElement(
        Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          React.createElement(
            'div',
            { className: 'App-modal-body' },
            React.createElement(
              Well,
              null,
              React.createElement(
                Form,
                { horizontal: true },
                this.getNodeTypeSelector(),
                this.getSubtitleTextInput(),
                this.getModalSchemaEditorButton()
              )
            )
          )
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { bsStyle: 'primary', onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalTemplateNodeEditor;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.PropTypesWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, nextProps) {
      return {
        labels: {
          thisClass: labels[labelTopics.ModalTemplateNodeEditor],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial,
        node: nextProps.node,
        selectedNodeType: nextProps.node.title,
        selectedSubtitle: nextProps.node.subtitle,
        selectedSchemaValue: "",
        showModal: nextProps.showModal,
        showModalSchemaEditor: false,
        showModalTextSearch: false,
        showTextInput: false,
        idKey: "head",
        modalTitle: _this2.props.node.subtitle
      };
    });
  };

  this.open = function () {
    _this2.setState({ showModal: true });
  };

  this.close = function () {
    _this2.setState({ showModal: false }, _this2.props.callBack());
  };

  this.getModalSchemaEditorButton = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return React.createElement(
        FormGroup,
        null,
        React.createElement(
          Col,
          { componentClass: ControlLabel, sm: 2 },
          '\xA0',
          _this2.state.labels.thisClass.editProperties
        ),
        React.createElement(
          Col,
          { sm: 8 },
          React.createElement(
            Button,
            { onClick: _this2.enableModalSchemaEditor },
            React.createElement(Glyphicon, { glyph: 'pencil' })
          )
        )
      );
    }
  };

  this.enableModalSchemaEditor = function () {
    _this2.setState({ showModalSchemaEditor: true });
  };

  this.getServiceDate = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return React.createElement(
        Form,
        { inline: true },
        React.createElement(
          FormGroup,
          { controlId: 'formInlineYear' },
          React.createElement(
            ControlLabel,
            null,
            'Year'
          ),
          ' ',
          React.createElement(FormControl, { type: 'text', placeholder: '' })
        ),
        ' ',
        React.createElement(
          FormGroup,
          { controlId: 'formInlineMonth' },
          React.createElement(
            ControlLabel,
            null,
            'Month'
          ),
          ' ',
          React.createElement(FormControl, { type: 'text', placeholder: '' })
        ),
        React.createElement(
          FormGroup,
          { controlId: 'formInlineDay' },
          React.createElement(
            ControlLabel,
            null,
            'Month'
          ),
          ' ',
          React.createElement(FormControl, { type: 'text', placeholder: '' })
        )
      );
    }
  };

  this.getModalSchemaEditor = function () {
    return React.createElement(ModalSchemaBasedEditor, {
      session: _this2.props.session,
      restPath: Server.getDbServerDocsApi(),
      showModal: _this2.state.showModalSchemaEditor,
      title: _this2.state.modalTitle,
      idLibrary: _this2.props.templateLibrary,
      idTopic: _this2.props.templateTopic,
      idKey: _this2.state.idKey,
      onClose: _this2.handleCloseModalSchemaEditor
    });
  };

  this.handleCloseModalSchemaEditor = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalSchemaEditor: false,
        selectedId: id,
        selectedSchemaValue: value
      });
    } else {
      _this2.setState({
        showModalSchemaEditor: false
      });
    }
  };

  this.getModalReactSelector = function () {
    return React.createElement(ModalReactSelector, {
      languageCode: _this2.props.session.languageCode,
      resources: _this2.state.selectorResource,
      initialValue: _this2.state.selectorInitialValue,
      callBack: _this2.handleReactSelectorCallback
    });
  };

  this.handleReactSelectorCallback = function (item) {
    if (item.length > 0) {
      _this2.setState({
        showModalReactSelector: false,
        selectedItem: item,
        selectedNodeType: item["value"]
      });
    } else {
      _this2.setState({
        showModalReactSelector: false
      });
    }
  };

  this.handleNodeTypeChange = function (selection) {
    var value = selection["value"];
    var node = _this2.state.node;
    node.title = value;
    _this2.setState({ node: node, selectedNodeType: value }, _this2.handleSelectionChange);
  };

  this.handleSelectionChange = function () {
    switch (_this2.state.selectedNodeType) {
      case "INSERT_SECTION":
        {
          break;
        }
      case "RID":
        {
          _this2.setState({
            showModalTextSearch: true
          });
          break;
        }
      case "SECTION":
        {
          _this2.setState({
            showTextInput: true
          });
          break;
        }
      case "SID":
        {
          _this2.setState({
            showModalTextSearch: true
          });
          break;
        }
      case "TEMPLATE":
        {
          _this2.setState({
            idKey: "head",
            showModalSchemaEditor: true,
            modalTitle: _this2.props.idLibrary + "~" + _this2.props.idTopic + "~head"
          });
          break;
        }
      case "tbd":
        {
          _this2.setState({
            showModalReactSelector: true,
            selectorResource: _this2.props.session.dropdowns["templatePartsDropdown"],
            selectorInitialValue: "SECTION"
          });
          break;
        }
    }
  };

  this.getModalTextSearch = function () {
    return React.createElement(ModalSearchTextWithCallback, {
      session: _this2.props.session,
      onCallback: _this2.handleTextLookupCallback,
      initialDocType: "Liturgical"
    });
  };

  this.handleTextLookupCallback = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalTextSearch: false,
        selectedId: id,
        selectedSchemaValue: value
      }, _this2.setSubtitle(id));
    } else {
      _this2.setState({
        showModalTextSearch: false
      });
    }
  };

  this.enableModalTextSearch = function () {
    _this2.setState({ showModalTextSearch: true });
  };

  this.handleSubtitleTextIdChange = function () {};

  this.getSubtitleTextIdLookup = function () {};

  this.setSubtitle = function (value) {
    var node = _this2.state.node;
    node.subtitle = value;
    _this2.setState({ node: node, selectedSubtitle: value });
  };

  this.handleSubtitleChange = function (event) {
    _this2.setSubtitle(event.target.value);
  };

  this.getSubtitleTextInput = function () {
    // Note: use fall throughs (i.e. no break) for switches that group together
    switch (_this2.state.selectedNodeType) {
      case "SID":
      case "RID":
        {
          return React.createElement(
            FormGroup,
            null,
            React.createElement(
              Col,
              { componentClass: ControlLabel, sm: 2 },
              _this2.state.labels.thisClass.nodeSubtitle
            ),
            React.createElement(
              Col,
              { sm: 8 },
              React.createElement(
                InputGroup,
                { className: 'App-InputGroup-Static' },
                React.createElement(
                  FormControl.Static,
                  null,
                  _this2.state.selectedSubtitle
                ),
                React.createElement(
                  InputGroup.Button,
                  null,
                  React.createElement(
                    Button,
                    { onClick: _this2.enableModalTextSearch },
                    React.createElement(Glyphicon, { glyph: 'search' })
                  )
                )
              )
            )
          );
          break;
        }
      case "SECTION":
        return React.createElement(
          FormGroup,
          null,
          React.createElement(
            Col,
            { componentClass: ControlLabel, sm: 2 },
            _this2.state.labels.thisClass.nodeSubtitle
          ),
          React.createElement(
            Col,
            { sm: 10 },
            React.createElement(FormControl, {
              type: 'text',
              defaultValue: _this2.state.selectedSubtitle,
              onChange: _this2.handleSubtitleChange
            })
          )
        );
        break;
      case "TEMPLATE":
        {
          return React.createElement(
            FormGroup,
            null,
            React.createElement(
              Col,
              { componentClass: ControlLabel, sm: 2 },
              _this2.state.labels.thisClass.nodeSubtitle
            ),
            React.createElement(
              Col,
              { sm: 8 },
              React.createElement(
                InputGroup,
                { className: 'App-InputGroup-Static' },
                React.createElement(
                  FormControl.Static,
                  null,
                  _this2.state.selectedSubtitle
                )
              )
            )
          );
          break;
        }
    }
  };

  this.getNodeTypeSelector = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return React.createElement(
        FormGroup,
        null,
        React.createElement(
          Col,
          { componentClass: ControlLabel, sm: 2 },
          _this2.state.labels.thisClass.nodeTypePrompt
        ),
        React.createElement(
          Col,
          { sm: 8 },
          React.createElement(
            InputGroup,
            { className: 'App-InputGroup-Static' },
            React.createElement(
              FormControl.Static,
              null,
              _this2.state.selectedNodeType
            )
          )
        )
      );
    } else {
      return React.createElement(
        FormGroup,
        null,
        React.createElement(
          Col,
          { componentClass: ControlLabel, sm: 2 },
          _this2.state.labels.thisClass.nodeTypePrompt
        ),
        React.createElement(
          Col,
          { sm: 10 },
          React.createElement(ReactSelector, {
            initialValue: _this2.state.selectedNodeType,
            resources: _this2.props.session.dropdowns["templatePartsDropdown"],
            changeHandler: _this2.handleNodeTypeChange,
            multiSelect: false
          })
        )
      );
    }
  };
}, _temp);
process.env.NODE_ENV !== "production" ? ModalTemplateNodeEditor.propTypes = {
  session: PropTypes.object.isRequired,
  showModal: PropTypes.bool.isRequired,
  node: PropTypes.object.isRequired,
  path: PropTypes.array.isRequired,
  treeIndex: PropTypes.number.isRequired,
  callBack: PropTypes.func.isRequired,
  templateLibrary: PropTypes.string.isRequired,
  templateTopic: PropTypes.string.isRequired
} : void 0;
ModalTemplateNodeEditor.defaultProps = {};

export default ModalTemplateNodeEditor;