var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Button, ControlLabel, Modal, Well } from 'react-bootstrap';

import TextNoteEditor from '../TextNoteEditor';
import MessageIcons from '../helpers/MessageIcons';
import Spinner from '../helpers/Spinner';
import axios from "axios/index";
import IdManager from "../helpers/IdManager";

/**
 * Display modal content.
 */
export var ModalTextNoteEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalTextNoteEditor, _React$Component);

  function ModalTextNoteEditor(props) {
    _classCallCheck(this, ModalTextNoteEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var textId = IdManager.getParts(props.noteIdTopic);
    var showForm = true;
    if (props.noteIdLibrary) {
      showForm = false;
    }

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true,
      showForm: showForm,
      textId: textId
    };

    _this.close = _this.close.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.onDelete = _this.onDelete.bind(_this);
    _this.handleTextNoteContentChange = _this.handleTextNoteContentChange.bind(_this);
    return _this;
  }

  ModalTextNoteEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalTextNoteEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.messages.searching,
      messageIcon: MessageIcons.getMessageIcons().info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var path = this.props.session.restServer + this.props.restPath + "/" + this.props.noteIdLibrary + "/" + this.props.noteIdTopic + "/" + this.props.noteIdKey;
    axios.get(path, config).then(function (response) {
      if (response.data.valueCount && response.data.valueCount > 0) {
        var data = response.data.values[0];
        var schemaId = data._valueSchemaId;
        var dataSchema = response.data.valueSchemas[schemaId].schema;
        var dataUiSchema = response.data.valueSchemas[schemaId].uiSchema;
        _this2.setState({
          schema: dataSchema,
          uiSchema: dataUiSchema,
          formData: data,
          showForm: true,
          message: _this2.state.labels.messages.found,
          messageIcon: MessageIcons.getMessageIcons().info
        });
      }
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = MessageIcons.getMessageIcons().error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.messages.foundNone;
        messageIcon = MessageIcons.getMessageIcons().warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  ModalTextNoteEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose(this.state.formData);
    }
  };

  ModalTextNoteEditor.prototype.render = function render() {
    return React.createElement(
      'div',
      null,
      React.createElement(
        Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-New-Entry-Form',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        React.createElement(
          Modal.Header,
          { closeButton: true },
          React.createElement(
            Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && React.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && React.createElement(
            Well,
            { className: "App-Well-From-Text" },
            React.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && React.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && React.createElement(
            Well,
            { className: "App-Well-To-Text" },
            React.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              React.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && React.createElement(
            ControlLabel,
            null,
            this.state.labels.references.infoBelow
          )
        ),
        React.createElement(
          Modal.Body,
          null,
          this.getEditor()
        ),
        React.createElement(
          Modal.Footer,
          null,
          React.createElement(
            Button,
            { onClick: this.close },
            this.state.labels.buttons.close
          )
        )
      )
    );
  };

  return ModalTextNoteEditor;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentDidMount = function () {
    if (_this3.props.noteIdLibrary && _this3.props.noteIdKey) {
      _this3.fetchData();
    }
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this3.setState({
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      }
    });
  };

  this.handleTextNoteContentChange = function () {};

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    if (_this3.props.onSubmit) {
      _this3.props.onSubmit(formData);
    }
  };

  this.onDelete = function (result) {
    _this3.close();
  };

  this.getEditor = function () {
    if (_this3.state.showForm) {
      return React.createElement(TextNoteEditor, {
        session: _this3.props.session,
        textId: _this3.props.noteIdTopic,
        onEditorChange: _this3.handleTextNoteContentChange,
        form: _this3.state.formData,
        id: "tinymiceeditor" + _this3.props.noteIdTopic,
        notesList: _this3.props.notesList,
        deleteCallback: _this3.onDelete
      });
    } else {
      return React.createElement(Spinner, { message: _this3.state.labels.messages.retrieving });
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalTextNoteEditor.propTypes = {
  session: PropTypes.object.isRequired,
  restPath: PropTypes.string.isRequired,
  noteIdLibrary: PropTypes.string,
  noteIdTopic: PropTypes.string.isRequired,
  noteIdKey: PropTypes.string,
  onSubmit: PropTypes.func,
  onClose: PropTypes.func,
  canUpdate: PropTypes.bool,
  notesList: PropTypes.array
} : void 0;
ModalTextNoteEditor.defaultProps = {
  canUpdate: true
};

export default ModalTextNoteEditor;