function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import ResourceSelector from './ReactSelector';
import FontAwesome from 'react-fontawesome';
import { Button } from 'react-bootstrap';

var NoteSearchOptions = function (_React$Component) {
  _inherits(NoteSearchOptions, _React$Component);

  function NoteSearchOptions(props) {
    _classCallCheck(this, NoteSearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {};

    _this.handleDocTypeChange = function (selection) {
      var type = selection["value"];
      _this.setState({
        selectedType: type,
        dropDownProperties: {
          msg: _this.props.labels.domainIs,
          source: _this.props.properties[type],
          initialValue: "*"
        }
      });
    };

    _this.handlePropertyChange = function (item) {
      var newSelectedValue = _this.state.value;

      if (item.value.startsWith("*")) {
        newSelectedValue = "";
      }
      _this.setState({
        selectedProperty: item.value,
        value: newSelectedValue
      });
    };

    _this.handleMatcherChange = function (item) {
      _this.setState({ selectedMatcher: item.value });
    };

    _this.handleValueChange = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleTagsSelection = function (selection) {
      var tags = selection.map(function (a) {
        return a.value;
      });

      _this.setState({
        selectedTags: tags.toString()
      });
    };

    _this.handleTagOperatorChange = function (selection) {
      _this.setState({
        selectedTagOperator: selection["value"]
      });
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.selectedType, _this.state.selectedProperty, _this.state.selectedMatcher, _this.state.value, _this.state.selectedTagOperator, _this.state.selectedTags);
      event.preventDefault();
    };

    _this.isDisabled = function () {
      // For now, we are not disabling the search for any reason.
      // The code below is stubbed out for the event that we
      // start disabling.
      var disableButton = false;
      if (_this.state.value && _this.state.value.length > 0) {
        disableButton = false;
      } else {
        switch (_this.state.selectedType) {
          case "*":
            {
              break;
            }
          default:
            {
              disableButton = false;
              break;
            }
        }
      }
      return disableButton;
    };

    var initialType = "Human";
    if (_this.props.initialType) {
      initialType = _this.props.initialType;
    }

    _this.state = {
      selectedType: initialType,
      selectedProperty: "value",
      selectedMatcher: "c",
      value: "",
      selectedTagOperator: "any",
      selectedTags: "",
      tagData: [],
      dropDownProperties: {
        msg: _this.props.labels.domainIs,
        source: _this.props.properties[initialType],
        initialValue: "*"
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTagsSelection = _this.handleTagsSelection.bind(_this);
    _this.handleTagOperatorChange = _this.handleTagOperatorChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);
    return _this;
  }

  NoteSearchOptions.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'container App-search-options-container' },
      React.createElement(
        'div',
        null,
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            React.createElement(ResourceSelector, {
              title: this.props.labels.findWhereTypeIs,
              initialValue: this.state.selectedType,
              resources: this.props.types,
              changeHandler: this.handleDocTypeChange,
              multiSelect: false
            })
          )
        )
      ),
      React.createElement(
        'div',
        { className: 'row' },
        React.createElement(
          'div',
          { className: 'col-sm-12' },
          React.createElement(ResourceSelector, {
            title: this.props.labels.propertyIs,
            initialValue: this.state.selectedProperty,
            resources: this.props.properties[this.state.selectedType],
            changeHandler: this.handlePropertyChange,
            multiSelect: false
          }),
          React.createElement(
            'form',
            { onSubmit: this.handleSubmit },
            React.createElement(
              'div',
              { className: 'control-label' },
              this.props.labels.propertyTextIs
            ),
            React.createElement('input', {
              type: 'text',
              value: this.state.value,
              onChange: this.handleValueChange,
              className: 'App-search-text-input',
              name: 'search' })
          ),
          React.createElement(ResourceSelector, {
            title: this.props.labels.matcherIs,
            initialValue: this.state.selectedMatcher,
            resources: this.props.matchers,
            changeHandler: this.handleMatcherChange,
            multiSelect: false
          }),
          this.state.selectedType !== "*" && React.createElement(
            'div',
            null,
            React.createElement(ResourceSelector, {
              title: this.props.labels.has,
              initialValue: 'any',
              resources: this.props.tagOperators,
              changeHandler: this.handleTagOperatorChange,
              multiSelect: false
            }),
            React.createElement(ResourceSelector, {
              title: this.props.labels.tags,
              initialValue: this.state.selectedTags,
              resources: this.props.tags[this.state.selectedType],
              changeHandler: this.handleTagsSelection,
              multiSelect: true
            })
          ),
          React.createElement(
            'div',
            { className: 'control-label' },
            this.props.labels.clickTheButton
          ),
          React.createElement(
            Button,
            {
              bsStyle: 'primary',
              bsSize: 'xsmall',
              type: 'submit',
              disabled: this.isDisabled(),
              onClick: this.handleSubmit
            },
            React.createElement(FontAwesome, { className: 'Button-Select-FontAwesome', name: "search" }),
            this.props.labels.submit
          )
        )
      )
    );
  };

  return NoteSearchOptions;
}(React.Component);

process.env.NODE_ENV !== "production" ? NoteSearchOptions.propTypes = {
  types: PropTypes.array.isRequired,
  initialType: PropTypes.string.isRequired,
  properties: PropTypes.object.isRequired,
  matchers: PropTypes.array.isRequired,
  tags: PropTypes.object.isRequired,
  tagOperators: PropTypes.array.isRequired,
  handleSubmit: PropTypes.func.isRequired,
  labels: PropTypes.object.isRequired
} : void 0;

export default NoteSearchOptions;