function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';

import Select from 'react-select';
import { ControlLabel } from 'react-bootstrap';

import 'react-select/dist/react-select.css';

// TODO: switch to VirtualizedSelect, see TopicsSelector for example.  Much faster
export var ReactSelector = function (_React$Component) {
  _inherits(ReactSelector, _React$Component);

  function ReactSelector(props) {
    _classCallCheck(this, ReactSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {

      _this.setState({
        value: nextProps.initialValue
      });
    };

    _this.handleChange = function (selection) {
      _this.props.changeHandler(selection, true);
      _this.setState({ value: selection });
    };

    _this.state = {
      value: props.initialValue
    };
    return _this;
  }

  ReactSelector.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'resourceSelector' },
      this.props.title ? React.createElement(
        ControlLabel,
        { className: 'resourceSelectorPrompt' },
        this.props.title
      ) : React.createElement('span', null),
      React.createElement(Select, {
        name: 'form-field-name',
        value: this.state.value,
        options: this.props.resources,
        onChange: this.handleChange,
        multi: this.props.multiSelect,
        autosize: true,
        clearable: true
      })
    );
  };

  return ReactSelector;
}(React.Component);;

process.env.NODE_ENV !== "production" ? ReactSelector.propTypes = {
  initialValue: PropTypes.string,
  resources: PropTypes.array.isRequired,
  changeHandler: PropTypes.func.isRequired,
  multiSelect: PropTypes.bool.isRequired,
  title: PropTypes.string
} : void 0;

// set default values for props here
ReactSelector.defaultProps = {
  initialValue: "",
  title: ""
};

export default ReactSelector;