function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import ResourceSelector from './ReactSelector';
import { Button } from 'react-bootstrap';
import FontAwesome from 'react-fontawesome';
import { get } from 'lodash';

/**
 * To future maintainers of this code.
 * This was written when I just started learning React Js.
 * The code I have written without a doubt needs to be
 * examined carefully if you are skilled in React JS,
 * and rewritten...
 * Michael Colburn, March 1, 2017
 */

var SearchOptions = function (_React$Component) {
  _inherits(SearchOptions, _React$Component);

  function SearchOptions(props) {
    _classCallCheck(this, SearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {
      _this.setState({
        dropdowns: {
          Biblical: {
            all: {
              books: _this.props.dropDowns.Biblical.all.books,
              chapters: _this.props.dropDowns.Biblical.all.chapters
            },
            domains: _this.props.dropDowns.Biblical.domains,
            topics: _this.props.dropDowns.Biblical.topics
          },
          Liturgical: {
            all: {
              books: _this.props.dropDowns.Liturgical.all.books
            },
            domains: _this.props.dropDowns.Liturgical.domains,
            topics: _this.props.dropDowns.Liturgical.topics
          },
          loaded: true
        }, function: function _function() {
          this.handleDocTypeChange({
            label: this.props.docType,
            value: this.props.docTyped
          });
        }
      });
    };

    _this.componentDidMount = function () {
      _this.handleDocTypeChange({
        label: _this.props.docType,
        value: _this.props.docType
      });
    };

    _this.componentWillReceiveProps = function (nextProps) {
      var docType = nextProps.docType;
      var domain = "*";
      var selectedBook = "*";
      var selectedChapter = "*";
      var property = "nnp";
      var matcher = "c";
      var value = "";
      var dropdownChapters = {};

      if (_this.state) {
        if (_this.state.docType) {
          docType = _this.state.docType;
        }
        if (_this.state.domain) {
          domain = _this.state.domain;
        }
        if (_this.state.selectedBook) {
          selectedBook = _this.state.selectedBook;
        }
        if (_this.state.selectedChapter) {
          selectedChapter = _this.state.selectedChapter;
        }
        if (_this.state.property) {
          property = _this.state.property;
        }
        if (_this.state.matcher) {
          matcher = _this.state.matcher;
        }
        if (_this.state.value) {
          value = _this.state.value;
        }
        if (_this.state.dropdownChapters) {
          dropdownChapters = _this.state.dropdownChapters;
        } else {
          dropdownChapters = {
            show: false,
            msg: "",
            initialValue: "*",
            source: []
          };
        }
      }

      _this.setState({
        docType: docType,
        domain: domain,
        selectedBook: selectedBook,
        selectedChapter: selectedChapter,
        property: property,
        matcher: matcher,
        value: value,
        dropdowns: {
          Biblical: {
            all: {
              books: nextProps.dropDowns.Biblical.all.books,
              chapters: nextProps.dropDowns.Biblical.all.chapters
            },
            domains: nextProps.dropDowns.Biblical.domains,
            topics: nextProps.dropDowns.Biblical.topics
          },
          Liturgical: {
            all: {
              books: nextProps.dropDowns.Liturgical.all.books
            },
            domains: nextProps.dropDowns.Liturgical.domains,
            topics: nextProps.dropDowns.Liturgical.topics
          },
          loaded: true
        },
        dropdownChapters: dropdownChapters
      }, _this.cascadeDocTypeChange(docType));
    };

    _this.isDisabled = function () {
      var disableButton = true;
      switch (_this.state.docType) {
        case "All":
          {
            break;
          }
        case "Biblical":
          {
            if (_this.state.value.length > 0) {
              disableButton = false;
            } else {
              if (_this.state.domain == "*") {
                if (_this.state.selectedBook == "*") {} else {
                  disableButton = false;
                }
              } else {
                if (_this.state.selectedBook == "*") {} else {
                  disableButton = false;
                }
              }
            }
            break;
          }
        case "Liturgical":
          {
            if (_this.state.value.length > 0) {
              disableButton = false;
            } else {
              if (_this.state.domain == "*") {
                if (_this.state.selectedBook == "*") {} else {
                  disableButton = false;
                }
              } else {
                if (_this.state.selectedBook == "*") {} else {
                  disableButton = false;
                }
              }
            }
            break;
          }
        default:
          {
            break;
          }
      }
      return disableButton;
    };

    _this.handleDocTypeChange = function (selection) {
      _this.setState({
        docType: selection["value"],
        suggestedQuery: _this.suggestedQuery(selection["value"]),
        domain: "*",
        selectedBook: "*",
        selectedChapter: "*"
      }, _this.cascadeDocTypeChange(selection["value"]));
    };

    _this.handlePropertyChange = function (item) {
      _this.setState({ property: item.value });
    };

    _this.handleMatcherChange = function (item) {
      _this.setState({ matcher: item.value });
    };

    _this.handleValueChange = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.docType, _this.state.domain, _this.state.selectedBook, _this.state.selectedChapter, _this.state.property, _this.state.matcher, _this.state.value);
      event.preventDefault();
    };

    _this.handleDomainChange = function (selection) {
      _this.setState({ domain: selection["value"] }, _this.setBookDropdown(selection["value"]));
    };

    _this.handleBookChange = function (selection) {
      _this.setState({
        selectedBook: selection["value"]
      }, _this.setChaptersDropdown(selection["value"]));
    };

    _this.handleChapterChange = function (selection) {
      _this.setState({
        selectedChapter: selection["value"],
        dropdownChapters: {
          show: _this.state.dropdownChapters.show,
          msg: _this.state.dropdownChapters.msg,
          source: _this.state.dropdownChapters.source,
          initialValue: selection["value"]
        }
      });
    };

    _this.setDomainDropdown = function (docType) {
      var msg = "";
      var show = false;
      var source = {};
      var showBooks = false;
      var bookMsg = "";
      var bookSource = [];
      switch (docType) {
        case "All":
          {
            show = false;
            break;
          }
        case "Biblical":
          {
            msg = _this.props.labels.domainIs;
            show = true;
            if (_this.state.dropdowns.loaded) {
              source = _this.state.dropdowns.Biblical.domains;
            }
            break;
          }
        case "Liturgical":
          {
            msg = _this.props.labels.domainIs;
            show = true;
            if (_this.state.dropdowns.loaded) {
              source = _this.state.dropdowns.Liturgical.domains;
              showBooks = true;
              bookMsg = _this.props.labels.bookIs;
              bookSource = _this.state.dropdowns.Liturgical["all"].books;
            }
            break;
          }
        default:
          {
            show = false;
            break;
          }
      }
      _this.setState({
        dropDownDomains: {
          show: show,
          msg: msg,
          source: source,
          initialValue: "*"
        },
        dropDownBooks: {
          show: showBooks,
          msg: bookMsg,
          source: bookSource,
          initialValue: "*"
        },
        dropdownChapters: {
          show: false,
          msg: "",
          source: [],
          initialValue: "*"
        }
      });
    };

    _this.state = {
      docType: _this.props.docType,
      domain: "*",
      selectedBook: "*",
      selectedChapter: "*",
      property: "nnp",
      matcher: "c",
      value: "",
      dropdowns: { Biblical: [], Liturgical: [], loaded: false },
      dropDownDomains: {
        show: true,
        msg: _this.props.labels.domainIs,
        source: [],
        initialValue: "*"
      },

      dropDownBooks: {
        show: true,
        msg: _this.props.labels.bookIs,
        source: [],
        initialValue: "*"
      },

      dropdownChapters: {
        show: false,
        msg: "",
        initialValue: "*",
        source: []
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handleDomainChange = _this.handleDomainChange.bind(_this);
    _this.handleBookChange = _this.handleBookChange.bind(_this);
    _this.handleChapterChange = _this.handleChapterChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.setBookDropdown = _this.setBookDropdown.bind(_this);
    _this.setChaptersDropdown = _this.setChaptersDropdown.bind(_this);
    _this.setDomainDropdown = _this.setDomainDropdown.bind(_this);
    _this.setGenericBookDropdown = _this.setGenericBookDropdown.bind(_this);
    _this.setGenericChaptersDropdown = _this.setGenericChaptersDropdown.bind(_this);
    _this.suggestedQuery = _this.suggestedQuery.bind(_this);
    _this.getDropdownChapterTitle = _this.getDropdownChapterTitle.bind(_this);
    _this.getDropdownSectionTitle = _this.getDropdownSectionTitle.bind(_this);
    _this.resetDropDownBooksState = _this.resetDropDownBooksState.bind(_this);
    _this.cascadeDocTypeChange = _this.cascadeDocTypeChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);
    return _this;
  }

  SearchOptions.prototype.resetDropDownBooksState = function resetDropDownBooksState() {
    this.setState({
      selectedBook: "*",
      dropDownBooks: {
        show: this.state.docType !== "Any",
        msg: this.props.labels.bookIs,
        source: [],
        initialValue: "*"
      }
    });
  };

  SearchOptions.prototype.cascadeDocTypeChange = function cascadeDocTypeChange(selection) {
    this.setDomainDropdown(selection);
    this.setGenericBookDropdown(selection);
    this.setGenericChaptersDropdown(selection);
  };

  SearchOptions.prototype.setGenericBookDropdown = function setGenericBookDropdown(type) {
    try {
      var msg = this.props.labels.bookIs;
      var show = false;
      var source = {};
      if (this.props.dropDowns) {
        if (type === "Biblical" && this.state.dropdowns.Biblical) {
          show = true;
          source = this.state.dropdowns.Biblical.all.books;
        } else if (type === "Liturgical" && this.state.dropdowns.Liturgical) {
          show = true;
          source = this.state.dropdowns.Liturgical.all.books;
        } // end of if
      }
      this.setState({
        dropDownBooks: {
          show: show,
          msg: msg,
          source: source,
          initialValue: "*"
        }
      });
    } catch (error) {
      this.setState({
        msg: error.message
      });
    }
  };

  // end of method

  SearchOptions.prototype.setBookDropdown = function setBookDropdown(domain) {
    var msg = this.props.labels.bookIs;
    var show = false;
    var source = {};
    if (domain && domain === "*") {
      this.setGenericBookDropdown(this.state.docType);
    } else {
      if (this.state.docType === "Biblical") {
        show = true;
        source = this.state.dropdowns.Biblical.topics[domain];
      } else if (this.state.docType === "Liturgical") {
        show = true;
        source = this.state.dropdowns.Liturgical.topics[domain];
      } // end of if
      this.setState({
        dropDownBooks: {
          show: show,
          msg: msg,
          source: source
        }
      });
    }
  };

  // end of method

  SearchOptions.prototype.setChaptersDropdown = function setChaptersDropdown(book) {
    var msg = "";
    var show = false;
    var source = {};
    if (this.state.docType === "Biblical") {
      if (this.state.domain === "*") {
        msg = this.props.labels.chapterIs;
        show = true;
        /**
         * If the combination of a domain and book exists, we will use its
         * chapter dropdown.
         *
         * Specifically, we will try to use certain
         * Greek language domains as the
         * basis to set generic chapter dropdowns.
         * For the Old Testament, we will use the UP CCATB LXX
         * Rahlf's version, and if not found, try each of the
         * LXX alternative manuscripts.  If that is not found,
         * we will assume we are searching the New Testament,
         * simply use the chapters for each book of the Patriarchal Greek NT.
         *
         */
        if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccat.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccat.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatb.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatb.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatba.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatba.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatog.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatog.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccats.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccats.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatth.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_eg_lxxupccatth.' + book];
        } else if (this.state.dropdowns.Biblical.topics['gr_gr_ntpt.' + book]) {
          source = this.state.dropdowns.Biblical.topics['gr_gr_ntpt.' + book];
        } else {
          source = this.state.dropdowns.Biblical.all.chapters;
        }
      } else {
        msg = this.props.labels.chapterIs;
        show = true;
        source = this.state.dropdowns.Biblical.topics[this.state.domain + '.' + book];
      }
    } else if (this.state.docType === "Liturgical") {
      if (this.state.dropdowns.loaded) {
        if (this.state.domain === "*") {
          source = this.state.dropdowns.Liturgical.topics["gr_gr_cog." + book];
          show = source !== undefined;
        } else {
          source = this.state.dropdowns.Liturgical.topics[this.state.domain + "." + book];
          show = source !== undefined;
        }
      }
    } // end of if
    this.setState({
      selectedChapter: "*",
      dropdownChapters: {
        show: show,
        msg: msg,
        source: source,
        initialValue: "*"
      }
    });
  }; // end of method

  SearchOptions.prototype.setGenericChaptersDropdown = function setGenericChaptersDropdown(type) {
    var msg = "";
    var show = false;
    var source = {};
    if (type === "Biblical") {
      msg = "Select Chapter...";
      show = true;
      source = this.state.dropdowns.Biblical.all.chapters;
    } // end of if
    this.setState({
      dropdownChapters: {
        show: show,
        msg: msg,
        source: source
      }
    });
  }; // end of method

  SearchOptions.prototype.suggestedQuery = function suggestedQuery(docType) {
    if (docType === "Biblical") {
      return "Enter a word or phrase from the Bible, even Greek...";
    } else if (docType === "Liturgical") {
      return "Enter a word or phrase from the Liturgical texts, even Greek...";
    } else {
      return "Enter a word or phrase from the Liturgical texts or the Bible, even Greek...";
    }
  };

  SearchOptions.prototype.getDropdownChapterTitle = function getDropdownChapterTitle() {
    var msg = "";
    if (this.state.docType === "Biblical") {
      if (this.state.domain === "*") {
        msg = this.props.labels.chapterIs;
      } else {
        msg = this.props.labels.chapterIs;
      }
    } else if (this.state.docType === "Liturgical") {
      switch (this.state.selectedBook) {
        case "da":
          msg = this.props.labels.dayIs;
          break;
        case "eo":
          msg = this.props.labels.weekIs;
          break;
        case "eu":
          msg = this.props.labels.serviceIs;
          break;
        case "he":
          msg = this.props.labels.typeIs;
          break;
        case "hi":
          msg = this.props.labels.sectionIs;
          break;
        case "ho":
          msg = this.props.labels.sectionIs;
          break;
        case "oc":
          msg = this.props.labels.modeIs;
          break;
        case "me":
          msg = this.props.labels.monthIs;
          break;
        case "pe":
          msg = this.props.labels.dayIs;
          break;
        case "tr":
          msg = this.props.labels.dayIs;
          break;
        default:
          msg = this.props.labels.chapterIs;
      }
    } // end of if
    return msg;
  };

  SearchOptions.prototype.getDropdownSectionTitle = function getDropdownSectionTitle() {
    var msg = "";
    if (this.state.docType === "Biblical") {} else if (this.state.docType === "Liturgical") {
      switch (this.state.selectedBook) {
        case "he":
          msg = this.props.labels.modeIs;
          break;
        case "oc":
          msg = this.props.labels.dayIs;
          break;
        case "me":
          msg = this.props.labels.monthIs;
          break;
        default:
          msg = "undefined subsection";
      }
    } // end of if
    return msg;
  };

  SearchOptions.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'container' },
      React.createElement(
        'div',
        null,
        React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            React.createElement(ResourceSelector, {
              title: this.props.labels.findWhereTypeIs,
              initialValue: this.state.docType,
              resources: this.props.docTypes,
              changeHandler: this.handleDocTypeChange,
              multiSelect: false
            })
          )
        ),
        this.state.dropDownDomains.show && React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            React.createElement(ResourceSelector, {
              title: this.props.labels.domainIs,
              initialValue: this.state.domain,
              resources: this.state.dropDownDomains.source,
              changeHandler: this.handleDomainChange,
              multiSelect: false
            })
          )
        ),
        this.state.dropDownBooks.show && React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            React.createElement(ResourceSelector, {
              title: this.props.labels.bookIs,
              initialValue: this.state.selectedBook,
              resources: this.state.dropDownBooks.source,
              changeHandler: this.handleBookChange,
              multiSelect: false
            })
          )
        ),
        this.state.dropdownChapters.show && React.createElement(
          'div',
          { className: 'row' },
          React.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            React.createElement(ResourceSelector, {
              title: this.getDropdownChapterTitle(),
              initialValue: this.state.selectedChapter,
              resources: this.state.dropdownChapters.source,
              changeHandler: this.handleChapterChange,
              multiSelect: false
            })
          )
        ),
        React.createElement(
          'div',
          null,
          React.createElement('p', null)
        )
      ),
      React.createElement(
        'div',
        { className: 'row' },
        React.createElement(
          'div',
          { className: 'col-sm-12' },
          React.createElement(ResourceSelector, {
            title: this.props.labels.propertyIs,
            initialValue: this.state.property,
            resources: this.props.properties,
            changeHandler: this.handlePropertyChange,
            multiSelect: false
          }),
          React.createElement(
            'form',
            { className: "App-Search-Options-Text-Form", onSubmit: this.handleSubmit },
            React.createElement(
              'div',
              { className: 'control-label' },
              this.props.labels.propertyTextIs
            ),
            React.createElement(
              'div',
              { className: "App-Search-Options-Text-Div" },
              React.createElement('input', {
                type: 'text',
                onChange: this.handleValueChange,
                className: 'App-search-text-input',
                name: 'search',
                value: this.state.value
              })
            ),
            React.createElement(ResourceSelector, {
              title: this.props.labels.matcherIs,
              initialValue: this.state.matcher,
              resources: this.props.matchers,
              changeHandler: this.handleMatcherChange,
              multiSelect: false
            }),
            React.createElement(
              'div',
              { className: 'control-label' },
              this.props.labels.clickTheButton
            ),
            React.createElement(
              Button,
              {
                bsStyle: 'primary',
                bsSize: 'xsmall',
                type: 'submit',
                disabled: this.isDisabled(),
                onClick: this.handleSubmit
              },
              React.createElement(FontAwesome, { className: 'Button-Select-FontAwesome', name: "search" }),
              this.props.labels.submit
            )
          )
        )
      )
    );
  };

  return SearchOptions;
}(React.Component);

process.env.NODE_ENV !== "production" ? SearchOptions.propTypes = {
  docType: PropTypes.string.isRequired,
  docTypes: PropTypes.array.isRequired,
  dropDowns: PropTypes.object.isRequired,
  properties: PropTypes.array.isRequired,
  matchers: PropTypes.array.isRequired,
  handleSubmit: PropTypes.func.isRequired,
  labels: PropTypes.object.isRequired
} : void 0;

export default SearchOptions;