function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import FontAwesome from 'react-fontawesome';
import { Button, FormControl, FormGroup, InputGroup } from 'react-bootstrap';

var SearchOptions = function (_React$Component) {
  _inherits(SearchOptions, _React$Component);

  function SearchOptions(props) {
    _classCallCheck(this, SearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.setValue = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.value);
      event.preventDefault();
    };

    _this.state = {
      value: ""
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    return _this;
  }

  SearchOptions.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'container' },
      React.createElement(
        'div',
        { className: 'row' },
        React.createElement(
          'div',
          { className: 'col-12' },
          React.createElement(
            'form',
            { className: "App-Search-Options-Text-Form", onSubmit: this.handleSubmit },
            React.createElement(
              'div',
              { className: 'control-label' },
              this.props.valueTitle
            ),
            React.createElement(
              'div',
              { className: "App-Search-Options-Text-Div" },
              React.createElement(
                FormGroup,
                null,
                React.createElement(
                  InputGroup,
                  null,
                  React.createElement(FormControl, {
                    type: 'text',
                    placeholder: this.props.placeholder,
                    onChange: this.setValue,
                    className: 'App-search-text-input'
                  }),
                  React.createElement(
                    InputGroup.Button,
                    null,
                    React.createElement(
                      Button,
                      {
                        className: 'App-search-button',
                        bsStyle: 'primary',
                        bsSize: 'xsmall',
                        type: 'submit',
                        disabled: !this.state.value,
                        onClick: this.handleSubmit
                      },
                      React.createElement(
                        'span',
                        { className: 'App-text-search-icon' },
                        React.createElement(FontAwesome, { name: "search" })
                      ),
                      this.props.buttonLabel
                    )
                  )
                )
              )
            )
          )
        )
      )
    );
  };

  return SearchOptions;
}(React.Component);

process.env.NODE_ENV !== "production" ? SearchOptions.propTypes = {
  valueTitle: PropTypes.string.isRequired,
  buttonLabel: PropTypes.string.isRequired,
  placeholder: PropTypes.string.isRequired,
  handleSubmit: PropTypes.func.isRequired
} : void 0;

export default SearchOptions;