var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import MessageIcons from '../helpers/MessageIcons';
import server from '../helpers/Server';
import 'react-select/dist/react-select.css';
import 'react-virtualized/styles.css';
import 'react-virtualized-select/styles.css';
import VirtualizedSelect from 'react-virtualized-select';

/**
 * Gets a list of topics from the web service and displays
 * them as a dropdown.  Returns the value the user selects.
 */
var TopicsSelector = (_temp = _class = function (_React$Component) {
  _inherits(TopicsSelector, _React$Component);

  function TopicsSelector(props) {
    _classCallCheck(this, TopicsSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, _this.state);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    _this.handleSelection = _this.handleSelection.bind(_this);
    return _this;
  }

  TopicsSelector.prototype.render = function render() {
    return React.createElement(
      'div',
      { className: 'row' },
      React.createElement(
        'div',
        { className: 'col-sm-12 col-md-12 col-lg-12' },
        this.state.dataFetched && React.createElement(VirtualizedSelect, {
          options: this.state.data,
          onChange: this.handleSelection,
          value: this.state.selectedItem
        })
      )
    );
  };

  return TopicsSelector;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentDidMount = function () {
    _this2.fetchData(_this2.props.library);
  };

  this.componentWillReceiveProps = function (nextProps) {
    var nextLibrary = nextProps.library;
    if (_this2.state.library && _this2.state.library !== nextLibrary) {
      _this2.fetchData(nextLibrary);
    }
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var dataFetched = false;
    var data = undefined;
    var selectedItem = "";
    if (currentState) {
      if (currentState.dataFetched) {
        dataFetched = currentState.dataFetched;
      }
      if (currentState.data) {
        data = currentState.data;
      }
      if (currentState.selectedItem && currentState.selectedItem.length > 0) {
        selectedItem = currentState.selectedItem;
      }
    }
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    return {
      labels: {
        thisClass: labels[labelTopics.TopicsSelector],
        messages: labels[labelTopics.messages]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedItem: selectedItem,
      dataFetched: dataFetched,
      data: data
    };
  };

  this.fetchData = function (library) {
    server.getTopics(_this2.props.session.restServer, _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, _this2.handleFetchCallback);
  };

  this.handleFetchCallback = function (restCallResult) {
    if (restCallResult) {
      _this2.setState({
        dataFetched: true,
        data: restCallResult.data.values[0].items
      });
    }
  };

  this.handleSelection = function (selection) {
    _this2.setState({
      selectedItem: selection["value"]
    });
    _this2.props.callBack(selection["value"]);
  };
}, _temp);


process.env.NODE_ENV !== "production" ? TopicsSelector.propTypes = {
  session: PropTypes.object.isRequired,
  library: PropTypes.string.isRequired,
  callBack: PropTypes.func.isRequired
} : void 0;

TopicsSelector.defaultProps = {};

export default TopicsSelector;