function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Panel, Well } from 'react-bootstrap';
import YouTube from 'react-youtube';

var YoutubeVideoPanel = function (_React$Component) {
  _inherits(YoutubeVideoPanel, _React$Component);

  function YoutubeVideoPanel(props) {
    _classCallCheck(this, YoutubeVideoPanel);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {};

    _this.onReady = function (event) {
      event.target.pauseVideo();
    };

    _this.onReady = _this.onReady.bind(_this);
    return _this;
  }

  YoutubeVideoPanel.prototype.render = function render() {

    return React.createElement(
      'div',
      null,
      React.createElement(
        Panel,
        {
          className: 'App-Youtube-panel',
          header: this.props.title,
          eventKey: this.props.eventKey,
          collapsible: true
        },
        React.createElement(
          Well,
          null,
          React.createElement(
            'p',
            { className: 'App-Youtube-Text' },
            this.props.text
          ),
          React.createElement(YouTube, {
            className: 'App-Youtube-player',
            videoId: this.props.videoId,
            opts: this.props.opts,
            onReady: this.onReady
          }),
          '}'
        )
      )
    );
  };

  return YoutubeVideoPanel;
}(React.Component);

process.env.NODE_ENV !== "production" ? YoutubeVideoPanel.propTypes = {
  videoId: PropTypes.string,
  title: PropTypes.string.isRequired,
  text: PropTypes.string.isRequired,
  eventKey: PropTypes.string.isRequired,
  opts: PropTypes.object
} : void 0;

YoutubeVideoPanel.defaultProps = {
  opts: {
    height: '390',
    width: '640',
    playerVars: { // https://developers.google.com/youtube/player_parameters
      autoplay: 1,
      modestbranding: 1,
      rel: 0
    }
  }
};

export default YoutubeVideoPanel;