var _class, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { get } from 'lodash';
import MessageIcons from './helpers/MessageIcons';
import Server from "../helpers/Server";

/**
 * This is a template for a new component.
 * To use it:
 * 1. Rename all occurrences of NewComponentTemplate to your component name.
 * 2. Replace Labels.getViewReferenceLabels with a call to get your component's labels
 * 3. Add content to the render function, etc...
 *
 * Note that if you use the Server with a callback,
 * you need to:
 *     let requestTokens = this.state._requestTokens;
 *     const requestToken = Server.getCancelToken();
 *     requestTokens.set(requestToken,"live");
 *     ...and pass requestToken via the Server call.
 *     If the component unmounts before the promise
 *     is fulfilled, the componentWillUnmount will
 *     remove it from the Server's list, thus avoiding
 *     the setState on unmounted component error.

 */
// TODO: rename class
var NewComponentTemplate = (_temp = _class = function (_React$Component) {
  _inherits(NewComponentTemplate, _React$Component);

  function NewComponentTemplate(props) {
    _classCallCheck(this, NewComponentTemplate);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, {});

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  // a method called by both the constructor and componentWillReceiveProps


  // TODO: add the content for the render function
  NewComponentTemplate.prototype.render = function render() {
    return React.createElement('div', { className: 'App-New-Component-Template' });
  };

  return NewComponentTemplate;
}(React.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentDidMount = function () {
    _this2.setState({ _isMounted: true });
  };

  this.componentWillUnmount = function () {
    for (var _iterator = _this2.state._requestTokens.keys(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var token = _ref;

      try {
        Server.cancelRequest(token);
      } catch (error) {
        console.log(error);
      }
    }
    _this2.setState({ _isMounted: false });
  };

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state));
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.setTheState = function (props, currentState) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: { // TODO: replace ViewReferences with method for this class
        thisClass: labels[labelTopics.ViewReferences],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: MessageIcons.getMessageIcons(),
      messageIcon: MessageIcons.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      _isMounted: get(currentState, "_isMounted", true),
      _requestTokens: get(currentState, "_requestTokens", new Map())
    }, function () {
      return this.handleStateChange("place holder");
    };
  };
}, _temp);
;

// TODO: rename class and add any additional propTypes you need
// TODO: review the structure of the Session class, which also holds User, UiSchemas, and Dropdowns
process.env.NODE_ENV !== "production" ? NewComponentTemplate.propTypes = {
  session: PropTypes.object.isRequired
} : void 0;

// set default values for props here
// TODO: rename class
NewComponentTemplate.defaultProps = {};

// TODO: rename class for export
export default NewComponentTemplate;