'use strict';

exports.__esModule = true;
exports.ActivityLister = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActivityLister = exports.ActivityLister = (_temp = _class = function (_React$Component) {
  _inherits(ActivityLister, _React$Component);

  function ActivityLister(props) {
    _classCallCheck(this, ActivityLister);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.fetchData = _this.fetchData.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.getTableGeneric = _this.getTableGeneric.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  ActivityLister.prototype.getSearchForm = function getSearchForm() {
    return _react2.default.createElement(
      'div',
      null,
      'Search Form goes here'
    );
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  ActivityLister.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ActivityLister.prototype.fetchData = function fetchData() {
    this.setState({
      message: this.state.labels.search.msg2,
      messageIcon: this.messageIcons.info,
      showSearchResults: false
    });

    var parms = "f=" + encodeURIComponent(this.state.selectedFromDate) + "&t=" + encodeURIComponent(this.state.selectedToDate);

    _Server2.default.getActivities(this.props.session.restServer, this.props.session.userInfo.username, this.props.session.userInfo.password, parms, this.handleSearchCallback);
  };

  ActivityLister.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-page App-search' },
      this.state.showSearchResults && this.state.data && _react2.default.createElement(
        'div',
        { className: 'App-search-results' },
        _react2.default.createElement(
          _reactBootstrap.Panel,
          {
            className: 'App-Grammar-Site-panel',
            header: this.state.title + (0, _moment2.default)().utc().format("YYYY-MM-DDTHH:mm:ss.SSS") + "Z",
            collapsible: true
          },
          _react2.default.createElement(
            'div',
            { className: 'row' },
            this.getTableGeneric()
          )
        )
      )
    );
  };

  return ActivityLister;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {
    if (_this2.props.session && _this2.props.session.userInfo && _this2.props.session.userInfo.domains && _this2.props.session.userInfo.domains.isSuperAdmin) {
      _this2.fetchData();
    }
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state.docType), _this2.fetchData);
  };

  this.setTheState = function (props, docType) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.SearchGeneric];

    return {
      labels: {
        resultsTableLabels: labels[labelTopics.resultsTable],
        search: theSearchLabels
      },
      message: theSearchLabels.msg1,
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      resultCount: 0,
      data: (0, _lodash.get)(_this2.state, "data", { values: [{ "who": "", "when:": "", "what:": "" }] }),
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      filter: { type: 'RegexFilter', delay: 100 },
      showSelectionButtons: false,
      selectedId: (0, _lodash.get)(_this2.state, "selectedId", ""),
      selectedFromDate: (0, _moment2.default)().utc().subtract(7, "days").format('YYYY-MM-DD'),
      selectedToDate: (0, _moment2.default)().utc().add(1, "days").format('YYYY-MM-DD'),
      showModalEditor: false,
      idColumnSize: "80px",
      title: "Activity for the last 7 days as of ",
      lastSearchTime: "",
      searchCount: ""
    };
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.handleSearchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      _this2.setState({
        data: restCallResult.data.values
      });
      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (restCallResult.data.valueCount) {
        resultCount = restCallResult.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }
  };

  this.getTableGeneric = function () {
    return _react2.default.createElement(
      _reactBootstrapTable.BootstrapTable,
      {
        ref: 'theTable',
        data: _this2.state.data,
        exportCSV: false,
        trClassName: "App-data-tr",
        striped: true,
        hover: true,
        pagination: true,
        options: _this2.state.options
      },
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'who',
          dataSort: true,
          width: "15%",
          filter: _this2.state.filter
        },
        'ID'
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'when',
          dataSort: true,
          width: "25%",
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerDomain
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          isKey: true,
          dataField: 'what',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.resultsTableLabels.headerTopic
      )
    );
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ActivityLister.propTypes = {
  session: _propTypes2.default.object.isRequired
} : void 0;

ActivityLister.defaultProps = {};

exports.default = ActivityLister;