'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _Auth = require('./helpers/Auth');

var _Auth2 = _interopRequireDefault(_Auth);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ChangePassword = function (_React$Component) {
  _inherits(ChangePassword, _React$Component);

  function ChangePassword(props) {
    _classCallCheck(this, ChangePassword);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: {
          thisClass: nextProps.session.labels[nextProps.session.labelTopics.ChangePasswordPage]
        },
        message: nextProps.session.labels[nextProps.session.labelTopics.messages].initial
      });
    };

    _this.onSubmit = function (_ref) {
      var formData = _ref.formData;

      if (formData.password === formData.passwordReenter) {
        var config = {
          auth: {
            username: formData.username,
            password: formData.currentPassword
          }
        };
        var path = "users/password/" + formData.username;
        _axios2.default.put(_this.props.session.restServer + _Server2.default.getWsServerAdminApi() + path, formData, config).then(function (response) {
          _Auth2.default.setCredentials(formData.username, formData.password, true);
          _this.props.callback(response.status, true, formData.username, formData.password, response.data // domain, email, firstname, lastname, title
          );
          _this.setState({
            formData: formData,
            message: _this.state.labels.thisClass.changed,
            messageIcon: _MessageIcons2.default.getMessageIcons().info
          });
        }).catch(function (error) {
          _this.setState({ msg: error.message });
          _this.props.callback(error.message, false, formData.username, formData.password, undefined);
        });
      } else {
        _this.setState({
          formData: formData,
          message: _this.state.labels.thisClass.doNotMatch,
          messageIcon: _MessageIcons2.default.getMessageIcons().error
        });
      }
    };

    _this.state = {
      path: "",
      username: "",
      password: "",
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ChangePasswordPage]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: props.session.labels[props.session.labelTopics.messages].initial
    };
    return _this;
  }

  ChangePassword.prototype.fetchLoginForm = function fetchLoginForm() {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    _axios2.default.get(this.props.session.restServer + _Server2.default.getWsServerPasswordChangeApi(), config).then(function (response) {
      if (response.data && response.data.valueSchemas) {
        var schemaInfo = response.data.valueSchemas["UserPasswordSelfChangeForm:1.1"];
        _this2.setState({
          data: response.data,
          schema: schemaInfo.schema,
          uiSchema: schemaInfo.uiSchema,
          formData: response.data.values[0].value,
          path: _this2.props.path
        });
      }
    }).catch(function (error) {
      _this2.setState({ data: error.message, path: _this2.props.path });
      _this2.props.callback(error.message, false, _this2.state.formData.username, _this2.state.formData.password);
    });
  };

  ChangePassword.prototype.render = function render() {
    if (this.state.path !== this.props.path) {
      this.fetchLoginForm();
    }
    if (this.state.data) {
      if (this.state.schema) {
        return _react2.default.createElement(
          'div',
          { className: 'App-login' },
          _react2.default.createElement(_reactJsonschemaForm2.default, { schema: this.state.schema,
            uiSchema: this.state.uiSchema,
            formData: this.state.formData,
            onSubmit: this.onSubmit
          }),
          _react2.default.createElement(
            'p',
            { className: 'App-login-msg' },
            _react2.default.createElement(_reactFontawesome2.default, { name: this.state.messageIcon }),
            ' ',
            this.state.message
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: 'App-login' },
          _react2.default.createElement(
            'p',
            null,
            this.props.path
          ),
          _react2.default.createElement(
            'pre',
            null,
            JSON.stringify(this.state.data, null, 2)
          )
        );
      }
    } else {
      return _react2.default.createElement(
        'div',
        { className: 'Resource' },
        _react2.default.createElement(
          'p',
          null,
          'Loading ',
          this.props.path,
          ' from ',
          this.root,
          '!'
        )
      );
    }
  };

  return ChangePassword;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? ChangePassword.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func.isRequired,
  formPrompt: _propTypes2.default.string.isRequired,
  formMsg: _propTypes2.default.string.isRequired
} : void 0;
ChangePassword.defaultProps = {};

exports.default = ChangePassword;
module.exports = exports['default'];