'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _reactBootstrap = require('react-bootstrap');

var _VersionNumbers = require('./helpers/VersionNumbers');

var _VersionNumbers2 = _interopRequireDefault(_VersionNumbers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Provides information about the running version.
 */
var Configuration = function (_React$Component) {
  _inherits(Configuration, _React$Component);

  function Configuration(props) {
    _classCallCheck(this, Configuration);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {
      _this.fetchData();
    };

    _this.state = {
      dataLoaded: false,
      dbServer: "",
      dbReadOnly: "",
      wsVersion: "",
      synchEnabled: false,
      synchDbConnectionOk: false
    };
    return _this;
  }

  Configuration.prototype.fetchData = function fetchData() {
    var _this2 = this;

    _axios2.default.get(this.props.restServer + _Server2.default.getWsServerVersionApi()).then(function (response) {
      _this2.setState({
        dataLoaded: true,
        dbServerDomain: response.data.dbServerDomain,
        dbReadOnly: response.data.dbReadOnly,
        wsVersion: response.data.wsVersion,
        synchEnabled: response.data.synchEnabled,
        synchDbConnectionOk: response.data.synchDbConnectionOk
      });
    }).catch(function (error) {
      _this2.setState({ data: error.message });
    });
  };

  Configuration.prototype.render = function render() {
    if (this.state.dataLoaded) {
      return _react2.default.createElement(
        'div',
        { className: 'App-DomainSelector' },
        _react2.default.createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'info' },
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.appVersion,
            ' ',
            this.props.appVersion,
            '.'
          ),
          _react2.default.createElement(
            'p',
            null,
            'ioc-liturgical-react ',
            _VersionNumbers2.default.getPackageNumber(),
            '.'
          ),
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.DbServer,
            ' ',
            this.state.dbServerDomain
          ),
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.RestServer,
            ' ',
            this.props.restServer
          ),
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.wsVersion,
            ' ',
            this.state.wsVersion
          ),
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.synchEnabled,
            ' ',
            this.state.synchEnabled
          ),
          _react2.default.createElement(
            'p',
            null,
            this.props.session.labels.pageAbout.synchDbConnectionOk,
            ' ',
            this.state.synchDbConnectionOkLabel
          )
        )
      );
    } else {
      return _react2.default.createElement(
        'div',
        { className: 'Resource' },
        _react2.default.createElement(
          'p',
          null,
          'Loading information...'
        )
      );
    }
  };

  return Configuration;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? Configuration.propTypes = {
  session: _propTypes2.default.object.isRequired,
  appVersion: _propTypes2.default.string.isRequired,
  restServer: _propTypes2.default.string.isRequired
} : void 0;

Configuration.defaultProps = {};

exports.default = Configuration;
module.exports = exports['default'];