'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ModalCountrySelector = require('./modules/ModalCountrySelector');

var _ModalCountrySelector2 = _interopRequireDefault(_ModalCountrySelector);

var _ModalLanguageSelector = require('./modules/ModalLanguageSelector');

var _ModalLanguageSelector2 = _interopRequireDefault(_ModalLanguageSelector);

var _index = require('axios/index');

var _index2 = _interopRequireDefault(_index);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DomainBuilder = (_temp = _class = function (_React$Component) {
  _inherits(DomainBuilder, _React$Component);

  function DomainBuilder(props) {
    _classCallCheck(this, DomainBuilder);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, {});

    _this.createRealmName = _this.createRealmName.bind(_this);
    _this.enableModalCountrySelector = _this.enableModalCountrySelector.bind(_this);
    _this.enableModalLanguageSelector = _this.enableModalLanguageSelector.bind(_this);
    _this.getCountryRow = _this.getCountryRow.bind(_this);
    _this.getFullDescriptionRow = _this.getFullDescriptionRow.bind(_this);
    _this.getLanguageRow = _this.getLanguageRow.bind(_this);
    _this.getModalCountrySelector = _this.getModalCountrySelector.bind(_this);
    _this.getModalLanguageSelector = _this.getModalLanguageSelector.bind(_this);
    _this.getRealmRow = _this.getRealmRow.bind(_this);
    _this.getSubmitRow = _this.getSubmitRow.bind(_this);
    _this.handleDescriptionChange = _this.handleDescriptionChange.bind(_this);
    _this.handleModalCountryClose = _this.handleModalCountryClose.bind(_this);
    _this.handleModalCountrySelection = _this.handleModalCountrySelection.bind(_this);
    _this.handleModalLanguageClose = _this.handleModalLanguageClose.bind(_this);
    _this.handleModalLanguageSelection = _this.handleModalLanguageSelection.bind(_this);
    _this.handleRealmChange = _this.handleRealmChange.bind(_this);
    _this.handleRealmNameChange = _this.handleRealmNameChange.bind(_this);
    _this.handleRealmTypeAcronymnChange = _this.handleRealmTypeAcronymnChange.bind(_this);
    _this.handleRealmTypeLastWordChange = _this.handleRealmTypeLastWordChange.bind(_this);
    _this.handleRealmTypeOtherChange = _this.handleRealmTypeOtherChange.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.setDomain = _this.setDomain.bind(_this);
    _this.createRealmDescription = _this.createRealmDescription.bind(_this);
    _this.postDomain = _this.postDomain.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  // a method called by both the constructor and componentWillReceiveProps


  DomainBuilder.prototype.handleRealmChange = function handleRealmChange(e) {
    var realm = e.target.value;
    var editMsg = "";
    if (realm.includes(" ") || realm.length > 19) {
      editMsg = this.state.labels.thisClass.nameEdit;
    }
    this.setState({ newRealm: realm, newRealmEditMsg: editMsg }, this.setDomain);
  };

  DomainBuilder.prototype.postDomain = function postDomain() {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    var row = this.state.data[this.state.updateIndex];
    var id = row.domain;
    var path = "misc/domains/" + this.state.newDomain;
    var message = "";
    _index2.default.post(this.props.session.restServer + _Server2.default.getWsServerAdminApi() + path, this.state.data[this.state.updateIndex], config).then(function (response) {
      message = "updated " + path;
      _this2.setState({
        message: message
      });
      _this2.setState({ centerDivVisible: true });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _MessageIcons2.default.getMessageIcons().error;
      _this2.setState({ message: message, messageIcon: messageIcon });
    });
  };

  DomainBuilder.prototype.handleRealmNameChange = function handleRealmNameChange(e) {
    var name = e.target.value;
    var desc = this.state.newRealmDesc;
    var realm = this.state.newRealm;
    if (name.length === 0) {
      realm = "";
    }
    if (this.state.newRealmType !== 'o') {
      desc = this.state.initialDesc + name;
      if (this.state.selectedLanguageName) {
        desc = this.state.selectedLanguageName + " " + desc;
      }
    }
    this.setState({ newRealm: realm, newRealmName: name, newRealmDesc: desc }, this.createRealmName);
  };

  DomainBuilder.prototype.handleRealmTypeAcronymnChange = function handleRealmTypeAcronymnChange(e) {
    this.setState({ newRealmType: 'a', newRealmEditMsg: "" }, this.createRealmName);
  };

  DomainBuilder.prototype.handleRealmTypeLastWordChange = function handleRealmTypeLastWordChange(e) {
    this.setState({ newRealmType: 'w', newRealmEditMsg: "" }, this.createRealmName);
  };

  DomainBuilder.prototype.handleRealmTypeOtherChange = function handleRealmTypeOtherChange(e) {
    this.setState({ newRealmType: 'o' }, this.createRealmName);
  };

  DomainBuilder.prototype.handleDescriptionChange = function handleDescriptionChange(e) {
    this.setState({ newRealmDesc: e.target.value }, this.setDomain);
  };

  DomainBuilder.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App App-Domain-Builder' },
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.thisClass.toCreate
        ),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.thisClass.domainDesc
        ),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.thisClass.howTo
        ),
        this.getModalCountrySelector(),
        this.getModalLanguageSelector(),
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(
            _reactBootstrap.Well,
            { className: 'App-Domain-Builder-Well' },
            this.getLanguageRow()
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            { className: 'App-Domain-Builder-Well' },
            this.getCountryRow()
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            { className: 'App-Domain-Builder-Well' },
            this.getRealmRow()
          ),
          this.getSubmitRow()
        )
      )
    );
  };

  return DomainBuilder;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this3.setState(_this3.setTheState(nextProps, _this3.state));
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.setTheState = function (props, currentState) {

    var initialDesc = "Translations by ";

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: {
        thisClass: labels[labelTopics.DomainBuilder],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedLanguageCode: (0, _lodash.get)(currentState, "selectedLanguageCode", ""),
      selectedLanguageName: (0, _lodash.get)(currentState, "selectedLanguageName", ""),
      selectedCountryCode: (0, _lodash.get)(currentState, "selectedCountryCode", ""),
      selectedCountryValue: (0, _lodash.get)(currentState, "selectedCountryValue", ""),
      newRealm: (0, _lodash.get)(currentState, "newRealm", ""),
      newRealmName: (0, _lodash.get)(currentState, "newRealmName", ""),
      newRealmType: (0, _lodash.get)(currentState, "newRealmType", 'a'),
      newRealmDesc: (0, _lodash.get)(currentState, "newRealmDesc", initialDesc),
      newDomain: (0, _lodash.get)(currentState, "newDomain", ""),
      showModalCountrySelector: (0, _lodash.get)(currentState, "showModalCountrySelector", false),
      initialDesc: initialDesc
    };
  };

  this.setDomain = function () {
    if (_this3.state.selectedLanguageCode && _this3.state.selectedCountryCode && _this3.state.newRealm && _this3.state.newRealmDesc && _this3.state.newRealmDesc !== _this3.state.initialDesc) {
      _this3.setState({
        newDomain: _this3.state.selectedLanguageCode + "_" + _this3.state.selectedCountryCode.toLowerCase() + "_" + _this3.state.newRealm
      }, _this3.createRealmDescription);
    } else {
      _this3.createRealmDescription();
    }
  };

  this.createRealmName = function () {
    var name = _this3.state.newRealmName;
    switch (_this3.state.newRealmType) {
      case "a":
        {
          try {
            var matches = name.match(/\b(\w)/g);
            name = matches.join('').toLowerCase();
          } catch (err) {
            name = _this3.state.newRealm;
          }
          break;
        }
      case "w":
        {
          try {
            var matches = name.split(" ");
            name = matches[matches.length - 1].toLowerCase();
          } catch (err) {
            name = _this3.state.newRealm;
          }
          break;
        }
      default:
        {
          name = _this3.state.newRealm;
        }
    }
    _this3.setState({ newRealm: name }, _this3.setDomain);
  };

  this.createRealmDescription = function () {
    var desc = _this3.state.newRealmDesc;
    if (_this3.state.newRealmType !== 'o') {
      desc = _this3.state.initialDesc + name;
      if (_this3.state.selectedLanguageName) {
        desc = _this3.state.selectedLanguageName + " " + desc;
      }
      if (_this3.state.newRealmName) {
        desc = desc + _this3.state.newRealmName;
      }
    }
    _this3.setState({ newRealmDesc: desc });
  };

  this.handleModalCountrySelection = function (code, value) {
    _this3.setState({ selectedCountryCode: code, selectedCountryName: value }, _this3.setDomain);
  };

  this.handleModalLanguageSelection = function (code, value, countryCode, countryValue) {
    _this3.setState({
      selectedLanguageCode: code,
      selectedLanguageName: value,
      selectedCountryCode: countryCode,
      selectedCountryValue: countryValue
    }, _this3.setDomain);
  };

  this.handleModalLanguageClose = function () {
    _this3.setState({ showModalLanguageSelector: false });
  };

  this.handleModalCountryClose = function () {
    _this3.setState({ showModalCountrySelector: false });
  };

  this.handleModalLanguageClose = function () {
    _this3.setState({ showModalLanguageSelector: false });
  };

  this.getModalCountrySelector = function () {
    if (_this3.state.showModalCountrySelector) {
      return _react2.default.createElement(
        'div',
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(_ModalCountrySelector2.default, {
          session: _this3.props.session,
          handleSubmit: _this3.handleModalCountrySelection,
          onClose: _this3.handleModalCountryClose
        })
      );
    }
  };

  this.getModalLanguageSelector = function () {
    if (_this3.state.showModalLanguageSelector) {
      return _react2.default.createElement(
        'div',
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(_ModalLanguageSelector2.default, {
          session: _this3.props.session,
          handleSubmit: _this3.handleModalLanguageSelection,
          onClose: _this3.handleModalLanguageClose
        })
      );
    }
  };

  this.enableModalCountrySelector = function () {
    _this3.setState({ showModalCountrySelector: true });
  };

  this.enableModalLanguageSelector = function () {
    _this3.setState({ showModalLanguageSelector: true });
  };

  this.getCountryRow = function () {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Row-Country-Select' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.countryCode,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 2, md: 2 },
          _this3.state.selectedCountryCode
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _this3.state.selectedCountryValue
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 2, md: 2 },
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              className: 'App-Button-Select',
              onClick: _this3.enableModalCountrySelector
            },
            _this3.state.labels.buttons.select
          )
        )
      )
    );
  };

  this.getLanguageRow = function () {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Row-Language-Select' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.languageCode,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 2, md: 2 },
          _this3.state.selectedLanguageCode
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _this3.state.selectedLanguageName
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 2, md: 2 },
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              className: 'App-Button-Select',
              onClick: _this3.enableModalLanguageSelector
            },
            _this3.state.labels.buttons.select
          )
        )
      )
    );
  };

  this.getRealmRow = function () {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.realmName,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 8, md: 8 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: _this3.state.newRealmName,
            placeholder: 'Enter text',
            onChange: _this3.handleRealmNameChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.realmType,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 8, md: 8 },
          _react2.default.createElement(
            _reactBootstrap.FormGroup,
            { controlId: "radioGroupRealmType" },
            _react2.default.createElement(
              _reactBootstrap.Radio,
              {
                name: 'radioGroup',
                inline: true,
                checked: _this3.state.newRealmType === 'a',
                onChange: _this3.handleRealmTypeAcronymnChange },
              _this3.state.labels.thisClass.acronymn
            ),
            ' ',
            _react2.default.createElement(
              _reactBootstrap.Radio,
              {
                name: 'radioGroup',
                inline: true,
                checked: _this3.state.newRealmType === 'w',
                onChange: _this3.handleRealmTypeLastWordChange },
              _this3.state.labels.thisClass.lastWord
            ),
            ' ',
            _react2.default.createElement(
              _reactBootstrap.Radio,
              {
                name: 'radioGroup',
                inline: true,
                checked: _this3.state.newRealmType === 'o',
                onChange: _this3.handleRealmTypeOtherChange },
              _this3.state.labels.thisClass.other
            )
          )
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.realmAcronymn,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 8, md: 8 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            readOnly: _this3.state.newRealmType !== 'o',
            value: _this3.state.newRealm,
            placeholder: 'Enter text',
            onChange: _this3.handleRealmChange
          })
        )
      ),
      _this3.state.newRealmEditMsg && _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 12, md: 12 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            { className: 'editMessage' },
            _this3.state.newRealmEditMsg
          )
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.realmDescription,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 8, md: 8 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            componentClass: 'textarea',
            value: _this3.state.newRealmDesc,
            readOnly: _this3.state.newRealmType !== 'o',
            placeholder: 'Enter text',
            onChange: _this3.handleDescriptionChange
          })
        )
      )
    );
  };

  this.getFullDescriptionRow = function () {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 12, md: 12 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.translations,
            ' ',
            _this3.state.newRealmDesc,
            ' ',
            _this3.state.labels.thisClass.inLanguage,
            ' ',
            _this3.state.selectedLanguageName,
            '  ',
            _this3.state.labels.thisClass.spokenIn,
            '  ',
            _this3.state.selectedCountryValue,
            ' '
          )
        )
      )
    );
  };

  this.getSubmitRow = function () {
    if (_this3.state.newDomain && _this3.state.newRealmName && _this3.state.selectedLanguageCode) {
      return _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Domain-Builder' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              type: 'submit',
              bsStyle: 'primary'
            },
            _this3.state.labels.messages.submit
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.domain,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 2, md: 2 },
          _this3.state.newDomain
        ),
        _react2.default.createElement(_reactBootstrap.Col, { xs: 4, md: 4 })
      );
    }
  };
}, _temp);
;

process.env.NODE_ENV !== "production" ? DomainBuilder.propTypes = {
  session: _propTypes2.default.object.isRequired
} : void 0;

// set default values for props here
DomainBuilder.defaultProps = {};

exports.default = DomainBuilder;
module.exports = exports['default'];