'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _lodash = require('lodash');

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormattedTextNote = function (_React$Component) {
  _inherits(FormattedTextNote, _React$Component);

  function FormattedTextNote(props) {
    _classCallCheck(this, FormattedTextNote);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentDidMount = function () {
      // make any initial function calls here...
    };

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState(function (prevState, props) {
        return {
          labels: {
            thisClass: nextProps.session.labels[nextProps.session.labelTopics.FormattedTextNote],
            buttons: nextProps.session.labels[nextProps.session.labelTopics.button],
            messages: nextProps.session.labels[nextProps.session.labelTopics.messages],
            resultsTableLabels: nextProps.session.labels[nextProps.session.labelTopics.resultsTable]
          },
          message: nextProps.session.labels[nextProps.session.labelTopics.messages].initial,
          somethingWeTrackIfChanged: (0, _lodash.get)(_this.state, "somethingWeTrackIfChanged", "")
        };
      }, function () {
        return this.handleStateChange("place holder");
      });
    };

    _this.handleStateChange = function (parm) {
      // call a function if needed
    };

    _this.getFormattedDiv = function () {
      if (_this.props.type === "REF_TO_BIBLE" || _this.props.type === "CHECK_YOUR_BIBLE") {
        return _react2.default.createElement(
          'div',
          { className: 'App App-Text-Note-formatted' },
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Scope' },
            _this.props.scopeLiturgical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Lemma' },
            _this.props.lemmaLiturgical
          ),
          _react2.default.createElement(_reactBootstrap.Glyphicon, { className: 'App App-Text-Note-Header-Scope-Glyph', glyph: "arrow-right" }),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Scope-Biblical' },
            _this.props.scopeBiblical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Lemma' },
            _this.props.lemmaBiblical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Title' },
            _this.props.title
          ),
          _react2.default.createElement('span', { className: 'App App-Text-Note-Header-Note', dangerouslySetInnerHTML: _this.createMarkup() })
        );
      } else if (_this.props.type && _this.props.type.startsWith("REF_TO")) {
        return _react2.default.createElement(
          'div',
          { className: 'App App-Text-Note-formatted' },
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Scope' },
            _this.props.scopeLiturgical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Lemma' },
            _this.props.lemmaLiturgical
          ),
          _react2.default.createElement(_reactBootstrap.Glyphicon, { className: 'App App-Text-Note-Header-Scope-Glyph', glyph: "arrow-right" }),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Title' },
            _this.props.title
          ),
          _react2.default.createElement('span', { className: 'App App-Text-Note-Header-Note', dangerouslySetInnerHTML: _this.createMarkup() })
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: 'App App-Text-Note-formatted' },
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Scope' },
            _this.props.scopeLiturgical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Lemma' },
            _this.props.lemmaLiturgical
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-Text-Note-Header-Title' },
            _this.props.title
          ),
          _react2.default.createElement('span', { className: 'App App-Text-Note-Header-Note', dangerouslySetInnerHTML: _this.createMarkup() })
        );
      }
    };

    var languageCode = props.session.languageCode;
    _this.state = {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.FormattedTextNote],
        buttons: props.session.labels[props.session.labelTopics.button],
        messages: props.session.labels[props.session.labelTopics.messages],
        resultsTableLabels: props.session.labels[props.session.labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: props.session.labels[props.session.labelTopics.messages].initial
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.getFormattedDiv = _this.getFormattedDiv.bind(_this);
    _this.createMarkup = _this.createMarkup.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  FormattedTextNote.prototype.createMarkup = function createMarkup() {
    return { __html: this.props.note };
  };

  // TODO: add the content for the render function
  FormattedTextNote.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App App-Formatted-Text-Note' },
      this.getFormattedDiv()
    );
  };

  return FormattedTextNote;
}(_react2.default.Component);

;

process.env.NODE_ENV !== "production" ? FormattedTextNote.propTypes = {
  session: _propTypes2.default.object.isRequired,
  note: _propTypes2.default.string.isRequired,
  type: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string.isRequired,
  scopeLiturgical: _propTypes2.default.string.isRequired,
  lemmaLiturgical: _propTypes2.default.string.isRequired,
  scopeBiblical: _propTypes2.default.string,
  lemmaBiblical: _propTypes2.default.string
} : void 0;

// set default values for props here
FormattedTextNote.defaultProps = {
  languageCode: "en"
};

exports.default = FormattedTextNote;
module.exports = exports['default'];