'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _DocIds = require('./modules/docs/DocIds');

var _DocIds2 = _interopRequireDefault(_DocIds);

var _DocProps = require('./modules/docs/DocProps');

var _DocProps2 = _interopRequireDefault(_DocProps);

var _DocComparison = require('./modules/docs/DocComparison');

var _DocComparison2 = _interopRequireDefault(_DocComparison);

var _DocSearchTypes = require('./modules/docs/DocSearchTypes');

var _DocSearchTypes2 = _interopRequireDefault(_DocSearchTypes);

var _DocSimpleSearch = require('./modules/docs/DocSimpleSearch');

var _DocSimpleSearch2 = _interopRequireDefault(_DocSimpleSearch);

var _DocSearchResults = require('./modules/docs/DocSearchResults');

var _DocSearchResults2 = _interopRequireDefault(_DocSearchResults);

var _DocSearchAdvanced = require('./modules/docs/DocSearchAdvanced');

var _DocSearchAdvanced2 = _interopRequireDefault(_DocSearchAdvanced);

var _DocSearchRegularExpressions = require('./modules/docs/DocSearchRegularExpressions');

var _DocSearchRegularExpressions2 = _interopRequireDefault(_DocSearchRegularExpressions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HelpSearch = function (_React$Component) {
  _inherits(HelpSearch, _React$Component);

  function HelpSearch(props) {
    _classCallCheck(this, HelpSearch);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: nextProps.session.labels[nextProps.session.labelTopics.help]
      });
    };

    _this.state = {
      labels: props.session.labels[props.session.labelTopics.help]
    };
    return _this;
  }

  HelpSearch.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-page App-help' },
      _react2.default.createElement(
        'h2',
        null,
        this.state.labels.searchPageTitle
      ),
      _react2.default.createElement(
        'div',
        { className: 'jumbotron' },
        _react2.default.createElement(
          'p',
          null,
          this.state.labels.searchPara01
        ),
        _react2.default.createElement(
          'p',
          null,
          this.state.labels.searchPara02
        ),
        _react2.default.createElement(
          'p',
          null,
          this.state.labels.searchPara03
        ),
        _react2.default.createElement(
          _reactBootstrap.Accordion,
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecDocIds, eventKey: '1' },
            _react2.default.createElement(_DocIds2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecDocProps, eventKey: '2' },
            _react2.default.createElement(_DocProps2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecDocSearchTypes, eventKey: '3' },
            _react2.default.createElement(_DocSearchTypes2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecSimpleSearch, eventKey: '4' },
            _react2.default.createElement(_DocSimpleSearch2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecSearchResults, eventKey: '6' },
            _react2.default.createElement(_DocSearchResults2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecDocVersionComparisonTitle, eventKey: '5' },
            _react2.default.createElement(_DocComparison2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecAdvancedSearch, eventKey: '7' },
            _react2.default.createElement(_DocSearchAdvanced2.default, { session: this.props.session })
          ),
          _react2.default.createElement(
            _reactBootstrap.Panel,
            { header: this.state.labels.searchSecDocRegExSearch, eventKey: '8' },
            _react2.default.createElement(_DocSearchRegularExpressions2.default, { session: this.props.session })
          )
        )
      )
    );
  };

  return HelpSearch;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? HelpSearch.propTypes = {
  session: _propTypes2.default.object.isRequired
} : void 0;

HelpSearch.defaultProps = {};

exports.default = HelpSearch;
module.exports = exports['default'];