'use strict';

exports.__esModule = true;
exports.LanguageLister = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LanguageLister = exports.LanguageLister = (_temp = _class = function (_React$Component) {
  _inherits(LanguageLister, _React$Component);

  function LanguageLister(props) {
    _classCallCheck(this, LanguageLister);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.getTableGeneric = _this.getTableGeneric.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  LanguageLister.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  LanguageLister.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-Language-Lister' },
      _react2.default.createElement(
        _reactBootstrap.ControlLabel,
        null,
        this.state.labels.thisClass.copyright
      ),
      this.getTableGeneric()
    );
  };

  return LanguageLister;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state.docType), _this2.fetchData);
  };

  this.setTheState = function (props, docType) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.SearchGeneric];

    return {
      labels: {
        thisClass: labels[labelTopics.LanguageLister],
        resultsTableLabels: labels[labelTopics.resultsTable],
        search: theSearchLabels
      },
      message: theSearchLabels.msg1,
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      resultCount: 0,
      data: (0, _lodash.get)(_this2.state, "data", { values: [{ "who": "", "when:": "", "what:": "" }] }),
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      filter: { type: 'RegexFilter', delay: 100 },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      showSelectionButtons: false,
      selectedCode: (0, _lodash.get)(_this2.state, "selectedCode", ""),
      selectedValue: (0, _lodash.get)(_this2.state, "selectedValue", ""),
      selectedCountryCode: (0, _lodash.get)(_this2.state, "selectedCountryCode", ""),
      selectedCountryValue: (0, _lodash.get)(_this2.state, "selectedCountryValue", ""),
      showModalEditor: false,
      idColumnSize: "80px"
    };
  };

  this.handleRowSelect = function (row, isSelected, e) {
    var langThree = row["languageCode"];
    var langTwo = row["languageCodeTwo"];
    var langCode = langThree;
    if (langTwo.length === 2) {
      langCode = langTwo;
    }
    var langName = row["languageName"];
    var langNameLocal = row["languageNameLocal"];
    if (langName !== langNameLocal) {
      langName = langNameLocal + " (" + langName + ")";
    }
    var countryName = row["countryName"];
    var countryNameLocal = row["countryNameLocal"];
    if (countryName !== countryNameLocal) {
      countryName = countryNameLocal + " (" + countryName + ")";
    }
    _this2.setState({
      selectedCode: langCode,
      selectedValue: langName,
      selectedCountryCode: row["countryCode"],
      selectedCountryValue: countryName
    }, _this2.handleCallback);
  };

  this.handleCallback = function () {
    if (_this2.props.callBack) {
      _this2.props.callBack(_this2.state.selectedCode, _this2.state.selectedValue, _this2.state.selectedCountryCode, _this2.state.selectedCountryValue);
    }
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.getTableGeneric = function () {
    return _react2.default.createElement(
      _reactBootstrapTable.BootstrapTable,
      {
        ref: 'theTable',
        data: _this2.props.session.dropdowns.isoLanguages,
        exportCSV: false,
        trClassName: "App-data-tr",
        striped: true,
        hover: true,
        pagination: true,
        options: _this2.state.options,
        selectRow: _this2.state.selectRow
      },
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          isKey: true,
          dataField: 'id',
          dataSort: true,
          'export': true,
          hidden: true
        },
        'ID'
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'languageNameLocal',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.nameLocal
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'languageName',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.nameEnglish
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'languageCodeTwo',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.codeTwo
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'languageCode',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.codeThree
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'area',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.area
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'countryCode',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.countryCode
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'countryName',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.countryName
      ),
      _react2.default.createElement(
        _reactBootstrapTable.TableHeaderColumn,
        {
          dataField: 'countryNameLocal',
          dataSort: true,
          filter: _this2.state.filter
        },
        _this2.state.labels.thisClass.countryNameLocal
      )
    );
  };
}, _temp);


process.env.NODE_ENV !== "production" ? LanguageLister.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callBack: _propTypes2.default.func
} : void 0;

LanguageLister.defaultProps = {};

exports.default = LanguageLister;