'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapDatePicker = require('react-bootstrap-date-picker');

var _reactBootstrapDatePicker2 = _interopRequireDefault(_reactBootstrapDatePicker);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _ResponseParser = require('./helpers/ResponseParser');

var _ResponseParser2 = _interopRequireDefault(_ResponseParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LiturgicalDayProperties = function (_React$Component) {
  _inherits(LiturgicalDayProperties, _React$Component);

  function LiturgicalDayProperties(props) {
    _classCallCheck(this, LiturgicalDayProperties);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState({
        labels: nextProps.session.labels[nextProps.session.labelTopics.ldp]
      });
    };

    _this.componentWillMount = function () {
      var value = new Date().toISOString();
      _this.setState({
        value: value // ISO String, ex: "2016-11-19T12:00:00.000Z"
      });
    };

    _this.handleChange = function (value, formattedValue) {
      _this.setState({
        value: value, // ISO String, ex: "2016-11-19T12:00:00.000Z"
        formattedValue: formattedValue // Formatted String, ex: "11/19/2016"
      }, _this.fetchData(value));
    };

    _this.onSelect = function (index) {
      _this.setState({
        selectedType: index
      });
    };

    _this.state = {
      selectedType: "g",
      labels: props.session.labels[props.session.labelTopics.ldp]
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    return _this;
  }

  LiturgicalDayProperties.prototype.fetchData = function fetchData(date) {
    var _this2 = this;

    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };
    var parms = "?t=" + encodeURIComponent(this.state.selectedType) + "&d=" + encodeURIComponent(date);
    _axios2.default.get(this.props.session.restServer + _Server2.default.getWsServerLiturgicalDayPropertiesApi() + parms, config).then(function (response) {
      _ResponseParser2.default.setItem(response.data);
      _this2.setState({
        item: _ResponseParser2.default.getItemObject()
      });
    }).catch(function (error) {
      _this2.setState({ data: error.message });
      _this2.props.callback(error.message, "");
    });
  };

  LiturgicalDayProperties.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-DateSelector' },
      _react2.default.createElement(
        'h3',
        { className: 'App-DateSelector-prompt' },
        this.props.formPrompt
      ),
      _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.prompt
        ),
        _react2.default.createElement('p', null),
        _react2.default.createElement(
          _reactBootstrap.DropdownButton,
          {
            bsStyle: 'primary',
            title: this.state.labels.calendar,
            key: "a",
            id: 'App-DateSelector-calendar-type',
            onSelect: this.onSelect
          },
          _react2.default.createElement(
            _reactBootstrap.MenuItem,
            { eventKey: 'j' },
            this.state.labels.julian
          ),
          _react2.default.createElement(
            _reactBootstrap.MenuItem,
            { eventKey: 'g' },
            this.state.labels.gregorian
          )
        ),
        _react2.default.createElement('p', null),
        _react2.default.createElement(_reactBootstrapDatePicker2.default, {
          id: 'app-datepicker',
          value: this.state.value,
          onChange: this.handleChange
        })
      ),
      this.state.item ? _react2.default.createElement(_reactJsonschemaForm2.default, {
        schema: this.state.item.schema,
        uiSchema: this.state.item.uiSchema,
        formData: this.state.item.value,
        onSubmit: this.onSubmit }) : _react2.default.createElement('div', null)
    );
  };

  return LiturgicalDayProperties;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? LiturgicalDayProperties.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func.isRequired
} : void 0;

LiturgicalDayProperties.defaultProps = {};

exports.default = LiturgicalDayProperties;
module.exports = exports['default'];