'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Auth = require('./helpers/Auth');

var _Auth2 = _interopRequireDefault(_Auth);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Login = function (_React$Component) {
  _inherits(Login, _React$Component);

  function Login(props) {
    _classCallCheck(this, Login);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.onSubmit = function (_ref) {
      var formData = _ref.formData;

      var config = {
        auth: {
          username: formData.username,
          password: formData.password
        }
      };
      _axios2.default.get(_this.props.restServer + _Server2.default.getWsServerLoginUserApi(), config).then(function (response) {
        _Auth2.default.setCredentials(formData.username, formData.password, true);
        _this.props.loginCallback(response.status, true, formData.username, formData.password, response.data.values // [0] = domain, email, firstname, lastname, title, and [1] = prefs
        );
        var parms = "l=" + encodeURIComponent(_this.props.location);

        _Server2.default.getResources(_this.props.restServer, formData.username, formData.password, parms, _this.props.dropdownsCallback);
      }).catch(function (error) {
        _Auth2.default.setCredentials(formData.username, formData.password, false);
        // important -- leave this here. There are errors thrown
        // by other components that get caught here for some reason.
        console.log("caught login error");
        console.log(error);
        _this.props.loginCallback(error.message, false, formData.username, formData.password, undefined);
      });
    };

    _this.state = {
      path: "",
      username: "",
      password: ""
    };
    return _this;
  }

  Login.prototype.fetchResources = function fetchResources() {};

  Login.prototype.fetchLoginForm = function fetchLoginForm() {
    var _this2 = this;

    _axios2.default.get(this.props.restServer + _Server2.default.getWsServerLoginApi()).then(function (response) {
      _this2.setState({ data: response.data, path: _this2.props.path });
    }).catch(function (error) {
      _this2.setState({ data: error.message, path: _this2.props.path });
      _this2.props.loginCallback(error.message, false, _this2.state.formData.username, _this2.state.formData.password);
    });
  };

  Login.prototype.render = function render() {
    if (this.state.path !== this.props.path) {
      this.fetchLoginForm();
    }
    if (this.state.data) {
      if (this.state.data.schema) {
        var formData = { username: this.props.username, password: this.props.password };
        return _react2.default.createElement(
          'div',
          { className: 'App-login' },
          _react2.default.createElement(
            'h3',
            { className: 'App-login-prompt' },
            this.props.formPrompt
          ),
          _react2.default.createElement(_reactJsonschemaForm2.default, { schema: this.state.data.schema,
            uiSchema: this.state.data.uiSchema,
            formData: formData,
            onSubmit: this.onSubmit
          }),
          _react2.default.createElement(
            'p',
            { className: 'App-login-msg' },
            this.props.formMsg
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          { className: 'App-login' },
          _react2.default.createElement(
            'p',
            null,
            this.props.path
          ),
          _react2.default.createElement(
            'pre',
            null,
            JSON.stringify(this.state.data, null, 2)
          )
        );
      }
    } else {
      return _react2.default.createElement(
        'div',
        { className: 'Resource' },
        _react2.default.createElement(
          'p',
          null,
          'Loading ',
          this.props.path,
          ' from ',
          this.root,
          '!'
        )
      );
    }
  };

  return Login;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? Login.propTypes = {
  restServer: _propTypes2.default.string.isRequired,
  username: _propTypes2.default.string.isRequired,
  password: _propTypes2.default.string.isRequired,
  loginCallback: _propTypes2.default.func.isRequired,
  dropdownsCallback: _propTypes2.default.func.isRequired,
  formPrompt: _propTypes2.default.string.isRequired,
  formMsg: _propTypes2.default.string.isRequired,
  location: _propTypes2.default.string
} : void 0;
Login.defaultProps = {
  location: "unknown|unknown|unknown|unknown|unknown"
};

exports.default = Login;
module.exports = exports['default'];