'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var cellStyle = {
  padding: '2em'
};

var Lookup = function (_React$Component) {
  _inherits(Lookup, _React$Component);

  function Lookup(props) {
    _classCallCheck(this, Lookup);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentDidMount = function () {
      _this.fetchData();
    };

    _this.componentWillReceiveProps = function (nextProps) {};

    _this.handleStateChange = function (parm) {
      // call a function if needed
    };

    _this.handleRestCallback = function (restCallResult) {
      if (restCallResult && restCallResult.data) {
        console.log(restCallResult);
        var value = restCallResult.data.values[0].value;
        _this.setState({
          dataLoaded: true,
          data: value
        });
      }
    };

    _this.getContent = function () {
      if (_this.state.dataLoaded) {
        return _react2.default.createElement(
          'div',
          { className: 'App-New-Component-Template' },
          _react2.default.createElement(
            'table',
            null,
            _react2.default.createElement(
              'tbody',
              null,
              _react2.default.createElement(
                'tr',
                null,
                _react2.default.createElement(
                  'td',
                  { style: cellStyle },
                  _this.props.idDomain,
                  '~',
                  _this.props.idTopic,
                  '~',
                  _this.props.idKey
                ),
                '  ',
                _react2.default.createElement(
                  'td',
                  { style: cellStyle },
                  _this.state.data
                )
              )
            )
          )
        );
      } else {
        if (_this.props && _this.props.idDomain) {
          return _react2.default.createElement(
            'div',
            { className: 'App-New-Component-Template' },
            _react2.default.createElement(
              'table',
              null,
              _react2.default.createElement(
                'tbody',
                null,
                _react2.default.createElement(
                  'tr',
                  null,
                  _react2.default.createElement(
                    'td',
                    { style: cellStyle },
                    _this.props.idDomain,
                    '~',
                    _this.props.idTopic,
                    '~',
                    _this.props.idKey
                  ),
                  '  ',
                  _react2.default.createElement(
                    'td',
                    { style: cellStyle },
                    ' '
                  )
                )
              )
            )
          );
        } else {
          return _react2.default.createElement('div', { className: 'App-New-Component-Template' });
        }
      }
    };

    _this.state = {
      dataLoaded: false,
      value: ""
    };

    _this.fetchData = _this.fetchData.bind(_this);
    _this.handleRestCallback = _this.handleRestCallback.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  Lookup.prototype.fetchData = function fetchData() {
    console.log("fetching data");
    _Server2.default.getLookupResult(this.props.session.restServer, this.props.idDomain, this.props.idTopic, this.props.idKey, this.handleRestCallback);
  };

  Lookup.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      this.getContent()
    );
  };

  return Lookup;
}(_react2.default.Component);

;

process.env.NODE_ENV !== "production" ? Lookup.propTypes = {
  session: _propTypes2.default.object.isRequired,
  idDomain: _propTypes2.default.string,
  idTopic: _propTypes2.default.string.isRequired,
  idKey: _propTypes2.default.string
} : void 0;

// set default values for props here
Lookup.defaultProps = {};

exports.default = Lookup;
module.exports = exports['default'];