'use strict';

exports.__esModule = true;
exports.ModalParaRowEditor = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _IdManager = require('./helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ParaRowTextEditor = require('./ParaRowTextEditor');

var _ParaRowTextEditor2 = _interopRequireDefault(_ParaRowTextEditor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display the ParaRowEditor as a modal window.
 */
var ModalParaRowEditor = exports.ModalParaRowEditor = function (_React$Component) {
  _inherits(ModalParaRowEditor, _React$Component);

  function ModalParaRowEditor(props) {
    _classCallCheck(this, ModalParaRowEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {
      if (_this.props.session.languageCode !== nextProps.session.languageCode) {
        _this.setState(function (prevState, props) {
          return {
            labels: {
              thisClass: nextProps.session.labels[nextProps.session.labelTopics.ModalParaRowEditor],
              messages: nextProps.session.labels[nextProps.session.labelTopics.messages],
              resultsTableLabels: nextProps.session.labels[nextProps.session.labelTopics.resultsTable]
            },
            message: nextProps.session.labels[nextProps.session.labelTopics.messages].initial
          };
        }, function () {
          return this.handleStateChange("place holder");
        });
      }
    };

    _this.handleStateChange = function (parm) {
      // call a function is needed, e.g. if you need to call the rest server again
    };

    _this.onSubmit = function (value) {
      _this.props.onSubmit(value);
    };

    _this.getModalInfo = function () {
      if (_this.props.canChange) {
        return _react2.default.createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'info' },
          _react2.default.createElement(
            'p',
            null,
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'hand-right' }),
            _this.state.labels.thisClass.msg1
          )
        );
      } else {
        return _react2.default.createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'warning' },
          _react2.default.createElement(
            'p',
            null,
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'hand-right' }),
            _this.state.labels.thisClass.msg2
          )
        );
      }
    };

    _this.state = {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ModalParaRowEditor],
        messages: props.session.labels[props.session.labelTopics.messages],
        resultsTableLabels: props.session.labels[props.session.labelTopics.resultsTable]
      },
      message: props.session.labels[props.session.labelTopics.messages].initial,
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      showModal: _this.props.showModal,
      topic: _IdManager2.default.getTopic(_this.props.editId),
      key: _IdManager2.default.getKey(_this.props.editId),
      valuesSame: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.getModalInfo = _this.getModalInfo.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  ModalParaRowEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSeq);
  };

  ModalParaRowEditor.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalParaRowEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        { backdrop: "static", dialogClassName: 'App-Modal-Para-Row-Editor', show: this.state.showModal, onHide: this.close },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          this.getModalInfo(),
          _react2.default.createElement(_ParaRowTextEditor2.default, {
            session: this.props.session,
            docType: 'Liturgical',
            idLibrary: _IdManager2.default.getLibrary(this.props.editId),
            idTopic: _IdManager2.default.getTopic(this.props.editId),
            idKey: _IdManager2.default.getKey(this.props.editId),
            value: this.props.value,
            onSubmit: this.onSubmit,
            canChange: this.props.canChange
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalParaRowEditor;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? ModalParaRowEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  onClose: _propTypes2.default.func.isRequired,
  onSubmit: _propTypes2.default.func.isRequired,
  showModal: _propTypes2.default.bool.isRequired,
  editId: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.string.isRequired,
  canChange: _propTypes2.default.bool.isRequired
} : void 0;
exports.default = ModalParaRowEditor;