'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _ReactSelector = require('./modules/ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _TopicsSelector = require('./modules/TopicsSelector');

var _TopicsSelector2 = _interopRequireDefault(_TopicsSelector);

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrapTable = require('react-bootstrap-table');

var _reactBootstrap = require('react-bootstrap');

var _User = require('./classes/User');

var _User2 = _interopRequireDefault(_User);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Provides a text editor with source and models as parallel columns
 */
var ParaColTextEditor = (_temp = _class = function (_React$Component) {
  _inherits(ParaColTextEditor, _React$Component);

  function ParaColTextEditor(props) {
    _classCallCheck(this, ParaColTextEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, _this.state);

    _this.editable = _this.editable.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    _this.handleValueUpdateCallback = _this.handleValueUpdateCallback.bind(_this);
    _this.setTableData = _this.setTableData.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleTopicSelect = _this.handleTopicSelect.bind(_this);
    _this.onBeforeSaveCell = _this.onBeforeSaveCell.bind(_this);
    _this.onAfterSaveCell = _this.onAfterSaveCell.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.handleLibrarySelection = _this.handleLibrarySelection.bind(_this);
    _this.handleFilterClear = _this.handleFilterClear.bind(_this);
    return _this;
  }

  /**
   *
   * @param row - returns the entire row including nbr, topicKey, etc.
   * @param cellName - the column title, i.e. the library
   * @param cellValue - the text value entered
   */


  /**
   * Does the user have permission to edit records in this library?
   * @param library
   * @returns {boolean}
   */


  ParaColTextEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App App-ParaColTextEditor' },
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(
            _reactBootstrap.Well,
            { className: 'App-Para-Col-Editor' },
            _react2.default.createElement(
              'form',
              { onSubmit: this.handleSubmit },
              _react2.default.createElement(
                _reactBootstrap.FormGroup,
                { controlId: 'formControlsTextarea' },
                _react2.default.createElement(
                  _reactBootstrap.Grid,
                  null,
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(
                        'h3',
                        null,
                        this.state.labels.thisClass.panelTitle
                      )
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(
                        'div',
                        { className: 'control-label' },
                        this.state.labels.thisClass.view
                      )
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(_TopicsSelector2.default, {
                        session: this.props.session,
                        library: "gr_gr_cog",
                        callBack: this.handleTopicSelect
                      })
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(
                        'div',
                        { className: 'control-label' },
                        this.state.labels.thisClass.including + " " + this.props.source + ", " + this.state.labels.thisClass.select + " " + this.state.maxLibraries + " " + this.state.labels.thisClass.libraries
                      )
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(_ReactSelector2.default, {
                        initialValue: this.state.libraries.join(),
                        resources: this.state.session.userInfo.domains.reader,
                        changeHandler: this.handleLibrarySelection,
                        multiSelect: true
                      })
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      null,
                      '\xA0'
                    )
                  ),
                  _react2.default.createElement(
                    _reactBootstrap.Row,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Col,
                      { xs: 12, md: 12 },
                      _react2.default.createElement(
                        _reactBootstrap.Button,
                        {
                          type: 'submit',
                          bsStyle: 'primary',
                          disabled: this.state.topic.length < 1 || this.state.libraries.length < 1
                        },
                        this.state.labels.messages.submit
                      ),
                      _react2.default.createElement(
                        'div',
                        null,
                        this.state.labels.messages.status,
                        ': ',
                        _react2.default.createElement(
                          'span',
                          { className: 'App App-message' },
                          _react2.default.createElement(_reactFontawesome2.default, {
                            name: this.state.messageIcon }),
                          this.state.message,
                          ' '
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        ),
        this.state.values && _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            _react2.default.createElement(
              _reactBootstrap.Grid,
              null,
              _react2.default.createElement(
                _reactBootstrap.Row,
                null,
                _react2.default.createElement(
                  _reactBootstrap.Col,
                  { xs: 9, md: 9 },
                  _react2.default.createElement(
                    'div',
                    { className: 'control-label' },
                    this.state.labels.thisClass.msg2
                  )
                ),
                _react2.default.createElement(
                  _reactBootstrap.Col,
                  { xs: 3, md: 3 },
                  _react2.default.createElement(
                    _reactBootstrap.Button,
                    {
                      onClick: this.handleFilterClear,
                      bsStyle: 'primary',
                      className: 'App-table-filter-clear'
                    },
                    this.state.labels.messages.clearFilters
                  )
                )
              )
            ),
            _react2.default.createElement(
              _reactBootstrapTable.BootstrapTable,
              {
                ref: 'table',
                data: this.state.values,
                trClassName: "App-data-tr",
                striped: true,
                pagination: true,
                options: this.state.options,
                cellEdit: this.state.cellEditProp
              },
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  ref: 'topicKey',
                  isKey: true,
                  dataField: 'topicKey',
                  dataSort: true,
                  width: this.state.topicKeyColumnSize,
                  filter: this.state.tableColumnFilter
                },
                'Topic~Key'
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  ref: 'source',
                  dataSort: true,
                  dataField: this.state.libraries[0],
                  tdClassname: 'tdColEditorSource',
                  width: this.state.libraryValueColumnSize,
                  editable: this.editable(this.state.libraries[0]),
                  filter: this.state.tableColumnFilter
                },
                this.state.libraries[0]
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  ref: 'lib1',
                  dataSort: true,
                  dataField: this.state.libraries[1],
                  editable: this.editable(this.state.libraries[1]),
                  tdClassname: 'tdColEditorLib1',
                  width: this.state.libraryValueColumnSize,
                  hidden: this.state.libraries[1].length == 0,
                  filter: this.state.tableColumnFilter
                },
                this.state.libraries[1]
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  ref: 'lib2',
                  dataField: this.state.libraries[2],
                  dataSort: true,
                  tdClassname: 'tdColEditorLib2',
                  width: this.state.libraryValueColumnSize,
                  editable: this.editable(this.state.libraries[2]),
                  filter: this.state.tableColumnFilter,
                  hidden: this.state.libraries[2].length == 0
                },
                this.state.libraries[2]
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  ref: 'lib3',
                  dataField: this.state.libraries[3],
                  dataSort: true,
                  editable: this.editable(this.state.libraries[0]),
                  tdClassname: 'tdColEditorLib3',
                  width: this.state.libraryValueColumnSize,
                  filter: this.state.tableColumnFilter,
                  hidden: this.state.libraries[3].length == 0
                },
                this.state.libraries[3]
              )
            )
          )
        )
      )
    );
  };

  return ParaColTextEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var dataFetched = false;
    var values = undefined;
    var about = {};
    var libraryKeyValues = {};
    var libraryKeys = [];
    var templateKeys = [];
    var libraries = [_this2.props.source, "", "", ""];
    var topic = "";
    var message = props.session.labels[props.session.labelTopics.messages].initial;
    var messageIcon = _MessageIcons2.default.getMessageIcons().info;

    if (currentState) {
      if (message !== currentState.message) {
        message = currentState.message;
      }
      if (messageIcon !== currentState.messageIcon) {
        messageIcon = currentState.messageIcon;
      }
      if (currentState.dataFetched) {
        dataFetched = currentState.dataFetched;
      }
      if (currentState.libraries) {
        libraries = currentState.libraries;
      }
      if (currentState.topic) {
        topic = currentState.topic;
      }
      if (currentState.dataFetched) {
        values = currentState.values;
      }
    }

    var userInfo = {};
    if (props.session && props.session.userInfo) {
      userInfo = new _User2.default(props.session.userInfo.username, props.session.userInfo.password, props.session.userInfo.domain, props.session.userInfo.email, props.session.userInfo.firstname, props.session.userInfo.lastname, props.session.userInfo.title, props.session.userInfo.authenticated, props.session.userInfo.domains);
    }

    var clickType = "dbclick";
    try {
      if (window.innerWidth < 800) {
        clickType = "click";
      }
    } catch (err) {
      clickType = "dbclick";
    }

    return {
      labels: {
        thisClass: props.session.labels[props.session.labelTopics.ParaColTextEditor],
        messages: props.session.labels[props.session.labelTopics.messages]
      },
      session: {
        userInfo: userInfo
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: message,
      resultCount: -1,
      topic: topic,
      libraries: libraries,
      dataFetched: dataFetched,
      values: values,
      about: about,
      libraryKeyValues: libraryKeyValues,
      libraryKeys: libraryKeys,
      templateKeys: templateKeys,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      cellEditProp: {
        mode: clickType,
        beforeSaveCell: _this2.onBeforeSaveCell,
        afterSaveCell: _this2.onAfterSaveCell
      },
      maxCols: 6,
      maxLibraries: 4,
      topicKeyColumnSize: "40px",
      libraryValueColumnSize: "80px",
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: props.session.labels[props.session.labelTopics.messages].regEx
      }
    };
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.fetchData = function () {
    var parms = "t=" + encodeURIComponent(_this2.state.topic) + "&l=" + encodeURIComponent(_this2.state.libraries);

    _this2.setState({
      message: _this2.state.labels.messages.retrieving
    }, _Server2.default.getViewForTopic(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, parms, _this2.handleFetchCallback));
  };

  this.handleFetchCallback = function (restCallResult) {
    if (restCallResult) {
      var data = restCallResult.data.values[0];
      console.log(data);
      var about = data.about;
      var templateKeys = data.templateKeys;
      var libraryKeys = data.libraryKeys;
      var libraryKeyValues = data.libraryKeyValues;
      _this2.setState({
        dataFetched: true,
        about: about,
        libraryKeyValues: libraryKeyValues,
        libraryKeys: libraryKeys,
        templateKeys: templateKeys,
        message: _this2.state.labels.messages.found + " " + templateKeys.length + " " + _this2.state.labels.messages.docs,
        messageIcon: restCallResult.messageIcon,
        resultCount: templateKeys.length
      }, _this2.setTableData);
    }
  };

  this.handleValueUpdateCallback = function (restCallResult) {
    if (restCallResult) {
      _this2.setState({
        message: restCallResult.message,
        messageIcon: restCallResult.messageIcon
      }, _this2.setTableData);
    }
  };

  this.setTableData = function () {
    if (_this2.state.dataFetched) {
      var tableData = [];
      var j = _this2.state.templateKeys.length;
      for (var i = 0; i < j; i++) {
        var topicKey = _this2.state.templateKeys[i].key;
        var seq = _this2.state.libraryKeyValues[_this2.state.libraries[0]][_this2.state.templateKeys[i].libKeysIndex].seq;
        var source = _this2.state.libraryKeyValues[_this2.state.libraries[0]][_this2.state.templateKeys[i].libKeysIndex].value;
        var lib1 = "";
        var lib2 = "";
        var lib3 = "";
        if (_this2.state.libraries[1].length > 0) {
          lib1 = _this2.state.libraryKeyValues[_this2.state.libraries[1]][_this2.state.templateKeys[i].libKeysIndex].value;
        }
        if (_this2.state.libraries[2].length > 0) {
          lib2 = _this2.state.libraryKeyValues[_this2.state.libraries[2]][_this2.state.templateKeys[i].libKeysIndex].value;
        }
        if (_this2.state.libraries[3].length > 0) {
          lib3 = _this2.state.libraryKeyValues[_this2.state.libraries[3]][_this2.state.templateKeys[i].libKeysIndex].value;
        }
        var row = {};
        row["nbr"] = i;
        row["seq"] = seq;
        row["topicKey"] = topicKey;
        row[_this2.state.libraries[0]] = source;
        row[_this2.state.libraries[1]] = lib1;
        row[_this2.state.libraries[2]] = lib2;
        row[_this2.state.libraries[3]] = lib3;
        tableData.push(row);
      }
      _this2.setState({
        values: tableData
      });
    }
  };

  this.handleTopicSelect = function (topic) {
    _this2.setState({
      topic: topic
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    // row["id"], etc.
  };

  this.onBeforeSaveCell = function (row, cellName, cellValue) {};

  this.onAfterSaveCell = function (row, cellName, cellValue) {
    var index = row.nbr;
    var seq = row.seq;
    var topicKey = row.topicKey;
    var library = cellName;
    var value = cellValue;
    var id = library + "~" + topicKey;
    // update the local array with the new value
    var libraryKeyValues = _this2.state.libraryKeyValues;
    libraryKeyValues[library][_this2.state.templateKeys[index].libKeysIndex].value = value;
    _this2.setState({
      libraryKeyValues: libraryKeyValues
    });

    // now update the database via a rest call
    var parms = "i=" + encodeURIComponent(id) + "&t=" + encodeURIComponent("Liturgical");

    _Server2.default.putValue(_this2.props.session.restServer, _this2.state.session.userInfo.username, _this2.state.session.userInfo.password, { value: value, seq: seq }, parms, _this2.handleValueUpdateCallback);
  };

  this.handleLibrarySelection = function (selection) {
    var libraries = [];
    var source = _this2.props.source;
    var sourceFound = false;
    libraries.push(_this2.props.source);
    selection.forEach(function (lib) {
      if (lib.value == source) {
        sourceFound = true;
      } else {
        libraries.push(lib.value);
      }
    });
    var emptyCols = _this2.state.maxCols - libraries.length;
    for (var i = 0; i < emptyCols; i++) {
      libraries.push("");
    }
    var message = "";
    var messageIcon = _MessageIcons2.default.getMessageIcons().info;
    if (!sourceFound) {
      message = _this2.state.labels.thisClass.sourceRequired + " " + _this2.props.source;
      messageIcon = _MessageIcons2.default.getMessageIcons().error;
    } else if (selection.length > _this2.state.maxLibraries) {
      message = _this2.state.labels.thisClass.maxLibraries + " " + _this2.state.maxLibraries;
      messageIcon = _MessageIcons2.default.getMessageIcons().error;
    }
    _this2.setState({
      libraries: libraries,
      message: message,
      messageIcon: messageIcon
    });
  };

  this.editable = function (library) {
    var canEdit = false;
    for (var _iterator = _this2.state.session.userInfo.domains.author, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var entry = _ref;

      if (entry.value == library) {
        canEdit = true;
        break;
      }
    }
    if (canEdit) {
      return { type: 'textarea' };
    } else {
      return false;
    }
  };

  this.handleSubmit = function (event) {
    _this2.fetchData();
    event.preventDefault();
  };

  this.handleFilterClear = function () {
    if (_this2.refs) {
      if (_this2.refs.topicKey) {
        _this2.refs.topicKey.applyFilter("");
      }
      if (_this2.refs.source) {
        _this2.refs.source.applyFilter("");
      }
      if (_this2.refs.lib1) {
        _this2.refs.lib1.applyFilter("");
      }
      if (_this2.refs.lib2) {
        _this2.refs.lib2.applyFilter("");
      }
      if (_this2.refs.lib3) {
        _this2.refs.lib3.applyFilter("");
      }
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ParaColTextEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  source: _propTypes2.default.string.isRequired
} : void 0;

ParaColTextEditor.defaultProps = {};

exports.default = ParaColTextEditor;
module.exports = exports['default'];