'use strict';

exports.__esModule = true;
exports.ParaRowTextEditor = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _lodash = require('lodash');

var _reactBootstrapTable = require('react-bootstrap-table');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _NotesLister = require('./NotesLister');

var _NotesLister2 = _interopRequireDefault(_NotesLister);

var _Grammar = require('./modules/Grammar');

var _Grammar2 = _interopRequireDefault(_Grammar);

var _Spinner = require('./helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _TextNotesLister = require('./TextNotesLister');

var _TextNotesLister2 = _interopRequireDefault(_TextNotesLister);

var _ReactSelector = require('./modules/ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _WorkflowForm = require('./helpers/WorkflowForm');

var _WorkflowForm2 = _interopRequireDefault(_WorkflowForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display a text to edit, with source and models as rows.
 */
var ParaRowTextEditor = exports.ParaRowTextEditor = (_temp = _class = function (_React$Component) {
  _inherits(ParaRowTextEditor, _React$Component);

  function ParaRowTextEditor(props) {
    _classCallCheck(this, ParaRowTextEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var pdfSubTitle = "";
    var prefs = {};
    if (props.session.userInfo && props.session.userInfo.prefs) {
      prefs = props.session.userInfo.prefs;
      if (prefs.includeNotesTransAdvice) {
        pdfSubTitle = "A Liturgical Translator's Manual";
      }
    }
    var citeData = [];
    if (props.session.dropdowns) {
      citeData = props.session.dropdowns.bibTexStylesDropdown;
    }
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ParaTextEditor],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        search: labels[labelTopics.search]
      },
      citeData: citeData,
      citeStyle: prefs.bibLatexStyle ? prefs.bibLatexStyle : "authoryear",
      greekSourceValue: "",
      greekSourceId: "",
      showSearchResults: false,
      message: (0, _lodash.get)(_this.state, "message", labels[labelTopics.search].msg1),
      downloadMessage: "",

      messageIcon: (0, _lodash.get)(_this.state, "messageIcon", _this.messageIcons.info),

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      showSelectionButtons: false,

      selectedId: "",

      selectedValue: "",

      selectedIdPartsPrompt: "Select one or more ID parts, then click on the search icon:",

      selectedIdParts: [{ key: "domain", label: "" }, { key: "topic", label: "" }, { key: "key", label: "" }],
      showIdPartSelector: false,
      idColumnSize: "80px",
      editorValue: props.value,
      currentDocType: props.docType,
      currentId: props.idLibrary + "~" + props.idTopic + "~" + props.idKey,
      currentIdLibrary: props.idLibrary,
      currentIdTopic: props.idTopic,
      currentIdKey: props.idKey,
      domain: "*",
      selectedBook: "*",
      selectedChapter: "*",
      docProp: "id",
      matcher: "ew",
      query: "~" + props.idTopic + "~" + props.idKey,
      pdfId: "",
      pdfTitle: "",
      pdfSubTitle: pdfSubTitle,
      pdfAuthor: prefs.author ? prefs.author : "",
      pdfAuthorTitle: prefs.authorTitle ? prefs.authorTitle : "",
      pdfAuthorAffiliation: prefs.authorAffiliation ? prefs.authorAffiliation : "",
      includeAdviceNotes: prefs.includeNotesTransAdvice ? prefs.includeNotesTransAdvice : "",
      includePersonalNotes: prefs.includeNotesUser ? prefs.includeNotesUser : "",
      includeGrammar: prefs.includeGrammar ? prefs.includeGrammar : "",
      combineNotes: prefs.combineNotes ? prefs.combineNotes : "",
      createToc: prefs.createToc ? prefs.createToc : "",
      showDownloadLinks: false,
      preparingDownloads: false,
      biblatex: "http://ftp.math.purdue.edu/mirrors/ctan.org/macros/latex/contrib/biblatex/doc/biblatex.pdf",
      submitDisabled: true
    };

    _this.fetchData = _this.fetchData.bind(_this);
    _this.getDownloadLinks = _this.getDownloadLinks.bind(_this);
    _this.getParaRows = _this.getParaRows.bind(_this);
    _this.getTabs = _this.getTabs.bind(_this);
    _this.getTextArea = _this.getTextArea.bind(_this);
    _this.getTitleRow = _this.getTitleRow.bind(_this);
    _this.getWorkflowPanel = _this.getWorkflowPanel.bind(_this);
    _this.getStatusIcon = _this.getStatusIcon.bind(_this);
    _this.getVisibilityIcon = _this.getVisibilityIcon.bind(_this);
    _this.handleciteStyleChange = _this.handleciteStyleChange.bind(_this);
    _this.handleDownloadRequest = _this.handleDownloadRequest.bind(_this);
    _this.handleDownloadCallback = _this.handleDownloadCallback.bind(_this);
    _this.handleEditorChange = _this.handleEditorChange.bind(_this);
    _this.handleIncludeAdviceNotesChange = _this.handleIncludeAdviceNotesChange.bind(_this);
    _this.handleIncludeGrammarChange = _this.handleIncludeGrammarChange.bind(_this);
    _this.handleIncludePersonalNotesChange = _this.handleIncludePersonalNotesChange.bind(_this);
    _this.handleCombineNotesChange = _this.handleCombineNotesChange.bind(_this);
    _this.handleCreateTocChange = _this.handleCreateTocChange.bind(_this);
    _this.handlePdfAuthorChange = _this.handlePdfAuthorChange.bind(_this);
    _this.handlePdfAuthorAffiliationChange = _this.handlePdfAuthorAffiliationChange.bind(_this);
    _this.handlePdfAuthorTitleChange = _this.handlePdfAuthorTitleChange.bind(_this);
    _this.handlePdfTitleChange = _this.handlePdfTitleChange.bind(_this);
    _this.handlePdfSubTitleChange = _this.handlePdfSubTitleChange.bind(_this);
    _this.handlePropsChange = _this.handlePropsChange.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleValueUpdateCallback = _this.handleValueUpdateCallback.bind(_this);
    _this.handleWorkflowCallback = _this.handleWorkflowCallback.bind(_this);
    _this.notifyParentValueChanged = _this.notifyParentValueChanged.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.submitDisabled = _this.submitDisabled.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  /**
   * Because we are passing back the value each time it changes,
   * componentWillReceiveProps keeps getting called.
   * We don't want that to result in calling fetchData unless
   * the docType, library, topic, or key changed.
   */


  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  ParaRowTextEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ParaRowTextEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.search.msg2,
      messageIcon: this.messageIcons.info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.props.docType) + "&d=" + encodeURIComponent(this.state.domain) + "&b=" + encodeURIComponent(this.state.selectedBook) + "&c=" + encodeURIComponent(this.state.selectedChapter) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher);
    var path = this.props.session.restServer + _Server2.default.getWsServerDbApi() + 'docs' + parms;
    _axios2.default.get(path, config).then(function (response) {
      var greekSource = response.data.values.find(function (o) {
        return o.id.startsWith("gr_gr_cog");
      });
      var greekSourceId = "";
      var greekSourceValue = "";
      var pdfTitle = _this2.state.pdfTitle;
      if (greekSource) {
        greekSourceId = greekSource.id;
        greekSourceValue = greekSource.value;
        if (pdfTitle.length === 0) {
          if (greekSourceValue.length > 31) {
            var words = greekSourceValue.substring(0, 30).split(/[\s,.;]/);
            if (words.length > 4) {
              pdfTitle = words[0] + " " + words[1] + " " + words[2] + " " + words[3];
            } else if (words.length > 3) {
              pdfTitle = words[0] + " " + words[1] + " " + words[2];
            } else if (words.length > 2) {
              pdfTitle = words[0] + " " + words[1];
            } else {
              pdfTitle = words[0];
            }
          } else {
            pdfTitle = greekSourceValue.substring(0, 30);
          }
        }
      }
      var thisText = response.data.values.find(function (o) {
        return o.id === _this2.props.idLibrary + "~" + _this2.props.idTopic + "~" + _this2.props.idKey;
      });
      var workflow = {
        assignedTo: "",
        status: "EDITING",
        visibility: "PRIVATE",
        statusIcon: "edit",
        visibilityIcon: "share-alt"
      };
      var originalWorkflow = {
        assignedTo: "",
        status: "EDITING",
        visibility: "PRIVATE"
      };
      try {
        if (thisText) {
          if (thisText.status) {
            var theStatus = thisText.status;
            workflow.status = thisText.status;
            originalWorkflow.status = theStatus;
            workflow.statusIcon = _this2.getStatusIcon(thisText.status);
          }
          if (thisText.visibility) {
            var theVisibility = thisText.visibility;
            workflow.visibility = thisText.visibility;
            originalWorkflow.visibility = theVisibility;
            workflow.visibilityIcon = _this2.getVisibilityIcon(thisText.visibility);
          }
        }
      } catch (err) {
        console.log(err);
      }
      var values = response.data.values.filter(function (row) {
        return row.value.length > 0;
      });
      response.data.values = values;

      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (values) {
        resultCount = values.length;
        if (resultCount === 0) {
          message = _this2.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true,
        data: response.data,
        greekSourceId: greekSourceId,
        greekSourceValue: greekSourceValue,
        pdfTitle: pdfTitle,
        thisText: thisText,
        workflow: workflow,
        originalWorkflow: originalWorkflow
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.search.foundNone;
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  ParaRowTextEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App App-Text-Note-Editor' },
      !this.state.showSearchResults ? _react2.default.createElement(_Spinner2.default, { message: this.state.labels.messages.retrieving }) : _react2.default.createElement(
        'div',
        { className: 'App-ParaRow-Text-Editor' },
        _react2.default.createElement(
          _reactBootstrap.Grid,
          null,
          this.getParaRows(),
          this.getTextArea(),
          this.getTabs()
        )
      )
    );
  };

  return ParaRowTextEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    _this3.fetchData();
  };

  this.componentWillReceiveProps = function (nextProps) {
    var prefs = {};
    var pdfSubTitle = (0, _lodash.get)(_this3.state, "pdfSubTitle", "");
    if (nextProps.session.userInfo && nextProps.session.userInfo.prefs) {
      prefs = nextProps.session.userInfo.prefs;
      if (pdfSubTitle.length === 0 && prefs.includeNotesTransAdvice) {
        pdfSubTitle = "A Liturgical Translator's Manual";
      }
    }
    var citeData = [];
    if (nextProps.session.dropdowns) {
      citeData = nextProps.session.dropdowns.bibTexStylesDropdown;
    }
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this3.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.ParaTextEditor],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          search: labels[labelTopics.search]
        },
        message: (0, _lodash.get)(prevState, "message", labels[labelTopics.search].msg1),
        messageIcon: (0, _lodash.get)(prevState, "messageIcon", _this3.messageIcons.info),
        greekSourceValue: "",
        greekSourceId: "",
        citeData: citeData,
        citeStyle: prefs.bibLatexStyle ? prefs.bibLatexStyle : "authoryear",
        pdfSubTitle: pdfSubTitle,
        pdfAuthor: prefs.author ? prefs.author : "",
        pdfAuthorTitle: prefs.authorTitle ? prefs.authorTitle : "",
        pdfAuthorAffiliation: prefs.authorAffiliation ? prefs.authorAffiliation : "",
        includeAdviceNotes: prefs.includeNotesTransAdvice ? prefs.includeNotesTransAdvice : "",
        includePersonalNotes: prefs.includeNotesUser ? prefs.includeNotesUser : "",
        includeGrammar: prefs.includeGrammar ? prefs.includeGrammar : "",
        combineNotes: prefs.combineNotes ? prefs.combineNotes : "",
        createToc: prefs.createToc ? prefs.createToc : ""
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    _this3.handlePropsChange();
  };

  this.handlePropsChange = function () {
    if (_this3.state.currentDocType !== _this3.props.docType || _this3.state.currentIdLibrary !== _this3.props.idLibrary || _this3.state.currentIdTopic !== _this3.props.idTopic || _this3.state.currentIdKey !== _this3.props.idKey) {
      _this3.fetchData();
    }
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle"
    // , toggleOn: "eye"
    // , toggleOff: "eye-slash"
    , toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.handleIncludeAdviceNotesChange = function (evt) {
    var pdfSubTitle = _this3.state.pdfSubTitle;
    if (_this3.state.includeAdviceNotes) {
      if (pdfSubTitle && pdfSubTitle.startsWith("A Liturgical Translator's")) {
        pdfSubTitle = "";
      }
    } else {
      if (!pdfSubTitle) {
        pdfSubTitle = "A Liturgical Translator's Manual";
      }
    }
    _this3.setState({
      includeAdviceNotes: evt.target.checked,
      pdfSubTitle: pdfSubTitle
    });
  };

  this.handleIncludePersonalNotesChange = function (evt) {
    _this3.setState({ includePersonalNotes: evt.target.checked });
  };

  this.handleIncludeGrammarChange = function (evt) {
    _this3.setState({ includeGrammar: evt.target.checked });
  };

  this.handleCombineNotesChange = function (evt) {
    _this3.setState({ combineNotes: evt.target.checked });
  };

  this.handleCreateTocChange = function (evt) {
    _this3.setState({ createToc: evt.target.checked });
  };

  this.getDownloadLinks = function () {
    if (_this3.state.showDownloadLinks) {
      var url = "data/" + _this3.state.pdfId;
      return _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App-Download-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { className: 'App-Download-Col', xs: 3, md: 3 },
          _react2.default.createElement(
            'a',
            { href: url + ".pdf", target: "_blank" },
            _this3.state.labels.buttons.downloadAsPdf
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { className: 'App-Download-Col', xs: 4, md: 4 },
          _react2.default.createElement(
            'a',
            { href: url + ".tex", target: "_blank" },
            _this3.state.labels.buttons.downloadAsTex
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { className: 'App-Download-Col', xs: 5, md: 5 },
          _react2.default.createElement(
            'a',
            { href: url + ".bib", target: "_blank" },
            _this3.state.labels.buttons.downloadAsTexBib
          )
        )
      );
    } else {
      if (_this3.state.preparingDownloads) {
        return _react2.default.createElement(
          _reactBootstrap.Row,
          { className: 'App-Download-Row' },
          _react2.default.createElement(
            _reactBootstrap.Col,
            { className: 'App-Download-Col', xs: 12, md: 12 },
            _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.preparingPdf })
          )
        );
      } else {
        return _react2.default.createElement('span', null);
      }
    }
  };

  this.handleciteStyleChange = function (selection) {
    _this3.setState({
      citeStyle: selection["value"]
    });
  };

  this.handleDownloadRequest = function () {
    _this3.setState({
      preparingDownloads: true,
      showDownloadLinks: false
    });

    var id = "gr_gr_cog/" + _this3.props.idTopic + "/" + _this3.props.idKey;

    var includeAdviceNotes = "false";
    var includePersonalNotes = "false";
    var includeGrammar = "false";
    var combineNotes = "false";
    var createToc = "false";

    if (_this3.state.includeAdviceNotes) {
      includeAdviceNotes = "true";
    }
    if (_this3.state.includePersonalNotes) {
      includePersonalNotes = "true";
    }
    if (_this3.state.includeGrammar) {
      includeGrammar = "true";
    }
    if (_this3.state.combineNotes) {
      combineNotes = "true";
    }
    if (_this3.state.includePersonalNotes) {
      includePersonalNotes = "true";
    }
    if (_this3.state.createToc) {
      createToc = "true";
    }
    var parms = "ia=" + encodeURIComponent(includeAdviceNotes) + "&ip=" + encodeURIComponent(includePersonalNotes) + "&ig=" + encodeURIComponent(includeGrammar) + "&cn=" + encodeURIComponent(combineNotes) + "&toc=" + encodeURIComponent(createToc) + "&al=" + encodeURIComponent(_this3.props.idLibrary) + "&mt=" + encodeURIComponent(_this3.state.pdfTitle) + "&st=" + encodeURIComponent(_this3.state.pdfSubTitle) + "&au=" + encodeURIComponent(_this3.state.pdfAuthor) + "&at=" + encodeURIComponent(_this3.state.pdfAuthorTitle) + "&af=" + encodeURIComponent(_this3.state.pdfAuthorAffiliation) + "&cs=" + encodeURIComponent(_this3.state.citeStyle);

    _Server2.default.getTextDownloads(_this3.props.session.restServer, _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, id, parms, _this3.handleDownloadCallback);
  };

  this.getWorkflowPanel = function () {
    if (_this3.props.canChange && !_this3.props.idLibrary.includes("_sys_")) {
      return _react2.default.createElement(
        _reactBootstrap.Tab,
        { eventKey: "workflow", title: _this3.state.labels.thisClass.workflowPanel },
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          _react2.default.createElement(_WorkflowForm2.default, {
            session: _this3.props.session,
            callback: _this3.handleWorkflowCallback,
            library: _this3.props.idLibrary,
            status: _this3.state.workflow.status,
            visibility: _this3.state.workflow.visibility
          })
        )
      );
    }
  };

  this.getStatusIcon = function (status) {
    var statusIcon = "edit";
    switch (status) {
      case "EDITING":
        {
          statusIcon = "edit";
          break;
        }
      case "REVIEWING":
        {
          statusIcon = "eye-open";
          break;
        }
      case "FINALIZED":
        {
          statusIcon = "check";
          break;
        }
      default:
        {
          var _statusIcon = "edit";
        }
    }
    return statusIcon;
  };

  this.getVisibilityIcon = function (visibility) {
    var visibilityIcon = "lock";
    switch (visibility) {
      case "PERSONAL":
        {
          visibilityIcon = "lock"; // user-secret
          break;
        }
      case "PRIVATE":
        {
          visibilityIcon = "share-alt";
          break;
        }
      case "PUBLIC":
        {
          visibilityIcon = "globe";
          break;
        }
      default:
        {
          var _visibilityIcon = "lock";
        }
    }
    return visibilityIcon;
  };

  this.handleWorkflowCallback = function (visibility, status, assignedTo) {
    if (visibility && status) {
      var statusIcon = _this3.getStatusIcon(status);
      var visibilityIcon = _this3.getVisibilityIcon(visibility);
      var workflow = _this3.state.workflow;
      workflow.status = status;
      workflow.visibility = visibility;
      workflow.assignedToUser = assignedTo;
      workflow.visibilityIcon = visibilityIcon;
      workflow.statusIcon = statusIcon;
      _this3.setState({
        workflow: workflow
      }, _this3.submitDisabled());
    }
  };

  this.getPdf = function () {
    _this3.setState({
      preparingDownloads: true,
      showDownloadLinks: false
    });

    var parms = "id=" + encodeURIComponent(id);

    _Server2.default.restGetPdf(_this3.props.session.restServer, _Server2.default.getDbServerAgesPdfApi(), _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, parms, _this3.state.pdfFilename).then(function (response) {
      _this3.setState({
        data: response,
        preparingDownloads: false,
        showDownloadLinks: true
      });
    }).catch(function (error) {
      _this3.setState({
        data: {
          values: [{
            "id": "",
            "library": "",
            "topic": "",
            "key": "",
            "value:": ""
          }],
          userMessage: error.userMessage,
          developerMessage: error.developerMessage,
          messageIcon: error.messageIcon,
          status: error.status,
          showSearchResults: false,
          resultCount: 0,
          fetching: false
        }
      });
    });
  };

  this.handleDownloadCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      var data = restCallResult.data.values[0];
      var pdfId = data.pdfId;
      var pdfFilename = data.pdfFilename;

      _this3.setState({
        pdfId: pdfId,
        pdfFilename: pdfFilename,
        preparingDownloads: false,
        showDownloadLinks: true
      });
    }
  };

  this.handlePdfStatusCallback = function (result) {
    var statusMessage = _this3.state.labels.messages.couldNotGenerate;
    var showPdfButton = false;
    if (result.code === 200) {
      var _statusMessage = "";
      showPdfButton = true;
    }
    _this3.setState({
      fetchingPdf: false,
      showPdfButton: showPdfButton,
      generationStatusMessage: statusMessage
    });
  };

  this.getTextArea = function () {
    if (_this3.props.canChange && !_this3.props.idLibrary.includes("_sys_")) {
      return _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _reactBootstrap.ControlLabel,
              null,
              _this3.state.labels.thisClass.yourTranslation + " (" + _this3.props.idLibrary + ")"
            )
          ),
          _react2.default.createElement('textarea', {
            className: 'App-Modal-Editor-TextArea',
            rows: '4',
            cols: '100',
            spellCheck: 'true',
            value: _this3.state.editorValue,
            onChange: _this3.handleEditorChange
          }),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              {
                type: 'submit',
                bsStyle: 'primary',
                disabled: _this3.state.submitDisabled,
                onClick: _this3.handleSubmit
              },
              _this3.state.labels.thisClass.submit
            ),
            _react2.default.createElement(
              'span',
              { className: 'App App-message' },
              _react2.default.createElement(_reactFontawesome2.default, {
                name: _this3.state.messageIcon }),
              _this3.state.message
            ),
            _react2.default.createElement(
              'span',
              { className: 'App App-Text-Editor-Workflow-Glyph' },
              _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: _this3.state.workflow.statusIcon }),
              _react2.default.createElement(_reactFontawesome2.default, { name: _this3.state.workflow.visibilityIcon })
            )
          )
        )
      );
    } else {
      return _react2.default.createElement('span', { className: 'App App-no-display' });
    }
  };

  this.submitDisabled = function () {
    if (_this3.state.editorValue === _this3.props.value && _this3.state.originalWorkflow.status === _this3.state.workflow.status && _this3.state.originalWorkflow.visibility === _this3.state.workflow.visibility) {
      _this3.setState({ submitDisabled: true });
    } else {
      _this3.setState({ submitDisabled: false });
    }
  };

  this.handlePdfAuthorChange = function (e) {
    _this3.setState({ pdfAuthor: e.target.value });
  };

  this.handlePdfAuthorAffiliationChange = function (e) {
    _this3.setState({ pdfAuthorAffiliation: e.target.value });
  };

  this.handlePdfAuthorTitleChange = function (e) {
    _this3.setState({ pdfAuthorTitle: e.target.value });
  };

  this.handlePdfTitleChange = function (e) {
    _this3.setState({ pdfTitle: e.target.value });
  };

  this.handlePdfSubTitleChange = function (e) {
    _this3.setState({ pdfSubTitle: e.target.value });
  };

  this.getTitleRow = function () {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-Title-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.pdfTitle,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 9, md: 9 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            id: "fxPdfTitle",
            className: "App App-PDF-Title",
            type: 'text',
            value: _this3.state.pdfTitle,
            placeholder: _this3.state.labels.thisClass.pdfTitle,
            onChange: _this3.handlePdfTitleChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-Title-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.pdfSubTitle,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 9, md: 9 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            id: "fxPdfSubTitle",
            className: "App App-PDF-Title",
            type: 'text',
            value: _this3.state.pdfSubTitle,
            placeholder: _this3.state.labels.thisClass.pdfSubTitle,
            onChange: _this3.handlePdfSubTitleChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-Author-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.pdfAuthor,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 9, md: 9 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            id: "fxPdfAuthor",
            className: "App App-PDF-Author",
            type: 'text',
            value: _this3.state.pdfAuthor,
            placeholder: _this3.state.labels.thisClass.pdfAuthor,
            onChange: _this3.handlePdfAuthorChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-Author-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.pdfAuthorTitle,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 9, md: 9 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            id: "fxPdfAuthorTitle",
            className: "App App-PDF-Author",
            type: 'text',
            value: _this3.state.pdfAuthorTitle,
            placeholder: _this3.state.labels.thisClass.pdfAuthorTitle,
            onChange: _this3.handlePdfAuthorTitleChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-Author-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.pdfAuthorAffiliation,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 9, md: 9 },
          _react2.default.createElement(_reactBootstrap.FormControl, {
            id: "fxPdfAuthorAffiliation",
            className: "App App-PDF-Author",
            type: 'text',
            value: _this3.state.pdfAuthorAffiliation,
            placeholder: _this3.state.labels.thisClass.pdfAuthorAffiliation,
            onChange: _this3.handlePdfAuthorAffiliationChange
          })
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'App show-grid App-PDF-BibStyle-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 3, md: 3 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this3.state.labels.thisClass.citeStyle,
            ':'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 5, md: 5 },
          _react2.default.createElement(
            'div',
            { className: 'App-PDF-BibStyle-Dropdown' },
            _react2.default.createElement(_ReactSelector2.default, {
              title: "",
              initialValue: _this3.state.citeStyle,
              resources: _this3.state.citeData,
              changeHandler: _this3.handleciteStyleChange,
              multiSelect: false
            })
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { xs: 4, md: 4 },
          _react2.default.createElement(
            'a',
            { className: 'App-See-Biblatex', href: _this3.state.biblatex, target: "_blank" },
            _this3.state.labels.thisClass.seeBiblatex
          )
        )
      )
    );
  };

  this.getTabs = function () {
    return _react2.default.createElement(
      'div',
      { className: 'row' },
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.Tabs,
          { id: 'App-Text-Node-Editor-Tabs', animation: false },
          _react2.default.createElement(
            _reactBootstrap.Tab,
            { eventKey: "textnotes", title: _this3.state.labels.thisClass.textualNotesPanelTitle },
            _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(_TextNotesLister2.default, {
                session: _this3.props.session,
                topicId: _this3.state.currentId,
                topicText: _this3.props.value
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Tab,
            { eventKey: "grammar", title: _this3.state.labels.thisClass.grammarPanelTitle },
            _react2.default.createElement(_Grammar2.default, {
              session: _this3.props.session,
              idTopic: _this3.props.idTopic,
              idKey: _this3.props.idKey
            })
          ),
          _react2.default.createElement(
            _reactBootstrap.Tab,
            { eventKey: "usernote", title: _this3.state.labels.thisClass.userNotesPanelTitle },
            _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(_NotesLister2.default, {
                session: _this3.props.session,
                type: "NoteUser",
                topicId: _this3.state.currentId,
                topicText: _this3.props.value
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Tab,
            { eventKey: "download", title: _this3.state.labels.thisClass.downloadPanelTitle },
            _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(
                _reactBootstrap.Well,
                null,
                _this3.getTitleRow(),
                _react2.default.createElement(
                  _reactBootstrap.Row,
                  null,
                  _react2.default.createElement(
                    _reactBootstrap.Col,
                    { className: 'App-Info-Row', xs: 12, md: 12 },
                    _react2.default.createElement(
                      _reactBootstrap.Checkbox,
                      {
                        checked: _this3.state.combineNotes,
                        onChange: _this3.handleCombineNotesChange,
                        inline: true
                      },
                      _this3.state.labels.thisClass.combineNotes
                    )
                  )
                ),
                _react2.default.createElement(
                  _reactBootstrap.Row,
                  null,
                  _react2.default.createElement(
                    _reactBootstrap.Col,
                    { className: 'App-Info-Row', xs: 12, md: 12 },
                    _react2.default.createElement(
                      _reactBootstrap.Checkbox,
                      {
                        checked: _this3.state.createToc,
                        onChange: _this3.handleCreateTocChange,
                        inline: true
                      },
                      _this3.state.labels.thisClass.createToc
                    )
                  )
                ),
                _react2.default.createElement(
                  _reactBootstrap.Row,
                  { className: 'App-Info-Row' },
                  _react2.default.createElement(
                    _reactBootstrap.Col,
                    { className: '', xs: 12, md: 12 },
                    _react2.default.createElement(
                      _reactBootstrap.Checkbox,
                      {
                        checked: _this3.state.includeGrammar,
                        onChange: _this3.handleIncludeGrammarChange,
                        inline: true
                      },
                      _this3.state.labels.thisClass.includeGrammar
                    )
                  )
                ),
                _react2.default.createElement(
                  _reactBootstrap.Row,
                  { className: 'App-Info-Row' },
                  _react2.default.createElement(
                    _reactBootstrap.Col,
                    { className: '', xs: 12, md: 12 },
                    _react2.default.createElement(
                      _reactBootstrap.Checkbox,
                      {
                        checked: _this3.state.includePersonalNotes,
                        onChange: _this3.handleIncludePersonalNotesChange,
                        inline: true
                      },
                      _this3.state.labels.thisClass.includePersonalNotes
                    )
                  )
                ),
                _react2.default.createElement(
                  _reactBootstrap.Row,
                  null,
                  _react2.default.createElement(
                    _reactBootstrap.Col,
                    { className: 'App-Info-Row', xs: 12, md: 12 },
                    _react2.default.createElement(
                      _reactBootstrap.Checkbox,
                      {
                        checked: _this3.state.includeAdviceNotes,
                        onChange: _this3.handleIncludeAdviceNotesChange,
                        inline: true
                      },
                      _this3.state.labels.thisClass.includeAdviceNotes
                    )
                  )
                )
              ),
              _react2.default.createElement(
                _reactBootstrap.Row,
                { className: 'App-Info-Row' },
                _react2.default.createElement(
                  _reactBootstrap.Button,
                  {
                    type: 'submit',
                    bsStyle: 'primary',
                    onClick: _this3.handleDownloadRequest
                  },
                  _this3.state.labels.buttons.createFiles
                )
              ),
              _this3.getDownloadLinks()
            )
          ),
          _this3.getWorkflowPanel()
        )
      )
    );
  };

  this.handleEditorChange = function (event) {
    _this3.setState({
      editorValue: event.target.value
    }, _this3.submitDisabled);
    if (_this3.props.onChange) {
      _this3.props.onChange(event.target.value);
    }
  };

  this.notifyParentValueChanged = function () {
    if (_this3.props.onSubmit && _this3.state.message === _this3.state.labels.messages.updated) {
      _this3.props.onSubmit(_this3.state.editorValue);
    }
  };

  this.handleValueUpdateCallback = function (restCallResult) {
    if (restCallResult) {
      var message = restCallResult.message;
      if (message === "OK") {
        message = _this3.state.labels.messages.updated;
      }
      _this3.setState({
        message: message,
        messageIcon: restCallResult.messageIcon
      }, _this3.notifyParentValueChanged);
    }
  };

  this.handleSubmit = function (event) {
    _this3.setState({
      message: _this3.state.labels.messages.updating,
      messageIcon: _this3.messageIcons.info
    });
    var parms = "i=" + encodeURIComponent(_this3.props.idLibrary + "~" + _this3.props.idTopic + "~" + _this3.props.idKey) + "&t=" + encodeURIComponent("Liturgical");
    _Server2.default.putValue(_this3.props.session.restServer, _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, {
      value: _this3.state.editorValue,
      seq: undefined,
      status: _this3.state.workflow.status,
      visibility: _this3.state.workflow.visibility
    }, parms, _this3.handleValueUpdateCallback);
  };

  this.getParaRows = function () {
    if (_this3.state.showSearchResults) {
      return _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          _this3.state.labels.thisClass.showingMatchesFor + " " + _this3.props.idTopic + "~" + _this3.props.idKey
        ),
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          _react2.default.createElement(
            _reactBootstrapTable.BootstrapTable,
            {
              data: _this3.state.data.values,
              trClassName: "App-data-tr",
              striped: true,
              hover: true,
              pagination: true,
              options: _this3.state.options
            },
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                isKey: true,
                dataField: 'id',
                dataSort: true,
                hidden: true
              },
              'ID'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'library',
                dataSort: true,
                width: _this3.state.idColumnSize },
              'Domain'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'value',
                dataSort: true
              },
              'Value'
            )
          )
        )
      );
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.retrieving });
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ParaRowTextEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  docType: _propTypes2.default.string.isRequired,
  idLibrary: _propTypes2.default.string.isRequired,
  idTopic: _propTypes2.default.string.isRequired,
  idKey: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.string.isRequired,
  canChange: _propTypes2.default.bool.isRequired,
  canReview: _propTypes2.default.bool,
  onSubmit: _propTypes2.default.func,
  onChange: _propTypes2.default.func
} : void 0;
exports.default = ParaRowTextEditor;