'use strict';

exports.__esModule = true;
exports.PublicationsLister = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapDatePicker = require('react-bootstrap-date-picker');

var _reactBootstrapDatePicker2 = _interopRequireDefault(_reactBootstrapDatePicker);

var _ReactSelector = require('./modules/ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _Spinner = require('./helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _reactBootstrapTable = require('react-bootstrap-table');

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PublicationsLister = exports.PublicationsLister = (_temp = _class = function (_React$Component) {
  _inherits(PublicationsLister, _React$Component);

  function PublicationsLister(props) {
    _classCallCheck(this, PublicationsLister);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.fetchData = _this.fetchData.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.getTable = _this.getTable.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    _this.applyFilters = _this.applyFilters.bind(_this);
    _this.handleDateChange = _this.handleDateChange.bind(_this);
    _this.onlyUnique = _this.onlyUnique.bind(_this);
    _this.getFilterRows = _this.getFilterRows.bind(_this);
    _this.handleTitleChange = _this.handleTitleChange.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    _this.updateDimensions = _this.updateDimensions.bind(_this);
    _this.getTypeRow = _this.getTypeRow.bind(_this);
    _this.getDateRow = _this.getDateRow.bind(_this);
    _this.handleAnyDateChange = _this.handleAnyDateChange.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  PublicationsLister.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  PublicationsLister.prototype.fetchData = function fetchData() {
    this.setState({
      message: this.state.labels.search.msg2,
      messageIcon: this.messageIcons.info,
      showSearchResults: false
    });

    _Server2.default.restGetPublications(this.props.session.restServer, this.handleSearchCallback);
  };

  PublicationsLister.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-pub-list' },
      this.getContent()
    );
  };

  return PublicationsLister;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {
    if (_this2.props.session) {
      _this2.fetchData();
    }
  };

  this.componentDidMount = function () {
    window.addEventListener("resize", _this2.updateDimensions);
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state.docType), _this2.fetchData);
  };

  this.setTheState = function (props, docType) {

    var hideBasedOnWidth = false;
    var innerWidth = window.innerWidth;
    if (innerWidth < 1024) {
      hideBasedOnWidth = true;
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var theSearchLabels = labels[labelTopics.SearchGeneric];

    return {
      labels: {
        resultsTableLabels: labels[labelTopics.resultsTable],
        messages: labels[labelTopics.messages],
        search: theSearchLabels,
        thisClass: labels[labelTopics.publications]
      },
      message: theSearchLabels.msg1,
      filterMessage: theSearchLabels.msg5,
      selectMessage: theSearchLabels.msg6,
      resultCount: 0,
      innerWidth: innerWidth,
      hideBasedOnWidth: hideBasedOnWidth,
      data: (0, _lodash.get)(_this2.state, "data", { values: [{ "who": "", "when:": "", "what:": "" }] }),
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      filter: { type: 'RegexFilter', delay: 100 },
      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      showSelectionButtons: false,
      selectedDate: (0, _lodash.get)(_this2.state, "selectedDate", (0, _moment2.default)().utc().format('YYYY-MM-DD')),
      selectedFormattedDate: (0, _lodash.get)(_this2.state, "selectedFormattedDate", (0, _moment2.default)().utc().format('YYYY/MM/DD')),
      selectedId: (0, _lodash.get)(_this2.state, "selectedId", ""),
      selectedFromDate: (0, _moment2.default)().utc().subtract(7, "days").format('YYYY-MM-DD'),
      selectedToDate: (0, _moment2.default)().utc().add(1, "days").format('YYYY-MM-DD'),
      selectedTitle: (0, _lodash.get)(_this2.state, "selectedTitle", ""),
      showModalEditor: false,
      idColumnSize: "80px",
      title: "Activity for the last 7 days as of ",
      lastSearchTime: "",
      searchCount: ""
    };
  };

  this.updateDimensions = function () {
    var hideBasedOnWidth = false;
    var innerWidth = window.innerWidth;
    if (innerWidth < 1024) {
      hideBasedOnWidth = true;
    }
    _this2.setState({ innerWidth: innerWidth, hideBasedOnWidth: hideBasedOnWidth });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    var url = row["url"];
    window.open(url, '_blank');
  };

  this.applyFilters = function () {
    _this2.refs.theBookTable.handleFilterData({
      date: { type: 'TextFilter', value: [_this2.state.selectedFormattedDate] },
      title: { type: 'TextFilter', value: [_this2.state.selectedTitle] }
    });
  };

  this.handleDateChange = function (value, formattedValue) {
    _this2.setState({
      selectedDate: value, // ISO String, ex: "2016-11-19T12:00:00.000Z"
      selectedFormattedDate: formattedValue // Formatted String, ex: "11/19/2016"
    }, _this2.applyFilters);
  };

  this.getSearchForm = function () {
    return _react2.default.createElement(
      'div',
      null,
      'Search Form goes here'
    );
  };

  this.onlyUnique = function (value, index, self) {
    return self.indexOf(value) === index;
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.handleSearchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      _this2.setState({
        data: restCallResult.data.values[0]["rowData"],
        titleData: restCallResult.data.values[1]["titleData"].items
      });
      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (restCallResult.data.valueCount) {
        resultCount = restCallResult.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.search.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }
  };

  this.handleAnyDateChange = function (evt) {
    var selectedFormattedDate = "any";
    var checked = evt.target.checked;
    if (checked) {} else {}
    _this2.setState({ anyDate: checked });
  };

  this.getTable = function () {
    if (_this2.state.showSearchResults && _this2.state.data) {
      return _react2.default.createElement(
        _reactBootstrapTable.BootstrapTable,
        {
          ref: 'theBookTable',
          data: _this2.state.data,
          exportCSV: false,
          trClassName: "App-data-tr",
          striped: true,
          hover: true,
          pagination: true,
          options: _this2.state.options,
          selectRow: _this2.state.selectRow
        },
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'url',
            isKey: true,
            hidden: true
          },
          'URL'
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'title',
            dataSort: true,
            filter: _this2.state.filter
          },
          _this2.state.labels.resultsTableLabels.headerTitle
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'date',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerDate
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'languageCodes',
            dataSort: true,
            filter: _this2.state.filter
          },
          _this2.state.labels.resultsTableLabels.headerLanguage
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'language',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerLanguage
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'region',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerRegion
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'countryCode',
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          'Country Code'
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'country',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerCountry
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'publisher',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerPublisher
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'filetype',
            dataSort: true,
            filter: _this2.state.filter,
            hidden: _this2.state.hideBasedOnWidth
          },
          _this2.state.labels.resultsTableLabels.headerFileType
        )
      );
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this2.state.labels.messages.retrieving });
    }
  };

  this.handleTitleChange = function (selection) {
    var title = selection["value"];
    if (title === "any") {
      title = "";
    }
    _this2.setState({
      selectedTitle: title
    }, _this2.applyFilters);
  };

  this.getDateRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Pub-Date-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Pub-Date-Selector" },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            { className: 'resourceSelectorPrompt' },
            _this2.state.labels.resultsTableLabels.headerDate
          ),
          _react2.default.createElement(_reactBootstrapDatePicker2.default, {
            id: 'app-datepicker',
            value: _this2.state.selectedDate,
            onChange: _this2.handleDateChange,
            dateFormat: "YYYY/MM/DD"
          }),
          _react2.default.createElement(
            _reactBootstrap.Checkbox,
            { checked: true, readOnly: true },
            'Checkbox'
          )
        )
      )
    );
  };

  this.getTypeRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Bibliography-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Bibliography-Type-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.state.labels.resultsTableLabels.headerTitle,
            initialValue: _this2.state.selectedTitle,
            resources: _this2.state.titleData,
            changeHandler: _this2.handleTitleChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getFilterRows = function () {
    return _react2.default.createElement(
      'div',
      { className: 'container App-search-options-container' },
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.Grid,
          null,
          _this2.getDateRow(),
          _this2.getTypeRow()
        )
      )
    );
  };

  this.getContent = function () {
    if (_this2.state.showSearchResults && _this2.state.data) {
      return _react2.default.createElement(
        'div',
        null,
        _this2.getFilterRows(),
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _this2.getTable()
        )
      );
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this2.state.labels.messages.retrieving });
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? PublicationsLister.propTypes = {
  session: _propTypes2.default.object.isRequired
} : void 0;

PublicationsLister.defaultProps = {};

exports.default = PublicationsLister;