'use strict';

exports.__esModule = true;
exports.SearchRelationships = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _LinkSearchOptions = require('./modules/LinkSearchOptions');

var _LinkSearchOptions2 = _interopRequireDefault(_LinkSearchOptions);

var _ModalSchemaBasedEditor = require('./modules/ModalSchemaBasedEditor');

var _ModalSchemaBasedEditor2 = _interopRequireDefault(_ModalSchemaBasedEditor);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchRelationships = exports.SearchRelationships = (_temp = _class = function (_React$Component) {
  _inherits(SearchRelationships, _React$Component);

  function SearchRelationships(props) {
    var _labels;

    _classCallCheck(this, SearchRelationships);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    var searchLabels = labels[labelTopics.searchLinks];
    _this.state = {
      labels: (_labels = {
        references: labels[labelTopics.ViewReferences],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      }, _labels['messages'] = labels[labelTopics.messages], _labels.searchLabels = searchLabels, _labels),
      domain: "*",

      query: "",

      matcher: "c",

      matcherTypes: [{ label: searchLabels.matchesAnywhere, value: "c" }, { label: searchLabels.matchesAtTheStart, value: "sw" }, { label: searchLabels.matchesAtTheEnd, value: "ew" }, { label: searchLabels.matchesRegEx, value: "rx" }],

      suggestedQuery: "",

      propertyTypes: [{ label: "ID", value: "id" }, { label: "Value (insensitive)", value: "nnp" }, { label: "Value (sensitive)", value: "value" }],

      docPropMessage: "",

      docPropMessageById: "Search By ID searches the ID of the docs, with the parts domain~topic~key, e.g. gr_gr_cog~actors~Priest.",

      docPropMessageByValue: "Search By Value is insensitive to accents, case, and punctuation.",

      docPropMessageByValueSensitive: "Search By Value (sensitive) is sensitive to accents, case, and punctuation.",

      searchFormToggle: _this.messageIcons.toggleOff,

      showSearchForm: true,

      filterMessage: searchLabels.msg5,

      selectMessage: searchLabels.msg6,

      searchFormType: "simple",
      showSearchResults: false,
      showIdPartSelector: true,
      resultCount: 0,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true,
        onExportToCSV: _this.onExportToCSV
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select"
      },

      showSelectionButtons: false,
      selectedId: "",
      selectedLibrary: "",
      selectedTopic: "",
      selectedKey: "",
      selectedFromId: "",
      selectedFromValue: "",
      selectedToId: "",
      selectedToValue: "",
      title: "",
      showModalCompareDocs: false,
      idColumnSize: "80px"
    };
    _this.fetchData = _this.fetchData.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleAdvancedSearchSubmit = _this.handleAdvancedSearchSubmit.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.handleCancelRequest = _this.handleCancelRequest.bind(_this);
    _this.handleDoneRequest = _this.handleDoneRequest.bind(_this);
    _this.getSelectedDocOptions = _this.getSelectedDocOptions.bind(_this);
    _this.showRowComparison = _this.showRowComparison.bind(_this);
    _this.getDocComparison = _this.getDocComparison.bind(_this);
    _this.handleCloseDocComparison = _this.handleCloseDocComparison.bind(_this);
    _this.getMatcherTypes = _this.getMatcherTypes.bind(_this);
    _this.deselectAllRows = _this.deselectAllRows.bind(_this);
    _this.onExportToCSV = _this.onExportToCSV.bind(_this);
    return _this;
  }

  SearchRelationships.prototype.getSearchForm = function getSearchForm() {
    return _react2.default.createElement(
      'div',
      null,
      this.state.dropdowns ? _react2.default.createElement(_LinkSearchOptions2.default, {
        types: this.state.dropdowns.linkTypes,
        libraries: this.state.dropdowns.linkTypeLibraries,
        properties: this.state.dropdowns.linkTypeProps,
        matchers: this.getMatcherTypes(),
        tags: this.state.dropdowns.linkTypeTags,
        tagOperators: this.state.dropdowns.linkTagOperators,
        handleSubmit: this.handleAdvancedSearchSubmit,
        labels: this.state.labels.searchLabels
      }) : "Loading dropdowns for search..."
    );
  };

  SearchRelationships.prototype.getMatcherTypes = function getMatcherTypes() {
    return [{ label: this.state.labels.searchLabels.matchesAnywhere, value: "c" }, { label: this.state.labels.searchLabels.matchesAtTheStart, value: "sw" }, { label: this.state.labels.searchLabels.matchesAtTheEnd, value: "ew" }, { label: this.state.labels.searchLabels.matchesRegEx, value: "rx" }];
  };

  SearchRelationships.prototype.handleCancelRequest = function handleCancelRequest() {
    if (this.props.callback) {
      this.props.callback("", "");
    }
  };

  SearchRelationships.prototype.handleDoneRequest = function handleDoneRequest() {
    if (this.props.callback) {
      this.props.callback(this.state.selectedId, this.state.selectedValue);
    }
  };

  SearchRelationships.prototype.getSelectedDocOptions = function getSelectedDocOptions() {
    return _react2.default.createElement(
      _reactBootstrap.Panel,
      null,
      _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.searchLabels.selectedDoc
        ),
        _react2.default.createElement(_reactBootstrap.FormControl, {
          type: 'text',
          value: this.state.selectedId,
          disabled: true
        }),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.searchLabels.selectedDoc
        ),
        _react2.default.createElement(_reactBootstrap.FormControl, {
          type: 'text',
          value: this.state.selectedValue,
          disabled: true
        }),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ButtonGroup,
            { bsSize: 'xsmall' },
            _react2.default.createElement(
              _reactBootstrap.Button,
              { onClick: this.handleCancelRequest },
              'Cancel'
            ),
            _react2.default.createElement(
              _reactBootstrap.Button,
              { onClick: this.handleDoneRequest },
              'Done'
            )
          )
        )
      )
    );
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  SearchRelationships.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  SearchRelationships.prototype.fetchData = function fetchData(event) {
    var _this2 = this;

    this.setState({
      message: this.state.labels.searchLabels.msg2,
      messageIcon: this.messageIcons.info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.state.docType) + "&d=" + encodeURIComponent(this.state.domain) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher) + "&l=" + encodeURIComponent(this.state.tags) + "&o=" + encodeURIComponent(this.state.tagOperator);
    var path = this.props.session.restServer + _Server2.default.getDbServerLinksApi() + parms;
    _axios2.default.get(path, config).then(function (response) {
      var resultCount = 0;
      var message = _this2.state.labels.searchLabels.foundNone;
      var found = _this2.state.labels.searchLabels.foundMany;
      if (response.data.valueCount) {
        resultCount = response.data.valueCount;
        if (resultCount === 0) {
          message = _this2.state.labels.searchLabels.foundNone;
        } else if (resultCount === 1) {
          message = _this2.state.labels.searchLabels.foundOne;
        } else {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        data: response.data,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.searchLabels.foundNone;
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  SearchRelationships.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-page App-search' },
      _react2.default.createElement(
        'h3',
        null,
        this.state.labels.searchLabels.pageTitle
      ),
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      _react2.default.createElement(
        'div',
        { className: 'App-search-form' },
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            this.getSearchForm()
          )
        )
      ),
      _react2.default.createElement(
        'div',
        null,
        this.state.labels.searchLabels.resultLabel,
        ': ',
        _react2.default.createElement(
          'span',
          { className: 'App App-message' },
          _react2.default.createElement(_reactFontawesome2.default, {
            name: this.state.messageIcon }),
          this.state.message,
          ' '
        )
      ),
      this.state.showSearchResults && _react2.default.createElement(
        'div',
        null,
        this.state.labels.searchLabels.msg5,
        ' ',
        this.state.labels.searchLabels.msg6
      ),
      this.state.showModalCompareDocs && this.getDocComparison(),
      this.state.showSearchResults && _react2.default.createElement(
        'div',
        { className: 'App-search-results' },
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            _reactBootstrapTable.BootstrapTable,
            {
              ref: 'theTable',
              data: this.state.data.values,
              exportCSV: false,
              trClassName: "App-data-tr",
              search: true,
              searchPlaceholder: this.state.labels.resultsTableLabels.filterPrompt,
              striped: true,
              hover: true,
              pagination: true,
              options: this.state.options,
              selectRow: this.state.selectRow
            },
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                isKey: true,
                dataField: 'id',
                dataSort: true,
                'export': true,
                hidden: true
              },
              'ID'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'library',
                dataSort: true,
                'export': false,
                tdClassname: 'tdDomain',
                width: "10%"
              },
              this.state.labels.resultsTableLabels.headerDomain
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'fromId',
                dataSort: true,
                'export': false
              },
              this.state.labels.resultsTableLabels.headerFromId
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'type',
                dataSort: true
              },
              this.state.labels.resultsTableLabels.headerType
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'toId',
                'export': false,
                dataSort: true
              },
              this.state.labels.resultsTableLabels.headerToId
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'tags',
                'export': false,
                dataSort: true
              },
              this.state.labels.resultsTableLabels.headerTags
            )
          )
        )
      )
    );
  };

  return SearchRelationships;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    var showSelectionButtons = false;
    if (_this3.props.callback) {
      showSelectionButtons = true;
    }
    _this3.setState({
      message: _this3.state.labels.searchLabels.msg1,
      messageIcon: _this3.messageIcons.info,
      docPropMessage: _this3.state.docPropMessageByValue,
      showSelectionButtons: showSelectionButtons
    });
    var config = {
      auth: {
        username: _this3.props.session.userInfo.username,
        password: _this3.props.session.userInfo.password
      }
    };
    var path = _this3.props.session.restServer + _Server2.default.getDbServerDropdownsSearchRelationshipsApi();
    _axios2.default.get(path, config).then(function (response) {
      // literals used as keys to get data from the response
      var valueKey = "dropdown";
      var listKey = "typeList";
      var libsKey = "typeLibraries";
      var propsKey = "typeProps";
      var tagsKey = "typeTags";
      var tagOperatorsKey = "tagOperators";

      var values = response.data.values[0][valueKey];
      _this3.setState({
        dropdowns: {
          linkTypes: values[listKey],
          linkTypeLibraries: values[libsKey],
          linkTypeProps: values[propsKey],
          linkTypeTags: values[tagsKey],
          linkTagOperators: values[tagOperatorsKey],
          loaded: true
        }
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this3.messageIcons.error;
      if (error && error.response && error.response.status === 401) {
        message = _Server2.default.getWsServerDbApi() + " is a protected database.  Please login and try again.";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.response && error.response.status === 404) {
        message = "error retrieving values for dropdowns";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.message && error.message.toLowerCase() === "network error") {
        message = "The database server " + _Server2.default.getWsServerDbApi() + " is not available.";
        messageIcon = _this3.messageIcons.error;
      }
      _this3.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    var _labels2;

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    var searchLabels = labels[labelTopics.searchLinks];

    _this3.setState({
      labels: (_labels2 = {
        references: labels[labelTopics.ViewReferences],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      }, _labels2['messages'] = labels[labelTopics.messages], _labels2.searchLabels = searchLabels, _labels2)
    });
  };

  this.deselectAllRows = function () {
    _this3.refs.theTable.setState({
      selectedRowKeys: []
    });
  };

  this.handleAdvancedSearchSubmit = function (type, domain, property, matcher, value, tagOperator, tags) {
    _this3.setState({
      docType: type,
      domain: domain,
      docProp: property,
      matcher: matcher,
      query: value,
      tagOperator: tagOperator,
      tags: tags
    }, function () {
      this.fetchData();
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    _this3.setState({
      selectedId: row["library"] + "~" + row["fromId"] + "~" + row["toId"],
      selectedLibrary: row["library"],
      selectedTopic: row["fromId"],
      selectedKey: row["toId"],
      title: row["fromId"] + " " + row["type"] + " " + row["toId"],
      showIdPartSelector: true,
      showModalCompareDocs: true,
      selectedFromId: row["fromId"],
      selectedFromValue: row["fromValue"],
      selectedToId: row["toId"],
      selectedToValue: row["toValue"]
    });
  };

  this.showRowComparison = function (id) {
    _this3.setState({
      showModalCompareDocs: true,
      selectedId: id
    });
  };

  this.handleCloseDocComparison = function (id, value) {
    if (id && id.length > 0) {
      _this3.setState({
        showModalCompareDocs: false,
        selectedId: id,
        selectedValue: value
      });
    } else {
      _this3.setState({
        showModalCompareDocs: false
      });
    }
    _this3.deselectAllRows();
  };

  this.getDocComparison = function () {
    return _react2.default.createElement(_ModalSchemaBasedEditor2.default, {
      session: _this3.props.session,
      restPath: _Server2.default.getDbServerLinksApi(),
      showModal: _this3.state.showModalCompareDocs,
      title: _this3.state.labels.references.textualReference,
      idLibrary: _this3.state.selectedLibrary,
      idTopic: _this3.state.selectedTopic,
      idKey: _this3.state.selectedKey,
      fromId: _this3.state.selectedFromId,
      fromText: _this3.state.selectedFromValue,
      toId: _this3.state.selectedToId,
      toText: _this3.state.selectedToValue,
      fromTitle: _this3.state.labels.references.theText,
      toTitle: _this3.state.labels.references.refersTo,
      onClose: _this3.handleCloseDocComparison,
      searchLabels: _this3.state.labels.searchLabels
    });
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this3.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle",
    toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };
  this.searchFormTypes = {
    simple: "simple",
    advanced: "advanced",
    idPattern: "id"
  };

  this.onExportToCSV = function (row) {
    return _this3.state.data.values;
  };
}, _temp);


process.env.NODE_ENV !== "production" ? SearchRelationships.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func
} : void 0;

exports.default = SearchRelationships;