'use strict';

exports.__esModule = true;
exports.Search = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _SearchOptionsAdvanced = require('./modules/SearchOptionsAdvanced');

var _SearchOptionsAdvanced2 = _interopRequireDefault(_SearchOptionsAdvanced);

var _SearchOptionsSimple = require('./modules/SearchOptionsSimple');

var _SearchOptionsSimple2 = _interopRequireDefault(_SearchOptionsSimple);

var _SearchTextResultsTable = require('./modules/SearchTextResultsTable');

var _SearchTextResultsTable2 = _interopRequireDefault(_SearchTextResultsTable);

var _ModalCompareDocs = require('./modules/ModalCompareDocs');

var _ModalCompareDocs2 = _interopRequireDefault(_ModalCompareDocs);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _Spinner = require('./helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _ModalParaRowEditor = require('./ModalParaRowEditor');

var _ModalParaRowEditor2 = _interopRequireDefault(_ModalParaRowEditor);

var _IdManager = require('./helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Search = exports.Search = (_temp = _class = function (_React$Component) {
  _inherits(Search, _React$Component);

  function Search(props) {
    _classCallCheck(this, Search);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    var search = labels[labelTopics.search];
    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ParaTextEditor],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTable: labels[labelTopics.resultsTable],
        search: search
      },
      docType: _this.props.initialDocType,
      docTypes: [{ label: "All", value: "all" }, { label: "Biblical", value: "Biblical" }, { label: "Liturgical", value: "Liturgical" }],

      domain: "*",

      selectedBook: "*",

      selectedChapter: "*",

      query: "",

      matcher: "c",

      matcherTypes: [{ label: search.matchesAnywhere, value: "c" }, { label: search.matchesAtTheStart, value: "sw" }, { label: search.matchesAtTheEnd, value: "ew" }, { label: search.matchesRegEx, value: "rx" }],

      suggestedQuery: "",

      docProp: "nnp",

      propertyTypes: [{ label: "ID", value: "id" }, { label: "Value (insensitive)", value: "nnp" }, { label: "Value (sensitive)", value: "value" }],

      docPropMessage: "",

      docPropMessageById: "Search By ID searches the ID of the docs, with the parts domain~topic~key, e.g. gr_gr_cog~actors~Priest.",

      docPropMessageByValue: "Search By Value is insensitive to accents, case, and punctuation.",

      docPropMessageByValueSensitive: "Search By Value (sensitive) is sensitive to accents, case, and punctuation.",

      searchFormToggle: _this.messageIcons.toggleOff,

      showSearchForm: true,

      filterMessage: search.msg5,

      selectMessage: search.msg6,

      searchFormType: "simple",

      showSearchResults: false,

      fetchingData: false,

      resultCount: 0,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select"
      },

      showSelectionButtons: false,

      selectedId: "",

      selectedIdPartsPrompt: "Select one or more ID parts, then click on the search icon:",

      selectedIdParts: [{ key: "domain", label: "" }, { key: "topic", label: "" }, { key: "key", label: "" }],
      showIdPartSelector: false,
      selectedValue: "",
      selectedSeq: "",
      showModalWindow: false,
      idColumnSize: "80px"
    };
    _this.deselectAllRows = _this.deselectAllRows.bind(_this);
    _this.editable = _this.editable.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getBars = _this.getBars.bind(_this);
    _this.getDocComparison = _this.getDocComparison.bind(_this);
    _this.getDocTypes = _this.getDocTypes.bind(_this);
    _this.getMatcherTypes = _this.getMatcherTypes.bind(_this);
    _this.getSearchAccordion = _this.getSearchAccordion.bind(_this);
    _this.getSearchForm = _this.getSearchForm.bind(_this);
    _this.getSelectedDocOptions = _this.getSelectedDocOptions.bind(_this);
    _this.getTableIndex = _this.getTableIndex.bind(_this);
    _this.handleAdvancedSearchSubmit = _this.handleAdvancedSearchSubmit.bind(_this);
    _this.handleCancelRequest = _this.handleCancelRequest.bind(_this);
    _this.handleCloseDocComparison = _this.handleCloseDocComparison.bind(_this);
    _this.handleDoneRequest = _this.handleDoneRequest.bind(_this);
    _this.handleEditorClose = _this.handleEditorClose.bind(_this);
    _this.handleIdQuerySelection = _this.handleIdQuerySelection.bind(_this);
    _this.handleParaTextEditorSubmit = _this.handleParaTextEditorSubmit.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.handleSearchFormTypeChange = _this.handleSearchFormTypeChange.bind(_this);
    _this.handleSimpleSearchSubmit = _this.handleSimpleSearchSubmit.bind(_this);
    _this.handleValueUpdateCallback = _this.handleValueUpdateCallback.bind(_this);
    _this.onRowClick = _this.onRowClick.bind(_this);
    _this.onRowDoubleClick = _this.onRowDoubleClick.bind(_this);
    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.searchFormOptionIcons = _this.searchFormOptionIcons.bind(_this);
    _this.showResultsStatus = _this.showResultsStatus.bind(_this);
    _this.showRowComparison = _this.showRowComparison.bind(_this);
    _this.showSelectionButtons = _this.showSelectionButtons.bind(_this);
    _this.toggleSearchForm = _this.toggleSearchForm.bind(_this);
    _this.toogleIdPattern = _this.toogleIdPattern.bind(_this);
    return _this;
  }

  Search.prototype.login = function login(loginRequired) {
    if (loginRequired) {
      this.props.router.replace('/login');
    }
  };

  /**
   * Does the user have permission to edit records in this library?
   * @param library
   * @returns {boolean}
   */


  Search.prototype.searchFormOptionIcons = function searchFormOptionIcons() {
    return _react2.default.createElement(
      'div',
      null,
      'Search Type:',
      _react2.default.createElement(
        'span',
        { className: 'App-search-options' },
        _react2.default.createElement(
          'label',
          {
            id: this.searchFormTypes.simple,
            className: 'App-search-form-option-label control-label',
            onClick: this.handleSearchFormTypeChange },
          _react2.default.createElement(_reactFontawesome2.default, {
            id: this.searchFormTypes.simple,
            onClick: this.handleSearchFormTypeChange,
            name: this.messageIcons.simpleSearch
          }),
          'Simple'
        ),
        _react2.default.createElement(
          'label',
          {
            id: this.searchFormTypes.advanced,
            onClick: this.handleSearchFormTypeChange,
            className: 'App-search-form-option-label control-label' },
          _react2.default.createElement(_reactFontawesome2.default, {
            id: this.searchFormTypes.advanced,
            onClick: this.handleSearchFormTypeChange,
            name: this.messageIcons.advancedSearch
          }),
          'Advanced'
        )
      )
    );
  };

  Search.prototype.handleSearchFormTypeChange = function handleSearchFormTypeChange(event) {
    switch (event.target.id) {
      case this.searchFormTypes.simple:
        {
          this.setState({
            searchFormType: this.searchFormTypes.simple
          });
          break;
        }
      case this.searchFormTypes.advanced:
        {
          this.setState({
            searchFormType: this.searchFormTypes.advanced
          });
          break;
        }
      case this.searchFormTypes.idPattern:
        {
          this.setState({
            searchFormType: this.searchFormTypes.idPattern
          });
          break;
        }
      default:
        {
          break;
        }
    }
  };

  Search.prototype.toogleIdPattern = function toogleIdPattern(id) {
    if (id.length > 0) {
      return this.formOptionStyles.visible;
    } else {
      return this.formOptionStyles.hidden;
    }
  };

  Search.prototype.getSearchAccordion = function getSearchAccordion(type) {
    if (this.props.callback) {
      return _react2.default.createElement(
        _reactBootstrap.Panel,
        { className: 'App-search-panel', header: this.state.labels.search.advanced, eventKey: '2' },
        this.state.dropdowns ? _react2.default.createElement(_SearchOptionsAdvanced2.default, {

          docType: this.state.docType,
          docTypes: this.state.docTypes,
          dropDowns: this.state.dropdowns,
          properties: this.state.propertyTypes,
          matchers: this.getMatcherTypes(),
          handleSubmit: this.handleAdvancedSearchSubmit,
          labels: this.state.labels.search
        }) : "Loading dropdowns for advanced search..."
      );
    } else {
      return _react2.default.createElement(
        _reactBootstrap.PanelGroup,
        { defaultActiveKey: '1', accordion: true },
        _react2.default.createElement(
          _reactBootstrap.Panel,
          { className: 'App-search-panel', header: this.state.labels.search.simple, eventKey: '1' },
          _react2.default.createElement(_SearchOptionsSimple2.default, {
            valueTitle: '',
            buttonLabel: this.state.labels.search.submit,
            placeholder: this.state.labels.search.prompt,
            handleSubmit: this.handleSimpleSearchSubmit
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Panel,
          { className: 'App-search-panel', header: this.state.labels.search.advanced, eventKey: '2' },
          this.state.dropdowns ? _react2.default.createElement(_SearchOptionsAdvanced2.default, {
            docType: this.props.initialDocType,
            docTypes: this.state.docTypes,
            dropDowns: this.state.dropdowns,
            properties: this.state.propertyTypes,
            matchers: this.getMatcherTypes(),
            handleSubmit: this.handleAdvancedSearchSubmit,
            labels: this.state.labels.search
          }) : "Loading dropdowns for advanced search..."
        )
      );
    }
  };

  Search.prototype.getSearchForm = function getSearchForm(type) {
    switch (type) {
      case this.searchFormTypes.advanced:
        {
          return _react2.default.createElement(_SearchOptionsAdvanced2.default, {
            docType: this.props.initialDocType,
            docTypes: this.getDocTypes(),
            dropDowns: this.state.dropdowns,
            properties: this.state.propertyTypes,
            matchers: this.state.matcherTypes,
            handleSubmit: this.handleAdvancedSearchSubmit,
            labels: this.state.labels.search
          });
        }
      default:
        {
          return _react2.default.createElement(_SearchOptionsSimple2.default, {
            valueTitle: '',
            buttonLabel: this.state.labels.search.submit,
            placeholder: 'enter a word or phrase and press the search icon...',
            handleSubmit: this.handleSimpleSearchSubmit
          });
        }
    }
  };

  Search.prototype.getMatcherTypes = function getMatcherTypes() {
    return [{ label: this.state.labels.search.matchesAnywhere, value: "c" }, { label: this.state.labels.search.matchesAtTheStart, value: "sw" }, { label: this.state.labels.search.matchesAtTheEnd, value: "ew" }, { label: this.state.labels.search.matchesRegEx, value: "rx" }];
  };

  Search.prototype.handleCancelRequest = function handleCancelRequest() {
    if (this.props.callback) {
      this.props.callback("", "");
    }
  };

  Search.prototype.handleDoneRequest = function handleDoneRequest() {
    if (this.props.callback) {
      this.props.callback(this.state.selectedId, this.state.selectedValue, this.state.selectedSeq, this.state.selectedSchema);
    }
  };

  Search.prototype.getSelectedDocOptions = function getSelectedDocOptions() {
    return _react2.default.createElement(
      _reactBootstrap.Panel,
      null,
      _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.search.searchToSelectInstructions
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.search.selectedId
        ),
        _react2.default.createElement(_reactBootstrap.FormControl, {
          type: 'text',
          value: this.state.selectedId,
          disabled: true
        }),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.search.selectedValue
        ),
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          this.state.selectedValue
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsSize: 'small',
              className: "Button-Cancel",
              onClick: this.handleCancelRequest },
            this.state.labels.buttons.cancel
          ),
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsSize: 'small',
              className: "Button-Select",
              bsStyle: 'primary',
              onClick: this.handleDoneRequest,
              disabled: this.state.selectedId.length < 1
            },
            this.state.labels.buttons.select
          )
        )
      )
    );
  };

  Search.prototype.handleIdQuerySelection = function handleIdQuerySelection(value) {
    this.setState({
      domain: "*",
      selectedBook: "*",
      selectedChapter: "*",
      docProp: "id",
      matcher: "rx",
      query: value
    }, this.fetchData);
  };

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  Search.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  Search.prototype.fetchData = function fetchData(event) {
    var _this2 = this;

    this.setState({
      message: this.state.labels.search.msg2,
      messageIcon: this.messageIcons.info,
      fetchingData: true
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.state.docType) + "&d=" + encodeURIComponent(this.state.domain) + "&b=" + encodeURIComponent(this.state.selectedBook) + "&c=" + encodeURIComponent(this.state.selectedChapter) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher) + "&l=" + encodeURIComponent(this.props.session.location);
    var path = this.props.session.restServer + _Server2.default.getWsServerDbApi() + 'docs' + parms;
    _axios2.default.get(path, config).then(function (response) {
      _this2.setState({
        data: response.data
      });
      var resultCount = 0;
      var message = _this2.state.labels.search.foundNone;
      var found = _this2.state.labels.search.foundMany;
      if (response.data.valueCount) {
        resultCount = response.data.valueCount;
        if (resultCount === 1) {
          message = _this2.state.labels.search.foundOne;
        } else if (resultCount > 1) {
          message = found + " " + resultCount + ".";
        }
      }

      _this2.setState({
        message: message,
        resultCount: resultCount,
        messageIcon: _this2.messageIcons.info,
        showSearchResults: true,
        fetchingData: false
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.search.foundNone;
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({
          data: message,
          message: message,
          messageIcon: messageIcon,
          fetchingData: false
        });
      }
    });
  };

  /**
   * If the type of doc is
   *  Liturgical
   * and selected selectedBook is
   *  eothinon
   *  menaion
   *  octoechos
   * then display the additional two dropdown boxes, e.g. for month and day
   *
   *  Biblical
   *  then display selectedChapter numbers <-- must vary based on selectedBook!
   *
   * TODO: in Java, query database for each domain and collect the possible values for each part of the topic.
   * @returns {XML}
   */

  //          <div>Search Form: <FontAwesome onClick={this.toggleSearchForm} name={this.state.searchFormToggle}/>{this.state.searchFormToggleMessage}</div>

  Search.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-search' },
      _react2.default.createElement(
        'h3',
        null,
        this.state.labels.search.pageTitle
      ),
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      _react2.default.createElement(
        'div',
        { className: 'App-search-form' },
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            this.getSearchAccordion(this.state.searchFormType)
          )
        )
      ),
      _react2.default.createElement(
        'div',
        null,
        this.state.labels.search.resultLabel,
        ': ',
        _react2.default.createElement(
          'span',
          { className: 'App App-message' },
          _react2.default.createElement(_reactFontawesome2.default, {
            name: this.state.messageIcon }),
          this.state.message,
          ' '
        )
      ),
      this.showResultsStatus(),
      this.state.showModalWindow && this.getDocComparison()
    );
  };

  return Search;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    var showSelectionButtons = false;
    if (_this3.props.callback) {
      showSelectionButtons = true;
    }
    _this3.setState({
      message: _this3.state.labels.search.msg1,
      messageIcon: _this3.messageIcons.info,
      docPropMessage: _this3.state.docPropMessageByValue,
      showSelectionButtons: showSelectionButtons
    });
    var config = {
      auth: {
        username: _this3.props.session.userInfo.username,
        password: _this3.props.session.userInfo.password
      }
    };
    var path = _this3.props.session.restServer + _Server2.default.getDbServerDropdownsSearchTextApi();
    _axios2.default.get(path, config).then(function (response) {
      var liturgicalDomains = response.data.values[1]["domains"];
      if (_this3.props && _this3.props.session && _this3.props.session.userInfo && _this3.props.session.userInfo.domains) {
        if (_this3.props.session.userInfo.domains.liturgicalSearch) {
          liturgicalDomains = _this3.props.session.userInfo.domains.liturgicalSearch;
        }
      }
      _this3.setState({
        dropdowns: {
          Biblical: {
            all: {
              books: response.data.values[0]["all"][0]["books"],
              chapters: response.data.values[0]["all"][0]["chapters"]
            },
            domains: response.data.values[0]["domains"],
            topics: response.data.values[0]["topics"]
          },
          Liturgical: {
            all: {
              books: response.data.values[1]["all"][0]["books"]
            },
            domains: liturgicalDomains,
            topics: response.data.values[1]["topics"]
          },
          loaded: true
        },
        domainInfo: response.data.values[2]
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this3.messageIcons.error;
      if (error && error.response && error.response.status === 401) {
        message = _Server2.default.getWsServerDbApi() + " is a protected database.  Please login and try again.";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.response && error.response.status === 404) {
        message = "error retrieving values for dropdowns";
        messageIcon = _this3.messageIcons.error;
      } else if (error && error.message && error.message.toLowerCase() === "network error") {
        message = "The database server " + _Server2.default.getWsServerDbApi() + " is not available.";
        messageIcon = _this3.messageIcons.error;
      }
      _this3.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    var dropdowns = {};
    var liturgicalDomains = [];
    if (_this3.state.dropdowns) {
      dropdowns = _this3.state.dropdowns;
    }
    if (dropdowns && dropdowns.Liturgical) {
      if (dropdowns.Liturgical.domains) {
        liturgicalDomains = dropdowns.Liturgical.domains;
      }
      if (nextProps && nextProps.session && nextProps.session.userInfo && nextProps.session.userInfo.domains) {
        if (nextProps.session.userInfo.domains.liturgicalSearch) {
          liturgicalDomains = nextProps.session.userInfo.domains.liturgicalSearch;
        }
      }
      dropdowns.Liturgical.domains = liturgicalDomains;
    }

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    var search = labels[labelTopics.search];

    _this3.setState({
      docType: nextProps.initialDocType,
      labels: {
        thisClass: labels[labelTopics.ParaTextEditor],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTable: labels[labelTopics.resultsTable],
        search: search
      },
      selectedId: "",
      selectedValue: "",
      selectedSeq: "",
      matcherTypes: [{ label: search.matchesAnywhere, value: "c" }, { label: search.matchesAtTheStart, value: "sw" }, { label: search.matchesAtTheEnd, value: "ew" }, { label: search.matchesRegEx, value: "rx" }],
      dropdowns: dropdowns
    });
  };

  this.getTableIndex = function (id) {
    var result = undefined;
    _this3.state.data.values.forEach(function (element, index) {
      if (element["id"] === id) {
        result = index;
        return true;
      }
    });
    return result;
  };

  this.handleParaTextEditorSubmit = function (value) {
    // only update if the value changed
    var data = _this3.state.data;
    var index = _this3.getTableIndex(_this3.state.selectedId);
    var currentValue = data.values[index].value;
    if (value !== currentValue) {
      // update the value held client-side in memory
      data.values[index].value = value;
      _this3.setState({
        data: data,
        showModalWindow: false
      });
      // now update the database via a rest call
      var parms = "i=" + encodeURIComponent(_this3.state.selectedId) + "&t=" + encodeURIComponent("Liturgical");
      _Server2.default.putValue(_this3.props.session.restServer, _this3.props.session.userInfo.username, _this3.props.session.userInfo.password, { value: value, seq: undefined }, parms, _this3.handleValueUpdateCallback);
    } else {
      _this3.setState({
        showModalWindow: false
      });
    }
  };

  this.handleValueUpdateCallback = function (restCallResult) {
    if (restCallResult) {
      _this3.setState({
        message: restCallResult.message,
        messageIcon: restCallResult.messageIcon
      }, _this3.setTableData);
    }
  };

  this.editable = function (id) {
    var canEdit = false;
    if (id) {
      var library = _IdManager2.default.getLibrary(id);
      for (var _iterator = _this3.props.session.userInfo.domains.author, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var entry = _ref;

        if (entry.value == library) {
          canEdit = true;
          break;
        }
      };
    }
    return canEdit;
  };

  this.toggleSearchForm = function () {
    var showing = _this3.state.searchFormType;
    var searchFormToggleIcon = void 0;
    var searchFormToggleMessage = void 0;

    if (showing) {
      searchFormToggleIcon = _this3.messageIcons.toggleOn;
      searchFormToggleMessage = _this3.state.advancedSearchMessage;
    } else {
      searchFormToggleIcon = _this3.messageIcons.toggleOff;
      searchFormToggleMessage = _this3.state.simpleSearchMessage;
    }
    _this3.setState({
      searchFormType: !showing,
      searchFormToggle: searchFormToggleIcon,
      searchFormToggleMessage: searchFormToggleMessage
    });
  };

  this.formOptionStyles = {
    hidden: { display: 'none' },
    visible: { display: 'inline' }
  };

  this.handleAdvancedSearchSubmit = function (type, domain, book, chapter, property, matcher, value, seq) {
    _this3.setState({
      docType: type,
      domain: domain,
      selectedBook: book,
      selectedChapter: chapter,
      docProp: property,
      matcher: matcher,
      query: value,
      selectedSeq: seq
    }, _this3.fetchData);
  };

  this.handleSimpleSearchSubmit = function (value) {
    _this3.setState({
      docType: "Liturgical",
      domain: "*",
      selectedBook: "*",
      selectedChapter: "*",
      docProp: "nnp",
      matcher: "c",
      query: value
    }, _this3.fetchData);
  };

  this.onRowClick = function (row) {};

  this.onRowDoubleClick = function (row) {};

  this.handleRowSelect = function (id, value, schemaId) {
    var idParts = id.split("~");
    _this3.setState({
      selectedId: id,
      selectedIdParts: [{ key: "domain", label: idParts[0] }, { key: "topic", label: idParts[1] }, { key: "key", label: idParts[2] }],
      selectedValue: value,
      selectedSchema: schemaId,
      showIdPartSelector: true,
      showModalWindow: true
    }, _this3.showRowComparison(id, value));
  };

  this.showRowComparison = function (id, value) {
    _this3.setState({
      showModalWindow: true,
      selectedId: id,
      selectedValue: value
    });
  };

  this.deselectAllRows = function () {
    if (_this3.refs && _this3.refs.theTable) {
      _this3.refs.theTable.setState({
        selectedRowKeys: []
      });
    }
  };

  this.handleCloseDocComparison = function (id, value, seq) {
    if (id && id.length > 0) {
      _this3.setState({
        showModalWindow: false,
        selectedId: id,
        selectedValue: value,
        selectedSeq: seq
      }, _this3.deselectAllRows);
    } else {
      _this3.setState({
        showModalWindow: false
      }, _this3.deselectAllRows);
    }
  };

  this.handleEditorClose = function (id, value, seq) {
    if (id && id.length > 0) {
      _this3.setState({
        showModalWindow: false,
        selectedId: id,
        selectedValue: value,
        selectedSeq: seq
      });
    } else {
      _this3.setState({
        showModalWindow: false
      });
    }
    _this3.deselectAllRows();
  };

  this.getDocTypes = function () {
    return [{ label: _this3.state.labels.search.typeAny, value: "all" }, { label: _this3.state.labels.search.biblical, value: "Biblical" }, { label: _this3.state.labels.search.liturgical, value: "Liturgical" }];
  };

  this.getDocComparison = function () {
    var debug = false;
    if (_this3.props.session.userInfo.authenticated && _this3.state.docType === "Liturgical" && !_this3.props.callback) {
      return _react2.default.createElement(_ModalParaRowEditor2.default, {
        session: _this3.props.session,
        editId: _this3.state.selectedId,
        value: _this3.state.selectedValue,
        showModal: _this3.state.showModalWindow,
        onClose: _this3.handleEditorClose,
        onSubmit: _this3.handleParaTextEditorSubmit,
        canChange: _this3.editable(_this3.state.selectedId)
      });
    } else {
      return _react2.default.createElement(_ModalCompareDocs2.default, {
        session: _this3.props.session,
        showModal: _this3.state.showModalWindow,
        title: _this3.state.selectedId,
        docType: _this3.state.docType,
        selectedIdParts: _this3.state.selectedIdParts,
        onClose: _this3.handleCloseDocComparison,
        labels: _this3.state.labels.search
      });
    }
  };

  this.showSelectionButtons = function (id) {
    _this3.setState({
      showSelectionButtons: true,
      selectedId: id
    });
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this3.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle"
    // , toggleOn: "eye"
    // , toggleOff: "eye-slash"
    , toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };
  this.searchFormTypes = {
    simple: "simple",
    advanced: "advanced",
    idPattern: "id"
  };

  this.getBars = function () {
    return _react2.default.createElement(
      'span',
      null,
      _react2.default.createElement(_reactFontawesome2.default, { name: 'bars' })
    );
  };

  this.showResultsStatus = function () {
    if (_this3.state.fetchingData) {
      return _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.retrieving });
    } else {
      if (_this3.state.showSearchResults) {
        return _react2.default.createElement(
          'div',
          null,
          _this3.state.labels.search.msg5,
          ' ',
          _this3.state.labels.search.msg6,
          _react2.default.createElement(_SearchTextResultsTable2.default, {
            session: _this3.props.session,
            data: _this3.state.data.values,
            callBack: _this3.handleRowSelect
          })
        );
      }
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? Search.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func,
  initialDocType: _propTypes2.default.string.isRequired,
  dropdowns: _propTypes2.default.object
} : void 0;

exports.default = Search;