'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _ModalSchemaBasedEditor = require('./modules/ModalSchemaBasedEditor');

var _ModalSchemaBasedEditor2 = _interopRequireDefault(_ModalSchemaBasedEditor);

var _ReactSelector = require('./modules/ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _SchemaBasedAddButton = require('./modules/SchemaBasedAddButton');

var _SchemaBasedAddButton2 = _interopRequireDefault(_SchemaBasedAddButton);

var _IdManager = require('./helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

var _MessageIcons = require('./helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _Server = require('./helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _Spinner = require('./helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _UiSchemas = require('./classes/UiSchemas');

var _UiSchemas2 = _interopRequireDefault(_UiSchemas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * For the prop ID, finds and displays all REFERS_TO relationships.
 * Provides a modal schema based editor for selected rows.
 */
var ViewReferences = (_temp = _class = function (_React$Component) {
  _inherits(ViewReferences, _React$Component);

  function ViewReferences(props) {
    _classCallCheck(this, ViewReferences);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var uiSchemas = {};
    if (props.session && props.session.uiSchemas) {
      uiSchemas = new _UiSchemas2.default(props.session.uiSchemas.formsDropdown, props.session.uiSchemas.formsSchemas, props.session.uiSchemas.forms);
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ViewReferences],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      session: {
        uiSchemas: uiSchemas
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      data: {},
      resultCount: 0,
      fetching: false,
      selectedDomain: "en_sys_ontology",
      showSearchResults: false,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true,
        onExportToCSV: _this.onExportToCSV
      },
      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select"
      }
    };

    _this.fetchDocData = _this.fetchDocData.bind(_this);
    _this.getModalEditor = _this.getModalEditor.bind(_this);
    _this.getTable = _this.getTable.bind(_this);
    _this.handleCloseModal = _this.handleCloseModal.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.onExportToCSV = _this.onExportToCSV.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleDomainChange = _this.handleDomainChange.bind(_this);
    _this.getSelector = _this.getSelector.bind(_this);
    _this.editable = _this.editable.bind(_this);
    _this.getEntityAddButton = _this.getEntityAddButton.bind(_this);
    _this.handleAddClose = _this.handleAddClose.bind(_this);
    _this.getTableColsForBiblicalReference = _this.getTableColsForBiblicalReference.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  // a property must be a table column (even if hidden)
  // and have export: { true } set


  ViewReferences.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-search' },
      _react2.default.createElement(
        'h3',
        null,
        this.state.labels.thisClass.pageTitle
      ),
      this.getSelector(),
      _react2.default.createElement(
        _reactBootstrap.ControlLabel,
        null,
        this.props.type === "*" ? this.state.labels.thisClass.ontologyRef : this.state.labels.thisClass.biblicalRef,
        ' ',
        this.state.labels.thisClass.panelTitle,
        ' ',
        this.props.id,
        ' ',
        this.state.labels.thisClass.library,
        ' ',
        this.state.selectedDomain
      ),
      _react2.default.createElement(
        'div',
        null,
        this.state.labels.messages.resultLabel,
        ': ',
        _react2.default.createElement(
          'span',
          { className: 'App App-message' },
          _react2.default.createElement(_reactFontawesome2.default, {
            name: this.state.messageIcon }),
          this.state.labels.messages.found,
          ' ',
          this.state.resultCount,
          ' ',
          this.state.labels.messages.docs,
          '  ',
          this.getEntityAddButton()
        )
      ),
      this.state.showSearchResults && _react2.default.createElement(
        _reactBootstrap.ControlLabel,
        null,
        this.state.labels.messages.filter,
        ' ',
        this.state.labels.messages.click
      ),
      this.state.showModalWindow && this.getModalEditor(),
      this.getTable()
    );
  };

  return ViewReferences;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    _this2.fetchDocData();
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(function (prevState, props) {
      var labels = nextProps.session.labels;
      var labelTopics = nextProps.session.labelTopics;
      return {
        labels: {
          thisClass: labels[labelTopics.ViewReferences],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.fetchDocData = function () {

    _this2.setState({ fetching: true });

    var exclude = "";
    if (_this2.props.type === "*") {
      exclude = "REFERS_TO_BIBLICAL_TEXT";
    }

    var parms = "t=" + encodeURIComponent(_this2.props.type) + "&d=" + encodeURIComponent("*") + "&q=" + encodeURIComponent(_this2.state.selectedDomain + "~" + _this2.props.id) + "&p=" + encodeURIComponent("id") + "&m=" + encodeURIComponent("sw") + "&l=" + encodeURIComponent("") + "&o=" + encodeURIComponent("any") + "&x=" + encodeURIComponent(exclude);

    _Server2.default.restGetPromise(_this2.props.session.restServer, _Server2.default.getDbServerLinksApi(), _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, parms).then(function (response) {
      _this2.setState({
        data: response.data,
        userMessage: response.userMessage,
        developerMessage: response.developerMessage,
        messageIcon: response.messageIcon,
        status: response.status,
        showSearchResults: response.data.values.length > 0,
        resultCount: response.data.values.length,
        fetching: false
      });
    }).catch(function (error) {
      _this2.setState({
        data: {
          values: [{
            "id": "",
            "library": "",
            "topic": "",
            "key": "",
            "value:": ""
          }],
          userMessage: error.userMessage,
          developerMessage: error.developerMessage,
          messageIcon: error.messageIcon,
          status: error.status,
          showSearchResults: false,
          resultCount: 0,
          fetching: false
        }
      });
    });
  };

  this.handleRowSelect = function (row, isSelected, e) {
    var id = _IdManager2.default.toId(row["library"], row["fromId"], row["toId"]);
    var type = row["type"].toLowerCase().replace(/_/g, " ") + "...";
    _this2.setState({
      selectedId: id,
      selectedLibrary: row["library"],
      selectedTopic: row["fromId"],
      selectedKey: row["toId"],
      selectedValue: row["value"],
      showIdPartSelector: true,
      showModalWindow: true,
      selectedType: type,
      selectedFromId: row["fromId"],
      selectedFromValue: row["fromValue"],
      selectedToId: row["toId"],
      selectedToValue: row["toValue"]
    });
  };

  this.editable = function (library) {
    var canEdit = false;
    if (library) {
      for (var _iterator = _this2.props.session.userInfo.domains.author, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var entry = _ref;

        if (entry.value == library) {
          canEdit = true;
          break;
        }
      };
    }
    return canEdit;
  };

  this.getModalEditor = function () {
    return _react2.default.createElement(_ModalSchemaBasedEditor2.default, {
      session: _this2.props.session,
      restPath: _Server2.default.getDbServerLinksApi(),
      showModal: _this2.state.showModalWindow,
      title: _this2.state.labels.thisClass.textualReference,
      idLibrary: _this2.state.selectedLibrary,
      idTopic: _this2.state.selectedTopic,
      idKey: _this2.state.selectedKey,
      fromId: _this2.state.selectedFromId,
      fromText: _this2.state.selectedFromValue,
      fromTitle: _this2.state.labels.thisClass.theText,
      toTitle: _this2.state.labels.thisClass.refersTo,
      toId: _this2.state.selectedToId,
      toText: _this2.state.selectedToValue,
      onClose: _this2.handleCloseModal,
      canUpdate: _this2.editable(_this2.state.selectedLibrary)
    });
  };

  this.handleCloseModal = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalWindow: false,
        selectedId: id,
        selectedValue: value
      });
    } else {
      _this2.setState({
        showModalWindow: false
      });
    }
  };

  this.onExportToCSV = function (row) {
    return _this2.state.data.values;
  };

  this.handleDomainChange = function (item) {
    _this2.setState({
      selectedDomain: item.value,
      showSearchResults: false
    }, _this2.fetchDocData);
  };

  this.getTableColsForBiblicalReference = function () {
    var keys = [];
    if (_this2.state.session.uiSchemas) {
      keys = _this2.state.session.uiSchemas.getPropsForSchema("LinkRefersToBiblicalTextCreateForm:1.1", ["id", "fromId", "type", "toId", "value", "toValue", "tags", "comments"]);
    }
    return keys;
  };

  this.getTable = function () {
    if (_this2.state.showSearchResults) {
      return _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          'div',
          { className: 'App-search-results' },
          _react2.default.createElement(
            'div',
            { className: 'row' },
            _react2.default.createElement(
              _reactBootstrapTable.BootstrapTable,
              {
                data: _this2.state.data.values,
                exportCSV: false,
                trClassName: "App-data-tr",
                search: true,
                searchPlaceholder: _this2.state.labels.resultsTableLabels.filterPrompt,
                striped: true,
                hover: true,
                pagination: true,
                options: _this2.state.options,
                selectRow: _this2.state.selectRow
              },
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  isKey: true,
                  dataField: 'id',
                  dataSort: true,
                  'export': true,
                  hidden: true
                },
                'ID'
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: 'fromId',
                  'export': true,
                  hidden: true
                },
                _this2.state.labels.resultsTableLabels.headerTo
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: 'type',
                  'export': true,
                  hidden: true
                },
                _this2.state.labels.resultsTableLabels.headerLink
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: _this2.props.type === "*" ? 'ontologyTopic' : 'toId',
                  'export': true
                },
                _this2.state.labels.resultsTableLabels.headerOntologyType
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: 'toId',
                  'export': true,
                  dataSort: true,
                  hidden: true
                },
                _this2.state.labels.resultsTableLabels.headerTo
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: _this2.props.type === "*" ? 'toValue' : 'value',
                  'export': true,
                  dataSort: true
                },
                _this2.state.labels.resultsTableLabels.headerOntologyInstance
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: 'tags',
                  'export': true,
                  dataSort: true
                },
                _this2.state.labels.resultsTableLabels.headerTags
              ),
              _react2.default.createElement(
                _reactBootstrapTable.TableHeaderColumn,
                {
                  dataField: 'comments',
                  'export': true,
                  dataSort: true,
                  hidden: true
                },
                _this2.state.labels.resultsTableLabels.headerComments
              )
            )
          )
        )
      );
    } else if (_this2.state.fetching) {
      return _react2.default.createElement(_Spinner2.default, { message: _this2.state.labels.messages.retrieving });
    } else {
      return _react2.default.createElement('div', null);
    }
  };

  this.getSelector = function () {
    if (_this2.props.session.userInfo.domains && _this2.props.session.userInfo.domains.reader) {
      return _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          _this2.state.labels.thisClass.prompt
        ),
        _react2.default.createElement(_ReactSelector2.default, {
          initialValue: _this2.state.selectedDomain,
          resources: _this2.props.session.userInfo.domains.reader,
          changeHandler: _this2.handleDomainChange,
          multiSelect: false
        })
      );
    } else {
      return _react2.default.createElement('div', null);
    }
  };

  this.handleAddClose = function () {
    _this2.fetchDocData();
  };

  this.getEntityAddButton = function () {
    /**
     * TODO: write a function in UiSchemas to find the id of a schema
     * based on the first part of the name
     */
    var id = "LinkRefersToBiblicalTextCreateForm:1.1";
    switch (_this2.props.type) {
      case "REFERS_TO_BIBLICAL_TEXT":
        id = "LinkRefersToBiblicalTextCreateForm:1.1";
        break;
      case "*":
        id = "LinkRefersToAnimalCreateForm:1.1"; // can be changed later by the user
        break;
    }
    var library = _this2.state.selectedDomain;

    return _react2.default.createElement(_SchemaBasedAddButton2.default, {
      session: _this2.props.session,
      restPath: _this2.state.session.uiSchemas.getHttpPostPathForSchema(id),
      uiSchema: _this2.state.session.uiSchemas.getUiSchema(id),
      schema: _this2.state.session.uiSchemas.getSchema(id),
      formData: _this2.state.session.uiSchemas.getForm(id),
      idLibrary: library,
      idTopic: _this2.props.id,
      idKey: "",
      seq: _IdManager2.default.toId(library, _this2.props.id, ""),
      onClose: _this2.handleAddClose,
      fromId: _this2.props.id,
      fromText: _this2.props.value
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ViewReferences.propTypes = {
  session: _propTypes2.default.object.isRequired,
  id: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.string,
  type: _propTypes2.default.string
} : void 0;

ViewReferences.defaultProps = {
  type: "*",
  value: ""
};

exports.default = ViewReferences;
module.exports = exports['default'];