'use strict';

exports.__esModule = true;

var _User = require('./User');

var _User2 = _interopRequireDefault(_User);

var _UiSchemas = require('./UiSchemas');

var _UiSchemas2 = _interopRequireDefault(_UiSchemas);

var _Dropdowns = require('./Dropdowns');

var _Dropdowns2 = _interopRequireDefault(_Dropdowns);

var _labels = require('./labels.json');

var _labels2 = _interopRequireDefault(_labels);

var _LabelTopics = require('./LabelTopics');

var _LabelTopics2 = _interopRequireDefault(_LabelTopics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } } /**
                                                                                                                                                           * Created by mac002 on 6/6/17.
                                                                                                                                                           */


// To produce labels.json and LabelTopics.js,
//   run ioc-liturgical-ws net.ages.alwb.utils.transformers.LabelsNeoToJson
// Note that labels.json is replaced once the user logs on.

var Session = function Session(restServer, languageCode, userInfo, uiSchemas, dropdowns, labels) {
  _classCallCheck(this, Session);

  //    let emptyLocation =  "countryCode|country|region|regionName|city";
  var emptyLocation = "unknown|unknown|unknown|unknown|unknown";
  this.restServer = restServer ? restServer : "";
  this.languageCode = languageCode ? languageCode : "en";
  this.userInfo = userInfo ? userInfo : new _User2.default();
  this.uiSchemas = uiSchemas ? uiSchemas : new _UiSchemas2.default();
  this.dropdowns = dropdowns ? dropdowns : new _Dropdowns2.default();
  this.labelsAll = this.labelsAll ? this.labelsAll : _labels2.default;
  this.labels = labels ? labels[this.languageCode] : _labels2.default[this.languageCode];
  this.labelTopics = this.labelTopics ? this.labelTopics : _LabelTopics2.default;
  this.location = this.location ? this.location : emptyLocation;
};

exports.default = Session;
module.exports = exports['default'];