"use strict";

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Created by mac002 on 6/6/17.
 */

var TreeNode = function () {
  function TreeNode(id, token, lemma, gloss, dependsOn, refersTo, label, gCase, gender, mood, number, person, pos, tense, voice, answersQuestion) {
    var _this = this;

    _classCallCheck(this, TreeNode);

    this.getGrammarForNounLikeWords = function () {
      return _this.pos + "." + _this.number + "." + _this.gender + "." + _this.case;
    };

    this.hasGrammarForNounLikeWords = function () {
      if (_this.pos && _this.gender && _this.number && _this.case) {
        if (TreeNode.requiresReferent(_this.pos)) {
          return _this.refersTo;
        } else {
          return true;
        }
      } else {
        return false;
      }
    };

    this.getGrammarForVerb = function () {
      return _this.pos + "." + _this.person + "." + _this.number + "." + _this.tense + "." + _this.voice + "." + _this.mood;
    };

    this.hasGrammarForVerb = function () {
      if (_this.pos && _this.person && _this.number && _this.tense && _this.voice && _this.mood) {
        return true;
      } else {
        return false;
      }
    };

    this.getGrammarForParticiple = function () {
      return _this.pos + "." + _this.voice + "." + _this.tense + "." + _this.gender + "." + _this.number + "." + _this.case;
    };

    this.hasGrammarForParticiple = function (requireReferent) {
      if (_this.pos && _this.voice && _this.tense && _this.gender && _this.number && _this.case) {
        if (requireReferent) {
          if (_this.refersTo) {
            return true;
          } else {
            return false;
          }
        } else {
          return true;
        }
      } else {
        return false;
      }
    };

    this.hasGrammarForInfinitive = function () {
      if (_this.pos && _this.voice && _this.tense) {
        return true;
      } else {
        return false;
      }
    };

    this.getGrammarForInfinitive = function () {
      return _this.pos + "." + _this.tense + "." + _this.voice;
    };

    this.hasGrammarForParticiple = function () {
      if (_this.pos && _this.tense && _this.voice) {
        return true;
      } else {
        return false;
      }
    };

    this.isComplete = function () {
      // TODO: rework.  Not working properly.
      var result = true;
      // if (
      //     this.lemma
      //     && this.gloss
      //     && this.dependsOn
      //     && this.label
      //     && this.pos
      //
      // ) {
      //   switch (this.pos) {
      //     case ("ADJ"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ADJ.COMP"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ADJ.SUP.ABS"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ADJ.SUP.REL"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ART"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ART.DEF"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("ART.INDF"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.COR"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.DEF"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.DEM"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.INDF"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.PERS"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.POSS"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.Q"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.REFL"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("PRON.REL"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("NOUN"): {
      //       result = this.hasGrammarForNounLikeWords();
      //       break;
      //     }
      //     case ("INF"): {
      //       result = this.hasGrammarForInfinitive();
      //       break;
      //     }
      //     case ("PTCP"): {
      //       result = this.hasGrammarForParticiple();
      //       break;
      //     }
      //     case ("VERB"): {
      //       result = this.hasGrammarForVerb();
      //       break;
      //     }
      //     default: {
      //       result = true;
      //     }
      //   }
      // }
      return result;
    };

    this.notComplete = function () {
      return !_this.isComplete();
    };

    this.getGrammar = function () {
      if (_this.pos.startsWith("ADJ") || _this.pos.startsWith("ART") || _this.pos.startsWith("PRON") || _this.pos.startsWith("NOUN")) {
        return _this.getGrammarForNounLikeWords();
      } else {
        switch (_this.pos) {
          case "INF":
            {
              return _this.getGrammarForInfinitive();
            }
          case "PTCP":
            {
              return _this.getGrammarForParticiple();
            }
          case "VERB":
            {
              return _this.getGrammarForVerb();
            }
          default:
            {
              return _this.pos;
            }
        }
      }
    };

    this.id = id;
    this.dependsOn = dependsOn ? dependsOn : "";
    this.refersTo = refersTo ? refersTo : "";
    this.answersQuestion = answersQuestion ? answersQuestion : "";
    this.token = token;
    this.lemma = lemma;
    this.gloss = gloss;
    this.label = label;
    this.case = gCase;
    this.gender = gender;
    this.mood = mood;
    this.number = number;
    this.person = person;
    this.pos = pos;
    this.tense = tense;
    this.voice = voice;
    if (this.pos) {
      this.grammar = this.getGrammar();
    } else {
      this.grammar = "TBD";
    }
  }

  // e.g. VERB.3.SG.PRS.ACT.IND


  // e.g. PTCP.ACT.AOR.M.SG.NOM


  // e.g. INF.AOR.ACT


  // e.g. INF.AOR.ACT


  TreeNode.requiresReferent = function requiresReferent(pos) {
    switch (pos) {
      case "PRON":
        {
          return true;
          break;
        }
      case "PRONCOR":
        {
          return false;
          break;
        }
      case "PRON.COR":
        {
          return false;
          break;
        }
      case "PRON.DEF":
        {
          return true;
          break;
        }
      case "PRONDEF":
        {
          return true;
          break;
        }
      case "PRON.DEM":
        {
          return true;
          break;
        }
      case "PRONDEM":
        {
          return true;
          break;
        }
      case "PRON.INDF":
        {
          return false;
          break;
        }
      case "PRONINDF":
        {
          return false;
          break;
        }
      case "PRONPERS":
        {
          return true;
          break;
        }
      case "PRON.PERS":
        {
          return true;
          break;
        }
      case "PRON.POSS":
        {
          return true;
          break;
        }
      case "PRONPOSS":
        {
          return true;
          break;
        }
      case "PRON.Q":
        {
          return false;
          break;
        }
      case "PRONQ":
        {
          return false;
          break;
        }
      case "PRON.REFL":
        {
          return true;
          break;
        }
      case "PRON.REL":
        {
          return false;
          break;
        }
      case "PRONREL":
        {
          return false;
          break;
        }
      default:
        {
          return false;
        }
    }
  };

  /**
   * On the server-side, the tags for grammar are set by LTKDbTokenAnalysis
   * in the org.ocmc.ioc.liturgical.schemas.models.supers package.
   * So, if changes are made here, you need to make
   * them also in LTKDbTokenAnalysis.
   */


  return TreeNode;
}();

exports.default = TreeNode;
module.exports = exports["default"];