'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('./MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BibleRefSelector = (_temp = _class = function (_React$Component) {
  _inherits(BibleRefSelector, _React$Component);

  function BibleRefSelector(props) {
    _classCallCheck(this, BibleRefSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var citeBook = "";
    var citeChapter = "";
    var citeVerse = "";

    if (props.book) {
      citeBook = props.book;
      citeChapter = props.chapter.substring(1, props.chapter.length);
      try {
        citeChapter = parseInt(citeChapter);
      } catch (err) {
        citeChapter = props.chapter;
      }
      citeVerse = 0;
      try {
        citeVerse = parseInt(props.verse);
      } catch (err) {
        citeVerse = props.verse;
      };
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.BibleRefSelector],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedBook: props.book,
      selectedChapter: props.chapter,
      selectedVerse: props.verse,
      selectedRef: "",
      citeBook: citeBook,
      citeChapter: citeChapter,
      citeVerse: citeVerse
    };

    _this.handleBookChange = _this.handleBookChange.bind(_this);
    _this.handleChapterChange = _this.handleChapterChange.bind(_this);
    _this.handleVerseChange = _this.handleVerseChange.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  BibleRefSelector.prototype.render = function render() {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Bible-Ref-Selector-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { className: 'App App-Bible-Ref-Selector-Label', xs: 3, md: 3 },
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          'Bible Ref:'
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Col,
        { className: 'App-Bible-Ref-Selector-Container', xs: 2, md: 2 },
        _react2.default.createElement(_reactSelect2.default, {
          name: 'App-Bible-Ref-Selector-Book',
          className: 'App-Bible-Ref-Selector-Book',
          value: this.state.selectedBook,
          options: this.props.session.dropdowns.biblicalBooksDropdown,
          onChange: this.handleBookChange,
          multi: false,
          autosize: true,
          clearable: true
        }),
        _react2.default.createElement(_reactBootstrap.Col, { className: 'App App-Bible-Ref-Selector-Label', xs: 2, md: 2 }),
        _react2.default.createElement(_reactSelect2.default, {
          name: 'App-Bible-Ref-Selector-Chapter',
          className: 'App-Bible-Ref-Selector-Chapter',
          value: this.state.selectedChapter,
          options: this.props.session.dropdowns.biblicalChaptersDropdown,
          onChange: this.handleChapterChange,
          multi: false,
          autosize: true,
          clearable: true
        }),
        _react2.default.createElement(_reactBootstrap.Col, { className: 'App App-Bible-Ref-Selector-Label', xs: 2, md: 2 }),
        _react2.default.createElement(_reactSelect2.default, {
          name: 'App-Bible-Ref-Selector-Verse',
          className: 'App-Bible-Ref-Selector-Verse',
          value: this.state.selectedVerse,
          options: this.props.session.dropdowns.biblicalVersesDropdown,
          onChange: this.handleVerseChange,
          multi: false,
          autosize: true,
          clearable: true
        })
      ),
      _react2.default.createElement(_reactBootstrap.Col, { className: 'App App-Bible-Ref-Selector-Label', xs: 3, md: 3 })
    );
  };

  return BibleRefSelector;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    if (_this2.props.session.languageCode !== nextProps.session.languageCode) {
      var labels = nextProps.session.labels;
      var labelTopics = nextProps.session.labelTopics;

      _this2.setState(function (prevState, props) {
        return {
          labels: {
            thisClass: labels[labelTopics.BibleRefSelector],
            buttons: labels[labelTopics.button],
            messages: labels[labelTopics.messages],
            resultsTableLabels: labels[labelTopics.resultsTable]
          },
          message: labels[labelTopics.messages].initial,
          selectedBook: (0, _lodash.get)(_this2.state, "selectedBook", nextProps.book),
          selectedChapter: (0, _lodash.get)(_this2.state, "selectedChapter", nextProps.chapter),
          selectedVerse: (0, _lodash.get)(_this2.state, "selectedVerse", nextProps.verse)

        };
      }, function () {
        return this.handleStateChange("place holder");
      });
    }
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.handleCallback = function () {
    _this2.props.callback(_this2.state.selectedBook, _this2.state.selectedChapter, _this2.state.selectedVerse, _this2.state.citeBook + " " + _this2.state.citeChapter + ":" + _this2.state.citeVerse);
  };

  this.handleBookChange = function (selection) {
    var book = selection["value"];
    var bookLabel = selection["label"];
    var citeBook = "";
    try {
      var parts = bookLabel.split(" - ");
      citeBook = parts[0];
    } catch (err) {
      citeBook = book;
    }
    _this2.setState({
      selectedBook: book,
      citeBook: citeBook,
      selectedRef: book + "~" + _this2.state.selectedChapter + "~" + _this2.state.selectedVerse
    }, _this2.handleCallback);
  };

  this.handleChapterChange = function (selection) {
    if (selection && selection["value"]) {
      var chapter = selection["value"];
      var citeChapter = chapter.substring(1, chapter.length);
      try {
        citeChapter = parseInt(citeChapter);
      } catch (err) {
        citeChapter = selection["value"];
      }
      _this2.setState({
        selectedChapter: chapter,
        citeChapter: citeChapter,
        selectedRef: _this2.state.selectedBook + "~" + chapter + "~" + _this2.state.selectedVerse
      }, _this2.handleCallback);
    }
  };

  this.handleVerseChange = function (selection) {
    if (selection && selection["value"]) {
      var verse = selection["value"];
      var citeVerse = verse;
      try {
        citeVerse = parseInt(verse);
      } catch (err) {
        citeVerse = verse;
      };

      _this2.setState({
        selectedVerse: selection["value"],
        citeVerse: citeVerse,
        selectedRef: _this2.state.selectedBook + "~" + _this2.state.selectedChapter + "~" + verse
      }, _this2.handleCallback);
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? BibleRefSelector.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func.isRequired,
  book: _propTypes2.default.string,
  chapter: _propTypes2.default.string,
  verse: _propTypes2.default.string
} : void 0;

// set default values for props here
BibleRefSelector.defaultProps = {
  book: "",
  chapter: "",
  verse: ""
};

exports.default = BibleRefSelector;
module.exports = exports['default'];