'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Server = require('./Server');

var _Server2 = _interopRequireDefault(_Server);

var _Spinner = require('./Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _MessageIcons = require('./MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DownloadUserRecords = (_temp = _class = function (_React$Component) {
  _inherits(DownloadUserRecords, _React$Component);

  function DownloadUserRecords(props) {
    _classCallCheck(this, DownloadUserRecords);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    _this.state = {
      fetching: false,
      labels: {
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.fetchDocData = _this.fetchDocData.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  DownloadUserRecords.prototype.render = function render() {
    if (this.state.fetching) {
      return _react2.default.createElement(_Spinner2.default, { message: this.state.labels.messages.retrieving });
    } else {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Button,
          { onClick: this.fetchDocData },
          'Download'
        )
      );
    }
  };

  return DownloadUserRecords;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState(function (prevState, props) {
      return {
        labels: {
          messages: labels[labelTopics.messages]
        },
        message: labels[labelTopics.messages].initial
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.fetchDocData = function () {
    _this2.setState({ fetching: true });
    _Server2.default.restGetUserDocs(_this2.props.session.restServer, _Server2.default.getDbServerUserDocsApi(), _this2.props.session.userInfo.username, _this2.props.session.userInfo.password).then(function (response) {
      _this2.setState({
        userMessage: response.userMessage,
        developerMessage: response.developerMessage,
        messageIcon: response.messageIcon,
        status: response.status,
        fetching: false
      });
    }).catch(function (error) {
      _this2.setState({
        userMessage: error.userMessage,
        developerMessage: error.developerMessage,
        messageIcon: error.messageIcon,
        status: error.status,
        fetching: false
      });
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? DownloadUserRecords.propTypes = {
  session: _propTypes2.default.object.isRequired
} : void 0;

// set default values for props here
DownloadUserRecords.defaultProps = {};

exports.default = DownloadUserRecords;
module.exports = exports['default'];