"use strict";

/**
 * Created by mac002 on 1/2/17.
 */

var delimiter = "~";

module.exports = {
  // splits the id into an object with its three parts: library, topic, key
  // if the key contains a colon, it is chapter:verse.  These will also become properties
  getParts: function getParts(id) {
    var IdParts = {};
    var parts = id.split(delimiter);
    if (parts.length === 3) {
      var book = "";
      var chapter = "";
      var verse = "";
      var chapVerse = parts[2].split(":");
      if (chapVerse.length === 2) {
        IdParts = {
          library: parts[0],
          topic: parts[1],
          key: parts[2],
          book: parts[1],
          chapter: chapVerse[0],
          verse: chapVerse[1]
        };
      } else {
        IdParts = {
          library: parts[0],
          topic: parts[1],
          key: parts[2]
        };
      }
    } else {
      IdParts = undefined;
    }
    return IdParts;
  }
  // extracts the library part of an ID
  , getLibrary: function getLibrary(id) {
    var parts = id.split(delimiter);
    if (parts.length === 3) {
      return parts[0];
    } else {
      return undefined;
    }
  }
  // extracts the topic part of an ID
  , getTopic: function getTopic(id) {
    var parts = id.split(delimiter);
    if (parts.length === 3) {
      return parts[1];
    } else {
      return undefined;
    }
  }
  // extracts the key part of an ID
  , getKey: function getKey(id) {
    var parts = id.split(delimiter);
    if (parts.length === 3) {
      return parts[2];
    } else {
      return undefined;
    }
  }
  // creates an ID from the parameters.
  , toId: function toId(library, topic, key) {
    return library + delimiter + topic + delimiter + key;
  },
  replaceLibrary: function replaceLibrary(id, newLibrary) {
    var parts = id.split(delimiter);
    if (parts.length === 3) {
      return newLibrary + delimiter + parts[1] + delimiter + parts[2];
    } else {
      return undefined;
    }
  },
  idToPaddedPath: function idToPaddedPath(id) {
    if (id) {
      return id.replace(/\|/g, " / ");
    }
  },
  idToPath: function idToPath(id) {
    if (id.includes("~")) {
      return id.replace(/~/g, "/");
    } else {
      return id.replace(/\|/g, "/");
    }
  },
  padPath: function padPath(path) {
    return path.replace(/\//g, " / ");
  }
};