'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Demonstrates the life cycle of a React component
 */
var LifeCycleDemoSubComponent = function (_React$Component) {
  _inherits(LifeCycleDemoSubComponent, _React$Component);

  function LifeCycleDemoSubComponent(props) {
    _classCallCheck(this, LifeCycleDemoSubComponent);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {
      _this.report("componentWillMount");
    };

    _this.componentDidMount = function () {
      _this.setState(function (prevState, props) {
        return {
          previous: prevState.stage,
          stage: "componentDidMount"
        };
      }, function () {
        return this.report("componentDidMount");
      });
    };

    _this.componentWillReceiveProps = function (nextProps) {
      _this.setState(function (prevState, props) {
        return {
          stage: "componentWillReceiveProps"
        };
      }, function () {
        return this.report("componentWillReceiveProps");
      });
    };

    _this.report = function (method) {
      console.log('LifeCycleDemoSubComponent.' + method + ' previous: ' + _this.state.previous + ' stage: ' + _this.state.stage);
    };

    _this.greet = function () {
      if (_this.props.languageCode === "en") {
        return _react2.default.createElement(
          'div',
          null,
          'Hello!'
        );
      } else if (_this.props.languageCode === "el") {
        return _react2.default.createElement(
          'div',
          null,
          '\u0393\u03B9\u03B1!'
        );
      } else {
        return _react2.default.createElement(
          'div',
          null,
          'I don\'t understand that language!'
        );
      }
    };

    _this.state = {
      previous: "",
      stage: "a"
    };
    _this.report = _this.report.bind(_this);
    _this.greet = _this.greet.bind(_this);
    _this.report("constructor");
    return _this;
  }

  LifeCycleDemoSubComponent.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      this.greet()
    );
  };

  return LifeCycleDemoSubComponent;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? LifeCycleDemoSubComponent.propTypes = {
  languageCode: _propTypes2.default.string.isRequired
} : void 0;

LifeCycleDemoSubComponent.defaultProps = {};

exports.default = LifeCycleDemoSubComponent;
module.exports = exports['default'];