'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('./MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _Server = require('./Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WorkflowForm = (_temp = _class = function (_React$Component) {
  _inherits(WorkflowForm, _React$Component);

  function WorkflowForm(props) {
    _classCallCheck(this, WorkflowForm);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    var thisClassLabels = labels[labelTopics.WorkflowForm];
    _this.state = {
      labels: {
        thisClass: thisClassLabels,
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      library: props.library,
      selectedStatus: props.status,
      selectedStatusIcon: _this.getStatusIcon(props.status),
      selectedVisibility: props.visibility,
      selectedVisibilityIcon: _this.getVisibilityIcon(props.visibility),
      selectedUser: props.session.userInfo.username,
      workflow: {
        userRolesForLibrary: {
          admins: [],
          authors: [],
          readers: [],
          reviewers: []
        },
        statusDropdown: [{ value: "EDITING", label: thisClassLabels.statusTypesEdit }, { value: "REVIEWING", label: thisClassLabels.statusTypesReview }, { value: "FINALIZED", label: thisClassLabels.statusTypesFinal }],
        visibilityDropdown: [{ value: "PERSONAL", label: thisClassLabels.visibilityTypesPersonal }, { value: "PRIVATE", label: thisClassLabels.visibilityTypesPrivate }, { value: "PUBLIC", label: thisClassLabels.visibilityTypesPublic }],
        isPublic: false,
        stateEnabled: false,
        workflowEnabled: false,
        defaultStatusAfterEdit: "FINALIZED",
        defaultStatusAfterFinalization: "FINALIZED"
      }
    };

    _this.getStatusIcon = _this.getStatusIcon.bind(_this);
    _this.getVisibilityIcon = _this.getVisibilityIcon.bind(_this);
    _this.handleStatusChange = _this.handleStatusChange.bind(_this);
    _this.handleVisibilityChange = _this.handleVisibilityChange.bind(_this);
    _this.handleUserChange = _this.handleUserChange.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  // use these (below) in the handleFetchCallback if want dropdowns from the web service
  // , statusDropdown: restCallResult.data.values[1].statusDropdown
  // , visibilityDropdown: restCallResult.data.values[2].visibilityDropdown

  WorkflowForm.prototype.render = function render() {
    return _react2.default.createElement(
      _reactBootstrap.Well,
      null,
      _react2.default.createElement(
        _reactBootstrap.Grid,
        null,
        _react2.default.createElement(
          _reactBootstrap.Row,
          { className: 'show-grid App App-Workflow-Selector-Row' },
          _react2.default.createElement(
            _reactBootstrap.Col,
            { className: 'App App-Workflow-Selector-Label', xs: 2, md: 2 },
            _react2.default.createElement(
              _reactBootstrap.ControlLabel,
              null,
              _react2.default.createElement(_reactBootstrap.Glyphicon, {
                className: 'App-Workflow-Selector-icon',
                glyph: this.state.selectedStatusIcon }),
              'Status:'
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Col,
            { className: 'App-Workflow-Selector-Dropdown', xs: 10, md: 10 },
            _react2.default.createElement(_reactSelect2.default, {
              name: 'App-Workflow-Selector-Status',
              className: 'App App-Workflow-Selector-Status',
              value: this.state.selectedStatus,
              options: this.state.workflow.statusDropdown,
              onChange: this.handleStatusChange,
              multi: false,
              autosize: true,
              clearable: true
            })
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Row,
          { className: 'show-grid App App-Workflow-Selector-Row' },
          _react2.default.createElement(
            _reactBootstrap.Col,
            { className: 'App App-Workflow-Selector-Label', xs: 2, md: 2 },
            _react2.default.createElement(
              _reactBootstrap.ControlLabel,
              null,
              _react2.default.createElement(_reactFontawesome2.default, { className: 'App-Workflow-Selector-icon',
                name: this.state.selectedVisibilityIcon }),
              'Visibility:'
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Col,
            { className: 'App-Workflow-Selector-Dropdown', xs: 10, md: 10 },
            _react2.default.createElement(_reactSelect2.default, {
              name: 'App-Workflow-Selector-Visibility',
              className: 'App App-Workflow-Selector-Visibility',
              value: this.state.selectedVisibility,
              options: this.state.workflow.visibilityDropdown,
              onChange: this.handleVisibilityChange,
              multi: false,
              autosize: true,
              clearable: true
            })
          )
        )
      )
    );
  };

  return WorkflowForm;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    _this2.fetchData(undefined);
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    var thisClassLabels = labels[labelTopics.WorkflowForm];
    var currentLibrary = _this2.state.library;
    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: thisClassLabels,
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable],
          library: nextProps.library
        },
        message: labels[labelTopics.messages].initial,
        selectedStatus: nextProps.status,
        selectedVisibility: nextProps.visibility,
        selectedStatusIcon: _this2.getStatusIcon(nextProps.status),
        selectedVisibilityIcon: _this2.getVisibilityIcon(nextProps.visibility),
        statusDropdown: [{ value: "EDITING", label: thisClassLabels.statusTypesEdit }, { value: "REVIEWING", label: thisClassLabels.statusTypesReview }, { value: "FINALIZED", label: thisClassLabels.statusTypesFinal }],
        visibilityDropdown: [{ value: "PERSONAL", label: thisClassLabels.visibilityTypesPersonal }, { value: "PRIVATE", label: thisClassLabels.visibilityTypesPrivate }, { value: "PUBLIC", label: thisClassLabels.visibilityTypesPublic }]
      };
    }, function () {
      return this.fetchData(currentLibrary);
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.fetchData = function (libraryToFetch) {
    if (libraryToFetch && libraryToFetch === _this2.state.library) {
      // ignore.  No need to call the web service
    } else {
      var library = _this2.props.library;
      if (library === "" || library === " ") {
        library = _this2.props.session.userInfo.domain;
      }
      if (library) {
        _Server2.default.getDropdownUsersForLibrary(_this2.props.session.restServer, _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, library, _this2.handleFetchCallback);
      }
    }
  };

  this.handleFetchCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data.values && restCallResult.data.values.length > 0) {
      var config = restCallResult.data.values[3].config;

      _this2.setState({
        workflow: {
          userRolesForLibrary: restCallResult.data.values[0],
          isPublic: config.isPublic,
          stateEnabled: config.stateEnabled,
          workflowEnabled: config.workflowEnabled,
          defaultStatusAfterEdit: config.defaultStatusAfterEdit,
          defaultStatusAfterFinalization: config.defaultStatusAfterFinalization,
          statusDropdown: _this2.state.workflow.statusDropdown,
          visibilityDropdown: _this2.state.workflow.visibilityDropdown
        }
      });
    }
  };

  this.handleCallback = function () {
    _this2.props.callback(_this2.state.selectedVisibility, _this2.state.selectedStatus, _this2.state.selectedUser);
  };

  this.getStatusIcon = function (status) {
    var statusIcon = "edit";
    switch (status) {
      case "EDITING":
        {
          statusIcon = "edit";
          break;
        }
      case "REVIEWING":
        {
          statusIcon = "eye-open";
          break;
        }
      case "FINALIZED":
        {
          statusIcon = "check";
          break;
        }
      default:
        {
          var _statusIcon = "edit";
        }
    }
    return statusIcon;
  };

  this.getVisibilityIcon = function (visibility) {
    var visibilityIcon = "lock";
    switch (visibility) {
      case "PERSONAL":
        {
          visibilityIcon = "lock"; // user-secret
          break;
        }
      case "PRIVATE":
        {
          visibilityIcon = "share-alt";
          break;
        }
      case "PUBLIC":
        {
          visibilityIcon = "globe";
          break;
        }
      default:
        {
          var _visibilityIcon = "lock";
        }
    }
    return visibilityIcon;
  };

  this.handleStatusChange = function (selection) {
    var icon = "edit";
    var value = selection["value"];
    switch (value) {
      case "EDITING":
        {
          icon = "edit";
          break;
        }
      case "REVIEWING":
        {
          icon = "eye-open";
          break;
        }
      case "FINALIZED":
        {
          icon = "check";
          break;
        }
    }
    _this2.setState({
      selectedStatus: value,
      selectedStatusIcon: icon
    }, _this2.handleCallback);
  };

  this.handleVisibilityChange = function (selection) {
    var icon = "edit";
    var value = selection["value"];
    switch (value) {
      case "PERSONAL":
        {
          icon = "lock";
          break;
        }
      case "PRIVATE":
        {
          icon = "share-alt";
          break;
        }
      case "PUBLIC":
        {
          icon = "globe";
          break;
        }
    }
    _this2.setState({
      selectedVisibility: value,
      selectedVisibilityIcon: icon
    }, _this2.handleCallback);
  };

  this.handleUserChange = function (selection) {
    _this2.setState({
      selectedUser: selection["value"]
    }, _this2.handleCallback);
  };

  this.getUserRow = function () {
    if (_this2.props.assignable) {
      return _react2.default.createElement(
        _reactBootstrap.Row,
        { className: 'show-grid App App-Workflow-Selector-Row' },
        _react2.default.createElement(
          _reactBootstrap.Col,
          { className: 'App App-Workflow-Selector-Label', xs: 2, md: 2 },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            'Assigned To:'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { className: 'App-Workflow-Selector-Dropdown', xs: 10, md: 10 },
          _react2.default.createElement(_reactSelect2.default, {
            name: 'App-Workflow-Selector-User',
            className: 'App App-Workflow-Selector-User',
            value: _this2.state.selectedUser,
            options: _this2.state.workflow.userRolesForLibrary.readers,
            onChange: _this2.handleUserChange,
            multi: false,
            autosize: true,
            clearable: true
          })
        )
      );
    } else {
      return _react2.default.createElement('span', { className: 'App-no-display' });
    }
  };
}, _temp);
;

process.env.NODE_ENV !== "production" ? WorkflowForm.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func.isRequired,
  library: _propTypes2.default.string.isRequired,
  status: _propTypes2.default.string,
  visibility: _propTypes2.default.string,
  assignable: _propTypes2.default.bool
} : void 0;

// set default values for props here
WorkflowForm.defaultProps = {
  languageCode: "en",
  status: "EDITING",
  visibility: "PERSONAL",
  assignable: false
};

exports.default = WorkflowForm;
module.exports = exports['default'];