'use strict';

exports.__esModule = true;
exports.CompareDocs = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrapTable = require('react-bootstrap-table');

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('../helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _Spinner = require('../helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _Grammar = require('./Grammar');

var _Grammar2 = _interopRequireDefault(_Grammar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var CompareDocs = exports.CompareDocs = (_temp = _class = function (_React$Component) {
  _inherits(CompareDocs, _React$Component);

  function CompareDocs(props) {
    _classCallCheck(this, CompareDocs);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this._isMounted = false;

    var topic = props.selectedIdParts[1].label;
    var key = props.selectedIdParts[2].label;
    var query = "~" + topic + "~" + key;

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        messages: labels[labelTopics.messages]
      },
      showSearchResults: false,
      message: _this.props.labels.msg1,

      messageIcon: _this.messageIcons.info,

      data: { values: [{ "id": "", "value:": "" }] },
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: _this.props.handleRowSelect ? false : true,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select",
        selected: []
      },

      showSelectionButtons: false,

      selectedId: "",

      selectedValue: "",

      selectedSeq: "",

      selectedIdPartsPrompt: "Select one or more ID parts, then click on the search icon:",

      selectedIdParts: [{ key: "domain", label: "" }, { key: "topic", label: "" }, { key: "key", label: "" }],

      showIdPartSelector: false,
      showModalCompareDocs: false,
      idColumnSize: "130px",
      query: query,
      lastQuery: undefined,
      domain: "*",
      selectedBook: "*",
      selectedChapter: "*",
      docProp: "id",
      matcher: "ew",
      unmounted: false,
      idTopic: topic,
      idKey: key
    };

    _this.fetchData = _this.fetchData.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.getGrammar = _this.getGrammar.bind(_this);
    _this.getTable = _this.getTable.bind(_this);
    _this.evaluateNeedToFetch = _this.evaluateNeedToFetch.bind(_this);
    _this.sendLibrariesInfo = _this.sendLibrariesInfo.bind(_this);
    return _this;
  }

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  CompareDocs.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  CompareDocs.prototype.fetchData = function fetchData() {
    var _this2 = this;

    if (this._isMounted) {
      this.setState({ message: this.props.labels.msg2, messageIcon: this.messageIcons.info });
      var config = {
        auth: {
          username: this.props.session.userInfo.username,
          password: this.props.session.userInfo.password
        }
      };

      var parms = "?t=" + encodeURIComponent(this.props.docType) + "&d=" + encodeURIComponent(this.state.domain) + "&b=" + encodeURIComponent(this.state.selectedBook) + "&c=" + encodeURIComponent(this.state.selectedChapter) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher);
      var path = this.props.session.restServer + _Server2.default.getWsServerDbApi() + 'docs' + parms;
      _axios2.default.get(path, config).then(function (response) {
        // if one of the values is greek, then make it the selected row
        var selectedId = "";
        var selectedValue = "";
        var selectRow = _this2.state.selectRow;
        var greekId = "";
        if (response.data.values) {
          // select the Greek value.  If not, if there is only one item, select it
          var theItem = response.data.values.find(function (o) {
            return o.id.startsWith("gr_");
          });
          if (theItem) {
            selectedId = theItem.id;
            selectedValue = theItem.value;
            selectRow.selected = [selectedId];
            greekId = selectedId;
          } else {
            if (response.data.values.length === 1) {
              theItem = response.data.values[0];
              selectedId = theItem.id;
              selectedValue = theItem.value;
              selectRow.selected = [selectedId];
            }
          }
        }
        var values = response.data.values.filter(function (row) {
          return row.value.length > 0;
        });
        var libraries = values.map(function (row) {
          return { library: row.library, topic: row.topic, key: row.key, id: row.id };
        });
        response.data.values = values;
        if (_this2._isMounted) {
          _this2.setState({
            selectRow: selectRow,
            selectedId: selectedId,
            selectedValue: selectedValue,
            data: response.data,
            lastQuery: _this2.state.query
          });
        }

        var resultCount = 0;
        var message = _this2.props.labels.foundNone;
        var found = _this2.props.labels.foundMany;
        if (response.data.valueCount) {
          resultCount = response.data.valueCount;
          if (resultCount === 0) {
            message = _this2.props.labels.foundNone;
          } else if (resultCount === 1) {
            message = _this2.props.labels.foundOne;
          } else {
            message = found + " " + resultCount + ".";
          }
        }
        if (_this2._isMounted) {
          _this2.setState({
            message: message,
            messageIcon: _this2.messageIcons.info,
            showSearchResults: true,
            greekId: greekId,
            libraries: libraries
          }, _this2.sendLibrariesInfo);
        }
      }).catch(function (error) {
        var message = error.message;
        var messageIcon = _this2.messageIcons.error;
        if (error && error.response && error.response.status === 404) {
          message = _this2.props.labels.foundNone;
          messageIcon = _this2.messageIcons.warning;
          if (_this2._isMounted) {
            _this2.setState({
              data: message,
              message: message,
              messageIcon: messageIcon,
              dataFetched: true,
              lastQuery: _this2.state.query
            });
          }
        }
      });
    }
  };

  CompareDocs.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      this.state.showSelectionButtons && this.getSelectedDocOptions(),
      this.getTable(),
      this.getGrammar()
    );
  };

  return CompareDocs;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillReceiveProps = function (nextProps) {
    var lastQuery = undefined;
    if (_this3.state.lastQuery) {
      lastQuery = _this3.state.lastQuery;
    }
    var topic = nextProps.selectedIdParts[1].label;
    var key = nextProps.selectedIdParts[2].label;
    var query = "~" + topic + "~" + key;
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this3.setState({
      labels: {
        messages: labels[labelTopics.messages]
      },
      showModal: nextProps.showModal,
      query: query,
      lastQuery: lastQuery,
      unmounted: false,
      idTopic: topic,
      idKey: key
    }, function () {
      this.evaluateNeedToFetch();
    });
  };

  this.componentDidMount = function () {
    _this3._isMounted = true;
    _this3.fetchData();
  };

  this.componentWillUnmount = function () {
    _this3._isMounted = false;
  };

  this.messageIcons = {
    info: "info-circle",
    warning: "lightbulb-o",
    error: "exclamation-triangle"
    // , toggleOn: "eye"
    // , toggleOff: "eye-slash"
    , toggleOn: "toggle-on",
    toggleOff: "toggle-off",
    simpleSearch: "minus",
    advancedSearch: "bars",
    idPatternSearch: "key"
  };

  this.evaluateNeedToFetch = function () {
    if (_this3.state.lastQuery === _this3.state.query) {
      // do nothing
    } else {
      _this3.fetchData();
    }
  };

  this.sendLibrariesInfo = function () {
    if (_this3.props.librariesInfoCallback && _this3.state.libraries) {
      _this3.props.librariesInfoCallback(_this3.props.docType, _this3.state.greekId, _this3.state.libraries);
    }
  };

  this.handleRowSelect = function (row) {
    var selectRow = _this3.state.selectRow;
    selectRow.selected = [row["id"]];
    var idParts = row["id"].split("~");
    _this3.setState({
      selectRow: selectRow,
      selectedId: row["id"],
      selectedIdParts: [{ key: "domain", label: idParts[0] }, { key: "topic", label: idParts[1] }, { key: "key", label: idParts[2] }],
      selectedValue: row["value"],
      selectedSeq: row["seq"]
    });
    if (_this3.props.handleRowSelect) {
      _this3.props.handleRowSelect(row);
    }
  };

  this.getTable = function () {
    if (_this3.state.showSearchResults) {
      return _react2.default.createElement(
        'div',
        { className: 'App-search-results' },
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            _reactBootstrapTable.BootstrapTable,
            {
              data: _this3.state.data.values,
              trClassName: "App-data-tr",
              striped: true,
              hover: true,
              pagination: true,
              options: _this3.state.options,
              selectRow: _this3.state.selectRow
            },
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                isKey: true,
                dataField: 'id',
                dataSort: true,
                hidden: true
              },
              'ID'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'seq',
                hidden: true
              },
              'ID'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'library',
                dataSort: true,
                width: _this3.state.idColumnSize },
              'Domain'
            ),
            _react2.default.createElement(
              _reactBootstrapTable.TableHeaderColumn,
              {
                dataField: 'value',
                dataSort: true
              },
              'Value'
            )
          )
        )
      );
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.retrieving });
    }
  };

  this.getGrammar = function () {
    if (_this3.props && _this3.props.docType && _this3.props.docType === "Liturgical") {
      return _react2.default.createElement(_Grammar2.default, {
        session: _this3.props.session,
        idTopic: _this3.state.idTopic,
        idKey: _this3.state.idKey,
        full: false
      });
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? CompareDocs.propTypes = {
  session: _propTypes2.default.object.isRequired,
  handleRowSelect: _propTypes2.default.func,
  title: _propTypes2.default.string.isRequired,
  docType: _propTypes2.default.string.isRequired,
  selectedIdParts: _propTypes2.default.array.isRequired,
  labels: _propTypes2.default.object.isRequired,
  instructions: _propTypes2.default.string,
  librariesInfoCallback: _propTypes2.default.func
} : void 0;

CompareDocs.defaultProps = {};

exports.default = CompareDocs;