'use strict';

exports.__esModule = true;
exports.EditableSelector = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _reactBootstrap = require('react-bootstrap');

require('react-select/dist/react-select.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EditableSelector = exports.EditableSelector = (_temp = _class = function (_React$Component) {
  _inherits(EditableSelector, _React$Component);

  function EditableSelector(props) {
    _classCallCheck(this, EditableSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button]
      },
      value: _this.props.initialValue,
      options: _this.props.options
    };
    _this.callBack = _this.callBack.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.onRemoveClick = _this.onRemoveClick.bind(_this);
    _this.onRemoveAllClick = _this.onRemoveAllClick.bind(_this);
    return _this;
  }

  EditableSelector.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'resourceSelector' },
      _react2.default.createElement(
        'div',
        { className: 'resourceSelectorPrompt' },
        this.props.title
      ),
      _react2.default.createElement(_reactSelect2.default.Creatable, {
        name: 'form-field-name',
        value: this.state.value,
        options: this.state.options,
        onChange: this.handleChange,
        multi: this.props.multiSelect,
        autosize: true,
        clearable: true
      }),
      _react2.default.createElement(
        'div',
        { className: 'App resourceSelectorButtons' },
        _react2.default.createElement(
          _reactBootstrap.Button,
          {
            className: 'App App-Button',
            bsStyle: 'primary',
            onClick: this.onRemoveClick },
          this.state.labels.buttons.remove
        ),
        _react2.default.createElement(
          _reactBootstrap.Button,
          {
            className: 'App App-Button',
            bsStyle: 'warning',
            onClick: this.onRemoveAllClick },
          this.state.labels.buttons.removeAll
        )
      )
    );
  };

  return EditableSelector;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState({
      labels: {
        buttons: labels[labelTopics.button]
      },
      value: nextProps.initialValue,
      options: nextProps.options
    });
  };

  this.callBack = function () {
    _this2.props.changeHandler(_this2.state.value, _this2.state.options);
  };

  this.handleChange = function (selection) {
    _this2.setState({ value: selection.value }, _this2.callBack);
  };

  this.onRemoveClick = function () {
    var value = _this2.state.value;
    var options = [];
    options = _this2.state.options.filter(function (el) {
      return el.value !== value;
    });
    _this2.setState({ options: options, value: "" }, _this2.callBack);
  };

  this.onRemoveAllClick = function () {
    _this2.setState({ options: [], value: "" }, _this2.callBack);
  };
}, _temp);


process.env.NODE_ENV !== "production" ? EditableSelector.propTypes = {
  session: _propTypes2.default.object.isRequired,
  initialValue: _propTypes2.default.string,
  options: _propTypes2.default.array.isRequired,
  changeHandler: _propTypes2.default.func.isRequired,
  multiSelect: _propTypes2.default.bool.isRequired,
  title: _propTypes2.default.string
} : void 0;

// set default values for props here
EditableSelector.defaultProps = {
  initialValue: "",
  title: ""
};

exports.default = EditableSelector;