'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _IdManager = require('../helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _reactBootstrap = require('react-bootstrap');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _lodash = require('lodash');

var _Server = require('./../helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _UiSchemas = require('../classes/UiSchemas');

var _UiSchemas2 = _interopRequireDefault(_UiSchemas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * This component provides a schema based form editor.
 * To add a new schema to the list, do so via
 * ioc-liturgical-schemas.NEW_FORM_CLASSES_DB_API
 * and set the entry's includeForSchemaEditor parameter to true.
 * Also, in this class, check the getTopic function.  Make sure
 * it handles the new schema.  Otherwise it's topic will be overwritten.
 *
 */
var GenericNewEntryForm = (_temp = _class = function (_React$Component) {
  _inherits(GenericNewEntryForm, _React$Component);

  function GenericNewEntryForm(props) {
    _classCallCheck(this, GenericNewEntryForm);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var schemaTypes = [];
    if (props.schemaTypes) {
      schemaTypes = props.schemaTypes;
    } else {
      if (props.session && props.session.dropdowns) {
        schemaTypes = props.session.dropdowns.schemaEditorDropdown.filter(function (el) {
          return !el.label.startsWith("Any ");
        });
      }
    }

    var userDomain = "";
    if (_this.props.session && _this.props.session.userInfo && _this.props.session.userInfo.domain) {
      userDomain = _this.props.session.userInfo.domain;
    }

    var ontologyLibrary = { label: "en_sys_ontology", value: "en_sys_ontology" };

    var libraries = _this.props.session.userInfo.domains.author;

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    var thisClassLabels = labels[labelTopics.GenericNewEntryForm];

    var title = thisClassLabels.title;
    if (props.title) {
      title = props.title;
    }

    var uiSchemas = {};
    if (props.session && props.session.uiSchemas) {
      uiSchemas = new _UiSchemas2.default(props.session.uiSchemas.formsDropdown, props.session.uiSchemas.formsSchemas, props.session.uiSchemas.forms);
    }

    _this.state = {
      labels: {
        thisClass: thisClassLabels,
        button: labels[labelTopics.button],
        httpCodes: labels[labelTopics.httpCodes],
        messages: labels[labelTopics.messages],
        search: labels[labelTopics.search],
        title: title
      },
      session: {
        uiSchemas: uiSchemas
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      schemaTypes: (0, _lodash.get)(_this.state, "schemaTypes", schemaTypes),
      schema: {},
      uiSchema: {},
      formData: {},
      showForm: false,
      newEntryType: "",
      newEntryLibrary: userDomain,
      newEntryTopic: "",
      newEntryKey: "",
      idUnique: false,
      idMessage: "",
      ontologyLibrary: ontologyLibrary,
      libraries: libraries
    };

    _this.getBibTex = _this.getBibTex.bind(_this);
    _this.getForm = _this.getForm.bind(_this);
    _this.getSchemaSelector = _this.getSchemaSelector.bind(_this);
    _this.getTopic = _this.getTopic.bind(_this);
    _this.getValidationState = _this.getValidationState.bind(_this);
    _this.handleSchemaTypeChange = _this.handleSchemaTypeChange.bind(_this);
    _this.handleNewEntryLibraryChange = _this.handleNewEntryLibraryChange.bind(_this);
    _this.handleNewEntryKeyChange = _this.handleNewEntryKeyChange.bind(_this);
    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.verifyIdIsUnique = _this.verifyIdIsUnique.bind(_this);
    _this.handleIdUniquenessCheckCallback = _this.handleIdUniquenessCheckCallback.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  /**
   * I am not using this because it turns ALL the fields
   * in the form to green or red, etc. and looks ugly.
   * Probably with CSS this can be controlled.
   * @returns {null}
   */


  GenericNewEntryForm.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-New-Component-Template' },
      this.getSchemaSelector(),
      this.state.showForm && this.getForm()
    );
  };

  return GenericNewEntryForm;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    var thisClassLabels = labels[labelTopics.GenericNewEntryForm];

    var schemaTypes = [];
    if (nextProps.schemaTypes) {
      schemaTypes = nextProps.schemaTypes;
    } else {
      if (nextProps.session && nextProps.session.dropdowns) {
        schemaTypes = nextProps.session.dropdowns.schemaEditorDropdown.filter(function (el) {
          return !el.label.startsWith("Any ");
        });
      }
    }

    var libraries = nextProps.session.userInfo.domains.author;
    var title = thisClassLabels.title;
    if (nextProps.title) {
      title = nextProps.title;
    }

    var uiSchemas = {};
    if (nextProps.session && nextProps.session.uiSchemas) {
      uiSchemas = new _UiSchemas2.default(nextProps.session.uiSchemas.formsDropdown, nextProps.session.uiSchemas.formsSchemas, nextProps.session.uiSchemas.forms);
    }

    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: thisClassLabels,
          button: labels[labelTopics.button],
          httpCodes: labels[labelTopics.httpCodes],
          messages: labels[labelTopics.messages],
          search: labels[labelTopics.search],
          title: title
        },
        session: {
          uiSchemas: uiSchemas
        },
        message: labels[labelTopics.messages].initial,
        schemaTypes: (0, _lodash.get)(prevState, "schemaTypes", schemaTypes),
        schema: (0, _lodash.get)(prevState, "schema", ""),
        uiSchema: (0, _lodash.get)(prevState, "uiSchema", {}),
        formData: (0, _lodash.get)(prevState, "formData", {}),
        libraries: libraries
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.getValidationState = function () {
    return null;
  };

  this.verifyIdIsUnique = function () {
    _Server2.default.getGenericExistsResult(_this2.props.session.restServer, _this2.props.session.userInfo.username, _this2.props.session.userInfo.password, _this2.state.newEntryLibrary, _this2.state.newEntryTopic, _this2.state.newEntryKey, _this2.handleIdUniquenessCheckCallback);
  };

  this.handleIdUniquenessCheckCallback = function (restCallResult) {
    if (restCallResult && restCallResult.data && restCallResult.data.values) {
      _this2.setState({
        data: restCallResult.data
      });
      var message = "";
      var idUnique = true;
      var showForm = true;
      var formData = _this2.state.formData;

      if (restCallResult.data.valueCount && restCallResult.data.valueCount > 0) {
        message = _this2.state.labels.thisClass.exists;
        idUnique = false;
        showForm = false;
      } else {
        formData.library = _this2.state.newEntryLibrary;
        formData.topic = _this2.state.newEntryTopic;
        formData.key = _this2.state.newEntryKey;
        formData.id = _IdManager2.default.toId(_this2.state.newEntryLibrary, _this2.state.newEntryTopic, _this2.state.newEntryKey);
      }
      _this2.setState({
        idMessage: message,
        idExists: idUnique,
        showForm: showForm,
        formData: formData
      });
    }
  };

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    _this2.setState({
      message: _this2.state.labels.search.creating,
      messageIcon: _this2.state.messageIcons.info
    });

    var config = {
      auth: {
        username: _this2.props.session.userInfo.username,
        password: _this2.props.session.userInfo.password
      }
    };
    var path = _this2.props.session.restServer + _this2.props.path;
    _axios2.default.post(path, formData, config).then(function (response) {
      _this2.setState({
        message: _this2.state.labels.search.created,
        formData: formData
      });
      if (_this2.props.onSubmit) {
        _this2.props.onSubmit(formData);
      }
    }).catch(function (error) {
      var message = error.response.statusText;
      if (_this2.state.labels.httpCodes[error.response.status]) {
        message = labels[languageCode].httpCodes[error.response.status];
      }

      var messageIcon = _this2.state.messageIcons.error;
      _this2.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.getTopic = function (selection) {
    var label = selection["label"];
    var value = selection["value"];
    if (value.startsWith("BibEntry")) {
      return "biblioentry";
    } else if (value.startsWith("Abbreviation")) {
      return "abbreviation";
    } else if (label.includes("Ontology")) {
      if (value.endsWith("CreateForm:1.1")) {
        value = value.substring(0, value.length - 14);
      } else if (value.endsWith(":1.1")) {
        value = value.substring(0, value.length - 4);
      }
      return value;
    } else if (label.startsWith("Dictionary")) {
      return "words";
    } else {
      return undefined;
    }
  };

  this.handleSchemaTypeChange = function (selection) {
    if (selection) {
      var type = selection["value"];
      var label = selection["label"];
      var topic = _this2.getTopic(selection);
      var schemaId = type;
      var schema = {};
      var uiSchema = {};
      var formData = {};
      var newEntryLibrary = _this2.state.newEntryLibrary;

      var libraries = _this2.props.session.userInfo.domains.author;

      if (label.includes("Ontology")) {
        libraries = libraries.filter(function (el) {
          return el.value === "en_sys_ontology";
        });
        newEntryLibrary = "en_sys_ontology";
      } else if (label.startsWith("Dictionary")) {
        newEntryLibrary = "en_sys_translib";
      }

      var message = "";
      if (libraries.length === 0) {
        message = _this2.state.messages.notAuthorized;
      }
      if (type && _this2.props.session && _this2.state.session.uiSchemas) {
        schema = _this2.state.session.uiSchemas.getSchema(schemaId);
        uiSchema = _this2.state.session.uiSchemas.getUiSchema(schemaId);
        formData = _this2.state.session.uiSchemas.getForm(schemaId);
      }
      _this2.setState({
        newEntryType: type,
        schema: schema,
        uiSchema: uiSchema,
        formData: formData,
        newEntryTopic: topic,
        showForm: false,
        libraries: libraries,
        newEntryLibrary: newEntryLibrary,
        message: message
      });
    }
  };

  this.handleNewEntryKeyChange = function (event) {
    _this2.setState({
      newEntryKey: event.target.value,
      idMessage: "",
      showForm: false
    });
  };

  this.handleNewEntryLibraryChange = function (selection) {
    if (selection && selection.value) {
      _this2.setState({
        newEntryLibrary: selection.value,
        showForm: false
      });
    }
  };

  this.getSchemaSelector = function () {
    if (_this2.props.session && _this2.props.session.userInfo && _this2.props.session.userInfo.domains && _this2.props.session.userInfo.domains.author) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'h3',
          null,
          _this2.state.labels.title
        ),
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          _this2.state.labels.thisClass.instructions
        ),
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          _react2.default.createElement(
            'form',
            null,
            _react2.default.createElement(
              _reactBootstrap.FormGroup,
              {
                controlId: 'formBasicText',
                validationState: _this2.getValidationState()
              },
              _react2.default.createElement(
                _reactBootstrap.Row,
                { className: 'App-Generic-Add-Options-Row' },
                _react2.default.createElement(
                  _reactBootstrap.ControlLabel,
                  null,
                  _this2.state.labels.thisClass.selectSchemaType
                ),
                _react2.default.createElement(_ReactSelector2.default, {
                  initialValue: _this2.state.newEntryType,
                  resources: _this2.state.schemaTypes,
                  changeHandler: _this2.handleSchemaTypeChange,
                  multiSelect: false
                })
              ),
              _react2.default.createElement(
                _reactBootstrap.Row,
                { className: 'App-Generic-Add-Options-Row' },
                _react2.default.createElement(
                  _reactBootstrap.ControlLabel,
                  null,
                  _this2.state.labels.thisClass.selectLibrary
                ),
                _react2.default.createElement(_ReactSelector2.default, {
                  initialValue: _this2.state.newEntryLibrary,
                  resources: _this2.state.libraries,
                  changeHandler: _this2.handleNewEntryLibraryChange,
                  multiSelect: false
                })
              ),
              _react2.default.createElement(_reactBootstrap.Row, { className: 'App-Generic-Add-Options-Row' }),
              _react2.default.createElement(
                _reactBootstrap.Row,
                { className: 'App-Generic-Add-Options-Row' },
                _react2.default.createElement(
                  _reactBootstrap.ControlLabel,
                  null,
                  _this2.state.labels.thisClass.enterKey
                ),
                _react2.default.createElement(_reactBootstrap.FormControl, {
                  className: "App App-Generic-Add-Key-text-input",
                  type: 'text',
                  value: _this2.state.newEntryKey,
                  placeholder: "Key",
                  onChange: _this2.handleNewEntryKeyChange
                }),
                _react2.default.createElement(_reactBootstrap.FormControl.Feedback, null),
                _react2.default.createElement(
                  _reactBootstrap.HelpBlock,
                  null,
                  _this2.state.idMessage
                )
              )
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsStyle: 'primary',
              type: 'submit',
              onClick: _this2.verifyIdIsUnique
            },
            _this2.state.labels.button.checkId
          )
        )
      );
    }
  };

  this.getBibTex = function () {
    if (_this2.state.newEntryType.startsWith("BibEntry")) {
      return _react2.default.createElement(
        'div',
        { className: 'App-BibTex-Notice' },
        _this2.state.labels.thisClass.bibTex,
        _react2.default.createElement(
          'a',
          { href: "http://mirrors.ibiblio.org/CTAN/macros/latex/contrib/biblatex/doc/biblatex.pdf", target: '_blank' },
          ' ',
          _this2.state.labels.thisClass.bibTexLink
        )
      );
    }
  };

  this.getForm = function () {
    if (_this2.state.schema) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'info' },
          _this2.state.labels.thisClass.formLengthWarning,
          _this2.getBibTex()
        ),
        _react2.default.createElement(
          _reactJsonschemaForm2.default,
          { schema: _this2.state.schema,
            uiSchema: _this2.state.uiSchema,
            formData: _this2.state.formData,
            onSubmit: _this2.onSubmit
          },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              {
                bsStyle: 'primary',
                type: 'submit'
              },
              _this2.state.labels.button.submit
            ),
            _react2.default.createElement(
              'span',
              { className: 'App App-message' },
              _react2.default.createElement(_reactFontawesome2.default, {
                name: _this2.state.messageIcon }),
              _this2.state.message
            )
          )
        )
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? GenericNewEntryForm.propTypes = {
  session: _propTypes2.default.object.isRequired,
  path: _propTypes2.default.string.isRequired,
  onSubmit: _propTypes2.default.func,
  schemaTypes: _propTypes2.default.array,
  title: _propTypes2.default.string
} : void 0;

// set default values for props here
GenericNewEntryForm.defaultProps = {
  languageCode: "en"
};

exports.default = GenericNewEntryForm;
module.exports = exports['default'];