'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _Spinner = require('../helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HyperTokenText = (_temp = _class = function (_React$Component) {
  _inherits(HyperTokenText, _React$Component);

  function HyperTokenText(props) {
    _classCallCheck(this, HyperTokenText);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.renderTokens = _this.renderTokens.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    _this.getRuby = _this.getRuby.bind(_this);
    _this.getTokenWordSpan = _this.getTokenWordSpan.bind(_this);

    return _this;
  }

  HyperTokenText.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App App-HyperTokenText-Container' },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.thisClass.instructions
        )
      ),
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          'div',
          { className: 'App App-HyperTokenText-Text' },
          this.renderTokens()
        )
      )
    );
  };

  return HyperTokenText;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state);
  };

  this.setTheState = function (props, currentState) {
    var selectedToken = (0, _lodash.get)(currentState, "selectedToken", -1);
    if (_this2.props.selectedToken !== props.selectedToken) {
      selectedToken = props.selectedToken;
    }
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;
    return {
      labels: {
        thisClass: labels[labelTopics.HyperTokenText],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedToken: selectedToken,
      lastPropToken: (0, _lodash.get)(props, "selectedToken", -1)
    };
  };

  this.handleClick = function (event) {
    _this2.setState({
      selectedToken: parseInt(event.currentTarget.id)
    });
    _this2.props.onClick(event.currentTarget.id, event.currentTarget.textContent.trim());
  };

  this.getTokenWordSpan = function (token, index) {
    if (_this2.state.selectedToken === index) {
      return _react2.default.createElement(
        'rb',
        null,
        _react2.default.createElement(
          'span',
          { className: 'App-HyperToken-Word-Selected', id: index, onClick: _this2.handleClick },
          token,
          '\xA0'
        )
      );
    } else {
      return _react2.default.createElement(
        'rb',
        null,
        _react2.default.createElement(
          'span',
          { className: 'App-HyperToken-Word', id: index, onClick: _this2.handleClick },
          token,
          '\xA0'
        )
      );
    }
  };

  this.getRuby = function (token, index) {
    return _react2.default.createElement(
      'ruby',
      { className: 'App App-HyperToken', key: index },
      _this2.getTokenWordSpan(token, index),
      _react2.default.createElement(
        'rt',
        null,
        _react2.default.createElement(
          'span',
          { className: 'App-HyperToken-Index' },
          index + 1
        )
      )
    );
  };

  this.renderTokens = function () {
    if (_this2.props.tokens && _this2.props.tokens.length > 0) {
      var result = [];
      var size = _this2.props.tokens.length;
      for (var index = 0; index < size; index++) {
        result.push(_this2.getRuby(_this2.props.tokens[index], index));
      }
      return result;
    } else {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_Spinner2.default, { message: _this2.state.labels.messages.retrieving })
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? HyperTokenText.propTypes = {
  session: _propTypes2.default.object.isRequired,
  tokens: _propTypes2.default.array.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  selectedToken: _propTypes2.default.number
} : void 0;

HyperTokenText.defaultProps = {};

exports.default = HyperTokenText;
module.exports = exports['default'];