'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _SearchText = require('../SearchText');

var _SearchText2 = _interopRequireDefault(_SearchText);

var _SearchOntology = require('../SearchOntology');

var _SearchOntology2 = _interopRequireDefault(_SearchOntology);

var _IdManager = require('../helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IdBuilder = (_temp = _class = function (_React$Component) {
  _inherits(IdBuilder, _React$Component);

  function IdBuilder(props) {
    _classCallCheck(this, IdBuilder);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.handleLibraryChange = _this.handleLibraryChange.bind(_this);
    _this.handleBiblicalBooksChange = _this.handleBiblicalBooksChange.bind(_this);
    _this.handleBiblicalChaptersChange = _this.handleBiblicalChaptersChange.bind(_this);
    _this.handleBiblicalVersesChange = _this.handleBiblicalVersesChange.bind(_this);
    _this.handleBiblicalSubversesChange = _this.handleBiblicalSubversesChange.bind(_this);
    _this.handleBiblicalChapterVerseSelection = _this.handleBiblicalChapterVerseSelection.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTopicSearchRequest = _this.handleTopicSearchRequest.bind(_this);
    _this.handleTopicSearchCallback = _this.handleTopicSearchCallback.bind(_this);
    _this.handleTopicTextCallback = _this.handleTopicTextCallback.bind(_this);
    _this.handleTopicTextChange = _this.handleTopicTextChange.bind(_this);
    _this.handleKeySearchRequest = _this.handleKeySearchRequest.bind(_this);
    _this.handleKeySearchCallback = _this.handleKeySearchCallback.bind(_this);
    _this.handleKeyTextCallback = _this.handleKeyTextCallback.bind(_this);
    _this.handleKeyTextChange = _this.handleKeyTextChange.bind(_this);
    _this.toogleTopicPanel = _this.toogleTopicPanel.bind(_this);
    _this.toogleKeyPanel = _this.toogleKeyPanel.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    _this.getLibrarySelector = _this.getLibrarySelector.bind(_this);
    _this.getSelector = _this.getSelector.bind(_this);
    _this.getIdFormControl = _this.getIdFormControl.bind(_this);
    _this.getIdValueFormControl = _this.getIdValueFormControl.bind(_this);
    _this.setTheState = _this.setTheState.bind(_this);
    return _this;
  }

  /**
   * The topic and key parts of an ID have differing content
   * depending on what the form schema is.
   *
   * This function returns a selector that is appropriate
   * for the type passed in.
   *
   * @param type
   */


  IdBuilder.prototype.handleTopicSearchRequest = function handleTopicSearchRequest() {
    this.setState({
      searchingForTopic: true
    });
  };

  IdBuilder.prototype.handleTopicSearchCallback = function handleTopicSearchCallback(id, value, seq) {
    if (id && id.length > 0) {
      this.props.handleTopicChange(id, value);
      if (this.props.IdTopicType === "TOPIC_FROM_ID_OF_SELECTED_BIBLICAL_VERSE" || this.props.IdTopicType === "TOPIC_FROM_ID_OF_SELECTED_LITURGICAL_TEXT") {
        this.setState({
          searchingForTopic: false,
          selectedTopic: _IdManager2.default.getTopic(id),
          selectedTopicValue: value,
          searchingForKey: false,
          selectedKey: _IdManager2.default.getKey(id),
          selectedKeyValue: "",
          selectedSeq: seq,
          panel: { keyOpen: false, topicOpen: false }
        }, this.handleSubmit);
      } else {
        this.setState({
          searchingForTopic: false,
          selectedTopic: id,
          selectedTopicValue: value,
          selectedSeq: seq,
          panel: { keyOpen: false, topicOpen: false }
        }, this.handleSubmit);
      }
    } else {
      this.setState({
        searchingForTopic: false,
        panel: { keyOpen: false, topicOpen: false }
      });
    }
  };

  IdBuilder.prototype.handleKeySearchRequest = function handleKeySearchRequest() {
    this.setState({
      searchingForKey: true
    });
  };

  IdBuilder.prototype.handleKeySearchCallback = function handleKeySearchCallback(id, value, seq) {
    if (id && id.length > 0) {
      var theValue = value;
      if (theValue === undefined) {
        theValue = id;
      }
      this.setState({
        searchingForKey: false,
        selectedKey: id,
        selectedKeyValue: theValue,
        selectedSeq: seq,
        panel: { keyOpen: false, topicOpen: false }
      }, this.handleSubmit);
    } else {
      this.setState({
        searchingForKey: false,
        panel: { keyOpen: false, topicOpen: false }
      });
    }
  };

  IdBuilder.prototype.render = function render() {
    return this.getContent();
  };

  return IdBuilder;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps, _this2.state.selectedLibrary);
  };

  this.setTheState = function (props, IdLibrary) {
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      searchLabels: labels[labelTopics.search],
      resultsTableLabels: labels[labelTopics.resultsTable],
      selectedLibrary: props.IdLibrary,
      selectedLibraryLabel: "",
      selectedTopic: props.IdTopic,
      tempTopic: "",
      selectedTopicValue: props.IdTopicValue,
      selectedKey: props.IdKey,
      tempKey: "",
      selectedKeyValue: props.IdKeyValue,
      selectedSeq: "",
      selectedBiblicalBook: "",
      selectedBiblicalChapter: "",
      selectedBiblicalVerse: "",
      selectedBiblicalSubverse: "*",
      searchingForTopic: false,
      searchingForKey: false,
      panel: {
        keyOpen: false,
        topicOpen: false,
        idBuilderOpen: true
      }
    };
  };

  this.getIdFormControl = function (type, labelType, label, value) {
    var searchLabels = _this2.state.searchLabels.IdParts[type];
    switch (type) {
      case "BIBLICAL_BOOK_ABBREVIATION":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "BIBLICAL_CHAPTER_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "NOTE_USING_ID_OF_SELECTED_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "ID_OF_SELECTED_ONTOLOGY_INSTANCE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "KEY_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "KEY_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "ONTOLOGY_TOPIC":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "TIMESTAMP":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      case "USER_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: value,
            disabled: true
          })
        );
        break;
      default:
    }
  };

  this.getIdValueFormControl = function (type, label, value) {
    switch (type) {
      case "BIBLICAL_BOOK_ABBREVIATION":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "BIBLICAL_CHAPTER_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "NOTE_USING_ID_OF_SELECTED_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "ID_OF_SELECTED_ONTOLOGY_INSTANCE":
        break;
      case "KEY_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        break;
      case "KEY_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        break;
      case "ONTOLOGY_TOPIC":
        return _react2.default.createElement('div', null);
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            label
          ),
          _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            value
          )
        );
        break;
      case "USER_TEXT":
        return _react2.default.createElement('div', null);
        break;
      default:
        return _react2.default.createElement('div', null);
    }
  };

  this.getLibrarySelector = function (type) {
    var searchLabels = _this2.state.searchLabels.IdParts[type];
    switch (type) {
      case "NOTE_USING_ID_OF_SELECTED_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            searchLabels.library
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: _this2.props.IdLibrary,
            disabled: true
          })
        );
        break;
      case "ONTOLOGY_TOPIC":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            searchLabels.library
          ),
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: _this2.props.IdLibrary,
            disabled: true
          })
        );
        break;
      default:
        return _react2.default.createElement(_ReactSelector2.default, {
          title: "Library...",
          initialValue: _this2.state.selectedLibrary,
          resources: _this2.props.session.userInfo.domains["author"],
          changeHandler: _this2.handleLibraryChange,
          multiSelect: false
        });
    }
  };

  this.getSelector = function (type, labelType, callback, textValue, textChangeHandler, textCallback) {
    var searchLabel = _this2.state.searchLabels.IdParts[type];
    switch (type) {
      case "BIBLICAL_BOOK_ABBREVIATION":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleTopicPanel,
              collapsible: true
            },
            _react2.default.createElement(_ReactSelector2.default, {
              title: searchLabel.topic,
              initialValue: _this2.state.selectedTopic,
              resources: _this2.props.session.dropdowns.biblicalBooksDropdown,
              changeHandler: _this2.handleBiblicalBooksChange,
              multiSelect: false
            })
          )
        );
        break;
      case "BIBLICAL_CHAPTER_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleKeyPanel,
              collapsible: true
            },
            _react2.default.createElement(_ReactSelector2.default, {
              title: searchLabel.chapter,
              initialValue: _this2.state.selectedBiblicalChapter,
              resources: _this2.props.session.dropdowns.biblicalChaptersDropdown,
              changeHandler: _this2.handleBiblicalChaptersChange,
              multiSelect: false
            }),
            _react2.default.createElement(_ReactSelector2.default, {
              title: searchLabel.verse,
              initialValue: _this2.state.selectedBiblicalVerse,
              resources: _this2.props.session.dropdowns.biblicalVersesDropdown,
              changeHandler: _this2.handleBiblicalVersesChange,
              multiSelect: false
            }),
            _react2.default.createElement(_ReactSelector2.default, {
              title: searchLabel.versePart,
              initialValue: _this2.state.selectedBiblicalSubverse,
              resources: _this2.props.session.dropdowns.biblicalSubversesDropdown,
              changeHandler: _this2.handleBiblicalSubversesChange,
              multiSelect: false
            })
          )
        );
        break;
      case "ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleKeyPanel,
              collapsible: true
            },
            _react2.default.createElement(_SearchText2.default, {
              session: _this2.props.session,
              callback: callback,
              searchLabels: _this2.state.searchLabels,
              resultsTableLabels: _this2.state.resultsTableLabels,
              initialDocType: 'Biblical'
            })
          )
        );
        break;
      case "NOTE_USING_ID_OF_SELECTED_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: true,
              onSelect: _this2.toogleTopicPanel,
              collapsible: true
            },
            _react2.default.createElement(_SearchText2.default, {
              session: _this2.props.session,
              callback: callback,
              searchLabels: _this2.state.searchLabels,
              resultsTableLabels: _this2.state.resultsTableLabels,
              initialDocType: 'Liturgical'
            })
          )
        );
        break;
      case "ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleTopicPanel,
              collapsible: true
            },
            _react2.default.createElement(_SearchText2.default, {
              session: _this2.props.session,
              callback: callback,
              searchLabels: _this2.state.searchLabels,
              resultsTableLabels: _this2.state.resultsTableLabels,
              initialDocType: 'Liturgical'
            })
          )
        );
        break;
      case "ID_OF_SELECTED_ONTOLOGY_INSTANCE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleKeyPanel,
              collapsible: true
            },
            _react2.default.createElement(_SearchOntology2.default, {
              session: _this2.props.session,
              callback: callback,
              editor: false,
              initialType: _this2.props.initialOntologyType,
              fixedType: true
            })
          )
        );
        break;
      case "KEY_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        break;
      case "KEY_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        break;
      case "ONTOLOGY_TOPIC":
        return _react2.default.createElement('div', null);
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_BIBLICAL_VERSE":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleTopicPanel,
              collapsible: true
            },
            _react2.default.createElement(
              _reactBootstrap.ControlLabel,
              null,
              searchLabel.key
            ),
            _react2.default.createElement(_SearchText2.default, {
              session: _this2.props.session,
              callback: callback,
              searchLabels: _this2.state.searchLabels,
              resultsTableLabels: _this2.state.resultsTableLabels,
              initialDocType: 'Biblical'
            })
          )
        );
        break;
      case "TOPIC_FROM_ID_OF_SELECTED_LITURGICAL_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Panel,
            {
              header: searchLabel.prompt,
              eventKey: type + labelType,
              expanded: _this2.state.panel[labelType + "Open"],
              onSelect: _this2.toogleTopicPanel,
              collapsible: true
            },
            _react2.default.createElement(_SearchText2.default, {
              session: _this2.props.session,
              callback: callback,
              searchLabels: _this2.state.searchLabels,
              resultsTableLabels: _this2.state.resultsTableLabels,
              initialDocType: 'Liturgical'
            })
          )
        );
        break;
      case "USER_TEXT":
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_reactBootstrap.FormControl, {
            type: 'text',
            value: textValue,
            placeholder: searchLabel.prompt,
            onChange: textChangeHandler
          }),
          _react2.default.createElement(
            _reactBootstrap.Button,
            { bsStyle: 'primary', type: 'submit', onClick: textCallback },
            searchLabel.button
          )
        );
        break;
      default:
    }
  };

  this.toogleTopicPanel = function () {
    _this2.setState({
      panel: {
        keyOpen: false,
        topicOpen: !_this2.state.panel.topicOpen
      }
    });
  };

  this.toogleKeyPanel = function () {
    _this2.setState({
      panel: {
        keyOpen: !_this2.state.panel.keyOpen,
        topicOpen: false
      }
    });
  };

  this.handleLibraryChange = function (selection) {
    _this2.props.handleLibraryChange(selection["value"]);
    _this2.setState({
      selectedLibrary: selection["value"],
      selectedLibraryLabel: selection["label"]
    }, _this2.handleSubmit);
  };

  this.handleBiblicalBooksChange = function (selection) {
    _this2.props.handleTopicChange(selection["value"], selection["label"]);
    _this2.setState({
      searchingForTopic: false,
      selectedTopic: selection["value"],
      selectedTopicValue: selection["label"],
      selectedSeq: "",
      panel: { keyOpen: false, topicOpen: false }
    }, _this2.handleSubmit);
  };

  this.handleBiblicalChaptersChange = function (selection) {
    _this2.setState({
      selectedBiblicalChapter: selection["value"],
      selectedBiblicalChapterLabel: selection["label"]
    }, _this2.handleBiblicalChapterVerseSelection);
  };

  this.handleBiblicalVersesChange = function (selection) {
    _this2.setState({
      selectedBiblicalVerse: selection["value"],
      selectedBiblicalVerseLabel: selection["label"]
    }, _this2.handleBiblicalChapterVerseSelection);
  };

  this.handleBiblicalSubversesChange = function (selection) {
    _this2.setState({
      selectedBiblicalSubverse: selection["value"],
      selectedBiblicalSubverseLabel: selection["label"]
    }, _this2.handleBiblicalChapterVerseSelection);
  };

  this.handleBiblicalChapterVerseSelection = function () {
    if (_this2.state.selectedBiblicalChapter.length > 0 && _this2.state.selectedBiblicalVerse.length > 0 && _this2.state.selectedBiblicalSubverse.length > 0) {
      var theKey = _this2.state.selectedBiblicalChapter + ":" + _this2.state.selectedBiblicalVerse;
      if (_this2.state.selectedBiblicalSubverse !== "*") {
        theKey = theKey + _this2.state.selectedBiblicalSubverse;
      }
      _this2.setState({
        searchingForKey: false,
        selectedKey: theKey,
        selectedKeyValue: theKey,
        keyPanelOpen: false
      }, _this2.handleSubmit);
    }
  };

  this.handleTopicTextChange = function (value) {

    if (value && value.target && value.target.value && value.target.value.length > 0) {
      _this2.setState({
        tempTopic: value.target.value
      });
    }
  };

  this.handleKeyTextChange = function (value) {
    if (value && value.target && value.target.value && value.target.value.length > 0) {
      _this2.setState({
        tempKey: value.target.value
      });
    }
  };

  this.handleTopicTextCallback = function () {
    _this2.setState({
      searchingForTopic: false,
      selectedTopic: _this2.state.tempTopic,
      selectedTopicValue: _this2.state.tempTopic,
      topicPanelOpen: false
    }, _this2.handleSubmit);
  };

  this.handleKeyTextCallback = function () {
    _this2.setState({
      searchingForKey: false,
      selectedKey: _this2.state.tempKey,
      selectedKeyValue: _this2.state.tempKey,
      keyPanelOpen: false
    }, _this2.handleSubmit);
  };

  this.handleSubmit = function () {
    if (_this2.state.selectedLibrary.length > 0 && _this2.state.selectedTopic.length > 0 && _this2.state.selectedKey.length > 0) {
      _this2.props.handleSubmit(_this2.state.selectedLibrary, _this2.state.selectedTopic, _this2.state.selectedTopicValue, _this2.state.selectedKey, _this2.state.selectedKeyValue, _this2.state.selectedSeq);
    }
  };

  this.getContent = function () {
    return _react2.default.createElement(
      'div',
      { className: 'container App-id-builder' },
      _react2.default.createElement(
        'div',
        { className: 'App-id-builder-header' },
        _this2.state.searchLabels.IdParts.msg1
      ),
      _react2.default.createElement('div', null),
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _this2.getLibrarySelector(_this2.props.IdTopicType)
      ),
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.FormGroup,
          null,
          _this2.getIdFormControl(_this2.props.IdTopicType, "topic", _this2.state.searchLabels.IdParts[_this2.props.IdTopicType].topic, _this2.state.selectedTopic),
          _this2.state.selectedTopic.length > 0 && _this2.getIdValueFormControl(_this2.props.IdTopicType, _this2.state.searchLabels.IdParts[_this2.props.IdTopicType].topicValue, _this2.state.selectedTopicValue)
        ),
        _this2.getSelector(_this2.props.IdTopicType, "topic", _this2.handleTopicSearchCallback, _this2.state.IdTopicValue, _this2.handleTopicTextChange, _this2.handleTopicTextCallback)
      ),
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.FormGroup,
          null,
          _this2.getIdFormControl(_this2.props.IdKeyType, "key", _this2.state.searchLabels.IdParts[_this2.props.IdKeyType].key, _this2.state.selectedKey),
          _this2.state.selectedKey.length > 0 && _this2.getIdValueFormControl(_this2.props.IdKeyType, _this2.state.searchLabels.IdParts[_this2.props.IdKeyType].keyValue, _this2.state.selectedKeyValue)
        ),
        _this2.getSelector(_this2.props.IdKeyType, "key", _this2.handleKeySearchCallback, _this2.state.tempKey, _this2.handleKeyTextChange, _this2.handleKeyTextCallback)
      )
    );
  };
}, _temp);


process.env.NODE_ENV !== "production" ? IdBuilder.propTypes = {
  session: _propTypes2.default.object.isRequired,
  IdLibrary: _propTypes2.default.string.isRequired,
  IdTopic: _propTypes2.default.string.isRequired,
  IdTopicValue: _propTypes2.default.string.isRequired,
  IdTopicType: _propTypes2.default.string.isRequired,
  IdKey: _propTypes2.default.string.isRequired,
  IdKeyValue: _propTypes2.default.string.isRequired,
  IdKeyType: _propTypes2.default.string.isRequired,
  handleLibraryChange: _propTypes2.default.func.isRequired,
  handleTopicChange: _propTypes2.default.func.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  initialOntologyType: _propTypes2.default.string.isRequired
} : void 0;

exports.default = IdBuilder;
module.exports = exports['default'];