'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinkSearchOptions = function (_React$Component) {
  _inherits(LinkSearchOptions, _React$Component);

  function LinkSearchOptions(props) {
    _classCallCheck(this, LinkSearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.PropTypesWillMount = function () {};

    _this.PropTypesWillReceiveProps = function (nextProps) {
      _this.setState({});
    };

    _this.handleDocTypeChange = function (selection) {
      var type = selection["value"];
      _this.setState({
        selectedType: type,
        dropDownLibraries: {
          msg: _this.props.labels.domainIs,
          source: _this.props.libraries[type],
          initialValue: "*"
        },
        dropDownProperties: {
          msg: _this.props.labels.domainIs,
          source: _this.props.properties[type],
          initialValue: "*"
        }
      });
    };

    _this.handlePropertyChange = function (item) {
      _this.setState({ selectedProperty: item.value });
    };

    _this.handleMatcherChange = function (item) {
      _this.setState({ selectedMatcher: item.value });
    };

    _this.handleValueChange = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleTagsSelection = function (selection) {
      var tags = selection.map(function (a) {
        return a.value;
      });

      _this.setState({
        selectedTags: tags
      });
    };

    _this.handleTagOperatorChange = function (selection) {
      _this.setState({
        selectedTagOperator: selection["value"]
      });
    };

    _this.isDisabled = function () {

      var disableButton = true;
      if (_this.state.value && _this.state.value.length > 0) {
        disableButton = false;
      } else {
        switch (_this.state.selectedType) {
          case "*":
            {
              if (_this.state.selectedLibrary && _this.state.selectedLibrary.length > 0) {
                disableButton = false;
              }
              break;
            }
          default:
            {
              disableButton = false;
              break;
            }
        }
      }
      return disableButton;
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.selectedType, _this.state.selectedLibrary, _this.state.selectedProperty, _this.state.selectedMatcher, _this.state.value, _this.state.selectedTagOperator, _this.state.selectedTags);
      event.preventDefault();
    };

    _this.handleDomainChange = function (selection) {
      _this.setState({
        selectedLibrary: selection["value"] });
    };

    var initialType = "REFERS_TO_BIBLICAL_TEXT";
    _this.state = {
      selectedType: initialType,
      selectedLibrary: "*",
      selectedProperty: "*",
      selectedMatcher: "c",
      value: "",
      selectedTagOperator: "any",
      selectedTags: [],
      tagData: [],
      dropDownLibraries: {
        msg: _this.props.labels.domainIs,
        source: _this.props.libraries[initialType],
        initialValue: "*"
      },
      dropDownProperties: {
        msg: _this.props.labels.domainIs,
        source: _this.props.properties[initialType],
        initialValue: "*"
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handleDomainChange = _this.handleDomainChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTagsSelection = _this.handleTagsSelection.bind(_this);
    _this.handleTagOperatorChange = _this.handleTagOperatorChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);
    return _this;
  }

  LinkSearchOptions.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'container App-search-options-container' },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.findWhereTypeIs,
              initialValue: this.state.selectedType,
              resources: this.props.types,
              changeHandler: this.handleDocTypeChange,
              multiSelect: false
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.domainIs,
              initialValue: this.state.selectedLibrary,
              resources: this.props.libraries[this.state.selectedType],
              changeHandler: this.handleDomainChange,
              multiSelect: false
            })
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(_ReactSelector2.default, {
            title: this.props.labels.propertyIs,
            initialValue: this.state.selectedProperty,
            resources: this.props.properties[this.state.selectedType],
            changeHandler: this.handlePropertyChange,
            multiSelect: false
          })
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(
            'form',
            { onSubmit: this.handleSubmit },
            _react2.default.createElement(
              'div',
              { className: 'resourceSelectorPrompt' },
              this.props.labels.propertyTextIs
            ),
            _react2.default.createElement('input', {
              type: 'text',
              onChange: this.handleValueChange,
              className: 'App-search-text-input',
              name: 'search' })
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12 col-md-12 col-lg-12' },
          _react2.default.createElement(_ReactSelector2.default, {
            title: this.props.labels.matcherIs,
            initialValue: this.state.selectedMatcher,
            resources: this.props.matchers,
            changeHandler: this.handleMatcherChange,
            multiSelect: false
          }),
          this.state.selectedType !== "*" && _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.has,
              initialValue: 'any',
              resources: this.props.tagOperators,
              changeHandler: this.handleTagOperatorChange,
              multiSelect: false
            }),
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.tags,
              initialValue: '',
              resources: this.props.tags[this.state.selectedType],
              changeHandler: this.handleTagsSelection,
              multiSelect: true
            })
          ),
          _react2.default.createElement(
            'div',
            { className: 'control-label' },
            this.props.labels.clickTheButton
          ),
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsStyle: 'primary',
              bsSize: 'xsmall',
              type: 'submit',
              disabled: this.isDisabled(),
              onClick: this.handleSubmit
            },
            _react2.default.createElement(_reactFontawesome2.default, { className: 'Button-Select-FontAwesome', name: "search" }),
            this.props.labels.submit
          )
        )
      )
    );
  };

  return LinkSearchOptions;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? LinkSearchOptions.propTypes = {
  types: _propTypes2.default.array.isRequired,
  libraries: _propTypes2.default.object.isRequired,
  properties: _propTypes2.default.object.isRequired,
  matchers: _propTypes2.default.array.isRequired,
  tags: _propTypes2.default.object.isRequired,
  tagOperators: _propTypes2.default.array.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  labels: _propTypes2.default.object.isRequired
} : void 0;

exports.default = LinkSearchOptions;
module.exports = exports['default'];