'use strict';

exports.__esModule = true;
exports.ModalAgesServiceSelector = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _reactBootstrapTable = require('react-bootstrap-table');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal window to allow user to select an AGES service or sacrament.
 */
var ModalAgesServiceSelector = exports.ModalAgesServiceSelector = function (_React$Component) {
  _inherits(ModalAgesServiceSelector, _React$Component);

  function ModalAgesServiceSelector(props) {
    _classCallCheck(this, ModalAgesServiceSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.PropTypesWillMount = function () {};

    _this.close = function () {
      _this.setState({ showModal: false }, _this.props.onClose);
    };

    _this.open = function () {
      _this.setState({ showModal: true });
    };

    _this.handleRowSelect = function (row, isSelected, e) {
      _this.setState({
        selectedUrl: row["url"]
      }, _this.props.callBack(row["url"], row["type"], row["date"], row["dayOfWeek"]));
    };

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalAgesServiceSelector],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      options: {
        sizePerPage: 15,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select"
      },
      tableColumnFilter: {
        defaultValue: "",
        type: 'RegexFilter',
        placeholder: labels[labelTopics.messages].regEx
      },

      showSelectionButtons: false,

      selectedId: "",
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    return _this;
  }

  ModalAgesServiceSelector.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(
            'div',
            { className: 'App-modal-body' },
            _react2.default.createElement(
              'div',
              { className: 'row' },
              _react2.default.createElement(
                _reactBootstrap.Alert,
                { bsStyle: 'info', className: 'App-modal-alert' },
                _react2.default.createElement(
                  'p',
                  null,
                  _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'hand-right' }),
                  this.state.labels.thisClass.msg1,
                  this.state.labels.thisClass.msg2,
                  this.state.labels.thisClass.msg3,
                  this.state.labels.thisClass.msg4
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'row' },
              _react2.default.createElement(
                _reactBootstrapTable.BootstrapTable,
                {
                  ref: 'table',
                  data: this.props.values,
                  trClassName: "App-data-tr",
                  striped: true,
                  pagination: true,
                  options: this.state.options,
                  selectRow: this.state.selectRow
                },
                _react2.default.createElement(
                  _reactBootstrapTable.TableHeaderColumn,
                  {
                    ref: 'url',
                    isKey: true,
                    dataField: 'url',
                    dataSort: true,
                    width: this.state.topicKeyColumnSize,
                    filter: this.state.tableColumnFilter,
                    hidden: true
                  },
                  "URL"
                ),
                _react2.default.createElement(
                  _reactBootstrapTable.TableHeaderColumn,
                  {
                    ref: 'type',
                    dataSort: true,
                    dataField: 'type',
                    tdClassname: 'tdColAgesType',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.type
                ),
                _react2.default.createElement(
                  _reactBootstrapTable.TableHeaderColumn,
                  {
                    ref: 'date',
                    dataSort: true,
                    dataField: 'date',
                    tdClassname: 'tdColAgesDate',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.date
                ),
                _react2.default.createElement(
                  _reactBootstrapTable.TableHeaderColumn,
                  {
                    ref: 'dayOfWeek',
                    dataField: "dayOfWeek",
                    dataSort: true,
                    tdClassname: 'tdColAgesDay',
                    width: this.state.libraryValueColumnSize,
                    filter: this.state.tableColumnFilter
                  },
                  this.state.labels.thisClass.dayOfWeek
                )
              )
            )
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalAgesServiceSelector;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? ModalAgesServiceSelector.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callBack: _propTypes2.default.func.isRequired,
  onClose: _propTypes2.default.func.isRequired,
  values: _propTypes2.default.array.isRequired
} : void 0;
exports.default = ModalAgesServiceSelector;