'use strict';

exports.__esModule = true;
exports.ModalCompareDocs = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('../helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _CompareDocs = require('./CompareDocs');

var _CompareDocs2 = _interopRequireDefault(_CompareDocs);

var _lodash = require('lodash');

var _TreeViewUtils = require('../helpers/TreeViewUtils');

var _TreeViewUtils2 = _interopRequireDefault(_TreeViewUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var ModalCompareDocs = exports.ModalCompareDocs = function (_React$Component) {
  _inherits(ModalCompareDocs, _React$Component);

  function ModalCompareDocs(props) {
    _classCallCheck(this, ModalCompareDocs);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentDidMount = function () {
      _this.setState({ _isMounted: true });
    };

    _this.componentWillUnmount = function () {
      if (_this.state && _this.state._requestTokens) {
        for (var _iterator = _this.state._requestTokens.keys(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          var token = _ref;

          try {
            _Server2.default.cancelRequest(token);
          } catch (error) {
            // ignore
          }
        }
      }
      _this.setState({ _isMounted: false });
    };

    _this.componentWillMount = function () {
      _this.setState({
        showModal: _this.props.showModal,
        domain: "*",
        selectedBook: "*",
        selectedChapter: "*",
        docProp: "id",
        matcher: "rx",
        query: ".*~" + _this.props.selectedIdParts[1].label + "~" + _this.props.selectedIdParts[2].label + "$"
      }, function () {
        this.fetchData();
      });
    };

    _this.messageIcons = {
      info: "info-circle",
      warning: "lightbulb-o",
      error: "exclamation-triangle"
      // , toggleOn: "eye"
      // , toggleOff: "eye-slash"
      , toggleOn: "toggle-on",
      toggleOff: "toggle-off",
      simpleSearch: "minus",
      advancedSearch: "bars",
      idPatternSearch: "key"
    };

    _this.fetchData = function () {
      var requestTokens = _this.state._requestTokens;
      var requestToken = _Server2.default.getRequestToken();
      requestTokens.set(requestToken, "live");
      _this.setState({
        message: _this.props.labels.msg2,
        messageIcon: _this.messageIcons.info,
        _requestTokens: requestTokens
      });

      var parms = "?t=" + encodeURIComponent(_this.props.docType) + "&d=" + encodeURIComponent(_this.state.domain) + "&b=" + encodeURIComponent(_this.state.selectedBook) + "&c=" + encodeURIComponent(_this.state.selectedChapter) + "&q=" + encodeURIComponent(_this.state.query) + "&p=" + encodeURIComponent(_this.state.docProp) + "&m=" + encodeURIComponent(_this.state.matcher);

      _Server2.default.getTextComparison(_this.props.session.restServer, _this.props.session.userInfo.username, _this.props.session.userInfo.password, parms, _this.handleFetchCallback, requestToken);
      _this.setState({ _requestTokens: requestTokens });
    };

    _this.handleFetchCallback = function (response) {
      if (_this.state._isMounted && response && response.data && response.data.values) {
        _this.state._requestTokens.delete(requestToken);
        // if one of the values is greek, then make it the selected row
        var selectedId = "";
        var selectedValue = "";
        var selectRow = _this.state.selectRow;
        if (response.data.values) {
          // select the Greek value.  If not, if there is only one item, select it
          var theItem = response.data.values.find(function (o) {
            return o.id.startsWith("gr_");
          });
          if (theItem) {
            selectedId = theItem.id;
            selectedValue = theItem.value;
            selectRow.selected = [selectedId];
          } else {
            if (response.data.values.length === 1) {
              theItem = response.data.values[0];
              selectedId = theItem.id;
              selectedValue = theItem.value;
              selectRow.selected = [selectedId];
            }
          }
        }
        _this.setState({
          selectRow: selectRow,
          selectedId: selectedId,
          selectedValue: selectedValue,
          data: response.data
        });
        var resultCount = 0;
        var message = _this.props.labels.foundNone;
        var found = _this.props.labels.foundMany;
        if (response.data.valueCount) {
          resultCount = response.data.valueCount;
          if (resultCount === 0) {
            message = _this.props.labels.foundNone;
          } else if (resultCount === 1) {
            message = _this.props.labels.foundOne;
          } else {
            message = found + " " + resultCount + ".";
          }
        }
        _this.setState({
          message: message,
          messageIcon: _this.messageIcons.info,
          showSearchResults: true
        });
      };
    };

    _this.handleRowSelect = function (row, isSelected, e) {
      var selectRow = _this.state.selectRow;
      selectRow.selected = [row["id"]];
      var idParts = row["id"].split("~");
      _this.setState({
        selectRow: selectRow,
        selectedId: row["id"],
        selectedIdParts: [{ key: "domain", label: idParts[0] }, { key: "topic", label: idParts[1] }, { key: "key", label: idParts[2] }],
        selectedValue: row["value"],
        selectedSeq: row["seq"]
      });
    };

    _this.state = {
      showSearchResults: false,
      message: _this.props.labels.msg1,

      messageIcon: _this.messageIcons.info,

      data: { values: [{ "id": "", "value:": "" }] },

      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },

      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: _this.props.hasCallback ? false : true,
        clickToSelect: false,
        onSelect: _this.handleRowSelect,
        className: "App-row-select",
        selected: []
      },

      showSelectionButtons: false,

      selectedId: "",

      selectedValue: "",

      selectedSeq: "",

      selectedIdPartsPrompt: "Select one or more ID parts, then click on the search icon:",

      selectedIdParts: [{ key: "domain", label: "" }, { key: "topic", label: "" }, { key: "key", label: "" }],

      showIdPartSelector: false,
      showModalCompareDocs: false,
      idColumnSize: "80px",
      _isMounted: (0, _lodash.get)(_this.state, "_isMounted", false),
      _requestTokens: (0, _lodash.get)(_this.state, "_requestTokens", new Map())
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.handleFetchCallback = _this.handleFetchCallback.bind(_this);
    _this.oldFetchData = _this.oldFetchData.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    return _this;
  }

  /**
   * font-awesome icons for messages
   * @type {{info: string, warning: string, error: string}}
   */


  ModalCompareDocs.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalCompareDocs.prototype.oldFetchData = function oldFetchData() {
    var _this2 = this;

    var requestTokens = this.state._requestTokens;
    var requestToken = _Server2.default.getRequestToken();
    requestTokens.set(requestToken, "live");
    this.setState({
      message: this.props.labels.msg2,
      messageIcon: this.messageIcons.info,
      _requestTokens: requestTokens
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var parms = "?t=" + encodeURIComponent(this.props.docType) + "&d=" + encodeURIComponent(this.state.domain) + "&b=" + encodeURIComponent(this.state.selectedBook) + "&c=" + encodeURIComponent(this.state.selectedChapter) + "&q=" + encodeURIComponent(this.state.query) + "&p=" + encodeURIComponent(this.state.docProp) + "&m=" + encodeURIComponent(this.state.matcher);
    var path = this.props.session.restServer + _Server2.default.getWsServerDbApi() + 'docs' + parms;
    _axios2.default.get(path, config).then(function (response) {
      if (_this2.state._requestTokens.has(requestToken)) {
        _this2.state._requestTokens.delete(requestToken);
        // if one of the values is greek, then make it the selected row
        var selectedId = "";
        var selectedValue = "";
        var selectRow = _this2.state.selectRow;
        if (response.data.values) {
          // select the Greek value.  If not, if there is only one item, select it
          var theItem = response.data.values.find(function (o) {
            return o.id.startsWith("gr_");
          });
          if (theItem) {
            selectedId = theItem.id;
            selectedValue = theItem.value;
            selectRow.selected = [selectedId];
          } else {
            if (response.data.values.length === 1) {
              theItem = response.data.values[0];
              selectedId = theItem.id;
              selectedValue = theItem.value;
              selectRow.selected = [selectedId];
            }
          }
        }
        _this2.setState({
          selectRow: selectRow,
          selectedId: selectedId,
          selectedValue: selectedValue,
          data: response.data
        });
        var resultCount = 0;
        var message = _this2.props.labels.foundNone;
        var found = _this2.props.labels.foundMany;
        if (response.data.valueCount) {
          resultCount = response.data.valueCount;
          if (resultCount === 0) {
            message = _this2.props.labels.foundNone;
          } else if (resultCount === 1) {
            message = _this2.props.labels.foundOne;
          } else {
            message = found + " " + resultCount + ".";
          }
        }
        _this2.setState({
          message: message,
          messageIcon: _this2.messageIcons.info,
          showSearchResults: true
        });
      }
    }).catch(function (error) {
      if (_this2.state._requestTokens.has(requestToken)) {
        _this2.state._requestTokens.delete(requestToken);
        var message = error.message;
        var messageIcon = _this2.messageIcons.error;
        if (error && error.response && error.response.status === 404) {
          message = _this2.props.labels.foundNone;
          messageIcon = _this2.messageIcons.warning;
          _this2.setState({ data: message, message: message, messageIcon: messageIcon });
        }
      }
    });
  };

  ModalCompareDocs.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSeq);
    }
  };

  ModalCompareDocs.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalCompareDocs.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          this.props.hasCallback && _react2.default.createElement(
            'div',
            { className: 'control-label' },
            this.props.labels.selectVersion
          ),
          _react2.default.createElement(
            'div',
            null,
            this.props.labels.resultLabel,
            ': ',
            _react2.default.createElement(
              'span',
              { className: 'App App-message' },
              _react2.default.createElement(_reactFontawesome2.default, {
                name: this.state.messageIcon }),
              this.state.message
            )
          ),
          _react2.default.createElement(_CompareDocs2.default, {
            session: this.props.session,
            handleRowSelect: this.handleRowSelect,
            title: this.props.title,
            docType: this.props.docType,
            selectedIdParts: this.props.selectedIdParts,
            labels: this.props.labels
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.props.labels.close
          )
        )
      )
    );
  };

  return ModalCompareDocs;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? ModalCompareDocs.propTypes = {
  session: _propTypes2.default.object.isRequired,
  onClose: _propTypes2.default.func,
  showModal: _propTypes2.default.bool.isRequired,
  hasCallback: _propTypes2.default.func,
  title: _propTypes2.default.string.isRequired,
  docType: _propTypes2.default.string.isRequired,
  selectedIdParts: _propTypes2.default.array.isRequired,
  labels: _propTypes2.default.object.isRequired,
  instructions: _propTypes2.default.string
} : void 0;

ModalCompareDocs.defaultProps = {};

exports.default = ModalCompareDocs;