'use strict';

exports.__esModule = true;
exports.ModalIdBuilder = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _IdBuilder = require('./IdBuilder');

var _IdBuilder2 = _interopRequireDefault(_IdBuilder);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal ID Builder to allow the user to select
 * the parts of the ID for a schema based form
 */
var ModalIdBuilder = exports.ModalIdBuilder = (_temp = _class = function (_React$Component) {
  _inherits(ModalIdBuilder, _React$Component);

  function ModalIdBuilder(props) {
    _classCallCheck(this, ModalIdBuilder);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.handleClose = _this.handleClose.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    return _this;
  }

  ModalIdBuilder.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalIdBuilder.prototype.handleClose = function handleClose() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.formData);
  };

  ModalIdBuilder.prototype.render = function render() {
    return _react2.default.createElement(
      _reactBootstrap.Well,
      null,
      this.getContent()
    );
  };

  return ModalIdBuilder;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState({
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      }
    });
  };

  this.getContent = function () {
    if (_this2.state.showModal) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Modal,
          {
            backdrop: "static",
            dialogClassName: 'App-Modal-Id-Builder',
            show: _this2.state.showModal,
            onHide: _this2.handleClose,
            keyboard: true
          },
          _react2.default.createElement(
            _reactBootstrap.Modal.Header,
            { closeButton: true },
            _react2.default.createElement(
              _reactBootstrap.Modal.Title,
              null,
              _this2.props.title
            ),
            _this2.props.text && _this2.props.textId && _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(
                'div',
                { className: "App-Modal-Text" },
                _this2.props.text,
                _react2.default.createElement(
                  'span',
                  { className: "control-label" },
                  ' (',
                  _this2.props.textId,
                  ')'
                )
              )
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Modal.Body,
            null,
            _react2.default.createElement(_IdBuilder2.default, {
              session: _this2.props.session,
              IdLibrary: _this2.props.IdLibrary,
              IdTopic: _this2.props.IdTopic,
              IdTopicValue: _this2.props.IdTopicValue,
              IdTopicType: _this2.props.IdTopicType,
              IdKey: _this2.props.IdKey,
              IdKeyValue: _this2.props.IdKeyValue,
              IdKeyType: _this2.props.IdKeyType,
              handleLibraryChange: _this2.props.handleLibraryChange,
              handleTopicChange: _this2.props.handleTopicChange,
              handleSubmit: _this2.handleClose,
              initialOntologyType: _this2.props.initialOntologyType
            })
          ),
          _react2.default.createElement(
            _reactBootstrap.Modal.Footer,
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              { onClick: _this2.close },
              _this2.state.labels.button.close
            )
          )
        )
      );
    } else {
      return _react2.default.createElement('div', null);
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ModalIdBuilder.propTypes = {
  session: _propTypes2.default.object.isRequired,
  IdLibrary: _propTypes2.default.string.isRequired,
  IdTopic: _propTypes2.default.string.isRequired,
  IdTopicValue: _propTypes2.default.string.isRequired,
  IdTopicType: _propTypes2.default.string.isRequired,
  IdKey: _propTypes2.default.string.isRequired,
  IdKeyValue: _propTypes2.default.string.isRequired,
  IdKeyType: _propTypes2.default.string.isRequired,
  handleLibraryChange: _propTypes2.default.func.isRequired,
  handleTopicChange: _propTypes2.default.func.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  initialOntologyType: _propTypes2.default.string.isRequired,
  onClose: _propTypes2.default.func.isRequired
} : void 0;

ModalIdBuilder.defaultProps = {};

exports.default = ModalIdBuilder;