'use strict';

exports.__esModule = true;
exports.ModalLanguageSelector = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _LanguageLister = require('../LanguageLister');

var _LanguageLister2 = _interopRequireDefault(_LanguageLister);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display a modal window for the user to search languages and select one
 */
var ModalLanguageSelector = exports.ModalLanguageSelector = (_temp = _class = function (_React$Component) {
  _inherits(ModalLanguageSelector, _React$Component);

  function ModalLanguageSelector(props) {
    _classCallCheck(this, ModalLanguageSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, {});

    _this.handleClose = _this.handleClose.bind(_this);
    _this.handleIdSelection = _this.handleIdSelection.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    _this.getSelection = _this.getSelection.bind(_this);
    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  ModalLanguageSelector.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalLanguageSelector.prototype.handleClose = function handleClose() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.formData);
  };

  ModalLanguageSelector.prototype.render = function render() {
    return _react2.default.createElement(
      _reactBootstrap.Well,
      null,
      this.getContent()
    );
  };

  return ModalLanguageSelector;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps, _this2.state));
  };

  this.setTheState = function (props, currentState) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: {
        thisClass: labels[labelTopics.ModalLanguageSelector],
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };
  };

  this.handleIdSelection = function (code, value, countryCode, countryValue) {
    _this2.setState({
      selectedCode: code,
      selectedValue: value,
      selectedCountryCode: countryCode,
      selectedCountryValue: countryValue
    }, _this2.handleCallback);
  };

  this.handleCallback = function () {
    if (_this2.props.handleSubmit) {
      _this2.props.handleSubmit(_this2.state.selectedCode, _this2.state.selectedValue, _this2.state.selectedCountryCode, _this2.state.selectedCountryValue);
    }
  };

  this.getSelection = function () {
    if (_this2.state.selectedCode) {
      return _react2.default.createElement(
        'span',
        null,
        _this2.state.labels.messages.youSelected,
        ' ',
        _this2.state.selectedCode,
        ' ',
        _this2.state.selectedValue,
        ' ',
        _this2.state.labels.thisClass.asSpokenIn,
        ' ',
        _this2.state.selectedCountryValue,
        '.'
      );
    }
  };

  this.getContent = function () {
    if (_this2.state.showModal) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Modal,
          {
            backdrop: "static",
            dialogClassName: 'App-Modal-Id-Builder',
            show: _this2.state.showModal,
            onHide: _this2.handleClose,
            keyboard: true
          },
          _react2.default.createElement(
            _reactBootstrap.Modal.Header,
            { closeButton: true },
            _react2.default.createElement(
              _reactBootstrap.Modal.Title,
              null,
              _this2.state.labels.thisClass.title
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Modal.Body,
            null,
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _reactBootstrap.ControlLabel,
                null,
                _this2.state.labels.messages.rowSelect,
                ' ',
                _this2.state.labels.messages.filter,
                ' ',
                _this2.state.labels.messages.close
              ),
              _react2.default.createElement(
                'div',
                null,
                _this2.getSelection()
              ),
              _react2.default.createElement(_LanguageLister2.default, {
                session: _this2.props.session,
                callBack: _this2.handleIdSelection
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Modal.Footer,
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              { onClick: _this2.handleClose },
              _this2.state.labels.button.close
            )
          )
        )
      );
    } else {
      return _react2.default.createElement('div', null);
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ModalLanguageSelector.propTypes = {
  session: _propTypes2.default.object.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  onClose: _propTypes2.default.func.isRequired
} : void 0;

ModalLanguageSelector.defaultProps = {};

exports.default = ModalLanguageSelector;