'use strict';

exports.__esModule = true;
exports.ModalNewEntryForm = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _NewEntryForm = require('./NewEntryForm');

var _NewEntryForm2 = _interopRequireDefault(_NewEntryForm);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var ModalNewEntryForm = exports.ModalNewEntryForm = (_temp = _class = function (_React$Component) {
  _inherits(ModalNewEntryForm, _React$Component);

  function ModalNewEntryForm(props) {
    _classCallCheck(this, ModalNewEntryForm);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.handleClose = _this.handleClose.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    return _this;
  }

  ModalNewEntryForm.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalNewEntryForm.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-New-Entry-Form',
          show: this.state.showModal,
          onHide: this.handleClose,
          keyboard: true
        },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-From-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-To-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.references.infoBelow
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(_NewEntryForm2.default, {
            session: this.props.session,
            path: this.props.restPath,
            schema: this.props.schema,
            uiSchema: this.props.uiSchema,
            formData: this.props.formData,
            onSubmit: this.onSubmit
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.handleClose },
            this.state.labels.buttons.close
          )
        )
      )
    );
  };

  return ModalNewEntryForm;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState({
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      }
    });
  };

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    if (_this2.props.onSubmit) {
      _this2.props.onSubmit(formData);
    }
  };

  this.handleClose = function () {
    _this2.setState({ showModal: false });
    if (_this2.props.onClose) {
      _this2.props.onClose(_this2.state.formData);
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ModalNewEntryForm.propTypes = {
  session: _propTypes2.default.object.isRequired,
  restPath: _propTypes2.default.string.isRequired,
  schema: _propTypes2.default.object.isRequired,
  uiSchema: _propTypes2.default.object.isRequired,
  formData: _propTypes2.default.object.isRequired,
  title: _propTypes2.default.string.isRequired,
  fromTitle: _propTypes2.default.string,
  fromId: _propTypes2.default.string,
  fromText: _propTypes2.default.string,
  toTitle: _propTypes2.default.string,
  toId: _propTypes2.default.string,
  toText: _propTypes2.default.string,
  onSubmit: _propTypes2.default.func,
  onClose: _propTypes2.default.func
} : void 0;
ModalNewEntryForm.defaultProps = {
  canUpdate: true
};

exports.default = ModalNewEntryForm;