'use strict';

exports.__esModule = true;
exports.ModalReactSelector = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal window to allow user to select an item from a list.
 */
var ModalReactSelector = exports.ModalReactSelector = function (_React$Component) {
  _inherits(ModalReactSelector, _React$Component);

  function ModalReactSelector(props) {
    _classCallCheck(this, ModalReactSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.PropTypesWillMount = function () {};

    _this.close = function () {
      _this.setState({ showModal: false });
    };

    _this.open = function () {
      _this.setState({ showModal: true });
    };

    _this.handleSelectionChange = function (selection) {
      var value = selection["value"];
      _this.setState({
        selectedValue: value
      }, _this.props.callBack(value));
    };

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalReactSelector],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedValue: "",
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.handleSelectionChange = _this.handleSelectionChange.bind(_this);
    return _this;
  }

  ModalReactSelector.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(
            'div',
            { className: 'App-modal-body' },
            _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(_ReactSelector2.default, {
                initialValue: this.props.initialValue,
                resources: this.props.resources,
                changeHandler: this.handleSelectionChange,
                multiSelect: false
              })
            )
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalReactSelector;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? ModalReactSelector.propTypes = {
  session: _propTypes2.default.object.isRequired,
  resources: _propTypes2.default.array.isRequired,
  initialValue: _propTypes2.default.string,
  callBack: _propTypes2.default.func.isRequired
} : void 0;
ModalReactSelector.defaultProps = {
  initialValue: ""
};

exports.default = ModalReactSelector;