'use strict';

exports.__esModule = true;
exports.ModalSchemaBasedEditor = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _reactBootstrap = require('react-bootstrap');

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _DeleteButton = require('../helpers/DeleteButton');

var _DeleteButton2 = _interopRequireDefault(_DeleteButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var ModalSchemaBasedEditor = exports.ModalSchemaBasedEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalSchemaBasedEditor, _React$Component);

  function ModalSchemaBasedEditor(props) {
    _classCallCheck(this, ModalSchemaBasedEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      resultCount: 0,
      showSearchResults: false,
      schema: {},
      uiSchema: {},
      formData: {},
      data: { values: [{ "id": "", "value:": "" }] },
      showForm: false,
      topicText: "",
      keyText: "",
      httpCodeLabels: labels[labelTopics.httpCodes],
      selectedId: "",
      selectedValue: "",
      selectedSchema: "",
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.getModalFooter = _this.getModalFooter.bind(_this);
    _this.onDelete = _this.onDelete.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    return _this;
  }

  ModalSchemaBasedEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalSchemaBasedEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.messages.searching,
      messageIcon: _MessageIcons2.default.getMessageIcons().info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var path = this.props.session.restServer + this.props.restPath + "/" + this.props.idLibrary + "/" + this.props.idTopic + "/" + this.props.idKey;
    _axios2.default.get(path, config).then(function (response) {
      if (response && response.data && response.data.valueCount && response.data.valueCount > 0) {
        var data = response.data.values[0];
        var schemaId = data._valueSchemaId;
        var dataSchema = response.data.valueSchemas[schemaId].schema;
        var dataUiSchema = response.data.valueSchemas[schemaId].uiSchema;
        _this2.setState({
          schema: dataSchema,
          uiSchema: dataUiSchema,
          formData: data,
          showForm: true,
          message: _this2.state.labels.messages.found,
          messageIcon: _MessageIcons2.default.getMessageIcons().info
        });
      }
    }).catch(function (error) {
      if (error) {
        if (error.message) {
          var message = error.message;
          var messageIcon = _MessageIcons2.default.getMessageIcons().error;
          if (error && error.response && error.response.status === 404) {
            //                message = this.state.labels.messages.foundNone;
            messageIcon = _MessageIcons2.default.getMessageIcons().warning;
            _this2.setState({ data: message, message: message, messageIcon: messageIcon });
          }
        } else {
          alert(JSON.stringify(error));
        }
      }
    });
  };

  ModalSchemaBasedEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSchema, this.state.formData);
  };

  ModalSchemaBasedEditor.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalSchemaBasedEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-Para-Row-Editor',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-From-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-To-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.references.infoBelow
          ),
          this.props.canUpdate ? _react2.default.createElement('div', null) : _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.messages.readOnly
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(
            _reactJsonschemaForm2.default,
            { schema: this.state.schema,
              uiSchema: this.state.uiSchema,
              formData: this.state.formData,
              onSubmit: this.onSubmit
            },
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                _reactBootstrap.Button,
                {
                  bsStyle: 'primary',
                  type: 'submit',
                  disabled: !this.props.canUpdate
                },
                this.state.labels.buttons.submit
              ),
              _react2.default.createElement(
                'span',
                { className: 'App App-message' },
                _react2.default.createElement(_reactFontawesome2.default, {
                  name: this.state.messageIcon }),
                this.state.message
              )
            )
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          this.getModalFooter()
        )
      )
    );
  };

  return ModalSchemaBasedEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    _this3.setState({
      showModal: _this3.props.showModal
    }, function () {
      this.fetchData();
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this3.setState({
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      message: labels[labelTopics.messages].initial,
      httpCodeLabels: labels[labelTopics.httpCodes]
    });
  };

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    var config = {
      auth: {
        username: _this3.props.session.userInfo.username,
        password: _this3.props.session.userInfo.password
      }
    };
    var path = _this3.props.session.restServer + _this3.props.restPath + "/" + _this3.props.idLibrary + "/" + _this3.props.idTopic + "/" + _this3.props.idKey;
    _axios2.default.put(path, formData, config).then(function (response) {
      _this3.setState({
        message: "updated ",
        formData: formData
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _MessageIcons2.default.getMessageIcons().error;
      _this3.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };

  this.onDelete = function () {
    _this3.close();
  };

  this.getModalFooter = function () {
    if (_this3.state.formData && _this3.state.formData.id) {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Row,
          { className: 'App show-grid App-PDF-Title-Row' },
          _react2.default.createElement(
            _reactBootstrap.Col,
            { xs: 3, md: 3 },
            _react2.default.createElement(
              _reactBootstrap.Button,
              { className: "App-Modal-Close-Button", onClick: _this3.close },
              _this3.state.labels.buttons.close
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Col,
            { xs: 9, md: 9 },
            _react2.default.createElement(_DeleteButton2.default, {
              session: _this3.props.session,
              idLibrary: _this3.state.formData.library,
              idTopic: _this3.state.formData.topic,
              idKey: _this3.state.formData.key,
              onDelete: _this3.onDelete
            })
          )
        )
      );
    } else {
      return _react2.default.createElement(
        _reactBootstrap.Button,
        { onClick: _this3.close },
        _this3.state.labels.buttons.close
      );
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalSchemaBasedEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  restPath: _propTypes2.default.string.isRequired,
  onClose: _propTypes2.default.func.isRequired,
  showModal: _propTypes2.default.bool.isRequired,
  title: _propTypes2.default.string.isRequired,
  fromTitle: _propTypes2.default.string,
  fromId: _propTypes2.default.string,
  fromText: _propTypes2.default.string,
  toTitle: _propTypes2.default.string,
  toId: _propTypes2.default.string,
  toText: _propTypes2.default.string,
  idLibrary: _propTypes2.default.string.isRequired,
  idTopic: _propTypes2.default.string.isRequired,
  idKey: _propTypes2.default.string.isRequired,
  canUpdate: _propTypes2.default.bool
} : void 0;
ModalSchemaBasedEditor.defaultProps = {
  canUpdate: true
};

exports.default = ModalSchemaBasedEditor;