'use strict';

exports.__esModule = true;
exports.ModalSearchOntologyWithCallback = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _SearchOntology = require('../SearchOntology');

var _SearchOntology2 = _interopRequireDefault(_SearchOntology);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal text search that allows user to select a doc.
 */
var ModalSearchOntologyWithCallback = exports.ModalSearchOntologyWithCallback = (_temp = _class = function (_React$Component) {
  _inherits(ModalSearchOntologyWithCallback, _React$Component);

  function ModalSearchOntologyWithCallback(props) {
    _classCallCheck(this, ModalSearchOntologyWithCallback);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable],
        searchLabels: labels[labelTopics.search]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true
    };

    _this.close = _this.close.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.handleSearchCallback = _this.handleSearchCallback.bind(_this);
    return _this;
  }

  ModalSearchOntologyWithCallback.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalSearchOntologyWithCallback.prototype.handleSearchCallback = function handleSearchCallback(id, value, seq, schema) {
    this.setState({ showModal: false });
    if (id.length > 0) {
      this.props.onCallback(id, value, seq, schema);
    } else {
      this.close();
    }
  };

  ModalSearchOntologyWithCallback.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose();
    }
  };

  ModalSearchOntologyWithCallback.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-Search-Text-With-Callback',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          ),
          this.props.text && this.props.textId && _react2.default.createElement(
            _reactBootstrap.Well,
            null,
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.text,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.textId,
                ')'
              )
            )
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(_SearchOntology2.default, {
            session: this.props.session,
            callback: this.handleSearchCallback,
            editor: false,
            initialType: this.props.initialDocType,
            fixedType: false
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.state.labels.button.close
          )
        )
      )
    );
  };

  return ModalSearchOntologyWithCallback;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState({
      labels: {
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable],
        searchLabels: labels[labelTopics.search]
      }
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ModalSearchOntologyWithCallback.propTypes = {
  session: _propTypes2.default.object.isRequired,
  initialDocType: _propTypes2.default.string,
  onCallback: _propTypes2.default.func.isRequired,
  onClose: _propTypes2.default.func
} : void 0;

ModalSearchOntologyWithCallback.defaultProps = {
  initialDocType: "Liturgical"
};

exports.default = ModalSearchOntologyWithCallback;