'use strict';

exports.__esModule = true;
exports.ModalSplitTemplateEditor = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _Spinner = require('../helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _SplitTemplateEditor = require('../SplitTemplateEditor');

var _SplitTemplateEditor2 = _interopRequireDefault(_SplitTemplateEditor);

var _reactModalResizableDraggable = require('react-modal-resizable-draggable');

var _reactModalResizableDraggable2 = _interopRequireDefault(_reactModalResizableDraggable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var ModalSplitTemplateEditor = exports.ModalSplitTemplateEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalSplitTemplateEditor, _React$Component);

  function ModalSplitTemplateEditor(props) {
    _classCallCheck(this, ModalSplitTemplateEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      resultCount: 0,
      showSearchResults: false,
      schema: {},
      uiSchema: {},
      formData: {},
      data: { values: [{ "id": "", "value:": "" }] },
      showForm: false,
      topicText: "",
      keyText: "",
      treeData: undefined,
      dataFetched: false
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.getEditor = _this.getEditor.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    return _this;
  }

  ModalSplitTemplateEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalSplitTemplateEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.messages.searching,
      messageIcon: _MessageIcons2.default.getMessageIcons().info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var path = this.props.session.restServer + this.props.restPath + "/" + this.props.idLibrary + "/" + this.props.idTopic + "/" + this.props.idKey;
    _axios2.default.get(path, config).then(function (response) {
      if (response.data.valueCount && response.data.valueCount > 0) {
        var data = response.data.values[0];
        var treeData = [];
        treeData.push(JSON.parse(data.node));
        var schemaId = data._valueSchemaId;
        var dataSchema = response.data.valueSchemas[schemaId].schema;
        var dataUiSchema = response.data.valueSchemas[schemaId].uiSchema;
        _this2.setState({
          schema: dataSchema,
          uiSchema: dataUiSchema,
          formData: data,
          showForm: true,
          message: _this2.state.labels.messages.found,
          messageIcon: _MessageIcons2.default.getMessageIcons().info,
          treeData: treeData,
          dataFetched: true
        });
      }
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _MessageIcons2.default.getMessageIcons().error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.messages.foundNone;
        messageIcon = _MessageIcons2.default.getMessageIcons().warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  ModalSplitTemplateEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    this.props.onClose(this.state.selectedId, this.state.selectedValue, this.state.selectedSchema);
  };

  ModalSplitTemplateEditor.prototype.open = function open() {
    this.setState({ showModal: true });
  };

  ModalSplitTemplateEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-Template-Editor',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-From-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-To-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.references.infoBelow
          ),
          this.props.canUpdate ? _react2.default.createElement('div', null) : _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.messages.readOnly
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          this.getEditor()
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.state.labels.buttons.close
          )
        )
      )
    );
  };

  return ModalSplitTemplateEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentWillMount = function () {
    _this3.setState({
      showModal: _this3.props.showModal
    }, function () {
      this.fetchData();
    });
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this3.setState({
      buttons: labels[labelTopics.button],
      messages: labels[labelTopics.messages],
      references: labels[labelTopics.ViewReferences]
    });
  };

  this.getEditor = function () {
    if (_this3.state.dataFetched) {
      return _react2.default.createElement(_SplitTemplateEditor2.default, {
        session: _this3.props.session,
        treeData: _this3.state.treeData,
        idLibrary: _this3.props.idLibrary,
        idTopic: _this3.props.idTopic,
        formData: _this3.state.formData,
        uiSchema: _this3.state.uiSchema,
        schema: _this3.state.schema
      });
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.searching });
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalSplitTemplateEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  restPath: _propTypes2.default.string.isRequired,
  onClose: _propTypes2.default.func.isRequired,
  showModal: _propTypes2.default.bool.isRequired,
  title: _propTypes2.default.string.isRequired,
  idLibrary: _propTypes2.default.string.isRequired,
  idTopic: _propTypes2.default.string.isRequired,
  idKey: _propTypes2.default.string.isRequired,
  canUpdate: _propTypes2.default.bool
} : void 0;
ModalSplitTemplateEditor.defaultProps = {
  canUpdate: true
};

exports.default = ModalSplitTemplateEditor;