'use strict';

exports.__esModule = true;
exports.ModalTemplateNodeEditor = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _ModalReactSelector = require('./ModalReactSelector');

var _ModalReactSelector2 = _interopRequireDefault(_ModalReactSelector);

var _ModalSearchTextWithCallback = require('./ModalSearchTextWithCallback');

var _ModalSearchTextWithCallback2 = _interopRequireDefault(_ModalSearchTextWithCallback);

var _ModalSchemaBasedEditor = require('./ModalSchemaBasedEditor');

var _ModalSchemaBasedEditor2 = _interopRequireDefault(_ModalSchemaBasedEditor);

var _Server = require('../helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal window to allow user to edit information about a template node.
 * TODO: when user sets node type to a switch (e.g. WHEN_DAY_NAME_IS), display a list of cases and allow user to check box to include.
 */
var ModalTemplateNodeEditor = exports.ModalTemplateNodeEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalTemplateNodeEditor, _React$Component);

  function ModalTemplateNodeEditor(props) {
    _classCallCheck(this, ModalTemplateNodeEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.ModalTemplateNodeEditor],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      node: _this.props.node,
      selectedNodeType: _this.props.node.title,
      selectedSubtitle: _this.props.node.subtitle,
      selectedSchemaValue: "",
      showModal: props.showModal,
      showModalSchemaEditor: false,
      showModalTextSearch: false,
      showTextInput: false,
      idKey: "head",
      modalTitle: _this.props.node.subtitle
    };

    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);

    _this.handleSelectionChange = _this.handleSelectionChange.bind(_this);

    _this.getModalTextSearch = _this.getModalTextSearch.bind(_this);
    _this.handleTextLookupCallback = _this.handleTextLookupCallback.bind(_this);

    _this.getModalSchemaEditorButton = _this.getModalSchemaEditorButton.bind(_this);
    _this.enableModalSchemaEditor = _this.enableModalSchemaEditor.bind(_this);
    _this.getModalSchemaEditor = _this.getModalSchemaEditor.bind(_this);
    _this.handleCloseModalSchemaEditor = _this.handleCloseModalSchemaEditor.bind(_this);

    _this.getModalReactSelector = _this.getModalReactSelector.bind(_this);
    _this.handleReactSelectorCallback = _this.handleReactSelectorCallback.bind(_this);

    _this.getSubtitleTextInput = _this.getSubtitleTextInput.bind(_this);
    _this.handleSubtitleChange = _this.handleSubtitleChange.bind(_this);

    _this.getSubtitleTextIdLookup = _this.getSubtitleTextIdLookup.bind(_this);
    _this.handleSubtitleTextIdChange = _this.handleSubtitleTextIdChange.bind(_this);
    _this.enableModalTextSearch = _this.enableModalTextSearch.bind(_this);

    _this.getNodeTypeSelector = _this.getNodeTypeSelector.bind(_this);
    _this.handleNodeTypeChange = _this.handleNodeTypeChange.bind(_this);

    _this.setSubtitle = _this.setSubtitle.bind(_this);
    _this.getServiceDate = _this.getServiceDate.bind(_this);

    return _this;
  }

  /**
   * This editor uses uischemas from the REST API
   * @returns {*}
   */


  /**
   * TODO: This is unfinished.  The idea is to allow the user
   * to see (and perhaps easily set) the year, month, and date
   * without having to invoke the modal schema based editor.
   * @returns {*}
   */


  ModalTemplateNodeEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      this.state.showModalSchemaEditor && this.getModalSchemaEditor(),
      this.state.showModalTextSearch && this.getModalTextSearch(),
      _react2.default.createElement(
        _reactBootstrap.Modal,
        { backdrop: "static", show: this.state.showModal, onHide: this.close },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.state.labels.thisClass.panelTitle
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          _react2.default.createElement(
            'div',
            { className: 'App-modal-body' },
            _react2.default.createElement(
              _reactBootstrap.Well,
              null,
              _react2.default.createElement(
                _reactBootstrap.Form,
                { horizontal: true },
                this.getNodeTypeSelector(),
                this.getSubtitleTextInput(),
                this.getModalSchemaEditorButton()
              )
            )
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { bsStyle: 'primary', onClick: this.close },
            this.state.labels.thisClass.close
          )
        )
      )
    );
  };

  return ModalTemplateNodeEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.PropTypesWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, nextProps) {
      return {
        labels: {
          thisClass: labels[labelTopics.ModalTemplateNodeEditor],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial,
        node: nextProps.node,
        selectedNodeType: nextProps.node.title,
        selectedSubtitle: nextProps.node.subtitle,
        selectedSchemaValue: "",
        showModal: nextProps.showModal,
        showModalSchemaEditor: false,
        showModalTextSearch: false,
        showTextInput: false,
        idKey: "head",
        modalTitle: _this2.props.node.subtitle
      };
    });
  };

  this.open = function () {
    _this2.setState({ showModal: true });
  };

  this.close = function () {
    _this2.setState({ showModal: false }, _this2.props.callBack());
  };

  this.getModalSchemaEditorButton = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.Col,
          { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
          '\xA0',
          _this2.state.labels.thisClass.editProperties
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { sm: 8 },
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: _this2.enableModalSchemaEditor },
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'pencil' })
          )
        )
      );
    }
  };

  this.enableModalSchemaEditor = function () {
    _this2.setState({ showModalSchemaEditor: true });
  };

  this.getServiceDate = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return _react2.default.createElement(
        _reactBootstrap.Form,
        { inline: true },
        _react2.default.createElement(
          _reactBootstrap.FormGroup,
          { controlId: 'formInlineYear' },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            'Year'
          ),
          ' ',
          _react2.default.createElement(_reactBootstrap.FormControl, { type: 'text', placeholder: '' })
        ),
        ' ',
        _react2.default.createElement(
          _reactBootstrap.FormGroup,
          { controlId: 'formInlineMonth' },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            'Month'
          ),
          ' ',
          _react2.default.createElement(_reactBootstrap.FormControl, { type: 'text', placeholder: '' })
        ),
        _react2.default.createElement(
          _reactBootstrap.FormGroup,
          { controlId: 'formInlineDay' },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            'Month'
          ),
          ' ',
          _react2.default.createElement(_reactBootstrap.FormControl, { type: 'text', placeholder: '' })
        )
      );
    }
  };

  this.getModalSchemaEditor = function () {
    return _react2.default.createElement(_ModalSchemaBasedEditor2.default, {
      session: _this2.props.session,
      restPath: _Server2.default.getDbServerDocsApi(),
      showModal: _this2.state.showModalSchemaEditor,
      title: _this2.state.modalTitle,
      idLibrary: _this2.props.templateLibrary,
      idTopic: _this2.props.templateTopic,
      idKey: _this2.state.idKey,
      onClose: _this2.handleCloseModalSchemaEditor
    });
  };

  this.handleCloseModalSchemaEditor = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalSchemaEditor: false,
        selectedId: id,
        selectedSchemaValue: value
      });
    } else {
      _this2.setState({
        showModalSchemaEditor: false
      });
    }
  };

  this.getModalReactSelector = function () {
    return _react2.default.createElement(_ModalReactSelector2.default, {
      languageCode: _this2.props.session.languageCode,
      resources: _this2.state.selectorResource,
      initialValue: _this2.state.selectorInitialValue,
      callBack: _this2.handleReactSelectorCallback
    });
  };

  this.handleReactSelectorCallback = function (item) {
    if (item.length > 0) {
      _this2.setState({
        showModalReactSelector: false,
        selectedItem: item,
        selectedNodeType: item["value"]
      });
    } else {
      _this2.setState({
        showModalReactSelector: false
      });
    }
  };

  this.handleNodeTypeChange = function (selection) {
    var value = selection["value"];
    var node = _this2.state.node;
    node.title = value;
    _this2.setState({ node: node, selectedNodeType: value }, _this2.handleSelectionChange);
  };

  this.handleSelectionChange = function () {
    switch (_this2.state.selectedNodeType) {
      case "INSERT_SECTION":
        {
          break;
        }
      case "RID":
        {
          _this2.setState({
            showModalTextSearch: true
          });
          break;
        }
      case "SECTION":
        {
          _this2.setState({
            showTextInput: true
          });
          break;
        }
      case "SID":
        {
          _this2.setState({
            showModalTextSearch: true
          });
          break;
        }
      case "TEMPLATE":
        {
          _this2.setState({
            idKey: "head",
            showModalSchemaEditor: true,
            modalTitle: _this2.props.idLibrary + "~" + _this2.props.idTopic + "~head"
          });
          break;
        }
      case "tbd":
        {
          _this2.setState({
            showModalReactSelector: true,
            selectorResource: _this2.props.session.dropdowns["templatePartsDropdown"],
            selectorInitialValue: "SECTION"
          });
          break;
        }
    }
  };

  this.getModalTextSearch = function () {
    return _react2.default.createElement(_ModalSearchTextWithCallback2.default, {
      session: _this2.props.session,
      onCallback: _this2.handleTextLookupCallback,
      initialDocType: "Liturgical"
    });
  };

  this.handleTextLookupCallback = function (id, value) {
    if (id && id.length > 0) {
      _this2.setState({
        showModalTextSearch: false,
        selectedId: id,
        selectedSchemaValue: value
      }, _this2.setSubtitle(id));
    } else {
      _this2.setState({
        showModalTextSearch: false
      });
    }
  };

  this.enableModalTextSearch = function () {
    _this2.setState({ showModalTextSearch: true });
  };

  this.handleSubtitleTextIdChange = function () {};

  this.getSubtitleTextIdLookup = function () {};

  this.setSubtitle = function (value) {
    var node = _this2.state.node;
    node.subtitle = value;
    _this2.setState({ node: node, selectedSubtitle: value });
  };

  this.handleSubtitleChange = function (event) {
    _this2.setSubtitle(event.target.value);
  };

  this.getSubtitleTextInput = function () {
    // Note: use fall throughs (i.e. no break) for switches that group together
    switch (_this2.state.selectedNodeType) {
      case "SID":
      case "RID":
        {
          return _react2.default.createElement(
            _reactBootstrap.FormGroup,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
              _this2.state.labels.thisClass.nodeSubtitle
            ),
            _react2.default.createElement(
              _reactBootstrap.Col,
              { sm: 8 },
              _react2.default.createElement(
                _reactBootstrap.InputGroup,
                { className: 'App-InputGroup-Static' },
                _react2.default.createElement(
                  _reactBootstrap.FormControl.Static,
                  null,
                  _this2.state.selectedSubtitle
                ),
                _react2.default.createElement(
                  _reactBootstrap.InputGroup.Button,
                  null,
                  _react2.default.createElement(
                    _reactBootstrap.Button,
                    { onClick: _this2.enableModalTextSearch },
                    _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'search' })
                  )
                )
              )
            )
          );
          break;
        }
      case "SECTION":
        return _react2.default.createElement(
          _reactBootstrap.FormGroup,
          null,
          _react2.default.createElement(
            _reactBootstrap.Col,
            { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
            _this2.state.labels.thisClass.nodeSubtitle
          ),
          _react2.default.createElement(
            _reactBootstrap.Col,
            { sm: 10 },
            _react2.default.createElement(_reactBootstrap.FormControl, {
              type: 'text',
              defaultValue: _this2.state.selectedSubtitle,
              onChange: _this2.handleSubtitleChange
            })
          )
        );
        break;
      case "TEMPLATE":
        {
          return _react2.default.createElement(
            _reactBootstrap.FormGroup,
            null,
            _react2.default.createElement(
              _reactBootstrap.Col,
              { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
              _this2.state.labels.thisClass.nodeSubtitle
            ),
            _react2.default.createElement(
              _reactBootstrap.Col,
              { sm: 8 },
              _react2.default.createElement(
                _reactBootstrap.InputGroup,
                { className: 'App-InputGroup-Static' },
                _react2.default.createElement(
                  _reactBootstrap.FormControl.Static,
                  null,
                  _this2.state.selectedSubtitle
                )
              )
            )
          );
          break;
        }
    }
  };

  this.getNodeTypeSelector = function () {
    if (_this2.state.selectedNodeType === "TEMPLATE") {
      return _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.Col,
          { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
          _this2.state.labels.thisClass.nodeTypePrompt
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { sm: 8 },
          _react2.default.createElement(
            _reactBootstrap.InputGroup,
            { className: 'App-InputGroup-Static' },
            _react2.default.createElement(
              _reactBootstrap.FormControl.Static,
              null,
              _this2.state.selectedNodeType
            )
          )
        )
      );
    } else {
      return _react2.default.createElement(
        _reactBootstrap.FormGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.Col,
          { componentClass: _reactBootstrap.ControlLabel, sm: 2 },
          _this2.state.labels.thisClass.nodeTypePrompt
        ),
        _react2.default.createElement(
          _reactBootstrap.Col,
          { sm: 10 },
          _react2.default.createElement(_ReactSelector2.default, {
            initialValue: _this2.state.selectedNodeType,
            resources: _this2.props.session.dropdowns["templatePartsDropdown"],
            changeHandler: _this2.handleNodeTypeChange,
            multiSelect: false
          })
        )
      );
    }
  };
}, _temp);

process.env.NODE_ENV !== "production" ? ModalTemplateNodeEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  showModal: _propTypes2.default.bool.isRequired,
  node: _propTypes2.default.object.isRequired,
  path: _propTypes2.default.array.isRequired,
  treeIndex: _propTypes2.default.number.isRequired,
  callBack: _propTypes2.default.func.isRequired,
  templateLibrary: _propTypes2.default.string.isRequired,
  templateTopic: _propTypes2.default.string.isRequired
} : void 0;
ModalTemplateNodeEditor.defaultProps = {};

exports.default = ModalTemplateNodeEditor;