'use strict';

exports.__esModule = true;
exports.ModalTextNoteEditor = undefined;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _TextNoteEditor = require('../TextNoteEditor');

var _TextNoteEditor2 = _interopRequireDefault(_TextNoteEditor);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _Spinner = require('../helpers/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _index = require('axios/index');

var _index2 = _interopRequireDefault(_index);

var _IdManager = require('../helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Display modal content.
 */
var ModalTextNoteEditor = exports.ModalTextNoteEditor = (_temp = _class = function (_React$Component) {
  _inherits(ModalTextNoteEditor, _React$Component);

  function ModalTextNoteEditor(props) {
    _classCallCheck(this, ModalTextNoteEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    var textId = _IdManager2.default.getParts(props.noteIdTopic);
    var showForm = true;
    if (props.noteIdLibrary) {
      showForm = false;
    }

    _this.state = {
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      showModal: true,
      showForm: showForm,
      textId: textId
    };

    _this.close = _this.close.bind(_this);
    _this.setMessage = _this.setMessage.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.onDelete = _this.onDelete.bind(_this);
    _this.handleTextNoteContentChange = _this.handleTextNoteContentChange.bind(_this);
    return _this;
  }

  ModalTextNoteEditor.prototype.setMessage = function setMessage(message) {
    this.setState({
      message: message
    });
  };

  ModalTextNoteEditor.prototype.fetchData = function fetchData() {
    var _this2 = this;

    this.setState({
      message: this.state.labels.messages.searching,
      messageIcon: _MessageIcons2.default.getMessageIcons().info
    });
    var config = {
      auth: {
        username: this.props.session.userInfo.username,
        password: this.props.session.userInfo.password
      }
    };

    var path = this.props.session.restServer + this.props.restPath + "/" + this.props.noteIdLibrary + "/" + this.props.noteIdTopic + "/" + this.props.noteIdKey;
    _index2.default.get(path, config).then(function (response) {
      if (response.data.valueCount && response.data.valueCount > 0) {
        var data = response.data.values[0];
        var schemaId = data._valueSchemaId;
        var dataSchema = response.data.valueSchemas[schemaId].schema;
        var dataUiSchema = response.data.valueSchemas[schemaId].uiSchema;
        _this2.setState({
          schema: dataSchema,
          uiSchema: dataUiSchema,
          formData: data,
          showForm: true,
          message: _this2.state.labels.messages.found,
          messageIcon: _MessageIcons2.default.getMessageIcons().info
        });
      }
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _MessageIcons2.default.getMessageIcons().error;
      if (error && error.response && error.response.status === 404) {
        message = _this2.state.labels.messages.foundNone;
        messageIcon = _MessageIcons2.default.getMessageIcons().warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };

  ModalTextNoteEditor.prototype.close = function close() {
    this.setState({ showModal: false });
    if (this.props.onClose) {
      this.props.onClose(this.state.formData);
    }
  };

  ModalTextNoteEditor.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Modal,
        {
          backdrop: "static",
          dialogClassName: 'App-Modal-New-Entry-Form',
          show: this.state.showModal,
          onHide: this.close,
          keyboard: true
        },
        _react2.default.createElement(
          _reactBootstrap.Modal.Header,
          { closeButton: true },
          _react2.default.createElement(
            _reactBootstrap.Modal.Title,
            null,
            this.props.title
          ),
          this.props.fromText && this.props.fromTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.fromTitle
          ),
          this.props.fromText && this.props.fromId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-From-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.fromText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.fromId,
                ')'
              )
            )
          ),
          this.props.fromText && this.props.toText && this.props.toTitle && _react2.default.createElement(
            'div',
            { className: "App-Text-Refers-To" },
            this.props.toTitle
          ),
          this.props.toText && this.props.toId && _react2.default.createElement(
            _reactBootstrap.Well,
            { className: "App-Well-To-Text" },
            _react2.default.createElement(
              'div',
              { className: "App-Modal-Text" },
              this.props.toText,
              _react2.default.createElement(
                'span',
                { className: "control-label" },
                ' (',
                this.props.toId,
                ')'
              )
            )
          ),
          this.props.toText && _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            this.state.labels.references.infoBelow
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Body,
          null,
          this.getEditor()
        ),
        _react2.default.createElement(
          _reactBootstrap.Modal.Footer,
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            { onClick: this.close },
            this.state.labels.buttons.close
          )
        )
      )
    );
  };

  return ModalTextNoteEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this.componentDidMount = function () {
    if (_this3.props.noteIdLibrary && _this3.props.noteIdKey) {
      _this3.fetchData();
    }
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this3.setState({
      labels: {
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        references: labels[labelTopics.ViewReferences]
      }
    });
  };

  this.handleTextNoteContentChange = function () {};

  this.onSubmit = function (_ref) {
    var formData = _ref.formData;

    if (_this3.props.onSubmit) {
      _this3.props.onSubmit(formData);
    }
  };

  this.onDelete = function (result) {
    _this3.close();
  };

  this.getEditor = function () {
    if (_this3.state.showForm) {
      return _react2.default.createElement(_TextNoteEditor2.default, {
        session: _this3.props.session,
        textId: _this3.props.noteIdTopic,
        onEditorChange: _this3.handleTextNoteContentChange,
        form: _this3.state.formData,
        id: "tinymiceeditor" + _this3.props.noteIdTopic,
        notesList: _this3.props.notesList,
        deleteCallback: _this3.onDelete
      });
    } else {
      return _react2.default.createElement(_Spinner2.default, { message: _this3.state.labels.messages.retrieving });
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? ModalTextNoteEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  restPath: _propTypes2.default.string.isRequired,
  noteIdLibrary: _propTypes2.default.string,
  noteIdTopic: _propTypes2.default.string.isRequired,
  noteIdKey: _propTypes2.default.string,
  onSubmit: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  canUpdate: _propTypes2.default.bool,
  notesList: _propTypes2.default.array
} : void 0;
ModalTextNoteEditor.defaultProps = {
  canUpdate: true
};

exports.default = ModalTextNoteEditor;