'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _reactJsonschemaForm = require('react-jsonschema-form');

var _reactJsonschemaForm2 = _interopRequireDefault(_reactJsonschemaForm);

var _reactBootstrap = require('react-bootstrap');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _IdManager = require('../helpers/IdManager');

var _IdManager2 = _interopRequireDefault(_IdManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * This component provides a schema based form editor
 */
var NewEntryForm = (_temp = _class = function (_React$Component) {
  _inherits(NewEntryForm, _React$Component);

  function NewEntryForm(props) {
    _classCallCheck(this, NewEntryForm);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.NewEntryForm],
        button: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        search: labels[labelTopics.search]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      formData: _this.props.formData
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onSubmit = _this.onSubmit.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  NewEntryForm.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-New-Component-Template' },
      _react2.default.createElement(
        _reactJsonschemaForm2.default,
        { schema: this.props.schema,
          uiSchema: this.props.uiSchema,
          formData: this.state.formData,
          onSubmit: this.onSubmit,
          onChange: this.onChange
        },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsStyle: 'primary',
              type: 'submit'
            },
            this.state.labels.button.submit
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-message' },
            _react2.default.createElement(_reactFontawesome2.default, {
              name: this.state.messageIcon }),
            this.state.message
          )
        )
      )
    );
  };

  return NewEntryForm;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;
    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.NewEntryForm],
          button: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          search: labels[labelTopics.search]
        },
        message: labels[labelTopics.messages].initial,
        formData: _this2.props.formData
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.onChange = function (_ref) {
    var formData = _ref.formData;

    _this2.setState({
      message: _this2.state.labels.search.initial,
      messageIcon: _this2.state.messageIcons.info,
      formData: formData
    });
  };

  this.onSubmit = function (_ref2) {
    var formData = _ref2.formData;

    _this2.setState({
      message: _this2.state.labels.search.creating,
      messageIcon: _this2.state.messageIcons.info
    });

    var config = {
      auth: {
        username: _this2.props.session.userInfo.username,
        password: _this2.props.session.userInfo.password
      }
    };
    var path = _this2.props.session.restServer + _this2.props.path;
    _axios2.default.post(path, formData, config).then(function (response) {
      _this2.setState({
        message: _this2.state.labels.search.created,
        formData: formData
      });
    }).catch(function (error) {
      var message = "";
      var messageIcon = _this2.state.messageIcons.error;
      if (error) {
        if (error.response) {
          message = error.response.statusText;
        } else {
          message = JSON.stringify(error);
        }
      } else {
        message = "unknown error";
      }
      _this2.setState({ data: message, message: message, messageIcon: messageIcon });
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? NewEntryForm.propTypes = {
  session: _propTypes2.default.object.isRequired,
  path: _propTypes2.default.string.isRequired,
  schema: _propTypes2.default.object.isRequired,
  uiSchema: _propTypes2.default.object.isRequired,
  formData: _propTypes2.default.object.isRequired,
  onSubmit: _propTypes2.default.func
} : void 0;

// set default values for props here
NewEntryForm.defaultProps = {
  languageCode: "en"
};

exports.default = NewEntryForm;
module.exports = exports['default'];