'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OntologySearchOptions = function (_React$Component) {
  _inherits(OntologySearchOptions, _React$Component);

  function OntologySearchOptions(props) {
    _classCallCheck(this, OntologySearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {};

    _this.handleDocTypeChange = function (selection) {
      var type = selection["value"];
      _this.setState({
        selectedType: type,
        dropDownProperties: {
          msg: _this.props.labels.domainIs,
          source: _this.props.properties[type],
          initialValue: "*"
        }
      });
    };

    _this.handlePropertyChange = function (item) {
      var newSelectedValue = _this.state.value;

      if (item.value.startsWith("*")) {
        newSelectedValue = "";
      }
      _this.setState({
        selectedProperty: item.value,
        value: newSelectedValue
      });
    };

    _this.handleMatcherChange = function (item) {
      _this.setState({ selectedMatcher: item.value });
    };

    _this.handleValueChange = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleTagsSelection = function (selection) {
      var tags = selection.map(function (a) {
        return a.value;
      });
      _this.setState({
        selectedTags: tags.toString()
      });
    };

    _this.handleTagOperatorChange = function (selection) {
      _this.setState({
        selectedTagOperator: selection["value"]
      });
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.selectedType, _this.state.selectedGenericType, _this.state.selectedProperty, _this.state.selectedMatcher, _this.state.value, _this.state.selectedTagOperator, _this.state.selectedTags);
      event.preventDefault();
    };

    _this.handleGenericTypeChange = function (selection) {
      _this.setState({
        selectedGenericType: selection["value"] });
    };

    _this.isDisabled = function () {
      // For now, we are not disabling the search for any reason.
      // The code below is stubbed out for the event that we
      // start disabling.
      var disableButton = false;
      if (_this.state.value && _this.state.value.length > 0) {
        disableButton = false;
      } else {
        switch (_this.state.selectedType) {
          case "*":
            {
              break;
            }
          default:
            {
              disableButton = false;
              break;
            }
        }
      }
      return disableButton;
    };

    var initialType = "Human";
    if (_this.props.initialType) {
      initialType = _this.props.initialType;
    }

    _this.state = {
      selectedType: initialType,
      selectedGenericType: "*",
      selectedProperty: "*",
      selectedMatcher: "c",
      value: "",
      selectedTagOperator: "any",
      selectedTags: "",
      tagData: [],
      dropDownProperties: {
        msg: _this.props.labels.domainIs,
        source: _this.props.properties[initialType],
        initialValue: "*"
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handleGenericTypeChange = _this.handleGenericTypeChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTagsSelection = _this.handleTagsSelection.bind(_this);
    _this.handleTagOperatorChange = _this.handleTagOperatorChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);
    return _this;
  }

  OntologySearchOptions.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'container App-search-options-container' },
      _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.findWhereTypeIs,
              initialValue: this.state.selectedType,
              resources: this.props.types,
              changeHandler: this.handleDocTypeChange,
              multiSelect: false
            })
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'row' },
          _react2.default.createElement(
            'div',
            { className: 'col-sm-12 col-md-12 col-lg-12' },
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.findWhereGenericTypeIs,
              initialValue: this.state.selectedGenericType,
              resources: this.props.types,
              changeHandler: this.handleGenericTypeChange,
              multiSelect: false
            })
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-sm-12' },
          _react2.default.createElement(_ReactSelector2.default, {
            title: this.props.labels.propertyIs,
            initialValue: this.state.selectedProperty,
            resources: this.props.properties[this.state.selectedType],
            changeHandler: this.handlePropertyChange,
            multiSelect: false
          }),
          _react2.default.createElement(
            'form',
            { onSubmit: this.handleSubmit },
            _react2.default.createElement(
              'div',
              { className: 'control-label' },
              this.props.labels.propertyTextIs
            ),
            _react2.default.createElement('input', {
              type: 'text',
              value: this.state.value,
              onChange: this.handleValueChange,
              className: 'App-search-text-input',
              name: 'search' })
          ),
          _react2.default.createElement(_ReactSelector2.default, {
            title: this.props.labels.matcherIs,
            initialValue: this.state.selectedMatcher,
            resources: this.props.matchers,
            changeHandler: this.handleMatcherChange,
            multiSelect: false
          }),
          this.state.selectedType !== "*" && _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.has,
              initialValue: 'any',
              resources: this.props.tagOperators,
              changeHandler: this.handleTagOperatorChange,
              multiSelect: false
            }),
            _react2.default.createElement(_ReactSelector2.default, {
              title: this.props.labels.tags,
              initialValue: this.state.selectedTags,
              resources: this.props.tags[this.state.selectedType],
              changeHandler: this.handleTagsSelection,
              multiSelect: true
            })
          ),
          _react2.default.createElement(
            'div',
            { className: 'control-label' },
            this.props.labels.clickTheButton
          ),
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsStyle: 'primary',
              bsSize: 'xsmall',
              type: 'submit',
              disabled: this.isDisabled(),
              onClick: this.handleSubmit
            },
            _react2.default.createElement(_reactFontawesome2.default, { className: 'Button-Select-FontAwesome', name: "search" }),
            this.props.labels.submit
          )
        )
      )
    );
  };

  return OntologySearchOptions;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? OntologySearchOptions.propTypes = {
  types: _propTypes2.default.array.isRequired,
  initialType: _propTypes2.default.string.isRequired,
  properties: _propTypes2.default.object.isRequired,
  matchers: _propTypes2.default.array.isRequired,
  tags: _propTypes2.default.object.isRequired,
  tagOperators: _propTypes2.default.array.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  labels: _propTypes2.default.object.isRequired
} : void 0;

exports.default = OntologySearchOptions;
module.exports = exports['default'];