'use strict';

exports.__esModule = true;
exports.ReactSelector = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _reactBootstrap = require('react-bootstrap');

require('react-select/dist/react-select.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO: switch to VirtualizedSelect, see TopicsSelector for example.  Much faster
var ReactSelector = exports.ReactSelector = function (_React$Component) {
  _inherits(ReactSelector, _React$Component);

  function ReactSelector(props) {
    _classCallCheck(this, ReactSelector);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillReceiveProps = function (nextProps) {

      _this.setState({
        value: nextProps.initialValue
      });
    };

    _this.handleChange = function (selection) {
      _this.props.changeHandler(selection, true);
      _this.setState({ value: selection });
    };

    _this.state = {
      value: props.initialValue
    };
    return _this;
  }

  ReactSelector.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'resourceSelector' },
      this.props.title ? _react2.default.createElement(
        _reactBootstrap.ControlLabel,
        { className: 'resourceSelectorPrompt' },
        this.props.title
      ) : _react2.default.createElement('span', null),
      _react2.default.createElement(_reactSelect2.default, {
        name: 'form-field-name',
        value: this.state.value,
        options: this.props.resources,
        onChange: this.handleChange,
        multi: this.props.multiSelect,
        autosize: true,
        clearable: true
      })
    );
  };

  return ReactSelector;
}(_react2.default.Component);

;

process.env.NODE_ENV !== "production" ? ReactSelector.propTypes = {
  initialValue: _propTypes2.default.string,
  resources: _propTypes2.default.array.isRequired,
  changeHandler: _propTypes2.default.func.isRequired,
  multiSelect: _propTypes2.default.bool.isRequired,
  title: _propTypes2.default.string
} : void 0;

// set default values for props here
ReactSelector.defaultProps = {
  initialValue: "",
  title: ""
};

exports.default = ReactSelector;