'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _CitationButton = require('../helpers/CitationButton');

var _CitationButton2 = _interopRequireDefault(_CitationButton);

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _draftJs = require('draft-js');

var _reactDraftWysiwyg = require('react-draft-wysiwyg');

var _draftjsToHtml = require('draftjs-to-html');

var _draftjsToHtml2 = _interopRequireDefault(_draftjsToHtml);

var _htmlToDraftjs = require('html-to-draftjs');

var _htmlToDraftjs2 = _interopRequireDefault(_htmlToDraftjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RichEditor = (_temp = _class = function (_React$Component) {
  _inherits(RichEditor, _React$Component);

  function RichEditor(props) {
    _classCallCheck(this, RichEditor);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var blocksFromHtml = (0, _htmlToDraftjs2.default)(props.content);
    var contentBlocks = blocksFromHtml.contentBlocks,
        entityMap = blocksFromHtml.entityMap;

    var contentState = _draftJs.ContentState.createFromBlockArray(contentBlocks, entityMap);
    var editorState = _draftJs.EditorState.createWithContent(contentState);

    var mention = {};
    if (props.suggestions) {
      mention = {
        separator: ' ',
        trigger: '@',
        suggestions: _this.props.suggestions
      };
    }
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      editorState: editorState,
      content: "",
      mention: mention
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.onEditorStateChange = _this.onEditorStateChange.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  RichEditor.prototype.render = function render() {
    var editorState = this.state.editorState;

    return _react2.default.createElement(_reactDraftWysiwyg.Editor, {
      editorState: editorState,
      wrapperClassName: 'RichEditor-root',
      editorClassName: 'RichEditor-editor',
      onEditorStateChange: this.onEditorStateChange,
      toolbarCustomButtons: [_react2.default.createElement(_CitationButton2.default, null)],
      spellCheck: true,
      toolbar: {
        options: ['inline'
        // , 'blockType'
        // , 'fontSize'
        // , 'list'
        , 'link', 'history'],
        inline: {
          options: ['bold', 'italic', 'underline']
        }
      },
      mention: this.state.mention
    });
  };

  return RichEditor;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    var languageCode = nextProps.session.languageCode;
    var mention = {};
    if (nextProps.suggestions) {
      mention = {
        separator: ' ',
        trigger: '@',
        suggestions: nextProps.suggestions
      };
    }
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, props) {
      return {
        message: labels[labelTopics.messages].initial,
        somethingWeTrackIfChanged: (0, _lodash.get)(_this2.state, "somethingWeTrackIfChanged", ""),
        mention: mention
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.onEditorStateChange = function (editorState) {
    var plain = editorState.getCurrentContent().getPlainText();
    var html = (0, _draftjsToHtml2.default)((0, _draftJs.convertToRaw)(editorState.getCurrentContent()));
    _this2.setState({
      editorState: editorState,
      plain: plain,
      html: html
    }, _this2.props.handleEditorChange(plain, html));
  };
}, _temp);
;

process.env.NODE_ENV !== "production" ? RichEditor.propTypes = {
  session: _propTypes2.default.object.isRequired,
  handleEditorChange: _propTypes2.default.func.isRequired,
  content: _propTypes2.default.string,
  suggestions: _propTypes2.default.array
} : void 0;

// set default values for props here
RichEditor.defaultProps = {
  languageCode: "en",
  content: "<p>Enter text here.</p>"
};

exports.default = RichEditor;
module.exports = exports['default'];