'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ModalSearchOntologyWithCallback = require('./ModalSearchOntologyWithCallback');

var _ModalSearchOntologyWithCallback2 = _interopRequireDefault(_ModalSearchOntologyWithCallback);

var _ModalSearchTextWithCallback = require('./ModalSearchTextWithCallback');

var _ModalSearchTextWithCallback2 = _interopRequireDefault(_ModalSearchTextWithCallback);

var _ModalNewEntryForm = require('./ModalNewEntryForm');

var _ModalNewEntryForm2 = _interopRequireDefault(_ModalNewEntryForm);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _UiSchemas = require('../classes/UiSchemas');

var _UiSchemas2 = _interopRequireDefault(_UiSchemas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Provides an Add button for adding an entry that is based on a json schema
 */
var SchemaBasedAddButton = (_temp = _class = function (_React$Component) {
  _inherits(SchemaBasedAddButton, _React$Component);

  function SchemaBasedAddButton(props) {
    _classCallCheck(this, SchemaBasedAddButton);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var uiSchemas = {};
    if (props.session && props.session.uiSchemas) {
      uiSchemas = new _UiSchemas2.default(props.session.uiSchemas.formsDropdown, props.session.uiSchemas.formsSchemas, props.session.uiSchemas.forms);
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.schemaBasedAddButton],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable],
        references: labels[labelTopics.ViewReferences]
      },
      session: {
        uiSchemas: uiSchemas
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      idTopicType: _this.props.formData["partTypeOfTopic"],
      idKeyType: _this.props.formData["partTypeOfKey"],
      showModal: false,
      idSelected: false,
      idLibrary: _this.props.idLibrary,
      idTopic: _this.props.idTopic,
      idTopicValue: "",
      idKey: _this.props.idKey,
      idKeyValue: "",
      initialOntologyType: "Animal",
      restPath: _this.props.restPath,
      uiSchema: _this.props.uiSchema,
      schema: _this.props.schema,
      formData: _this.props.formData
    };

    _this.handleStateChange = _this.handleStateChange.bind(_this);
    _this.handleAddButtonClick = _this.handleAddButtonClick.bind(_this);
    _this.handleIdBuilderClose = _this.handleIdBuilderClose.bind(_this);
    _this.handleModalClose = _this.handleModalClose.bind(_this);
    _this.handleModalSubmit = _this.handleModalSubmit.bind(_this);
    _this.getContent = _this.getContent.bind(_this);
    _this.setFormData = _this.setFormData.bind(_this);

    _this.handleIdLibrarySelection = _this.handleIdLibrarySelection.bind(_this);
    _this.handleIdTopicSelection = _this.handleIdTopicSelection.bind(_this);
    _this.handleIdKeySelection = _this.handleIdKeySelection.bind(_this);
    return _this;
  }

  // if we need to do something after setState, do it here...


  SchemaBasedAddButton.prototype.render = function render() {
    return _react2.default.createElement(
      'span',
      null,
      this.getContent()
    );
  };

  return SchemaBasedAddButton;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.schemaBasedAddButton],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable],
          references: labels[labelTopics.ViewReferences]
        },
        message: labels[labelTopics.messages].initial
      };
    }, function () {
      return this.handleStateChange("place holder");
    });
  };

  this.handleStateChange = function (parm) {
    // call a function if needed
  };

  this.handleIdLibrarySelection = function (library) {
    if (library) {
      _this2.setState({
        idLibrary: library
      });
    }
  };

  this.handleIdTopicSelection = function (topic, value) {
    _this2.setState({
      idTopic: topic,
      idTopicValue: value
    });
  };

  this.handleIdKeySelection = function (id, value, seq, schema) {
    var schemaId = _this2.state.session.uiSchemas.getLinkCreateSchemaIdForSchemaId(schema);
    var formData = _this2.state.session.uiSchemas.getForm(schemaId);

    _this2.setState({
      idKey: id,
      idKeyValue: value,
      idKeySeq: seq,
      idSelected: true,
      idSchema: schemaId,
      idTopicType: formData["partTypeOfTopic"],
      idKeyType: formData["partTypeOfKey"],
      restPath: _this2.state.session.uiSchemas.getHttpPostPathForSchema(schemaId),
      uiSchema: _this2.state.session.uiSchemas.getUiSchema(schemaId),
      schema: _this2.state.session.uiSchemas.getSchema(schemaId),
      formData: formData
    });
  };

  this.handleAddButtonClick = function () {
    var idSelected = false;
    if (_this2.state.idKeyType === "TIMESTAMP") {
      idSelected = true;
    }
    _this2.setState({
      idSelected: idSelected,
      showModal: true
    });
  };

  this.handleIdBuilderClose = function () {
    var idSelected = _this2.state.idKey && _this2.state.idKey.length > 0;
    _this2.setState({
      idSelected: idSelected,
      showModal: idSelected
    });
  };

  this.handleModalClose = function () {
    _this2.setState({
      showModal: false
    });
    _this2.props.onClose();
  };

  this.handleModalSubmit = function (_ref) {
    var formData = _ref.formData;

    if (_this2.props.onSubmit) {
      _this2.props.onSubmit(formData);
    }
  };

  this.setFormData = function () {
    var date = new Date();
    var month = (date.getMonth() + 1).toString().padStart(2, "0");
    var day = date.getDate().toString().padStart(2, "0");
    var hour = date.getHours().toString().padStart(2, "0");
    var minute = date.getMinutes().toString().padStart(2, "0");
    var second = date.getSeconds().toString().padStart(2, "0");
    var key = date.getFullYear() + "." + month + "." + day + ".T" + hour + "." + minute + "." + second;
    var formData = _this2.state.formData;
    formData.library = _this2.props.idLibrary;
    formData.topic = _this2.props.idTopic;
    formData.key = key; //this.state.idKey;
    formData.id = _this2.props.idLibrary + "~" + _this2.props.idTopic + "~" + key;
    formData.seq = formData.id;
    formData.status = "FINALIZED";
    return formData;
  };

  this.getContent = function () {
    if (_this2.state.showModal) {
      if (_this2.state.idSelected) {
        return _react2.default.createElement(_ModalNewEntryForm2.default, {
          session: _this2.props.session,
          restPath: _this2.state.restPath,
          uiSchema: _this2.state.uiSchema,
          schema: _this2.state.schema,
          formData: _this2.setFormData(),
          title: _this2.props.title,
          fromId: _this2.props.fromId,
          fromText: _this2.props.fromText,
          toId: _this2.state.idKey,
          toText: _this2.state.idKeyValue,
          fromTitle: _this2.state.labels.references.theText,
          toTitle: _this2.state.labels.references.refersTo,
          onSubmit: _this2.handleModalSubmit,
          onClose: _this2.handleModalClose
        });
      } else {
        switch (_this2.state.idKeyType) {
          case "ID_OF_SELECTED_BIBLICAL_VERSE":
            return _react2.default.createElement(_ModalSearchTextWithCallback2.default, {
              session: _this2.props.session,
              initialDocType: "Biblical",
              onCallback: _this2.handleIdKeySelection,
              onClose: _this2.handleIdBuilderClose
            });
          case "ID_OF_SELECTED_ONTOLOGY_INSTANCE":
            return _react2.default.createElement(_ModalSearchOntologyWithCallback2.default, {
              session: _this2.props.session,
              initialDocType: "Animal",
              onCallback: _this2.handleIdKeySelection,
              onClose: _this2.handleIdBuilderClose
            });
        }
      }
    } else {
      return _react2.default.createElement(
        _reactBootstrap.Button,
        {
          className: 'Schema-Based-Add-Button',
          bsStyle: 'primary',
          bsSize: "xsmall",
          onClick: _this2.handleAddButtonClick },
        _react2.default.createElement(_reactFontawesome2.default, {
          className: 'App-Add-ico',
          name: 'plus' })
      );
    }
  };
}, _temp);


process.env.NODE_ENV !== "production" ? SchemaBasedAddButton.propTypes = {
  session: _propTypes2.default.object.isRequired,
  restPath: _propTypes2.default.string.isRequired,
  uiSchema: _propTypes2.default.object.isRequired,
  schema: _propTypes2.default.object.isRequired,
  formData: _propTypes2.default.object.isRequired,
  idLibrary: _propTypes2.default.string.isRequired,
  idTopic: _propTypes2.default.string.isRequired,
  idKey: _propTypes2.default.string.isRequired,
  seq: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string.isRequired,
  fromTitle: _propTypes2.default.string,
  fromId: _propTypes2.default.string,
  fromText: _propTypes2.default.string,
  toTitle: _propTypes2.default.string,
  onClose: _propTypes2.default.func.isRequired,
  onSubmit: _propTypes2.default.func
} : void 0;

// set default values for props here
SchemaBasedAddButton.defaultProps = {
  languageCode: "en",
  title: "",
  fromTitle: "",
  fromId: "",
  fromText: "",
  toTitle: ""
};

exports.default = SchemaBasedAddButton;
module.exports = exports['default'];