'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchOptions = function (_React$Component) {
  _inherits(SearchOptions, _React$Component);

  function SearchOptions(props) {
    _classCallCheck(this, SearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.setValue = function (event) {
      _this.setState({ value: event.target.value });
    };

    _this.handleSubmit = function (event) {
      _this.props.handleSubmit(_this.state.value);
      event.preventDefault();
    };

    _this.state = {
      value: ""
    };
    _this.setValue = _this.setValue.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    return _this;
  }

  SearchOptions.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'container' },
      _react2.default.createElement(
        'div',
        { className: 'row' },
        _react2.default.createElement(
          'div',
          { className: 'col-12' },
          _react2.default.createElement(
            'form',
            { className: "App-Search-Options-Text-Form", onSubmit: this.handleSubmit },
            _react2.default.createElement(
              'div',
              { className: 'control-label' },
              this.props.valueTitle
            ),
            _react2.default.createElement(
              'div',
              { className: "App-Search-Options-Text-Div" },
              _react2.default.createElement(
                _reactBootstrap.FormGroup,
                null,
                _react2.default.createElement(
                  _reactBootstrap.InputGroup,
                  null,
                  _react2.default.createElement(_reactBootstrap.FormControl, {
                    type: 'text',
                    placeholder: this.props.placeholder,
                    onChange: this.setValue,
                    className: 'App-search-text-input'
                  }),
                  _react2.default.createElement(
                    _reactBootstrap.InputGroup.Button,
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.Button,
                      {
                        className: 'App-search-button',
                        bsStyle: 'primary',
                        bsSize: 'xsmall',
                        type: 'submit',
                        disabled: !this.state.value,
                        onClick: this.handleSubmit
                      },
                      _react2.default.createElement(
                        'span',
                        { className: 'App-text-search-icon' },
                        _react2.default.createElement(_reactFontawesome2.default, { name: "search" })
                      ),
                      this.props.buttonLabel
                    )
                  )
                )
              )
            )
          )
        )
      )
    );
  };

  return SearchOptions;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? SearchOptions.propTypes = {
  valueTitle: _propTypes2.default.string.isRequired,
  buttonLabel: _propTypes2.default.string.isRequired,
  placeholder: _propTypes2.default.string.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired
} : void 0;

exports.default = SearchOptions;
module.exports = exports['default'];