'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _reactBootstrapTable = require('react-bootstrap-table');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchTextResultsTable = (_temp = _class = function (_React$Component) {
  _inherits(SearchTextResultsTable, _React$Component);

  function SearchTextResultsTable(props) {
    _classCallCheck(this, SearchTextResultsTable);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props);

    _this.onSizePerPageList = _this.onSizePerPageList.bind(_this);
    _this.handleRowSelect = _this.handleRowSelect.bind(_this);
    _this.getTable = _this.getTable.bind(_this);

    return _this;
  }

  // a method called by both the constructor and componentWillReceiveProps


  SearchTextResultsTable.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-search-results' },
      this.getTable()
    );
  };

  return SearchTextResultsTable;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentDidMount = function () {
    // make any initial function calls here...
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.setState(_this2.setTheState(nextProps));
  };

  this.setTheState = function (props) {

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: labels[labelTopics.resultsTable],
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      options: {
        sizePerPage: 30,
        sizePerPageList: [5, 15, 30],
        onSizePerPageList: _this2.onSizePerPageList,
        hideSizePerPage: true,
        paginationShowsTotal: true
      },
      filter: { type: 'RegexFilter', delay: 100 },
      selectRow: {
        mode: 'radio' // or checkbox
        , hideSelectColumn: false,
        clickToSelect: false,
        onSelect: _this2.handleRowSelect,
        className: "App-row-select"
      },
      showSelectionButtons: false,
      selectedId: "",
      idColumnSize: "80px"
    };
  };

  this.handleRowSelect = function (row) {
    _this2.setState({
      selectedId: row["id"]
    }, _this2.props.callBack(row["id"], row["value"], row["_valueSchemaId"]));
  };

  this.onSizePerPageList = function (sizePerPage) {
    _this2.setState({
      options: { sizePerPage: sizePerPage }
    });
  };

  this.getTable = function () {
    return _react2.default.createElement(
      'div',
      { className: 'row' },
      _react2.default.createElement(
        _reactBootstrapTable.BootstrapTable,
        {
          ref: 'theTable',
          data: _this2.props.data,
          exportCSV: false,
          trClassName: "App-data-tr",
          striped: true,
          hover: true,
          pagination: true,
          options: _this2.state.options,
          selectRow: _this2.state.selectRow
        },
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            isKey: true,
            dataField: 'id',
            dataSort: true,
            'export': true,
            hidden: true
          },
          'ID'
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'library',
            search: true,
            dataSort: true,
            'export': false,
            filter: _this2.state.filter,
            tdClassname: 'tdDomain',
            width: _this2.state.idColumnSize },
          _this2.state.labels.headerDomain
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'topic',
            filter: _this2.state.filter,
            dataSort: true,
            'export': false,
            width: _this2.state.idColumnSize },
          _this2.state.labels.headerTopic
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'key',
            filter: _this2.state.filter,
            'export': false,
            dataSort: true,
            width: _this2.state.idColumnSize },
          _this2.state.labels.headerKey
        ),
        _react2.default.createElement(
          _reactBootstrapTable.TableHeaderColumn,
          {
            dataField: 'value',
            filter: _this2.state.filter,
            dataSort: true
          },
          _this2.state.labels.headerValue
        ),
        _react2.default.createElement(_reactBootstrapTable.TableHeaderColumn, {
          dataField: '_valueSchemaId',
          'export': false,
          hidden: true
        })
      )
    );
  };
}, _temp);
;

process.env.NODE_ENV !== "production" ? SearchTextResultsTable.propTypes = {
  session: _propTypes2.default.object.isRequired,
  data: _propTypes2.default.array.isRequired,
  callBack: _propTypes2.default.func.isRequired
} : void 0;

// set default values for props here
SearchTextResultsTable.defaultProps = {};

exports.default = SearchTextResultsTable;
module.exports = exports['default'];