'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ReactSelector = require('./ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextNoteSearchOptions = (_temp = _class = function (_React$Component) {
  _inherits(TextNoteSearchOptions, _React$Component);

  function TextNoteSearchOptions(props) {
    _classCallCheck(this, TextNoteSearchOptions);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var initialType = "*";
    if (_this.props.initialType) {
      initialType = _this.props.initialType;
    }

    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    _this.state = {
      labels: {
        thisClass: labels[labelTopics.searchNotes],
        buttons: labels[labelTopics.button],
        messages: labels[labelTopics.messages],
        resultsTableLabels: labels[labelTopics.resultsTable]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      selectedType: initialType,
      selectedProperty: "value",
      selectedMatcher: "c",
      value: "",
      selectedTagOperator: "any",
      selectedTags: "",
      tagData: [],
      dropDownProperties: {
        msg: _this.props.labels.domainIs,
        source: _this.props.properties[initialType],
        initialValue: "*"
      }
    };
    _this.handleDocTypeChange = _this.handleDocTypeChange.bind(_this);
    _this.handlePropertyChange = _this.handlePropertyChange.bind(_this);
    _this.handleMatcherChange = _this.handleMatcherChange.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleTagsSelection = _this.handleTagsSelection.bind(_this);
    _this.handleTagOperatorChange = _this.handleTagOperatorChange.bind(_this);
    _this.isDisabled = _this.isDisabled.bind(_this);

    _this.getTypeRow = _this.getTypeRow.bind(_this);
    _this.getPropertyRow = _this.getPropertyRow.bind(_this);
    _this.getMatchLocationRow = _this.getMatchLocationRow.bind(_this);
    _this.getHasTagRow = _this.getHasTagRow.bind(_this);
    _this.getTagRow = _this.getTagRow.bind(_this);
    _this.getTextRow = _this.getTextRow.bind(_this);
    _this.getButtonRow = _this.getButtonRow.bind(_this);

    return _this;
  }

  TextNoteSearchOptions.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'container App-search-options-container' },
      _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.Grid,
          null,
          this.getTypeRow(),
          this.getPropertyRow(),
          this.getTextRow(),
          this.getMatchLocationRow(),
          this.getHasTagRow(),
          this.getTagRow(),
          this.getButtonRow()
        )
      )
    );
  };

  return TextNoteSearchOptions;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {};

  this.componentWillReceiveProps = function (nextProps) {

    var labels = nextProps.session.labels;
    var labelTopics = nextProps.session.labelTopics;

    _this2.setState(function (prevState, props) {
      return {
        labels: {
          thisClass: labels[labelTopics.searchNotes],
          buttons: labels[labelTopics.button],
          messages: labels[labelTopics.messages],
          resultsTableLabels: labels[labelTopics.resultsTable]
        },
        message: labels[labelTopics.messages].initial
      };
    });
  };

  this.handleDocTypeChange = function (selection) {
    var type = selection["value"];
    _this2.setState({
      selectedType: type,
      dropDownProperties: {
        msg: _this2.props.labels.domainIs,
        source: _this2.props.properties[type],
        initialValue: "*"
      }
    });
  };

  this.handlePropertyChange = function (item) {
    var newSelectedValue = _this2.state.value;

    if (item.value.startsWith("*")) {
      newSelectedValue = "";
    }
    _this2.setState({
      selectedProperty: item.value,
      value: newSelectedValue
    });
  };

  this.handleMatcherChange = function (item) {
    _this2.setState({ selectedMatcher: item.value });
  };

  this.handleValueChange = function (event) {
    _this2.setState({ value: event.target.value });
  };

  this.handleTagsSelection = function (selection) {
    var tags = selection.map(function (a) {
      return a.value;
    });

    _this2.setState({
      selectedTags: tags.toString()
    });
  };

  this.handleTagOperatorChange = function (selection) {
    _this2.setState({
      selectedTagOperator: selection["value"]
    });
  };

  this.handleSubmit = function (event) {
    _this2.props.handleSubmit(_this2.state.selectedType, _this2.state.selectedProperty, _this2.state.selectedMatcher, _this2.state.value, _this2.state.selectedTagOperator, _this2.state.selectedTags);
    event.preventDefault();
  };

  this.isDisabled = function () {
    // For now, we are not disabling the search for any reason.
    // The code below is stubbed out for the event that we
    // start disabling.
    var disableButton = false;
    if (_this2.state.value && _this2.state.value.length > 0) {
      disableButton = false;
    } else {
      switch (_this2.state.selectedType) {
        case "*":
          {
            break;
          }
        default:
          {
            disableButton = false;
            break;
          }
      }
    }
    return disableButton;
  };

  this.getTypeRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Type-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.props.labels.findWhereTypeIs,
            initialValue: _this2.state.selectedType,
            resources: _this2.props.types,
            changeHandler: _this2.handleDocTypeChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getPropertyRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Type-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.props.labels.propertyIs,
            initialValue: _this2.state.selectedProperty,
            resources: _this2.props.properties,
            changeHandler: _this2.handlePropertyChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getTextRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          _this2.props.labels.propertyTextIs
        ),
        _react2.default.createElement(_reactBootstrap.FormControl, {
          id: "fxTextNoteSearchText",
          className: "App App-search-text-input",
          type: 'text',
          value: _this2.state.value,
          placeholder: _this2.props.labels.textPrompt,
          onChange: _this2.handleValueChange
        })
      )
    );
  };

  this.getMatchLocationRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Type-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.props.labels.matcherIs,
            initialValue: _this2.state.selectedMatcher,
            resources: _this2.props.matchers,
            changeHandler: _this2.handleMatcherChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getHasTagRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Tag-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.props.labels.has,
            initialValue: _this2.state.selectedTagOperator,
            resources: _this2.props.tagOperators,
            changeHandler: _this2.handleTagOperatorChange,
            multiSelect: false
          })
        )
      )
    );
  };

  this.getTagRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Tag-Selector" },
          _react2.default.createElement(_ReactSelector2.default, {
            title: _this2.props.labels.tags,
            initialValue: _this2.state.selectedTags,
            resources: _this2.props.tags,
            changeHandler: _this2.handleTagsSelection,
            multiSelect: true
          })
        )
      )
    );
  };

  this.getButtonRow = function () {
    return _react2.default.createElement(
      _reactBootstrap.Row,
      { className: 'show-grid App-Text-Note-Search-Options-Row' },
      _react2.default.createElement(
        _reactBootstrap.Col,
        { xs: 12, md: 12 },
        _react2.default.createElement(
          'div',
          { className: "App App-Text-Note-Selector-Button" },
          _react2.default.createElement(
            _reactBootstrap.ControlLabel,
            null,
            _this2.props.labels.clickTheButton
          ),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _reactBootstrap.Button,
              {
                bsStyle: 'primary',
                bsSize: 'xsmall',
                type: 'submit',
                disabled: _this2.isDisabled(),
                onClick: _this2.handleSubmit
              },
              _react2.default.createElement(_reactFontawesome2.default, { className: 'Button-Select-FontAwesome', name: "search" }),
              _this2.props.labels.submit
            )
          )
        )
      )
    );
  };
}, _temp);


process.env.NODE_ENV !== "production" ? TextNoteSearchOptions.propTypes = {
  session: _propTypes2.default.object.isRequired,
  types: _propTypes2.default.array.isRequired,
  initialType: _propTypes2.default.string.isRequired,
  properties: _propTypes2.default.array.isRequired,
  matchers: _propTypes2.default.array.isRequired,
  tags: _propTypes2.default.array.isRequired,
  tagOperators: _propTypes2.default.array.isRequired,
  handleSubmit: _propTypes2.default.func.isRequired,
  labels: _propTypes2.default.object.isRequired
} : void 0;

exports.default = TextNoteSearchOptions;
module.exports = exports['default'];