'use strict';

exports.__esModule = true;

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Server = require('../helpers/Server');

var _Server2 = _interopRequireDefault(_Server);

var _reactBootstrap = require('react-bootstrap');

var _MessageIcons = require('../helpers/MessageIcons');

var _MessageIcons2 = _interopRequireDefault(_MessageIcons);

var _ReactSelector = require('../modules/ReactSelector');

var _ReactSelector2 = _interopRequireDefault(_ReactSelector);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WorkflowAssignment = (_temp = _class = function (_React$Component) {
  _inherits(WorkflowAssignment, _React$Component);

  function WorkflowAssignment(props) {
    _classCallCheck(this, WorkflowAssignment);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.state = _this.setTheState(props, "");

    _this.handleStatusChange = _this.handleStatusChange.bind(_this);
    _this.handleUserChange = _this.handleUserChange.bind(_this);
    _this.fetchData = _this.fetchData.bind(_this);
    _this.handleCallback = _this.handleCallback.bind(_this);
    return _this;
  }

  WorkflowAssignment.prototype.render = function render() {
    return _react2.default.createElement(
      'div',
      { className: 'App-Workflow-Assignment' },
      this.state.dropdownsLoaded && _react2.default.createElement(
        _reactBootstrap.Well,
        null,
        _react2.default.createElement(
          _reactBootstrap.ControlLabel,
          null,
          this.state.labels.thisClass.title
        ),
        _react2.default.createElement(
          'div',
          null,
          this.state.labels.thisClass.instructions
        ),
        _react2.default.createElement(_ReactSelector2.default, {
          title: this.state.labels.thisClass.status,
          initialValue: this.state.selectedStatus,
          resources: this.state.statuses,
          changeHandler: this.handleStatusChange,
          multiSelect: false
        }),
        this.state.userRolesIndex.length > 0 && _react2.default.createElement(_ReactSelector2.default, {
          title: this.state.labels.thisClass.user[this.state.selectedStatus],
          initialValue: this.state.selectedUser,
          resources: this.state.userRolesForDomain[this.state.userRolesIndex],
          changeHandler: this.handleUserChange,
          multiSelect: false
        }),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              bsStyle: 'primary',
              type: 'submit',
              onClick: this.handleCallback
            },
            this.state.labels.thisClass.submit
          ),
          _react2.default.createElement(
            'span',
            { className: 'App App-message' },
            _react2.default.createElement(_reactFontawesome2.default, {
              name: this.state.messageIcon }),
            this.state.message
          )
        )
      )
    );
  };

  return WorkflowAssignment;
}(_react2.default.Component), _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentWillMount = function () {
    _this2.fetchData();
  };

  this.componentWillReceiveProps = function (nextProps) {
    _this2.state = _this2.setTheState(nextProps);
    _this2.fetchData();
  };

  this.setTheState = function (props) {
    var labels = props.session.labels;
    var labelTopics = props.session.labelTopics;

    return {
      labels: {
        thisClass: labels[labelTopics.WorkflowAssignment],
        messages: labels[labelTopics.messages]
      },
      messageIcons: _MessageIcons2.default.getMessageIcons(),
      messageIcon: _MessageIcons2.default.getMessageIcons().info,
      message: labels[labelTopics.messages].initial,
      userRolesForDomain: {
        admins: [],
        authors: [],
        readers: [],
        reviewers: []
      },
      userRolesIndex: "",
      statuses: [],
      selectedUser: "",
      selectedStatus: "",
      dropdownsLoaded: false
    };
  };

  this.handleStatusChange = function (item) {

    var userIndex = "";

    switch (item.value) {
      case "EDITING":
        userIndex = "authors";
        break;
      case "READY_TO_EDIT":
        userIndex = "admins";
        break;
      case "READY_TO_FINALIZE":
        userIndex = "admins";
        break;
      case "READY_TO_REVIEW":
        userIndex = "admins";
        break;
      case "REVIEWING":
        userIndex = "reviewers";
        break;
      default:
    }

    _this2.setState({
      selectedStatus: item.value,
      selectedUser: "",
      userRolesIndex: userIndex
    });
  };

  this.handleUserChange = function (item) {
    _this2.setState({ selectedUser: item.value });
  };

  this.handleCallback = function () {
    _this2.props.callback(_this2.state.selectedStatus, _this2.state.selectedUser);
  };

  this.fetchData = function () {
    var config = {
      auth: {
        username: _this2.props.session.userInfo.username,
        password: _this2.props.session.userInfo.password
      }
    };

    var path = _this2.props.session.restServer + _Server2.default.getWsServerDropdownsForUserRolesForDomainApi() + "/" + _this2.props.library;
    _axios2.default.get(path, config).then(function (response) {
      _this2.setState({
        userRolesForDomain: response.data.values[0],
        statuses: response.data.values[1].statuses,
        dropdownsLoaded: true
      });
    }).catch(function (error) {
      var message = error.message;
      var messageIcon = _this2.messageIcons.error;
      if (error && error.response && error.response.status === 404) {
        message = "no docs found";
        messageIcon = _this2.messageIcons.warning;
        _this2.setState({ data: message, message: message, messageIcon: messageIcon });
      }
    });
  };
}, _temp);


process.env.NODE_ENV !== "production" ? WorkflowAssignment.propTypes = {
  session: _propTypes2.default.object.isRequired,
  callback: _propTypes2.default.func.isRequired,
  library: _propTypes2.default.string.isRequired
} : void 0;

WorkflowAssignment.defaultProps = {};

exports.default = WorkflowAssignment;
module.exports = exports['default'];