'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _reactYoutube = require('react-youtube');

var _reactYoutube2 = _interopRequireDefault(_reactYoutube);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var YoutubeVideoPanel = function (_React$Component) {
  _inherits(YoutubeVideoPanel, _React$Component);

  function YoutubeVideoPanel(props) {
    _classCallCheck(this, YoutubeVideoPanel);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.componentWillMount = function () {};

    _this.componentWillReceiveProps = function (nextProps) {};

    _this.onReady = function (event) {
      event.target.pauseVideo();
    };

    _this.onReady = _this.onReady.bind(_this);
    return _this;
  }

  YoutubeVideoPanel.prototype.render = function render() {

    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        _reactBootstrap.Panel,
        {
          className: 'App-Youtube-panel',
          header: this.props.title,
          eventKey: this.props.eventKey,
          collapsible: true
        },
        _react2.default.createElement(
          _reactBootstrap.Well,
          null,
          _react2.default.createElement(
            'p',
            { className: 'App-Youtube-Text' },
            this.props.text
          ),
          _react2.default.createElement(_reactYoutube2.default, {
            className: 'App-Youtube-player',
            videoId: this.props.videoId,
            opts: this.props.opts,
            onReady: this.onReady
          }),
          '}'
        )
      )
    );
  };

  return YoutubeVideoPanel;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? YoutubeVideoPanel.propTypes = {
  videoId: _propTypes2.default.string,
  title: _propTypes2.default.string.isRequired,
  text: _propTypes2.default.string.isRequired,
  eventKey: _propTypes2.default.string.isRequired,
  opts: _propTypes2.default.object
} : void 0;

YoutubeVideoPanel.defaultProps = {
  opts: {
    height: '390',
    width: '640',
    playerVars: { // https://developers.google.com/youtube/player_parameters
      autoplay: 1,
      modestbranding: 1,
      rel: 0
    }
  }
};

exports.default = YoutubeVideoPanel;
module.exports = exports['default'];